// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/api/cloudquotas/v1/cloudquotas.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fapi_2fcloudquotas_2fv1_2fcloudquotas_2eproto__INCLUDED
#define GRPC_google_2fapi_2fcloudquotas_2fv1_2fcloudquotas_2eproto__INCLUDED

#include "google/api/cloudquotas/v1/cloudquotas.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace api {
namespace cloudquotas {
namespace v1 {

// The Cloud Quotas API is an infrastructure service for Google Cloud that lets
// service consumers list and manage their resource usage limits.
//
// - List/Get the metadata and current status of the quotas for a service.
// - Create/Update quota preferencess that declare the preferred quota values.
// - Check the status of a quota preference request.
// - List/Get pending and historical quota preference.
class CloudQuotas final {
 public:
  static constexpr char const* service_full_name() {
    return "google.api.cloudquotas.v1.CloudQuotas";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists QuotaInfos of all quotas for a given project, folder or organization.
    virtual ::grpc::Status ListQuotaInfos(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest& request, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>> AsyncListQuotaInfos(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>>(AsyncListQuotaInfosRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>> PrepareAsyncListQuotaInfos(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>>(PrepareAsyncListQuotaInfosRaw(context, request, cq));
    }
    // Retrieve the QuotaInfo of a quota for a project, folder or organization.
    virtual ::grpc::Status GetQuotaInfo(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest& request, ::google::api::cloudquotas::v1::QuotaInfo* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaInfo>> AsyncGetQuotaInfo(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaInfo>>(AsyncGetQuotaInfoRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaInfo>> PrepareAsyncGetQuotaInfo(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaInfo>>(PrepareAsyncGetQuotaInfoRaw(context, request, cq));
    }
    // Lists QuotaPreferences in a given project, folder or organization.
    virtual ::grpc::Status ListQuotaPreferences(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest& request, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>> AsyncListQuotaPreferences(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>>(AsyncListQuotaPreferencesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>> PrepareAsyncListQuotaPreferences(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>>(PrepareAsyncListQuotaPreferencesRaw(context, request, cq));
    }
    // Gets details of a single QuotaPreference.
    virtual ::grpc::Status GetQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest& request, ::google::api::cloudquotas::v1::QuotaPreference* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>> AsyncGetQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>>(AsyncGetQuotaPreferenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>> PrepareAsyncGetQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>>(PrepareAsyncGetQuotaPreferenceRaw(context, request, cq));
    }
    // Creates a new QuotaPreference that declares the desired value for a quota.
    virtual ::grpc::Status CreateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest& request, ::google::api::cloudquotas::v1::QuotaPreference* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>> AsyncCreateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>>(AsyncCreateQuotaPreferenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>> PrepareAsyncCreateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>>(PrepareAsyncCreateQuotaPreferenceRaw(context, request, cq));
    }
    // Updates the parameters of a single QuotaPreference. It can updates the
    // config in any states, not just the ones pending approval.
    virtual ::grpc::Status UpdateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest& request, ::google::api::cloudquotas::v1::QuotaPreference* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>> AsyncUpdateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>>(AsyncUpdateQuotaPreferenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>> PrepareAsyncUpdateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>>(PrepareAsyncUpdateQuotaPreferenceRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists QuotaInfos of all quotas for a given project, folder or organization.
      virtual void ListQuotaInfos(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* request, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListQuotaInfos(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* request, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieve the QuotaInfo of a quota for a project, folder or organization.
      virtual void GetQuotaInfo(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* request, ::google::api::cloudquotas::v1::QuotaInfo* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetQuotaInfo(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* request, ::google::api::cloudquotas::v1::QuotaInfo* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists QuotaPreferences in a given project, folder or organization.
      virtual void ListQuotaPreferences(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* request, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListQuotaPreferences(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* request, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single QuotaPreference.
      virtual void GetQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new QuotaPreference that declares the desired value for a quota.
      virtual void CreateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single QuotaPreference. It can updates the
      // config in any states, not just the ones pending approval.
      virtual void UpdateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>* AsyncListQuotaInfosRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>* PrepareAsyncListQuotaInfosRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaInfo>* AsyncGetQuotaInfoRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaInfo>* PrepareAsyncGetQuotaInfoRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>* AsyncListQuotaPreferencesRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>* PrepareAsyncListQuotaPreferencesRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>* AsyncGetQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>* PrepareAsyncGetQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>* AsyncCreateQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>* PrepareAsyncCreateQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>* AsyncUpdateQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::cloudquotas::v1::QuotaPreference>* PrepareAsyncUpdateQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListQuotaInfos(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest& request, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>> AsyncListQuotaInfos(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>>(AsyncListQuotaInfosRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>> PrepareAsyncListQuotaInfos(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>>(PrepareAsyncListQuotaInfosRaw(context, request, cq));
    }
    ::grpc::Status GetQuotaInfo(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest& request, ::google::api::cloudquotas::v1::QuotaInfo* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaInfo>> AsyncGetQuotaInfo(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaInfo>>(AsyncGetQuotaInfoRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaInfo>> PrepareAsyncGetQuotaInfo(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaInfo>>(PrepareAsyncGetQuotaInfoRaw(context, request, cq));
    }
    ::grpc::Status ListQuotaPreferences(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest& request, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>> AsyncListQuotaPreferences(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>>(AsyncListQuotaPreferencesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>> PrepareAsyncListQuotaPreferences(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>>(PrepareAsyncListQuotaPreferencesRaw(context, request, cq));
    }
    ::grpc::Status GetQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest& request, ::google::api::cloudquotas::v1::QuotaPreference* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>> AsyncGetQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>>(AsyncGetQuotaPreferenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>> PrepareAsyncGetQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>>(PrepareAsyncGetQuotaPreferenceRaw(context, request, cq));
    }
    ::grpc::Status CreateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest& request, ::google::api::cloudquotas::v1::QuotaPreference* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>> AsyncCreateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>>(AsyncCreateQuotaPreferenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>> PrepareAsyncCreateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>>(PrepareAsyncCreateQuotaPreferenceRaw(context, request, cq));
    }
    ::grpc::Status UpdateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest& request, ::google::api::cloudquotas::v1::QuotaPreference* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>> AsyncUpdateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>>(AsyncUpdateQuotaPreferenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>> PrepareAsyncUpdateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>>(PrepareAsyncUpdateQuotaPreferenceRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListQuotaInfos(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* request, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* response, std::function<void(::grpc::Status)>) override;
      void ListQuotaInfos(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* request, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetQuotaInfo(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* request, ::google::api::cloudquotas::v1::QuotaInfo* response, std::function<void(::grpc::Status)>) override;
      void GetQuotaInfo(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* request, ::google::api::cloudquotas::v1::QuotaInfo* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListQuotaPreferences(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* request, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListQuotaPreferences(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* request, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, std::function<void(::grpc::Status)>) override;
      void GetQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, std::function<void(::grpc::Status)>) override;
      void CreateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, std::function<void(::grpc::Status)>) override;
      void UpdateQuotaPreference(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>* AsyncListQuotaInfosRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>* PrepareAsyncListQuotaInfosRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaInfo>* AsyncGetQuotaInfoRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaInfo>* PrepareAsyncGetQuotaInfoRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>* AsyncListQuotaPreferencesRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>* PrepareAsyncListQuotaPreferencesRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>* AsyncGetQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>* PrepareAsyncGetQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>* AsyncCreateQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>* PrepareAsyncCreateQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>* AsyncUpdateQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::cloudquotas::v1::QuotaPreference>* PrepareAsyncUpdateQuotaPreferenceRaw(::grpc::ClientContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListQuotaInfos_;
    const ::grpc::internal::RpcMethod rpcmethod_GetQuotaInfo_;
    const ::grpc::internal::RpcMethod rpcmethod_ListQuotaPreferences_;
    const ::grpc::internal::RpcMethod rpcmethod_GetQuotaPreference_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateQuotaPreference_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateQuotaPreference_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists QuotaInfos of all quotas for a given project, folder or organization.
    virtual ::grpc::Status ListQuotaInfos(::grpc::ServerContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* request, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* response);
    // Retrieve the QuotaInfo of a quota for a project, folder or organization.
    virtual ::grpc::Status GetQuotaInfo(::grpc::ServerContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* request, ::google::api::cloudquotas::v1::QuotaInfo* response);
    // Lists QuotaPreferences in a given project, folder or organization.
    virtual ::grpc::Status ListQuotaPreferences(::grpc::ServerContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* request, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* response);
    // Gets details of a single QuotaPreference.
    virtual ::grpc::Status GetQuotaPreference(::grpc::ServerContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response);
    // Creates a new QuotaPreference that declares the desired value for a quota.
    virtual ::grpc::Status CreateQuotaPreference(::grpc::ServerContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response);
    // Updates the parameters of a single QuotaPreference. It can updates the
    // config in any states, not just the ones pending approval.
    virtual ::grpc::Status UpdateQuotaPreference(::grpc::ServerContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListQuotaInfos : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListQuotaInfos() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListQuotaInfos() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListQuotaInfos(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListQuotaInfos(::grpc::ServerContext* context, ::google::api::cloudquotas::v1::ListQuotaInfosRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::cloudquotas::v1::ListQuotaInfosResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetQuotaInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetQuotaInfo() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetQuotaInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQuotaInfo(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaInfo* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetQuotaInfo(::grpc::ServerContext* context, ::google::api::cloudquotas::v1::GetQuotaInfoRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::cloudquotas::v1::QuotaInfo>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListQuotaPreferences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListQuotaPreferences() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListQuotaPreferences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListQuotaPreferences(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListQuotaPreferences(::grpc::ServerContext* context, ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetQuotaPreference() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetQuotaPreference(::grpc::ServerContext* context, ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::cloudquotas::v1::QuotaPreference>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateQuotaPreference() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_CreateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateQuotaPreference(::grpc::ServerContext* context, ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::cloudquotas::v1::QuotaPreference>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateQuotaPreference() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_UpdateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateQuotaPreference(::grpc::ServerContext* context, ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::cloudquotas::v1::QuotaPreference>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListQuotaInfos<WithAsyncMethod_GetQuotaInfo<WithAsyncMethod_ListQuotaPreferences<WithAsyncMethod_GetQuotaPreference<WithAsyncMethod_CreateQuotaPreference<WithAsyncMethod_UpdateQuotaPreference<Service > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListQuotaInfos : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListQuotaInfos() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::ListQuotaInfosRequest, ::google::api::cloudquotas::v1::ListQuotaInfosResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* request, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* response) { return this->ListQuotaInfos(context, request, response); }));}
    void SetMessageAllocatorFor_ListQuotaInfos(
        ::grpc::MessageAllocator< ::google::api::cloudquotas::v1::ListQuotaInfosRequest, ::google::api::cloudquotas::v1::ListQuotaInfosResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::ListQuotaInfosRequest, ::google::api::cloudquotas::v1::ListQuotaInfosResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListQuotaInfos() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListQuotaInfos(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListQuotaInfos(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetQuotaInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetQuotaInfo() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::GetQuotaInfoRequest, ::google::api::cloudquotas::v1::QuotaInfo>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* request, ::google::api::cloudquotas::v1::QuotaInfo* response) { return this->GetQuotaInfo(context, request, response); }));}
    void SetMessageAllocatorFor_GetQuotaInfo(
        ::grpc::MessageAllocator< ::google::api::cloudquotas::v1::GetQuotaInfoRequest, ::google::api::cloudquotas::v1::QuotaInfo>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::GetQuotaInfoRequest, ::google::api::cloudquotas::v1::QuotaInfo>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetQuotaInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQuotaInfo(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaInfo* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetQuotaInfo(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaInfo* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListQuotaPreferences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListQuotaPreferences() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* request, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* response) { return this->ListQuotaPreferences(context, request, response); }));}
    void SetMessageAllocatorFor_ListQuotaPreferences(
        ::grpc::MessageAllocator< ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListQuotaPreferences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListQuotaPreferences(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListQuotaPreferences(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetQuotaPreference() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response) { return this->GetQuotaPreference(context, request, response); }));}
    void SetMessageAllocatorFor_GetQuotaPreference(
        ::grpc::MessageAllocator< ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetQuotaPreference(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateQuotaPreference() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response) { return this->CreateQuotaPreference(context, request, response); }));}
    void SetMessageAllocatorFor_CreateQuotaPreference(
        ::grpc::MessageAllocator< ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateQuotaPreference(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateQuotaPreference() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* request, ::google::api::cloudquotas::v1::QuotaPreference* response) { return this->UpdateQuotaPreference(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateQuotaPreference(
        ::grpc::MessageAllocator< ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateQuotaPreference(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListQuotaInfos<WithCallbackMethod_GetQuotaInfo<WithCallbackMethod_ListQuotaPreferences<WithCallbackMethod_GetQuotaPreference<WithCallbackMethod_CreateQuotaPreference<WithCallbackMethod_UpdateQuotaPreference<Service > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListQuotaInfos : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListQuotaInfos() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListQuotaInfos() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListQuotaInfos(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetQuotaInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetQuotaInfo() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetQuotaInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQuotaInfo(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaInfo* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListQuotaPreferences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListQuotaPreferences() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListQuotaPreferences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListQuotaPreferences(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetQuotaPreference() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateQuotaPreference() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_CreateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateQuotaPreference() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_UpdateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListQuotaInfos : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListQuotaInfos() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListQuotaInfos() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListQuotaInfos(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListQuotaInfos(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetQuotaInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetQuotaInfo() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetQuotaInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQuotaInfo(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaInfo* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetQuotaInfo(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListQuotaPreferences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListQuotaPreferences() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListQuotaPreferences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListQuotaPreferences(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListQuotaPreferences(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetQuotaPreference() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetQuotaPreference(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateQuotaPreference() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_CreateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateQuotaPreference(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateQuotaPreference() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_UpdateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateQuotaPreference(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListQuotaInfos : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListQuotaInfos() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListQuotaInfos(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListQuotaInfos() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListQuotaInfos(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListQuotaInfos(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetQuotaInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetQuotaInfo() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetQuotaInfo(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetQuotaInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQuotaInfo(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaInfo* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetQuotaInfo(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListQuotaPreferences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListQuotaPreferences() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListQuotaPreferences(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListQuotaPreferences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListQuotaPreferences(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListQuotaPreferences(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetQuotaPreference() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetQuotaPreference(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetQuotaPreference(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateQuotaPreference() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateQuotaPreference(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateQuotaPreference(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateQuotaPreference() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateQuotaPreference(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateQuotaPreference(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListQuotaInfos : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListQuotaInfos() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::cloudquotas::v1::ListQuotaInfosRequest, ::google::api::cloudquotas::v1::ListQuotaInfosResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::cloudquotas::v1::ListQuotaInfosRequest, ::google::api::cloudquotas::v1::ListQuotaInfosResponse>* streamer) {
                       return this->StreamedListQuotaInfos(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListQuotaInfos() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListQuotaInfos(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaInfosRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaInfosResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListQuotaInfos(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::cloudquotas::v1::ListQuotaInfosRequest,::google::api::cloudquotas::v1::ListQuotaInfosResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetQuotaInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetQuotaInfo() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::cloudquotas::v1::GetQuotaInfoRequest, ::google::api::cloudquotas::v1::QuotaInfo>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::cloudquotas::v1::GetQuotaInfoRequest, ::google::api::cloudquotas::v1::QuotaInfo>* streamer) {
                       return this->StreamedGetQuotaInfo(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetQuotaInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetQuotaInfo(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaInfoRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaInfo* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetQuotaInfo(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::cloudquotas::v1::GetQuotaInfoRequest,::google::api::cloudquotas::v1::QuotaInfo>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListQuotaPreferences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListQuotaPreferences() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>* streamer) {
                       return this->StreamedListQuotaPreferences(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListQuotaPreferences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListQuotaPreferences(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest* /*request*/, ::google::api::cloudquotas::v1::ListQuotaPreferencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListQuotaPreferences(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::cloudquotas::v1::ListQuotaPreferencesRequest,::google::api::cloudquotas::v1::ListQuotaPreferencesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetQuotaPreference() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>* streamer) {
                       return this->StreamedGetQuotaPreference(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetQuotaPreference(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::cloudquotas::v1::GetQuotaPreferenceRequest,::google::api::cloudquotas::v1::QuotaPreference>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateQuotaPreference() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>* streamer) {
                       return this->StreamedCreateQuotaPreference(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateQuotaPreference(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::cloudquotas::v1::CreateQuotaPreferenceRequest,::google::api::cloudquotas::v1::QuotaPreference>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateQuotaPreference : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateQuotaPreference() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest, ::google::api::cloudquotas::v1::QuotaPreference>* streamer) {
                       return this->StreamedUpdateQuotaPreference(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateQuotaPreference() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateQuotaPreference(::grpc::ServerContext* /*context*/, const ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest* /*request*/, ::google::api::cloudquotas::v1::QuotaPreference* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateQuotaPreference(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest,::google::api::cloudquotas::v1::QuotaPreference>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListQuotaInfos<WithStreamedUnaryMethod_GetQuotaInfo<WithStreamedUnaryMethod_ListQuotaPreferences<WithStreamedUnaryMethod_GetQuotaPreference<WithStreamedUnaryMethod_CreateQuotaPreference<WithStreamedUnaryMethod_UpdateQuotaPreference<Service > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListQuotaInfos<WithStreamedUnaryMethod_GetQuotaInfo<WithStreamedUnaryMethod_ListQuotaPreferences<WithStreamedUnaryMethod_GetQuotaPreference<WithStreamedUnaryMethod_CreateQuotaPreference<WithStreamedUnaryMethod_UpdateQuotaPreference<Service > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace cloudquotas
}  // namespace api
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fapi_2fcloudquotas_2fv1_2fcloudquotas_2eproto__INCLUDED
