// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/api/servicecontrol/v1/quota_controller.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fapi_2fservicecontrol_2fv1_2fquota_5fcontroller_2eproto__INCLUDED
#define GRPC_google_2fapi_2fservicecontrol_2fv1_2fquota_5fcontroller_2eproto__INCLUDED

#include "google/api/servicecontrol/v1/quota_controller.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace api {
namespace servicecontrol {
namespace v1 {

// [Google Quota Control API](/service-control/overview)
//
// Allows clients to allocate and release quota against a [managed
// service](https://cloud.google.com/service-management/reference/rpc/google.api/servicemanagement.v1#google.api.servicemanagement.v1.ManagedService).
class QuotaController final {
 public:
  static constexpr char const* service_full_name() {
    return "google.api.servicecontrol.v1.QuotaController";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Attempts to allocate quota for the specified consumer. It should be called
    // before the operation is executed.
    //
    // This method requires the `servicemanagement.services.quota`
    // permission on the specified service. For more information, see
    // [Cloud IAM](https://cloud.google.com/iam).
    //
    // **NOTE:** The client **must** fail-open on server errors `INTERNAL`,
    // `UNKNOWN`, `DEADLINE_EXCEEDED`, and `UNAVAILABLE`. To ensure system
    // reliability, the server may inject these errors to prohibit any hard
    // dependency on the quota functionality.
    virtual ::grpc::Status AllocateQuota(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest& request, ::google::api::servicecontrol::v1::AllocateQuotaResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v1::AllocateQuotaResponse>> AsyncAllocateQuota(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v1::AllocateQuotaResponse>>(AsyncAllocateQuotaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v1::AllocateQuotaResponse>> PrepareAsyncAllocateQuota(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v1::AllocateQuotaResponse>>(PrepareAsyncAllocateQuotaRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Attempts to allocate quota for the specified consumer. It should be called
      // before the operation is executed.
      //
      // This method requires the `servicemanagement.services.quota`
      // permission on the specified service. For more information, see
      // [Cloud IAM](https://cloud.google.com/iam).
      //
      // **NOTE:** The client **must** fail-open on server errors `INTERNAL`,
      // `UNKNOWN`, `DEADLINE_EXCEEDED`, and `UNAVAILABLE`. To ensure system
      // reliability, the server may inject these errors to prohibit any hard
      // dependency on the quota functionality.
      virtual void AllocateQuota(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* request, ::google::api::servicecontrol::v1::AllocateQuotaResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AllocateQuota(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* request, ::google::api::servicecontrol::v1::AllocateQuotaResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v1::AllocateQuotaResponse>* AsyncAllocateQuotaRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v1::AllocateQuotaResponse>* PrepareAsyncAllocateQuotaRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status AllocateQuota(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest& request, ::google::api::servicecontrol::v1::AllocateQuotaResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v1::AllocateQuotaResponse>> AsyncAllocateQuota(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v1::AllocateQuotaResponse>>(AsyncAllocateQuotaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v1::AllocateQuotaResponse>> PrepareAsyncAllocateQuota(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v1::AllocateQuotaResponse>>(PrepareAsyncAllocateQuotaRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void AllocateQuota(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* request, ::google::api::servicecontrol::v1::AllocateQuotaResponse* response, std::function<void(::grpc::Status)>) override;
      void AllocateQuota(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* request, ::google::api::servicecontrol::v1::AllocateQuotaResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v1::AllocateQuotaResponse>* AsyncAllocateQuotaRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v1::AllocateQuotaResponse>* PrepareAsyncAllocateQuotaRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_AllocateQuota_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Attempts to allocate quota for the specified consumer. It should be called
    // before the operation is executed.
    //
    // This method requires the `servicemanagement.services.quota`
    // permission on the specified service. For more information, see
    // [Cloud IAM](https://cloud.google.com/iam).
    //
    // **NOTE:** The client **must** fail-open on server errors `INTERNAL`,
    // `UNKNOWN`, `DEADLINE_EXCEEDED`, and `UNAVAILABLE`. To ensure system
    // reliability, the server may inject these errors to prohibit any hard
    // dependency on the quota functionality.
    virtual ::grpc::Status AllocateQuota(::grpc::ServerContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* request, ::google::api::servicecontrol::v1::AllocateQuotaResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_AllocateQuota : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AllocateQuota() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_AllocateQuota() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AllocateQuota(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* /*request*/, ::google::api::servicecontrol::v1::AllocateQuotaResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAllocateQuota(::grpc::ServerContext* context, ::google::api::servicecontrol::v1::AllocateQuotaRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::servicecontrol::v1::AllocateQuotaResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_AllocateQuota<Service > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_AllocateQuota : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AllocateQuota() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicecontrol::v1::AllocateQuotaRequest, ::google::api::servicecontrol::v1::AllocateQuotaResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* request, ::google::api::servicecontrol::v1::AllocateQuotaResponse* response) { return this->AllocateQuota(context, request, response); }));}
    void SetMessageAllocatorFor_AllocateQuota(
        ::grpc::MessageAllocator< ::google::api::servicecontrol::v1::AllocateQuotaRequest, ::google::api::servicecontrol::v1::AllocateQuotaResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicecontrol::v1::AllocateQuotaRequest, ::google::api::servicecontrol::v1::AllocateQuotaResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AllocateQuota() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AllocateQuota(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* /*request*/, ::google::api::servicecontrol::v1::AllocateQuotaResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AllocateQuota(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* /*request*/, ::google::api::servicecontrol::v1::AllocateQuotaResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_AllocateQuota<Service > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_AllocateQuota : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AllocateQuota() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_AllocateQuota() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AllocateQuota(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* /*request*/, ::google::api::servicecontrol::v1::AllocateQuotaResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_AllocateQuota : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AllocateQuota() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_AllocateQuota() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AllocateQuota(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* /*request*/, ::google::api::servicecontrol::v1::AllocateQuotaResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAllocateQuota(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AllocateQuota : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AllocateQuota() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AllocateQuota(context, request, response); }));
    }
    ~WithRawCallbackMethod_AllocateQuota() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AllocateQuota(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* /*request*/, ::google::api::servicecontrol::v1::AllocateQuotaResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AllocateQuota(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AllocateQuota : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AllocateQuota() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicecontrol::v1::AllocateQuotaRequest, ::google::api::servicecontrol::v1::AllocateQuotaResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicecontrol::v1::AllocateQuotaRequest, ::google::api::servicecontrol::v1::AllocateQuotaResponse>* streamer) {
                       return this->StreamedAllocateQuota(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AllocateQuota() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AllocateQuota(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v1::AllocateQuotaRequest* /*request*/, ::google::api::servicecontrol::v1::AllocateQuotaResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAllocateQuota(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicecontrol::v1::AllocateQuotaRequest,::google::api::servicecontrol::v1::AllocateQuotaResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_AllocateQuota<Service > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_AllocateQuota<Service > StreamedService;
};

}  // namespace v1
}  // namespace servicecontrol
}  // namespace api
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fapi_2fservicecontrol_2fv1_2fquota_5fcontroller_2eproto__INCLUDED
