// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/automl/v1/prediction_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fautoml_2fv1_2fprediction_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fautoml_2fv1_2fprediction_5fservice_2eproto__INCLUDED

#include "google/cloud/automl/v1/prediction_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace automl {
namespace v1 {

// AutoML Prediction API.
//
// On any input that is documented to expect a string parameter in
// snake_case or dash-case, either of those cases is accepted.
class PredictionService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.automl.v1.PredictionService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Perform an online prediction. The prediction result is directly
    // returned in the response.
    // Available for following ML scenarios, and their expected request payloads:
    //
    // AutoML Vision Classification
    //
    // * An image in .JPEG, .GIF or .PNG format, image_bytes up to 30MB.
    //
    // AutoML Vision Object Detection
    //
    // * An image in .JPEG, .GIF or .PNG format, image_bytes up to 30MB.
    //
    // AutoML Natural Language Classification
    //
    // * A TextSnippet up to 60,000 characters, UTF-8 encoded or a document in
    // .PDF, .TIF or .TIFF format with size upto 2MB.
    //
    // AutoML Natural Language Entity Extraction
    //
    // * A TextSnippet up to 10,000 characters, UTF-8 NFC encoded or a document
    //  in .PDF, .TIF or .TIFF format with size upto 20MB.
    //
    // AutoML Natural Language Sentiment Analysis
    //
    // * A TextSnippet up to 60,000 characters, UTF-8 encoded or a document in
    // .PDF, .TIF or .TIFF format with size upto 2MB.
    //
    // AutoML Translation
    //
    // * A TextSnippet up to 25,000 characters, UTF-8 encoded.
    //
    // AutoML Tables
    //
    // * A row with column values matching
    //   the columns of the model, up to 5MB. Not available for FORECASTING
    //   `prediction_type`.
    virtual ::grpc::Status Predict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest& request, ::google::cloud::automl::v1::PredictResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::PredictResponse>> AsyncPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::PredictResponse>>(AsyncPredictRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::PredictResponse>> PrepareAsyncPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::PredictResponse>>(PrepareAsyncPredictRaw(context, request, cq));
    }
    // Perform a batch prediction. Unlike the online [Predict][google.cloud.automl.v1.PredictionService.Predict], batch
    // prediction result won't be immediately available in the response. Instead,
    // a long running operation object is returned. User can poll the operation
    // result via [GetOperation][google.longrunning.Operations.GetOperation]
    // method. Once the operation is done, [BatchPredictResult][google.cloud.automl.v1.BatchPredictResult] is returned in
    // the [response][google.longrunning.Operation.response] field.
    // Available for following ML scenarios:
    //
    // * AutoML Vision Classification
    // * AutoML Vision Object Detection
    // * AutoML Video Intelligence Classification
    // * AutoML Video Intelligence Object Tracking * AutoML Natural Language Classification
    // * AutoML Natural Language Entity Extraction
    // * AutoML Natural Language Sentiment Analysis
    // * AutoML Tables
    virtual ::grpc::Status BatchPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchPredictRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchPredictRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Perform an online prediction. The prediction result is directly
      // returned in the response.
      // Available for following ML scenarios, and their expected request payloads:
      //
      // AutoML Vision Classification
      //
      // * An image in .JPEG, .GIF or .PNG format, image_bytes up to 30MB.
      //
      // AutoML Vision Object Detection
      //
      // * An image in .JPEG, .GIF or .PNG format, image_bytes up to 30MB.
      //
      // AutoML Natural Language Classification
      //
      // * A TextSnippet up to 60,000 characters, UTF-8 encoded or a document in
      // .PDF, .TIF or .TIFF format with size upto 2MB.
      //
      // AutoML Natural Language Entity Extraction
      //
      // * A TextSnippet up to 10,000 characters, UTF-8 NFC encoded or a document
      //  in .PDF, .TIF or .TIFF format with size upto 20MB.
      //
      // AutoML Natural Language Sentiment Analysis
      //
      // * A TextSnippet up to 60,000 characters, UTF-8 encoded or a document in
      // .PDF, .TIF or .TIFF format with size upto 2MB.
      //
      // AutoML Translation
      //
      // * A TextSnippet up to 25,000 characters, UTF-8 encoded.
      //
      // AutoML Tables
      //
      // * A row with column values matching
      //   the columns of the model, up to 5MB. Not available for FORECASTING
      //   `prediction_type`.
      virtual void Predict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest* request, ::google::cloud::automl::v1::PredictResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Predict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest* request, ::google::cloud::automl::v1::PredictResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Perform a batch prediction. Unlike the online [Predict][google.cloud.automl.v1.PredictionService.Predict], batch
      // prediction result won't be immediately available in the response. Instead,
      // a long running operation object is returned. User can poll the operation
      // result via [GetOperation][google.longrunning.Operations.GetOperation]
      // method. Once the operation is done, [BatchPredictResult][google.cloud.automl.v1.BatchPredictResult] is returned in
      // the [response][google.longrunning.Operation.response] field.
      // Available for following ML scenarios:
      //
      // * AutoML Vision Classification
      // * AutoML Vision Object Detection
      // * AutoML Video Intelligence Classification
      // * AutoML Video Intelligence Object Tracking * AutoML Natural Language Classification
      // * AutoML Natural Language Entity Extraction
      // * AutoML Natural Language Sentiment Analysis
      // * AutoML Tables
      virtual void BatchPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::PredictResponse>* AsyncPredictRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::PredictResponse>* PrepareAsyncPredictRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchPredictRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchPredictRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status Predict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest& request, ::google::cloud::automl::v1::PredictResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::PredictResponse>> AsyncPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::PredictResponse>>(AsyncPredictRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::PredictResponse>> PrepareAsyncPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::PredictResponse>>(PrepareAsyncPredictRaw(context, request, cq));
    }
    ::grpc::Status BatchPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchPredictRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchPredictRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void Predict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest* request, ::google::cloud::automl::v1::PredictResponse* response, std::function<void(::grpc::Status)>) override;
      void Predict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest* request, ::google::cloud::automl::v1::PredictResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchPredict(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::PredictResponse>* AsyncPredictRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::PredictResponse>* PrepareAsyncPredictRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchPredictRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchPredictRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::BatchPredictRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_Predict_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchPredict_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Perform an online prediction. The prediction result is directly
    // returned in the response.
    // Available for following ML scenarios, and their expected request payloads:
    //
    // AutoML Vision Classification
    //
    // * An image in .JPEG, .GIF or .PNG format, image_bytes up to 30MB.
    //
    // AutoML Vision Object Detection
    //
    // * An image in .JPEG, .GIF or .PNG format, image_bytes up to 30MB.
    //
    // AutoML Natural Language Classification
    //
    // * A TextSnippet up to 60,000 characters, UTF-8 encoded or a document in
    // .PDF, .TIF or .TIFF format with size upto 2MB.
    //
    // AutoML Natural Language Entity Extraction
    //
    // * A TextSnippet up to 10,000 characters, UTF-8 NFC encoded or a document
    //  in .PDF, .TIF or .TIFF format with size upto 20MB.
    //
    // AutoML Natural Language Sentiment Analysis
    //
    // * A TextSnippet up to 60,000 characters, UTF-8 encoded or a document in
    // .PDF, .TIF or .TIFF format with size upto 2MB.
    //
    // AutoML Translation
    //
    // * A TextSnippet up to 25,000 characters, UTF-8 encoded.
    //
    // AutoML Tables
    //
    // * A row with column values matching
    //   the columns of the model, up to 5MB. Not available for FORECASTING
    //   `prediction_type`.
    virtual ::grpc::Status Predict(::grpc::ServerContext* context, const ::google::cloud::automl::v1::PredictRequest* request, ::google::cloud::automl::v1::PredictResponse* response);
    // Perform a batch prediction. Unlike the online [Predict][google.cloud.automl.v1.PredictionService.Predict], batch
    // prediction result won't be immediately available in the response. Instead,
    // a long running operation object is returned. User can poll the operation
    // result via [GetOperation][google.longrunning.Operations.GetOperation]
    // method. Once the operation is done, [BatchPredictResult][google.cloud.automl.v1.BatchPredictResult] is returned in
    // the [response][google.longrunning.Operation.response] field.
    // Available for following ML scenarios:
    //
    // * AutoML Vision Classification
    // * AutoML Vision Object Detection
    // * AutoML Video Intelligence Classification
    // * AutoML Video Intelligence Object Tracking * AutoML Natural Language Classification
    // * AutoML Natural Language Entity Extraction
    // * AutoML Natural Language Sentiment Analysis
    // * AutoML Tables
    virtual ::grpc::Status BatchPredict(::grpc::ServerContext* context, const ::google::cloud::automl::v1::BatchPredictRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Predict() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::PredictRequest* /*request*/, ::google::cloud::automl::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPredict(::grpc::ServerContext* context, ::google::cloud::automl::v1::PredictRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::automl::v1::PredictResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchPredict() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_BatchPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::BatchPredictRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchPredict(::grpc::ServerContext* context, ::google::cloud::automl::v1::BatchPredictRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_Predict<WithAsyncMethod_BatchPredict<Service > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Predict() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::PredictRequest, ::google::cloud::automl::v1::PredictResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::PredictRequest* request, ::google::cloud::automl::v1::PredictResponse* response) { return this->Predict(context, request, response); }));}
    void SetMessageAllocatorFor_Predict(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::PredictRequest, ::google::cloud::automl::v1::PredictResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::PredictRequest, ::google::cloud::automl::v1::PredictResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::PredictRequest* /*request*/, ::google::cloud::automl::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Predict(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::PredictRequest* /*request*/, ::google::cloud::automl::v1::PredictResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchPredict() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::BatchPredictRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::BatchPredictRequest* request, ::google::longrunning::Operation* response) { return this->BatchPredict(context, request, response); }));}
    void SetMessageAllocatorFor_BatchPredict(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::BatchPredictRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::BatchPredictRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::BatchPredictRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchPredict(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::BatchPredictRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_Predict<WithCallbackMethod_BatchPredict<Service > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Predict() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::PredictRequest* /*request*/, ::google::cloud::automl::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchPredict() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_BatchPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::BatchPredictRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Predict() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::PredictRequest* /*request*/, ::google::cloud::automl::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPredict(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchPredict() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_BatchPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::BatchPredictRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchPredict(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Predict() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Predict(context, request, response); }));
    }
    ~WithRawCallbackMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::PredictRequest* /*request*/, ::google::cloud::automl::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Predict(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchPredict() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchPredict(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::BatchPredictRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchPredict(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Predict() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::PredictRequest, ::google::cloud::automl::v1::PredictResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::PredictRequest, ::google::cloud::automl::v1::PredictResponse>* streamer) {
                       return this->StreamedPredict(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::PredictRequest* /*request*/, ::google::cloud::automl::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPredict(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::PredictRequest,::google::cloud::automl::v1::PredictResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchPredict() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::BatchPredictRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::BatchPredictRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchPredict(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::BatchPredictRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchPredict(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::BatchPredictRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_Predict<WithStreamedUnaryMethod_BatchPredict<Service > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_Predict<WithStreamedUnaryMethod_BatchPredict<Service > > StreamedService;
};

}  // namespace v1
}  // namespace automl
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fautoml_2fv1_2fprediction_5fservice_2eproto__INCLUDED
