// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/license_codes/v1/license_codes.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_LICENSE_CODES_V1_INTERNAL_LICENSE_CODES_REST_CONNECTION_IMPL_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_LICENSE_CODES_V1_INTERNAL_LICENSE_CODES_REST_CONNECTION_IMPL_H

#include "google/cloud/compute/license_codes/v1/internal/license_codes_rest_stub.h"
#include "google/cloud/compute/license_codes/v1/internal/license_codes_retry_traits.h"
#include "google/cloud/compute/license_codes/v1/license_codes_connection.h"
#include "google/cloud/compute/license_codes/v1/license_codes_connection_idempotency_policy.h"
#include "google/cloud/compute/license_codes/v1/license_codes_options.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_license_codes_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class LicenseCodesRestConnectionImpl
    : public compute_license_codes_v1::LicenseCodesConnection {
 public:
  ~LicenseCodesRestConnectionImpl() override = default;

  LicenseCodesRestConnectionImpl(
      std::unique_ptr<google::cloud::BackgroundThreads> background,
      std::shared_ptr<compute_license_codes_v1_internal::LicenseCodesRestStub>
          stub,
      Options options);

  Options options() override { return options_; }

  StatusOr<google::cloud::cpp::compute::v1::LicenseCode> GetLicenseCode(
      google::cloud::cpp::compute::license_codes::v1::
          GetLicenseCodeRequest const& request) override;

  StatusOr<google::cloud::cpp::compute::v1::TestPermissionsResponse>
  TestIamPermissions(google::cloud::cpp::compute::license_codes::v1::
                         TestIamPermissionsRequest const& request) override;

 private:
  static std::unique_ptr<compute_license_codes_v1::LicenseCodesRetryPolicy>
  retry_policy(Options const& options) {
    return options
        .get<compute_license_codes_v1::LicenseCodesRetryPolicyOption>()
        ->clone();
  }

  static std::unique_ptr<BackoffPolicy> backoff_policy(Options const& options) {
    return options
        .get<compute_license_codes_v1::LicenseCodesBackoffPolicyOption>()
        ->clone();
  }

  static std::unique_ptr<
      compute_license_codes_v1::LicenseCodesConnectionIdempotencyPolicy>
  idempotency_policy(Options const& options) {
    return options
        .get<compute_license_codes_v1::
                 LicenseCodesConnectionIdempotencyPolicyOption>()
        ->clone();
  }

  std::unique_ptr<google::cloud::BackgroundThreads> background_;
  std::shared_ptr<compute_license_codes_v1_internal::LicenseCodesRestStub>
      stub_;
  Options options_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_license_codes_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_LICENSE_CODES_V1_INTERNAL_LICENSE_CODES_REST_CONNECTION_IMPL_H
