// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/cx/v3/test_case.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_CX_INTERNAL_TEST_CASES_STUB_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_CX_INTERNAL_TEST_CASES_STUB_H

#include "google/cloud/completion_queue.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/dialogflow/cx/v3/test_case.grpc.pb.h>
#include <google/cloud/location/locations.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace dialogflow_cx_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class TestCasesStub {
 public:
  virtual ~TestCasesStub() = 0;

  virtual StatusOr<google::cloud::dialogflow::cx::v3::ListTestCasesResponse>
  ListTestCases(grpc::ClientContext& context, Options const& options,
                google::cloud::dialogflow::cx::v3::ListTestCasesRequest const&
                    request) = 0;

  virtual Status BatchDeleteTestCases(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::BatchDeleteTestCasesRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::dialogflow::cx::v3::TestCase> GetTestCase(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::GetTestCaseRequest const& request) = 0;

  virtual StatusOr<google::cloud::dialogflow::cx::v3::TestCase> CreateTestCase(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::CreateTestCaseRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::dialogflow::cx::v3::TestCase> UpdateTestCase(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::UpdateTestCaseRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncRunTestCase(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::cx::v3::RunTestCaseRequest const& request) = 0;

  virtual StatusOr<google::longrunning::Operation> RunTestCase(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::cx::v3::RunTestCaseRequest const& request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>>
  AsyncBatchRunTestCases(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::cx::v3::BatchRunTestCasesRequest const&
          request) = 0;

  virtual StatusOr<google::longrunning::Operation> BatchRunTestCases(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::cx::v3::BatchRunTestCasesRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::dialogflow::cx::v3::CalculateCoverageResponse>
  CalculateCoverage(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::CalculateCoverageRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncImportTestCases(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::cx::v3::ImportTestCasesRequest const&
          request) = 0;

  virtual StatusOr<google::longrunning::Operation> ImportTestCases(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::cx::v3::ImportTestCasesRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncExportTestCases(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::cx::v3::ExportTestCasesRequest const&
          request) = 0;

  virtual StatusOr<google::longrunning::Operation> ExportTestCases(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::cx::v3::ExportTestCasesRequest const&
          request) = 0;

  virtual StatusOr<
      google::cloud::dialogflow::cx::v3::ListTestCaseResultsResponse>
  ListTestCaseResults(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::ListTestCaseResultsRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::dialogflow::cx::v3::TestCaseResult>
  GetTestCaseResult(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::GetTestCaseResultRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::location::ListLocationsResponse>
  ListLocations(
      grpc::ClientContext& context, Options const& options,
      google::cloud::location::ListLocationsRequest const& request) = 0;

  virtual StatusOr<google::cloud::location::Location> GetLocation(
      grpc::ClientContext& context, Options const& options,
      google::cloud::location::GetLocationRequest const& request) = 0;

  virtual StatusOr<google::longrunning::ListOperationsResponse> ListOperations(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::ListOperationsRequest const& request) = 0;

  virtual StatusOr<google::longrunning::Operation> GetOperation(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::GetOperationRequest const& request) = 0;

  virtual Status CancelOperation(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::CancelOperationRequest const& request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::GetOperationRequest const& request) = 0;

  virtual future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::CancelOperationRequest const& request) = 0;
};

class DefaultTestCasesStub : public TestCasesStub {
 public:
  DefaultTestCasesStub(
      std::unique_ptr<
          google::cloud::dialogflow::cx::v3::TestCases::StubInterface>
          grpc_stub,
      std::unique_ptr<google::cloud::location::Locations::StubInterface>
          locations_stub,
      std::unique_ptr<google::longrunning::Operations::StubInterface>
          operations_stub)
      : grpc_stub_(std::move(grpc_stub)),
        locations_stub_(std::move(locations_stub)),
        operations_stub_(std::move(operations_stub)) {}

  StatusOr<google::cloud::dialogflow::cx::v3::ListTestCasesResponse>
  ListTestCases(grpc::ClientContext& context, Options const& options,
                google::cloud::dialogflow::cx::v3::ListTestCasesRequest const&
                    request) override;

  Status BatchDeleteTestCases(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::BatchDeleteTestCasesRequest const&
          request) override;

  StatusOr<google::cloud::dialogflow::cx::v3::TestCase> GetTestCase(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::GetTestCaseRequest const& request)
      override;

  StatusOr<google::cloud::dialogflow::cx::v3::TestCase> CreateTestCase(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::CreateTestCaseRequest const& request)
      override;

  StatusOr<google::cloud::dialogflow::cx::v3::TestCase> UpdateTestCase(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::UpdateTestCaseRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncRunTestCase(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::cx::v3::RunTestCaseRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> RunTestCase(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::cx::v3::RunTestCaseRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncBatchRunTestCases(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::cx::v3::BatchRunTestCasesRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> BatchRunTestCases(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::cx::v3::BatchRunTestCasesRequest const&
          request) override;

  StatusOr<google::cloud::dialogflow::cx::v3::CalculateCoverageResponse>
  CalculateCoverage(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::CalculateCoverageRequest const&
          request) override;

  future<StatusOr<google::longrunning::Operation>> AsyncImportTestCases(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::cx::v3::ImportTestCasesRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> ImportTestCases(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::cx::v3::ImportTestCasesRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncExportTestCases(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::cx::v3::ExportTestCasesRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> ExportTestCases(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::cx::v3::ExportTestCasesRequest const& request)
      override;

  StatusOr<google::cloud::dialogflow::cx::v3::ListTestCaseResultsResponse>
  ListTestCaseResults(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::ListTestCaseResultsRequest const&
          request) override;

  StatusOr<google::cloud::dialogflow::cx::v3::TestCaseResult> GetTestCaseResult(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::cx::v3::GetTestCaseResultRequest const&
          request) override;

  StatusOr<google::cloud::location::ListLocationsResponse> ListLocations(
      grpc::ClientContext& context, Options const& options,
      google::cloud::location::ListLocationsRequest const& request) override;

  StatusOr<google::cloud::location::Location> GetLocation(
      grpc::ClientContext& context, Options const& options,
      google::cloud::location::GetLocationRequest const& request) override;

  StatusOr<google::longrunning::ListOperationsResponse> ListOperations(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::ListOperationsRequest const& request) override;

  StatusOr<google::longrunning::Operation> GetOperation(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::GetOperationRequest const& request) override;

  Status CancelOperation(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::CancelOperationRequest const& request) override;

  future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::GetOperationRequest const& request) override;

  future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::CancelOperationRequest const& request) override;

 private:
  std::unique_ptr<google::cloud::dialogflow::cx::v3::TestCases::StubInterface>
      grpc_stub_;
  std::unique_ptr<google::cloud::location::Locations::StubInterface>
      locations_stub_;
  std::unique_ptr<google::longrunning::Operations::StubInterface>
      operations_stub_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_cx_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_CX_INTERNAL_TEST_CASES_STUB_H
