// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/discoveryengine/v1/grounded_generation_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_GROUNDED_GENERATION_CONNECTION_IMPL_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_GROUNDED_GENERATION_CONNECTION_IMPL_H

#include "google/cloud/discoveryengine/v1/grounded_generation_connection.h"
#include "google/cloud/discoveryengine/v1/grounded_generation_connection_idempotency_policy.h"
#include "google/cloud/discoveryengine/v1/grounded_generation_options.h"
#include "google/cloud/discoveryengine/v1/internal/grounded_generation_retry_traits.h"
#include "google/cloud/discoveryengine/v1/internal/grounded_generation_stub.h"
#include "google/cloud/async_streaming_read_write_rpc.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <memory>

namespace google {
namespace cloud {
namespace discoveryengine_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class GroundedGenerationServiceConnectionImpl
    : public discoveryengine_v1::GroundedGenerationServiceConnection {
 public:
  ~GroundedGenerationServiceConnectionImpl() override = default;

  GroundedGenerationServiceConnectionImpl(
      std::unique_ptr<google::cloud::BackgroundThreads> background,
      std::shared_ptr<
          discoveryengine_v1_internal::GroundedGenerationServiceStub>
          stub,
      Options options);

  Options options() override { return options_; }

  std::unique_ptr<::google::cloud::AsyncStreamingReadWriteRpc<
      google::cloud::discoveryengine::v1::GenerateGroundedContentRequest,
      google::cloud::discoveryengine::v1::GenerateGroundedContentResponse>>
  AsyncStreamGenerateGroundedContent() override;

  StatusOr<google::cloud::discoveryengine::v1::GenerateGroundedContentResponse>
  GenerateGroundedContent(
      google::cloud::discoveryengine::v1::GenerateGroundedContentRequest const&
          request) override;

  StatusOr<google::cloud::discoveryengine::v1::CheckGroundingResponse>
  CheckGrounding(
      google::cloud::discoveryengine::v1::CheckGroundingRequest const& request)
      override;

  StreamRange<google::longrunning::Operation> ListOperations(
      google::longrunning::ListOperationsRequest request) override;

  StatusOr<google::longrunning::Operation> GetOperation(
      google::longrunning::GetOperationRequest const& request) override;

  Status CancelOperation(
      google::longrunning::CancelOperationRequest const& request) override;

 private:
  std::unique_ptr<google::cloud::BackgroundThreads> background_;
  std::shared_ptr<discoveryengine_v1_internal::GroundedGenerationServiceStub>
      stub_;
  Options options_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace discoveryengine_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_GROUNDED_GENERATION_CONNECTION_IMPL_H
