// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/eventarc/publishing/v1/publisher.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2feventarc_2fpublishing_2fv1_2fpublisher_2eproto__INCLUDED
#define GRPC_google_2fcloud_2feventarc_2fpublishing_2fv1_2fpublisher_2eproto__INCLUDED

#include "google/cloud/eventarc/publishing/v1/publisher.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace eventarc {
namespace publishing {
namespace v1 {

// Eventarc processes events generated by an event provider and delivers them to
// a subscriber.
//
// An event provider is a software-as-a-service (SaaS) system or
// product that can generate and deliver events through Eventarc.
//
// A third-party event provider is an event provider from outside of Google.
//
// A partner is a third-party event provider that is integrated with Eventarc.
//
// A subscriber is a GCP customer interested in receiving events.
//
// Channel is a first-class Eventarc resource that is created and managed
// by the subscriber in their GCP project. A Channel represents a subscriber's
// intent to receive events from an event provider. A Channel is associated with
// exactly one event provider.
//
// ChannelConnection is a first-class Eventarc resource that
// is created and managed by the partner in their GCP project. A
// ChannelConnection represents a connection between a partner and a
// subscriber's Channel. A ChannelConnection has a one-to-one mapping with a
// Channel.
//
// Publisher allows an event provider to publish events to Eventarc.
class Publisher final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.eventarc.publishing.v1.Publisher";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Publish events to a ChannelConnection in a partner's project.
    virtual ::grpc::Status PublishChannelConnectionEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest& request, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>> AsyncPublishChannelConnectionEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>>(AsyncPublishChannelConnectionEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>> PrepareAsyncPublishChannelConnectionEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>>(PrepareAsyncPublishChannelConnectionEventsRaw(context, request, cq));
    }
    // Publish events to a subscriber's channel.
    virtual ::grpc::Status PublishEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest& request, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>> AsyncPublishEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>>(AsyncPublishEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>> PrepareAsyncPublishEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>>(PrepareAsyncPublishEventsRaw(context, request, cq));
    }
    // Publish events to a message bus.
    virtual ::grpc::Status Publish(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest& request, ::google::cloud::eventarc::publishing::v1::PublishResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishResponse>> AsyncPublish(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishResponse>>(AsyncPublishRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishResponse>> PrepareAsyncPublish(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishResponse>>(PrepareAsyncPublishRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Publish events to a ChannelConnection in a partner's project.
      virtual void PublishChannelConnectionEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PublishChannelConnectionEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Publish events to a subscriber's channel.
      virtual void PublishEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PublishEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Publish events to a message bus.
      virtual void Publish(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest* request, ::google::cloud::eventarc::publishing::v1::PublishResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Publish(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest* request, ::google::cloud::eventarc::publishing::v1::PublishResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>* AsyncPublishChannelConnectionEventsRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>* PrepareAsyncPublishChannelConnectionEventsRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>* AsyncPublishEventsRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>* PrepareAsyncPublishEventsRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishResponse>* AsyncPublishRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::eventarc::publishing::v1::PublishResponse>* PrepareAsyncPublishRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status PublishChannelConnectionEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest& request, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>> AsyncPublishChannelConnectionEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>>(AsyncPublishChannelConnectionEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>> PrepareAsyncPublishChannelConnectionEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>>(PrepareAsyncPublishChannelConnectionEventsRaw(context, request, cq));
    }
    ::grpc::Status PublishEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest& request, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>> AsyncPublishEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>>(AsyncPublishEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>> PrepareAsyncPublishEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>>(PrepareAsyncPublishEventsRaw(context, request, cq));
    }
    ::grpc::Status Publish(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest& request, ::google::cloud::eventarc::publishing::v1::PublishResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishResponse>> AsyncPublish(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishResponse>>(AsyncPublishRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishResponse>> PrepareAsyncPublish(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishResponse>>(PrepareAsyncPublishRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void PublishChannelConnectionEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* response, std::function<void(::grpc::Status)>) override;
      void PublishChannelConnectionEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void PublishEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* response, std::function<void(::grpc::Status)>) override;
      void PublishEvents(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Publish(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest* request, ::google::cloud::eventarc::publishing::v1::PublishResponse* response, std::function<void(::grpc::Status)>) override;
      void Publish(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest* request, ::google::cloud::eventarc::publishing::v1::PublishResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>* AsyncPublishChannelConnectionEventsRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>* PrepareAsyncPublishChannelConnectionEventsRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>* AsyncPublishEventsRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>* PrepareAsyncPublishEventsRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishResponse>* AsyncPublishRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::eventarc::publishing::v1::PublishResponse>* PrepareAsyncPublishRaw(::grpc::ClientContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_PublishChannelConnectionEvents_;
    const ::grpc::internal::RpcMethod rpcmethod_PublishEvents_;
    const ::grpc::internal::RpcMethod rpcmethod_Publish_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Publish events to a ChannelConnection in a partner's project.
    virtual ::grpc::Status PublishChannelConnectionEvents(::grpc::ServerContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* response);
    // Publish events to a subscriber's channel.
    virtual ::grpc::Status PublishEvents(::grpc::ServerContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* response);
    // Publish events to a message bus.
    virtual ::grpc::Status Publish(::grpc::ServerContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest* request, ::google::cloud::eventarc::publishing::v1::PublishResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_PublishChannelConnectionEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PublishChannelConnectionEvents() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_PublishChannelConnectionEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PublishChannelConnectionEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPublishChannelConnectionEvents(::grpc::ServerContext* context, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_PublishEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PublishEvents() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_PublishEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PublishEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPublishEvents(::grpc::ServerContext* context, ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Publish : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Publish() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_Publish() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Publish(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPublish(::grpc::ServerContext* context, ::google::cloud::eventarc::publishing::v1::PublishRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::eventarc::publishing::v1::PublishResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_PublishChannelConnectionEvents<WithAsyncMethod_PublishEvents<WithAsyncMethod_Publish<Service > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_PublishChannelConnectionEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PublishChannelConnectionEvents() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* response) { return this->PublishChannelConnectionEvents(context, request, response); }));}
    void SetMessageAllocatorFor_PublishChannelConnectionEvents(
        ::grpc::MessageAllocator< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PublishChannelConnectionEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PublishChannelConnectionEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PublishChannelConnectionEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_PublishEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PublishEvents() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::eventarc::publishing::v1::PublishEventsRequest, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* request, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* response) { return this->PublishEvents(context, request, response); }));}
    void SetMessageAllocatorFor_PublishEvents(
        ::grpc::MessageAllocator< ::google::cloud::eventarc::publishing::v1::PublishEventsRequest, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::eventarc::publishing::v1::PublishEventsRequest, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PublishEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PublishEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PublishEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Publish : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Publish() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::eventarc::publishing::v1::PublishRequest, ::google::cloud::eventarc::publishing::v1::PublishResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::eventarc::publishing::v1::PublishRequest* request, ::google::cloud::eventarc::publishing::v1::PublishResponse* response) { return this->Publish(context, request, response); }));}
    void SetMessageAllocatorFor_Publish(
        ::grpc::MessageAllocator< ::google::cloud::eventarc::publishing::v1::PublishRequest, ::google::cloud::eventarc::publishing::v1::PublishResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::eventarc::publishing::v1::PublishRequest, ::google::cloud::eventarc::publishing::v1::PublishResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Publish() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Publish(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Publish(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_PublishChannelConnectionEvents<WithCallbackMethod_PublishEvents<WithCallbackMethod_Publish<Service > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_PublishChannelConnectionEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PublishChannelConnectionEvents() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_PublishChannelConnectionEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PublishChannelConnectionEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_PublishEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PublishEvents() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_PublishEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PublishEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Publish : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Publish() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_Publish() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Publish(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_PublishChannelConnectionEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PublishChannelConnectionEvents() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_PublishChannelConnectionEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PublishChannelConnectionEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPublishChannelConnectionEvents(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_PublishEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PublishEvents() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_PublishEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PublishEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPublishEvents(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Publish : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Publish() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_Publish() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Publish(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPublish(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PublishChannelConnectionEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PublishChannelConnectionEvents() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PublishChannelConnectionEvents(context, request, response); }));
    }
    ~WithRawCallbackMethod_PublishChannelConnectionEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PublishChannelConnectionEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PublishChannelConnectionEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PublishEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PublishEvents() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PublishEvents(context, request, response); }));
    }
    ~WithRawCallbackMethod_PublishEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PublishEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PublishEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Publish : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Publish() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Publish(context, request, response); }));
    }
    ~WithRawCallbackMethod_Publish() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Publish(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Publish(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PublishChannelConnectionEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PublishChannelConnectionEvents() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>* streamer) {
                       return this->StreamedPublishChannelConnectionEvents(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PublishChannelConnectionEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PublishChannelConnectionEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPublishChannelConnectionEvents(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsRequest,::google::cloud::eventarc::publishing::v1::PublishChannelConnectionEventsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PublishEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PublishEvents() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::eventarc::publishing::v1::PublishEventsRequest, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::eventarc::publishing::v1::PublishEventsRequest, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse>* streamer) {
                       return this->StreamedPublishEvents(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PublishEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PublishEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishEventsRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPublishEvents(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::eventarc::publishing::v1::PublishEventsRequest,::google::cloud::eventarc::publishing::v1::PublishEventsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Publish : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Publish() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::eventarc::publishing::v1::PublishRequest, ::google::cloud::eventarc::publishing::v1::PublishResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::eventarc::publishing::v1::PublishRequest, ::google::cloud::eventarc::publishing::v1::PublishResponse>* streamer) {
                       return this->StreamedPublish(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Publish() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Publish(::grpc::ServerContext* /*context*/, const ::google::cloud::eventarc::publishing::v1::PublishRequest* /*request*/, ::google::cloud::eventarc::publishing::v1::PublishResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPublish(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::eventarc::publishing::v1::PublishRequest,::google::cloud::eventarc::publishing::v1::PublishResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_PublishChannelConnectionEvents<WithStreamedUnaryMethod_PublishEvents<WithStreamedUnaryMethod_Publish<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_PublishChannelConnectionEvents<WithStreamedUnaryMethod_PublishEvents<WithStreamedUnaryMethod_Publish<Service > > > StreamedService;
};

}  // namespace v1
}  // namespace publishing
}  // namespace eventarc
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2feventarc_2fpublishing_2fv1_2fpublisher_2eproto__INCLUDED
