// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/kms/v1/autokey.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fkms_2fv1_2fautokey_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fkms_2fv1_2fautokey_2eproto__INCLUDED

#include "google/cloud/kms/v1/autokey.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace kms {
namespace v1 {

// Provides interfaces for using [Cloud KMS
// Autokey](https://cloud.google.com/kms/help/autokey) to provision new
// [CryptoKeys][google.cloud.kms.v1.CryptoKey], ready for Customer Managed
// Encryption Key (CMEK) use, on-demand. To support certain client tooling, this
// feature is modeled around a [KeyHandle][google.cloud.kms.v1.KeyHandle]
// resource: creating a [KeyHandle][google.cloud.kms.v1.KeyHandle] in a resource
// project and given location triggers Cloud KMS Autokey to provision a
// [CryptoKey][google.cloud.kms.v1.CryptoKey] in the configured key project and
// the same location.
//
// Prior to use in a given resource project,
// [UpdateAutokeyConfig][google.cloud.kms.v1.AutokeyAdmin.UpdateAutokeyConfig]
// should have been called on an ancestor folder, setting the key project where
// Cloud KMS Autokey should create new
// [CryptoKeys][google.cloud.kms.v1.CryptoKey]. See documentation for additional
// prerequisites. To check what key project, if any, is currently configured on
// a resource project's ancestor folder, see
// [ShowEffectiveAutokeyConfig][google.cloud.kms.v1.AutokeyAdmin.ShowEffectiveAutokeyConfig].
class Autokey final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.kms.v1.Autokey";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a new [KeyHandle][google.cloud.kms.v1.KeyHandle], triggering the
    // provisioning of a new [CryptoKey][google.cloud.kms.v1.CryptoKey] for CMEK
    // use with the given resource type in the configured key project and the same
    // location. [GetOperation][google.longrunning.Operations.GetOperation] should
    // be used to resolve the resulting long-running operation and get the
    // resulting [KeyHandle][google.cloud.kms.v1.KeyHandle] and
    // [CryptoKey][google.cloud.kms.v1.CryptoKey].
    virtual ::grpc::Status CreateKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateKeyHandleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateKeyHandleRaw(context, request, cq));
    }
    // Returns the [KeyHandle][google.cloud.kms.v1.KeyHandle].
    virtual ::grpc::Status GetKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest& request, ::google::cloud::kms::v1::KeyHandle* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyHandle>> AsyncGetKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyHandle>>(AsyncGetKeyHandleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyHandle>> PrepareAsyncGetKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyHandle>>(PrepareAsyncGetKeyHandleRaw(context, request, cq));
    }
    // Lists [KeyHandles][google.cloud.kms.v1.KeyHandle].
    virtual ::grpc::Status ListKeyHandles(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest& request, ::google::cloud::kms::v1::ListKeyHandlesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyHandlesResponse>> AsyncListKeyHandles(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyHandlesResponse>>(AsyncListKeyHandlesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyHandlesResponse>> PrepareAsyncListKeyHandles(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyHandlesResponse>>(PrepareAsyncListKeyHandlesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a new [KeyHandle][google.cloud.kms.v1.KeyHandle], triggering the
      // provisioning of a new [CryptoKey][google.cloud.kms.v1.CryptoKey] for CMEK
      // use with the given resource type in the configured key project and the same
      // location. [GetOperation][google.longrunning.Operations.GetOperation] should
      // be used to resolve the resulting long-running operation and get the
      // resulting [KeyHandle][google.cloud.kms.v1.KeyHandle] and
      // [CryptoKey][google.cloud.kms.v1.CryptoKey].
      virtual void CreateKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the [KeyHandle][google.cloud.kms.v1.KeyHandle].
      virtual void GetKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest* request, ::google::cloud::kms::v1::KeyHandle* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest* request, ::google::cloud::kms::v1::KeyHandle* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists [KeyHandles][google.cloud.kms.v1.KeyHandle].
      virtual void ListKeyHandles(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest* request, ::google::cloud::kms::v1::ListKeyHandlesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListKeyHandles(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest* request, ::google::cloud::kms::v1::ListKeyHandlesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateKeyHandleRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateKeyHandleRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyHandle>* AsyncGetKeyHandleRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyHandle>* PrepareAsyncGetKeyHandleRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyHandlesResponse>* AsyncListKeyHandlesRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyHandlesResponse>* PrepareAsyncListKeyHandlesRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateKeyHandleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateKeyHandleRaw(context, request, cq));
    }
    ::grpc::Status GetKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest& request, ::google::cloud::kms::v1::KeyHandle* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyHandle>> AsyncGetKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyHandle>>(AsyncGetKeyHandleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyHandle>> PrepareAsyncGetKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyHandle>>(PrepareAsyncGetKeyHandleRaw(context, request, cq));
    }
    ::grpc::Status ListKeyHandles(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest& request, ::google::cloud::kms::v1::ListKeyHandlesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyHandlesResponse>> AsyncListKeyHandles(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyHandlesResponse>>(AsyncListKeyHandlesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyHandlesResponse>> PrepareAsyncListKeyHandles(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyHandlesResponse>>(PrepareAsyncListKeyHandlesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest* request, ::google::cloud::kms::v1::KeyHandle* response, std::function<void(::grpc::Status)>) override;
      void GetKeyHandle(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest* request, ::google::cloud::kms::v1::KeyHandle* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListKeyHandles(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest* request, ::google::cloud::kms::v1::ListKeyHandlesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListKeyHandles(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest* request, ::google::cloud::kms::v1::ListKeyHandlesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateKeyHandleRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateKeyHandleRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyHandle>* AsyncGetKeyHandleRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyHandle>* PrepareAsyncGetKeyHandleRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyHandlesResponse>* AsyncListKeyHandlesRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyHandlesResponse>* PrepareAsyncListKeyHandlesRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateKeyHandle_;
    const ::grpc::internal::RpcMethod rpcmethod_GetKeyHandle_;
    const ::grpc::internal::RpcMethod rpcmethod_ListKeyHandles_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a new [KeyHandle][google.cloud.kms.v1.KeyHandle], triggering the
    // provisioning of a new [CryptoKey][google.cloud.kms.v1.CryptoKey] for CMEK
    // use with the given resource type in the configured key project and the same
    // location. [GetOperation][google.longrunning.Operations.GetOperation] should
    // be used to resolve the resulting long-running operation and get the
    // resulting [KeyHandle][google.cloud.kms.v1.KeyHandle] and
    // [CryptoKey][google.cloud.kms.v1.CryptoKey].
    virtual ::grpc::Status CreateKeyHandle(::grpc::ServerContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest* request, ::google::longrunning::Operation* response);
    // Returns the [KeyHandle][google.cloud.kms.v1.KeyHandle].
    virtual ::grpc::Status GetKeyHandle(::grpc::ServerContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest* request, ::google::cloud::kms::v1::KeyHandle* response);
    // Lists [KeyHandles][google.cloud.kms.v1.KeyHandle].
    virtual ::grpc::Status ListKeyHandles(::grpc::ServerContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest* request, ::google::cloud::kms::v1::ListKeyHandlesResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateKeyHandle() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyHandleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateKeyHandle(::grpc::ServerContext* context, ::google::cloud::kms::v1::CreateKeyHandleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetKeyHandle() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyHandleRequest* /*request*/, ::google::cloud::kms::v1::KeyHandle* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetKeyHandle(::grpc::ServerContext* context, ::google::cloud::kms::v1::GetKeyHandleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::KeyHandle>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListKeyHandles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListKeyHandles() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListKeyHandles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeyHandles(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyHandlesRequest* /*request*/, ::google::cloud::kms::v1::ListKeyHandlesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListKeyHandles(::grpc::ServerContext* context, ::google::cloud::kms::v1::ListKeyHandlesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::ListKeyHandlesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateKeyHandle<WithAsyncMethod_GetKeyHandle<WithAsyncMethod_ListKeyHandles<Service > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateKeyHandle() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateKeyHandleRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::CreateKeyHandleRequest* request, ::google::longrunning::Operation* response) { return this->CreateKeyHandle(context, request, response); }));}
    void SetMessageAllocatorFor_CreateKeyHandle(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::CreateKeyHandleRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateKeyHandleRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyHandleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateKeyHandle(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyHandleRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetKeyHandle() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetKeyHandleRequest, ::google::cloud::kms::v1::KeyHandle>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::GetKeyHandleRequest* request, ::google::cloud::kms::v1::KeyHandle* response) { return this->GetKeyHandle(context, request, response); }));}
    void SetMessageAllocatorFor_GetKeyHandle(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::GetKeyHandleRequest, ::google::cloud::kms::v1::KeyHandle>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetKeyHandleRequest, ::google::cloud::kms::v1::KeyHandle>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyHandleRequest* /*request*/, ::google::cloud::kms::v1::KeyHandle* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetKeyHandle(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyHandleRequest* /*request*/, ::google::cloud::kms::v1::KeyHandle* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListKeyHandles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListKeyHandles() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListKeyHandlesRequest, ::google::cloud::kms::v1::ListKeyHandlesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::ListKeyHandlesRequest* request, ::google::cloud::kms::v1::ListKeyHandlesResponse* response) { return this->ListKeyHandles(context, request, response); }));}
    void SetMessageAllocatorFor_ListKeyHandles(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::ListKeyHandlesRequest, ::google::cloud::kms::v1::ListKeyHandlesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListKeyHandlesRequest, ::google::cloud::kms::v1::ListKeyHandlesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListKeyHandles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeyHandles(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyHandlesRequest* /*request*/, ::google::cloud::kms::v1::ListKeyHandlesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListKeyHandles(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyHandlesRequest* /*request*/, ::google::cloud::kms::v1::ListKeyHandlesResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateKeyHandle<WithCallbackMethod_GetKeyHandle<WithCallbackMethod_ListKeyHandles<Service > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateKeyHandle() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyHandleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetKeyHandle() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyHandleRequest* /*request*/, ::google::cloud::kms::v1::KeyHandle* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListKeyHandles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListKeyHandles() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListKeyHandles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeyHandles(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyHandlesRequest* /*request*/, ::google::cloud::kms::v1::ListKeyHandlesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateKeyHandle() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyHandleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateKeyHandle(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetKeyHandle() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyHandleRequest* /*request*/, ::google::cloud::kms::v1::KeyHandle* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetKeyHandle(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListKeyHandles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListKeyHandles() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListKeyHandles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeyHandles(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyHandlesRequest* /*request*/, ::google::cloud::kms::v1::ListKeyHandlesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListKeyHandles(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateKeyHandle() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateKeyHandle(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyHandleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateKeyHandle(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetKeyHandle() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetKeyHandle(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyHandleRequest* /*request*/, ::google::cloud::kms::v1::KeyHandle* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetKeyHandle(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListKeyHandles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListKeyHandles() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListKeyHandles(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListKeyHandles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeyHandles(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyHandlesRequest* /*request*/, ::google::cloud::kms::v1::ListKeyHandlesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListKeyHandles(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateKeyHandle() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::CreateKeyHandleRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::CreateKeyHandleRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateKeyHandle(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyHandleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateKeyHandle(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::CreateKeyHandleRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetKeyHandle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetKeyHandle() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::GetKeyHandleRequest, ::google::cloud::kms::v1::KeyHandle>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::GetKeyHandleRequest, ::google::cloud::kms::v1::KeyHandle>* streamer) {
                       return this->StreamedGetKeyHandle(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetKeyHandle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetKeyHandle(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyHandleRequest* /*request*/, ::google::cloud::kms::v1::KeyHandle* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetKeyHandle(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::GetKeyHandleRequest,::google::cloud::kms::v1::KeyHandle>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListKeyHandles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListKeyHandles() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::ListKeyHandlesRequest, ::google::cloud::kms::v1::ListKeyHandlesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::ListKeyHandlesRequest, ::google::cloud::kms::v1::ListKeyHandlesResponse>* streamer) {
                       return this->StreamedListKeyHandles(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListKeyHandles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListKeyHandles(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyHandlesRequest* /*request*/, ::google::cloud::kms::v1::ListKeyHandlesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListKeyHandles(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::ListKeyHandlesRequest,::google::cloud::kms::v1::ListKeyHandlesResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateKeyHandle<WithStreamedUnaryMethod_GetKeyHandle<WithStreamedUnaryMethod_ListKeyHandles<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateKeyHandle<WithStreamedUnaryMethod_GetKeyHandle<WithStreamedUnaryMethod_ListKeyHandles<Service > > > StreamedService;
};

}  // namespace v1
}  // namespace kms
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fkms_2fv1_2fautokey_2eproto__INCLUDED
