// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/kms/v1/autokey_admin.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_KMS_V1_INTERNAL_AUTOKEY_ADMIN_TRACING_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_KMS_V1_INTERNAL_AUTOKEY_ADMIN_TRACING_CONNECTION_H

#include "google/cloud/kms/v1/autokey_admin_connection.h"
#include "google/cloud/version.h"
#include <memory>

namespace google {
namespace cloud {
namespace kms_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

class AutokeyAdminTracingConnection : public kms_v1::AutokeyAdminConnection {
 public:
  ~AutokeyAdminTracingConnection() override = default;

  explicit AutokeyAdminTracingConnection(
      std::shared_ptr<kms_v1::AutokeyAdminConnection> child);

  Options options() override { return child_->options(); }

  StatusOr<google::cloud::kms::v1::AutokeyConfig> UpdateAutokeyConfig(
      google::cloud::kms::v1::UpdateAutokeyConfigRequest const& request)
      override;

  StatusOr<google::cloud::kms::v1::AutokeyConfig> GetAutokeyConfig(
      google::cloud::kms::v1::GetAutokeyConfigRequest const& request) override;

  StatusOr<google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>
  ShowEffectiveAutokeyConfig(
      google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest const& request)
      override;

  StreamRange<google::cloud::location::Location> ListLocations(
      google::cloud::location::ListLocationsRequest request) override;

  StatusOr<google::cloud::location::Location> GetLocation(
      google::cloud::location::GetLocationRequest const& request) override;

  StatusOr<google::iam::v1::Policy> SetIamPolicy(
      google::iam::v1::SetIamPolicyRequest const& request) override;

  StatusOr<google::iam::v1::Policy> GetIamPolicy(
      google::iam::v1::GetIamPolicyRequest const& request) override;

  StatusOr<google::iam::v1::TestIamPermissionsResponse> TestIamPermissions(
      google::iam::v1::TestIamPermissionsRequest const& request) override;

  StatusOr<google::longrunning::Operation> GetOperation(
      google::longrunning::GetOperationRequest const& request) override;

 private:
  std::shared_ptr<kms_v1::AutokeyAdminConnection> child_;
};

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

/**
 * Conditionally applies the tracing decorator to the given connection.
 *
 * The connection is only decorated if tracing is enabled (as determined by the
 * connection's options).
 */
std::shared_ptr<kms_v1::AutokeyAdminConnection>
MakeAutokeyAdminTracingConnection(
    std::shared_ptr<kms_v1::AutokeyAdminConnection> conn);

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace kms_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_KMS_V1_INTERNAL_AUTOKEY_ADMIN_TRACING_CONNECTION_H
