// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/oslogin/v1/oslogin.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_OSLOGIN_V1_OS_LOGIN_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_OSLOGIN_V1_OS_LOGIN_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/oslogin/v1/oslogin.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace oslogin_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class OsLoginServiceConnectionIdempotencyPolicy {
 public:
  virtual ~OsLoginServiceConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<OsLoginServiceConnectionIdempotencyPolicy> clone()
      const;

  virtual google::cloud::Idempotency CreateSshPublicKey(
      google::cloud::oslogin::v1::CreateSshPublicKeyRequest const& request);

  virtual google::cloud::Idempotency DeletePosixAccount(
      google::cloud::oslogin::v1::DeletePosixAccountRequest const& request);

  virtual google::cloud::Idempotency DeleteSshPublicKey(
      google::cloud::oslogin::v1::DeleteSshPublicKeyRequest const& request);

  virtual google::cloud::Idempotency GetLoginProfile(
      google::cloud::oslogin::v1::GetLoginProfileRequest const& request);

  virtual google::cloud::Idempotency GetSshPublicKey(
      google::cloud::oslogin::v1::GetSshPublicKeyRequest const& request);

  virtual google::cloud::Idempotency ImportSshPublicKey(
      google::cloud::oslogin::v1::ImportSshPublicKeyRequest const& request);

  virtual google::cloud::Idempotency UpdateSshPublicKey(
      google::cloud::oslogin::v1::UpdateSshPublicKeyRequest const& request);
};

std::unique_ptr<OsLoginServiceConnectionIdempotencyPolicy>
MakeDefaultOsLoginServiceConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace oslogin_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_OSLOGIN_V1_OS_LOGIN_CONNECTION_IDEMPOTENCY_POLICY_H
