// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/recommender/v1/recommender_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2frecommender_2fv1_2frecommender_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2frecommender_2fv1_2frecommender_5fservice_2eproto__INCLUDED

#include "google/cloud/recommender/v1/recommender_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace recommender {
namespace v1 {

// Provides insights and recommendations for cloud customers for various
// categories like performance optimization, cost savings, reliability, feature
// discovery, etc. Insights and recommendations are generated automatically
// based on analysis of user resources, configuration and monitoring metrics.
class Recommender final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.recommender.v1.Recommender";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists insights for the specified Cloud Resource. Requires the
    // recommender.*.list IAM permission for the specified insight type.
    virtual ::grpc::Status ListInsights(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest& request, ::google::cloud::recommender::v1::ListInsightsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListInsightsResponse>> AsyncListInsights(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListInsightsResponse>>(AsyncListInsightsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListInsightsResponse>> PrepareAsyncListInsights(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListInsightsResponse>>(PrepareAsyncListInsightsRaw(context, request, cq));
    }
    // Gets the requested insight. Requires the recommender.*.get IAM permission
    // for the specified insight type.
    virtual ::grpc::Status GetInsight(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest& request, ::google::cloud::recommender::v1::Insight* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>> AsyncGetInsight(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>>(AsyncGetInsightRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>> PrepareAsyncGetInsight(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>>(PrepareAsyncGetInsightRaw(context, request, cq));
    }
    // Marks the Insight State as Accepted. Users can use this method to
    // indicate to the Recommender API that they have applied some action based
    // on the insight. This stops the insight content from being updated.
    //
    // MarkInsightAccepted can be applied to insights in ACTIVE state. Requires
    // the recommender.*.update IAM permission for the specified insight.
    virtual ::grpc::Status MarkInsightAccepted(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest& request, ::google::cloud::recommender::v1::Insight* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>> AsyncMarkInsightAccepted(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>>(AsyncMarkInsightAcceptedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>> PrepareAsyncMarkInsightAccepted(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>>(PrepareAsyncMarkInsightAcceptedRaw(context, request, cq));
    }
    // Lists recommendations for the specified Cloud Resource. Requires the
    // recommender.*.list IAM permission for the specified recommender.
    virtual ::grpc::Status ListRecommendations(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest& request, ::google::cloud::recommender::v1::ListRecommendationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListRecommendationsResponse>> AsyncListRecommendations(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListRecommendationsResponse>>(AsyncListRecommendationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListRecommendationsResponse>> PrepareAsyncListRecommendations(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListRecommendationsResponse>>(PrepareAsyncListRecommendationsRaw(context, request, cq));
    }
    // Gets the requested recommendation. Requires the recommender.*.get
    // IAM permission for the specified recommender.
    virtual ::grpc::Status GetRecommendation(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest& request, ::google::cloud::recommender::v1::Recommendation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>> AsyncGetRecommendation(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>>(AsyncGetRecommendationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>> PrepareAsyncGetRecommendation(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>>(PrepareAsyncGetRecommendationRaw(context, request, cq));
    }
    // Mark the Recommendation State as Dismissed. Users can use this method to
    // indicate to the Recommender API that an ACTIVE recommendation has to
    // be marked back as DISMISSED.
    //
    // MarkRecommendationDismissed can be applied to recommendations in ACTIVE
    // state.
    //
    // Requires the recommender.*.update IAM permission for the specified
    // recommender.
    virtual ::grpc::Status MarkRecommendationDismissed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest& request, ::google::cloud::recommender::v1::Recommendation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>> AsyncMarkRecommendationDismissed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>>(AsyncMarkRecommendationDismissedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>> PrepareAsyncMarkRecommendationDismissed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>>(PrepareAsyncMarkRecommendationDismissedRaw(context, request, cq));
    }
    // Marks the Recommendation State as Claimed. Users can use this method to
    // indicate to the Recommender API that they are starting to apply the
    // recommendation themselves. This stops the recommendation content from being
    // updated. Associated insights are frozen and placed in the ACCEPTED state.
    //
    // MarkRecommendationClaimed can be applied to recommendations in CLAIMED,
    // SUCCEEDED, FAILED, or ACTIVE state.
    //
    // Requires the recommender.*.update IAM permission for the specified
    // recommender.
    virtual ::grpc::Status MarkRecommendationClaimed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest& request, ::google::cloud::recommender::v1::Recommendation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>> AsyncMarkRecommendationClaimed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>>(AsyncMarkRecommendationClaimedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>> PrepareAsyncMarkRecommendationClaimed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>>(PrepareAsyncMarkRecommendationClaimedRaw(context, request, cq));
    }
    // Marks the Recommendation State as Succeeded. Users can use this method to
    // indicate to the Recommender API that they have applied the recommendation
    // themselves, and the operation was successful. This stops the recommendation
    // content from being updated. Associated insights are frozen and placed in
    // the ACCEPTED state.
    //
    // MarkRecommendationSucceeded can be applied to recommendations in ACTIVE,
    // CLAIMED, SUCCEEDED, or FAILED state.
    //
    // Requires the recommender.*.update IAM permission for the specified
    // recommender.
    virtual ::grpc::Status MarkRecommendationSucceeded(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest& request, ::google::cloud::recommender::v1::Recommendation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>> AsyncMarkRecommendationSucceeded(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>>(AsyncMarkRecommendationSucceededRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>> PrepareAsyncMarkRecommendationSucceeded(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>>(PrepareAsyncMarkRecommendationSucceededRaw(context, request, cq));
    }
    // Marks the Recommendation State as Failed. Users can use this method to
    // indicate to the Recommender API that they have applied the recommendation
    // themselves, and the operation failed. This stops the recommendation content
    // from being updated. Associated insights are frozen and placed in the
    // ACCEPTED state.
    //
    // MarkRecommendationFailed can be applied to recommendations in ACTIVE,
    // CLAIMED, SUCCEEDED, or FAILED state.
    //
    // Requires the recommender.*.update IAM permission for the specified
    // recommender.
    virtual ::grpc::Status MarkRecommendationFailed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest& request, ::google::cloud::recommender::v1::Recommendation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>> AsyncMarkRecommendationFailed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>>(AsyncMarkRecommendationFailedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>> PrepareAsyncMarkRecommendationFailed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>>(PrepareAsyncMarkRecommendationFailedRaw(context, request, cq));
    }
    // Gets the requested Recommender Config. There is only one instance of the
    // config for each Recommender.
    virtual ::grpc::Status GetRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest& request, ::google::cloud::recommender::v1::RecommenderConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>> AsyncGetRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>>(AsyncGetRecommenderConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>> PrepareAsyncGetRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>>(PrepareAsyncGetRecommenderConfigRaw(context, request, cq));
    }
    // Updates a Recommender Config. This will create a new revision of the
    // config.
    virtual ::grpc::Status UpdateRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest& request, ::google::cloud::recommender::v1::RecommenderConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>> AsyncUpdateRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>>(AsyncUpdateRecommenderConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>> PrepareAsyncUpdateRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>>(PrepareAsyncUpdateRecommenderConfigRaw(context, request, cq));
    }
    // Gets the requested InsightTypeConfig. There is only one instance of the
    // config for each InsightType.
    virtual ::grpc::Status GetInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest& request, ::google::cloud::recommender::v1::InsightTypeConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>> AsyncGetInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>>(AsyncGetInsightTypeConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>> PrepareAsyncGetInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>>(PrepareAsyncGetInsightTypeConfigRaw(context, request, cq));
    }
    // Updates an InsightTypeConfig change. This will create a new revision of the
    // config.
    virtual ::grpc::Status UpdateInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest& request, ::google::cloud::recommender::v1::InsightTypeConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>> AsyncUpdateInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>>(AsyncUpdateInsightTypeConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>> PrepareAsyncUpdateInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>>(PrepareAsyncUpdateInsightTypeConfigRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists insights for the specified Cloud Resource. Requires the
      // recommender.*.list IAM permission for the specified insight type.
      virtual void ListInsights(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest* request, ::google::cloud::recommender::v1::ListInsightsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInsights(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest* request, ::google::cloud::recommender::v1::ListInsightsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the requested insight. Requires the recommender.*.get IAM permission
      // for the specified insight type.
      virtual void GetInsight(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest* request, ::google::cloud::recommender::v1::Insight* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInsight(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest* request, ::google::cloud::recommender::v1::Insight* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Marks the Insight State as Accepted. Users can use this method to
      // indicate to the Recommender API that they have applied some action based
      // on the insight. This stops the insight content from being updated.
      //
      // MarkInsightAccepted can be applied to insights in ACTIVE state. Requires
      // the recommender.*.update IAM permission for the specified insight.
      virtual void MarkInsightAccepted(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* request, ::google::cloud::recommender::v1::Insight* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MarkInsightAccepted(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* request, ::google::cloud::recommender::v1::Insight* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists recommendations for the specified Cloud Resource. Requires the
      // recommender.*.list IAM permission for the specified recommender.
      virtual void ListRecommendations(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest* request, ::google::cloud::recommender::v1::ListRecommendationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRecommendations(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest* request, ::google::cloud::recommender::v1::ListRecommendationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the requested recommendation. Requires the recommender.*.get
      // IAM permission for the specified recommender.
      virtual void GetRecommendation(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest* request, ::google::cloud::recommender::v1::Recommendation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRecommendation(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest* request, ::google::cloud::recommender::v1::Recommendation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Mark the Recommendation State as Dismissed. Users can use this method to
      // indicate to the Recommender API that an ACTIVE recommendation has to
      // be marked back as DISMISSED.
      //
      // MarkRecommendationDismissed can be applied to recommendations in ACTIVE
      // state.
      //
      // Requires the recommender.*.update IAM permission for the specified
      // recommender.
      virtual void MarkRecommendationDismissed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MarkRecommendationDismissed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Marks the Recommendation State as Claimed. Users can use this method to
      // indicate to the Recommender API that they are starting to apply the
      // recommendation themselves. This stops the recommendation content from being
      // updated. Associated insights are frozen and placed in the ACCEPTED state.
      //
      // MarkRecommendationClaimed can be applied to recommendations in CLAIMED,
      // SUCCEEDED, FAILED, or ACTIVE state.
      //
      // Requires the recommender.*.update IAM permission for the specified
      // recommender.
      virtual void MarkRecommendationClaimed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MarkRecommendationClaimed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Marks the Recommendation State as Succeeded. Users can use this method to
      // indicate to the Recommender API that they have applied the recommendation
      // themselves, and the operation was successful. This stops the recommendation
      // content from being updated. Associated insights are frozen and placed in
      // the ACCEPTED state.
      //
      // MarkRecommendationSucceeded can be applied to recommendations in ACTIVE,
      // CLAIMED, SUCCEEDED, or FAILED state.
      //
      // Requires the recommender.*.update IAM permission for the specified
      // recommender.
      virtual void MarkRecommendationSucceeded(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* request, ::google::cloud::recommender::v1::Recommendation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MarkRecommendationSucceeded(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* request, ::google::cloud::recommender::v1::Recommendation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Marks the Recommendation State as Failed. Users can use this method to
      // indicate to the Recommender API that they have applied the recommendation
      // themselves, and the operation failed. This stops the recommendation content
      // from being updated. Associated insights are frozen and placed in the
      // ACCEPTED state.
      //
      // MarkRecommendationFailed can be applied to recommendations in ACTIVE,
      // CLAIMED, SUCCEEDED, or FAILED state.
      //
      // Requires the recommender.*.update IAM permission for the specified
      // recommender.
      virtual void MarkRecommendationFailed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MarkRecommendationFailed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the requested Recommender Config. There is only one instance of the
      // config for each Recommender.
      virtual void GetRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a Recommender Config. This will create a new revision of the
      // config.
      virtual void UpdateRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the requested InsightTypeConfig. There is only one instance of the
      // config for each InsightType.
      virtual void GetInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an InsightTypeConfig change. This will create a new revision of the
      // config.
      virtual void UpdateInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListInsightsResponse>* AsyncListInsightsRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListInsightsResponse>* PrepareAsyncListInsightsRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>* AsyncGetInsightRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>* PrepareAsyncGetInsightRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>* AsyncMarkInsightAcceptedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Insight>* PrepareAsyncMarkInsightAcceptedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListRecommendationsResponse>* AsyncListRecommendationsRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::ListRecommendationsResponse>* PrepareAsyncListRecommendationsRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>* AsyncGetRecommendationRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>* PrepareAsyncGetRecommendationRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>* AsyncMarkRecommendationDismissedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>* PrepareAsyncMarkRecommendationDismissedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>* AsyncMarkRecommendationClaimedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>* PrepareAsyncMarkRecommendationClaimedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>* AsyncMarkRecommendationSucceededRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>* PrepareAsyncMarkRecommendationSucceededRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>* AsyncMarkRecommendationFailedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::Recommendation>* PrepareAsyncMarkRecommendationFailedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>* AsyncGetRecommenderConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>* PrepareAsyncGetRecommenderConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>* AsyncUpdateRecommenderConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::RecommenderConfig>* PrepareAsyncUpdateRecommenderConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>* AsyncGetInsightTypeConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>* PrepareAsyncGetInsightTypeConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>* AsyncUpdateInsightTypeConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::recommender::v1::InsightTypeConfig>* PrepareAsyncUpdateInsightTypeConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListInsights(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest& request, ::google::cloud::recommender::v1::ListInsightsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListInsightsResponse>> AsyncListInsights(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListInsightsResponse>>(AsyncListInsightsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListInsightsResponse>> PrepareAsyncListInsights(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListInsightsResponse>>(PrepareAsyncListInsightsRaw(context, request, cq));
    }
    ::grpc::Status GetInsight(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest& request, ::google::cloud::recommender::v1::Insight* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>> AsyncGetInsight(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>>(AsyncGetInsightRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>> PrepareAsyncGetInsight(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>>(PrepareAsyncGetInsightRaw(context, request, cq));
    }
    ::grpc::Status MarkInsightAccepted(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest& request, ::google::cloud::recommender::v1::Insight* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>> AsyncMarkInsightAccepted(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>>(AsyncMarkInsightAcceptedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>> PrepareAsyncMarkInsightAccepted(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>>(PrepareAsyncMarkInsightAcceptedRaw(context, request, cq));
    }
    ::grpc::Status ListRecommendations(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest& request, ::google::cloud::recommender::v1::ListRecommendationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListRecommendationsResponse>> AsyncListRecommendations(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListRecommendationsResponse>>(AsyncListRecommendationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListRecommendationsResponse>> PrepareAsyncListRecommendations(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListRecommendationsResponse>>(PrepareAsyncListRecommendationsRaw(context, request, cq));
    }
    ::grpc::Status GetRecommendation(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest& request, ::google::cloud::recommender::v1::Recommendation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>> AsyncGetRecommendation(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>>(AsyncGetRecommendationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>> PrepareAsyncGetRecommendation(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>>(PrepareAsyncGetRecommendationRaw(context, request, cq));
    }
    ::grpc::Status MarkRecommendationDismissed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest& request, ::google::cloud::recommender::v1::Recommendation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>> AsyncMarkRecommendationDismissed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>>(AsyncMarkRecommendationDismissedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>> PrepareAsyncMarkRecommendationDismissed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>>(PrepareAsyncMarkRecommendationDismissedRaw(context, request, cq));
    }
    ::grpc::Status MarkRecommendationClaimed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest& request, ::google::cloud::recommender::v1::Recommendation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>> AsyncMarkRecommendationClaimed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>>(AsyncMarkRecommendationClaimedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>> PrepareAsyncMarkRecommendationClaimed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>>(PrepareAsyncMarkRecommendationClaimedRaw(context, request, cq));
    }
    ::grpc::Status MarkRecommendationSucceeded(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest& request, ::google::cloud::recommender::v1::Recommendation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>> AsyncMarkRecommendationSucceeded(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>>(AsyncMarkRecommendationSucceededRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>> PrepareAsyncMarkRecommendationSucceeded(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>>(PrepareAsyncMarkRecommendationSucceededRaw(context, request, cq));
    }
    ::grpc::Status MarkRecommendationFailed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest& request, ::google::cloud::recommender::v1::Recommendation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>> AsyncMarkRecommendationFailed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>>(AsyncMarkRecommendationFailedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>> PrepareAsyncMarkRecommendationFailed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>>(PrepareAsyncMarkRecommendationFailedRaw(context, request, cq));
    }
    ::grpc::Status GetRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest& request, ::google::cloud::recommender::v1::RecommenderConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>> AsyncGetRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>>(AsyncGetRecommenderConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>> PrepareAsyncGetRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>>(PrepareAsyncGetRecommenderConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest& request, ::google::cloud::recommender::v1::RecommenderConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>> AsyncUpdateRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>>(AsyncUpdateRecommenderConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>> PrepareAsyncUpdateRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>>(PrepareAsyncUpdateRecommenderConfigRaw(context, request, cq));
    }
    ::grpc::Status GetInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest& request, ::google::cloud::recommender::v1::InsightTypeConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>> AsyncGetInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>>(AsyncGetInsightTypeConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>> PrepareAsyncGetInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>>(PrepareAsyncGetInsightTypeConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest& request, ::google::cloud::recommender::v1::InsightTypeConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>> AsyncUpdateInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>>(AsyncUpdateInsightTypeConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>> PrepareAsyncUpdateInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>>(PrepareAsyncUpdateInsightTypeConfigRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListInsights(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest* request, ::google::cloud::recommender::v1::ListInsightsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInsights(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest* request, ::google::cloud::recommender::v1::ListInsightsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInsight(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest* request, ::google::cloud::recommender::v1::Insight* response, std::function<void(::grpc::Status)>) override;
      void GetInsight(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest* request, ::google::cloud::recommender::v1::Insight* response, ::grpc::ClientUnaryReactor* reactor) override;
      void MarkInsightAccepted(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* request, ::google::cloud::recommender::v1::Insight* response, std::function<void(::grpc::Status)>) override;
      void MarkInsightAccepted(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* request, ::google::cloud::recommender::v1::Insight* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRecommendations(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest* request, ::google::cloud::recommender::v1::ListRecommendationsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRecommendations(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest* request, ::google::cloud::recommender::v1::ListRecommendationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRecommendation(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest* request, ::google::cloud::recommender::v1::Recommendation* response, std::function<void(::grpc::Status)>) override;
      void GetRecommendation(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest* request, ::google::cloud::recommender::v1::Recommendation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void MarkRecommendationDismissed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, std::function<void(::grpc::Status)>) override;
      void MarkRecommendationDismissed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void MarkRecommendationClaimed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, std::function<void(::grpc::Status)>) override;
      void MarkRecommendationClaimed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void MarkRecommendationSucceeded(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* request, ::google::cloud::recommender::v1::Recommendation* response, std::function<void(::grpc::Status)>) override;
      void MarkRecommendationSucceeded(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* request, ::google::cloud::recommender::v1::Recommendation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void MarkRecommendationFailed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, std::function<void(::grpc::Status)>) override;
      void MarkRecommendationFailed(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* request, ::google::cloud::recommender::v1::Recommendation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response, std::function<void(::grpc::Status)>) override;
      void GetRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response, std::function<void(::grpc::Status)>) override;
      void UpdateRecommenderConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response, std::function<void(::grpc::Status)>) override;
      void GetInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response, std::function<void(::grpc::Status)>) override;
      void UpdateInsightTypeConfig(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListInsightsResponse>* AsyncListInsightsRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListInsightsResponse>* PrepareAsyncListInsightsRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>* AsyncGetInsightRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>* PrepareAsyncGetInsightRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>* AsyncMarkInsightAcceptedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Insight>* PrepareAsyncMarkInsightAcceptedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListRecommendationsResponse>* AsyncListRecommendationsRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::ListRecommendationsResponse>* PrepareAsyncListRecommendationsRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>* AsyncGetRecommendationRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>* PrepareAsyncGetRecommendationRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>* AsyncMarkRecommendationDismissedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>* PrepareAsyncMarkRecommendationDismissedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>* AsyncMarkRecommendationClaimedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>* PrepareAsyncMarkRecommendationClaimedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>* AsyncMarkRecommendationSucceededRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>* PrepareAsyncMarkRecommendationSucceededRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>* AsyncMarkRecommendationFailedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::Recommendation>* PrepareAsyncMarkRecommendationFailedRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>* AsyncGetRecommenderConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>* PrepareAsyncGetRecommenderConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>* AsyncUpdateRecommenderConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::RecommenderConfig>* PrepareAsyncUpdateRecommenderConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>* AsyncGetInsightTypeConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>* PrepareAsyncGetInsightTypeConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>* AsyncUpdateInsightTypeConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::recommender::v1::InsightTypeConfig>* PrepareAsyncUpdateInsightTypeConfigRaw(::grpc::ClientContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListInsights_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInsight_;
    const ::grpc::internal::RpcMethod rpcmethod_MarkInsightAccepted_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRecommendations_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRecommendation_;
    const ::grpc::internal::RpcMethod rpcmethod_MarkRecommendationDismissed_;
    const ::grpc::internal::RpcMethod rpcmethod_MarkRecommendationClaimed_;
    const ::grpc::internal::RpcMethod rpcmethod_MarkRecommendationSucceeded_;
    const ::grpc::internal::RpcMethod rpcmethod_MarkRecommendationFailed_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRecommenderConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateRecommenderConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInsightTypeConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateInsightTypeConfig_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists insights for the specified Cloud Resource. Requires the
    // recommender.*.list IAM permission for the specified insight type.
    virtual ::grpc::Status ListInsights(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest* request, ::google::cloud::recommender::v1::ListInsightsResponse* response);
    // Gets the requested insight. Requires the recommender.*.get IAM permission
    // for the specified insight type.
    virtual ::grpc::Status GetInsight(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::GetInsightRequest* request, ::google::cloud::recommender::v1::Insight* response);
    // Marks the Insight State as Accepted. Users can use this method to
    // indicate to the Recommender API that they have applied some action based
    // on the insight. This stops the insight content from being updated.
    //
    // MarkInsightAccepted can be applied to insights in ACTIVE state. Requires
    // the recommender.*.update IAM permission for the specified insight.
    virtual ::grpc::Status MarkInsightAccepted(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* request, ::google::cloud::recommender::v1::Insight* response);
    // Lists recommendations for the specified Cloud Resource. Requires the
    // recommender.*.list IAM permission for the specified recommender.
    virtual ::grpc::Status ListRecommendations(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest* request, ::google::cloud::recommender::v1::ListRecommendationsResponse* response);
    // Gets the requested recommendation. Requires the recommender.*.get
    // IAM permission for the specified recommender.
    virtual ::grpc::Status GetRecommendation(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest* request, ::google::cloud::recommender::v1::Recommendation* response);
    // Mark the Recommendation State as Dismissed. Users can use this method to
    // indicate to the Recommender API that an ACTIVE recommendation has to
    // be marked back as DISMISSED.
    //
    // MarkRecommendationDismissed can be applied to recommendations in ACTIVE
    // state.
    //
    // Requires the recommender.*.update IAM permission for the specified
    // recommender.
    virtual ::grpc::Status MarkRecommendationDismissed(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* request, ::google::cloud::recommender::v1::Recommendation* response);
    // Marks the Recommendation State as Claimed. Users can use this method to
    // indicate to the Recommender API that they are starting to apply the
    // recommendation themselves. This stops the recommendation content from being
    // updated. Associated insights are frozen and placed in the ACCEPTED state.
    //
    // MarkRecommendationClaimed can be applied to recommendations in CLAIMED,
    // SUCCEEDED, FAILED, or ACTIVE state.
    //
    // Requires the recommender.*.update IAM permission for the specified
    // recommender.
    virtual ::grpc::Status MarkRecommendationClaimed(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* request, ::google::cloud::recommender::v1::Recommendation* response);
    // Marks the Recommendation State as Succeeded. Users can use this method to
    // indicate to the Recommender API that they have applied the recommendation
    // themselves, and the operation was successful. This stops the recommendation
    // content from being updated. Associated insights are frozen and placed in
    // the ACCEPTED state.
    //
    // MarkRecommendationSucceeded can be applied to recommendations in ACTIVE,
    // CLAIMED, SUCCEEDED, or FAILED state.
    //
    // Requires the recommender.*.update IAM permission for the specified
    // recommender.
    virtual ::grpc::Status MarkRecommendationSucceeded(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* request, ::google::cloud::recommender::v1::Recommendation* response);
    // Marks the Recommendation State as Failed. Users can use this method to
    // indicate to the Recommender API that they have applied the recommendation
    // themselves, and the operation failed. This stops the recommendation content
    // from being updated. Associated insights are frozen and placed in the
    // ACCEPTED state.
    //
    // MarkRecommendationFailed can be applied to recommendations in ACTIVE,
    // CLAIMED, SUCCEEDED, or FAILED state.
    //
    // Requires the recommender.*.update IAM permission for the specified
    // recommender.
    virtual ::grpc::Status MarkRecommendationFailed(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* request, ::google::cloud::recommender::v1::Recommendation* response);
    // Gets the requested Recommender Config. There is only one instance of the
    // config for each Recommender.
    virtual ::grpc::Status GetRecommenderConfig(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response);
    // Updates a Recommender Config. This will create a new revision of the
    // config.
    virtual ::grpc::Status UpdateRecommenderConfig(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response);
    // Gets the requested InsightTypeConfig. There is only one instance of the
    // config for each InsightType.
    virtual ::grpc::Status GetInsightTypeConfig(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response);
    // Updates an InsightTypeConfig change. This will create a new revision of the
    // config.
    virtual ::grpc::Status UpdateInsightTypeConfig(::grpc::ServerContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInsights : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInsights() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListInsights() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInsights(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListInsightsRequest* /*request*/, ::google::cloud::recommender::v1::ListInsightsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInsights(::grpc::ServerContext* context, ::google::cloud::recommender::v1::ListInsightsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::ListInsightsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInsight : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInsight() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetInsight() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInsight(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInsight(::grpc::ServerContext* context, ::google::cloud::recommender::v1::GetInsightRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::Insight>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MarkInsightAccepted : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MarkInsightAccepted() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_MarkInsightAccepted() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkInsightAccepted(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMarkInsightAccepted(::grpc::ServerContext* context, ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::Insight>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRecommendations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRecommendations() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListRecommendations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRecommendations(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListRecommendationsRequest* /*request*/, ::google::cloud::recommender::v1::ListRecommendationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRecommendations(::grpc::ServerContext* context, ::google::cloud::recommender::v1::ListRecommendationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::ListRecommendationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRecommendation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRecommendation() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetRecommendation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRecommendation(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommendationRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRecommendation(::grpc::ServerContext* context, ::google::cloud::recommender::v1::GetRecommendationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::Recommendation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MarkRecommendationDismissed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MarkRecommendationDismissed() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_MarkRecommendationDismissed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationDismissed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMarkRecommendationDismissed(::grpc::ServerContext* context, ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::Recommendation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MarkRecommendationClaimed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MarkRecommendationClaimed() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_MarkRecommendationClaimed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationClaimed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMarkRecommendationClaimed(::grpc::ServerContext* context, ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::Recommendation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MarkRecommendationSucceeded : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MarkRecommendationSucceeded() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_MarkRecommendationSucceeded() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationSucceeded(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMarkRecommendationSucceeded(::grpc::ServerContext* context, ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::Recommendation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MarkRecommendationFailed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MarkRecommendationFailed() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_MarkRecommendationFailed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationFailed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMarkRecommendationFailed(::grpc::ServerContext* context, ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::Recommendation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRecommenderConfig() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_GetRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRecommenderConfig(::grpc::ServerContext* context, ::google::cloud::recommender::v1::GetRecommenderConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::RecommenderConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateRecommenderConfig() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_UpdateRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRecommenderConfig(::grpc::ServerContext* context, ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::RecommenderConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInsightTypeConfig() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_GetInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInsightTypeConfig(::grpc::ServerContext* context, ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::InsightTypeConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateInsightTypeConfig() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_UpdateInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInsightTypeConfig(::grpc::ServerContext* context, ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::recommender::v1::InsightTypeConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListInsights<WithAsyncMethod_GetInsight<WithAsyncMethod_MarkInsightAccepted<WithAsyncMethod_ListRecommendations<WithAsyncMethod_GetRecommendation<WithAsyncMethod_MarkRecommendationDismissed<WithAsyncMethod_MarkRecommendationClaimed<WithAsyncMethod_MarkRecommendationSucceeded<WithAsyncMethod_MarkRecommendationFailed<WithAsyncMethod_GetRecommenderConfig<WithAsyncMethod_UpdateRecommenderConfig<WithAsyncMethod_GetInsightTypeConfig<WithAsyncMethod_UpdateInsightTypeConfig<Service > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListInsights : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInsights() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::ListInsightsRequest, ::google::cloud::recommender::v1::ListInsightsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::ListInsightsRequest* request, ::google::cloud::recommender::v1::ListInsightsResponse* response) { return this->ListInsights(context, request, response); }));}
    void SetMessageAllocatorFor_ListInsights(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::ListInsightsRequest, ::google::cloud::recommender::v1::ListInsightsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::ListInsightsRequest, ::google::cloud::recommender::v1::ListInsightsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInsights() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInsights(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListInsightsRequest* /*request*/, ::google::cloud::recommender::v1::ListInsightsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInsights(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::ListInsightsRequest* /*request*/, ::google::cloud::recommender::v1::ListInsightsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInsight : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInsight() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::GetInsightRequest, ::google::cloud::recommender::v1::Insight>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::GetInsightRequest* request, ::google::cloud::recommender::v1::Insight* response) { return this->GetInsight(context, request, response); }));}
    void SetMessageAllocatorFor_GetInsight(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::GetInsightRequest, ::google::cloud::recommender::v1::Insight>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::GetInsightRequest, ::google::cloud::recommender::v1::Insight>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInsight() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInsight(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInsight(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MarkInsightAccepted : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MarkInsightAccepted() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::MarkInsightAcceptedRequest, ::google::cloud::recommender::v1::Insight>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* request, ::google::cloud::recommender::v1::Insight* response) { return this->MarkInsightAccepted(context, request, response); }));}
    void SetMessageAllocatorFor_MarkInsightAccepted(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::MarkInsightAcceptedRequest, ::google::cloud::recommender::v1::Insight>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::MarkInsightAcceptedRequest, ::google::cloud::recommender::v1::Insight>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MarkInsightAccepted() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkInsightAccepted(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MarkInsightAccepted(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRecommendations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRecommendations() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::ListRecommendationsRequest, ::google::cloud::recommender::v1::ListRecommendationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::ListRecommendationsRequest* request, ::google::cloud::recommender::v1::ListRecommendationsResponse* response) { return this->ListRecommendations(context, request, response); }));}
    void SetMessageAllocatorFor_ListRecommendations(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::ListRecommendationsRequest, ::google::cloud::recommender::v1::ListRecommendationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::ListRecommendationsRequest, ::google::cloud::recommender::v1::ListRecommendationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRecommendations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRecommendations(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListRecommendationsRequest* /*request*/, ::google::cloud::recommender::v1::ListRecommendationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRecommendations(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::ListRecommendationsRequest* /*request*/, ::google::cloud::recommender::v1::ListRecommendationsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRecommendation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRecommendation() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::GetRecommendationRequest, ::google::cloud::recommender::v1::Recommendation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::GetRecommendationRequest* request, ::google::cloud::recommender::v1::Recommendation* response) { return this->GetRecommendation(context, request, response); }));}
    void SetMessageAllocatorFor_GetRecommendation(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::GetRecommendationRequest, ::google::cloud::recommender::v1::Recommendation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::GetRecommendationRequest, ::google::cloud::recommender::v1::Recommendation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRecommendation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRecommendation(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommendationRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRecommendation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommendationRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MarkRecommendationDismissed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MarkRecommendationDismissed() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest, ::google::cloud::recommender::v1::Recommendation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* request, ::google::cloud::recommender::v1::Recommendation* response) { return this->MarkRecommendationDismissed(context, request, response); }));}
    void SetMessageAllocatorFor_MarkRecommendationDismissed(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest, ::google::cloud::recommender::v1::Recommendation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest, ::google::cloud::recommender::v1::Recommendation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MarkRecommendationDismissed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationDismissed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MarkRecommendationDismissed(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MarkRecommendationClaimed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MarkRecommendationClaimed() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest, ::google::cloud::recommender::v1::Recommendation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* request, ::google::cloud::recommender::v1::Recommendation* response) { return this->MarkRecommendationClaimed(context, request, response); }));}
    void SetMessageAllocatorFor_MarkRecommendationClaimed(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest, ::google::cloud::recommender::v1::Recommendation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest, ::google::cloud::recommender::v1::Recommendation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MarkRecommendationClaimed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationClaimed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MarkRecommendationClaimed(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MarkRecommendationSucceeded : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MarkRecommendationSucceeded() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest, ::google::cloud::recommender::v1::Recommendation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* request, ::google::cloud::recommender::v1::Recommendation* response) { return this->MarkRecommendationSucceeded(context, request, response); }));}
    void SetMessageAllocatorFor_MarkRecommendationSucceeded(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest, ::google::cloud::recommender::v1::Recommendation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest, ::google::cloud::recommender::v1::Recommendation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MarkRecommendationSucceeded() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationSucceeded(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MarkRecommendationSucceeded(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MarkRecommendationFailed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MarkRecommendationFailed() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::MarkRecommendationFailedRequest, ::google::cloud::recommender::v1::Recommendation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* request, ::google::cloud::recommender::v1::Recommendation* response) { return this->MarkRecommendationFailed(context, request, response); }));}
    void SetMessageAllocatorFor_MarkRecommendationFailed(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::MarkRecommendationFailedRequest, ::google::cloud::recommender::v1::Recommendation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::MarkRecommendationFailedRequest, ::google::cloud::recommender::v1::Recommendation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MarkRecommendationFailed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationFailed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MarkRecommendationFailed(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRecommenderConfig() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::GetRecommenderConfigRequest, ::google::cloud::recommender::v1::RecommenderConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response) { return this->GetRecommenderConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetRecommenderConfig(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::GetRecommenderConfigRequest, ::google::cloud::recommender::v1::RecommenderConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::GetRecommenderConfigRequest, ::google::cloud::recommender::v1::RecommenderConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRecommenderConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateRecommenderConfig() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest, ::google::cloud::recommender::v1::RecommenderConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* request, ::google::cloud::recommender::v1::RecommenderConfig* response) { return this->UpdateRecommenderConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateRecommenderConfig(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest, ::google::cloud::recommender::v1::RecommenderConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest, ::google::cloud::recommender::v1::RecommenderConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRecommenderConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInsightTypeConfig() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::GetInsightTypeConfigRequest, ::google::cloud::recommender::v1::InsightTypeConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response) { return this->GetInsightTypeConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetInsightTypeConfig(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::GetInsightTypeConfigRequest, ::google::cloud::recommender::v1::InsightTypeConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::GetInsightTypeConfigRequest, ::google::cloud::recommender::v1::InsightTypeConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInsightTypeConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateInsightTypeConfig() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest, ::google::cloud::recommender::v1::InsightTypeConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* request, ::google::cloud::recommender::v1::InsightTypeConfig* response) { return this->UpdateInsightTypeConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateInsightTypeConfig(
        ::grpc::MessageAllocator< ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest, ::google::cloud::recommender::v1::InsightTypeConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest, ::google::cloud::recommender::v1::InsightTypeConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInsightTypeConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListInsights<WithCallbackMethod_GetInsight<WithCallbackMethod_MarkInsightAccepted<WithCallbackMethod_ListRecommendations<WithCallbackMethod_GetRecommendation<WithCallbackMethod_MarkRecommendationDismissed<WithCallbackMethod_MarkRecommendationClaimed<WithCallbackMethod_MarkRecommendationSucceeded<WithCallbackMethod_MarkRecommendationFailed<WithCallbackMethod_GetRecommenderConfig<WithCallbackMethod_UpdateRecommenderConfig<WithCallbackMethod_GetInsightTypeConfig<WithCallbackMethod_UpdateInsightTypeConfig<Service > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListInsights : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInsights() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListInsights() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInsights(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListInsightsRequest* /*request*/, ::google::cloud::recommender::v1::ListInsightsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInsight : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInsight() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetInsight() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInsight(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MarkInsightAccepted : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MarkInsightAccepted() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_MarkInsightAccepted() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkInsightAccepted(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRecommendations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRecommendations() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListRecommendations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRecommendations(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListRecommendationsRequest* /*request*/, ::google::cloud::recommender::v1::ListRecommendationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRecommendation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRecommendation() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetRecommendation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRecommendation(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommendationRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MarkRecommendationDismissed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MarkRecommendationDismissed() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_MarkRecommendationDismissed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationDismissed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MarkRecommendationClaimed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MarkRecommendationClaimed() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_MarkRecommendationClaimed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationClaimed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MarkRecommendationSucceeded : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MarkRecommendationSucceeded() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_MarkRecommendationSucceeded() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationSucceeded(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MarkRecommendationFailed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MarkRecommendationFailed() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_MarkRecommendationFailed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationFailed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRecommenderConfig() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_GetRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateRecommenderConfig() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_UpdateRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInsightTypeConfig() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_GetInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateInsightTypeConfig() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_UpdateInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInsights : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInsights() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListInsights() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInsights(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListInsightsRequest* /*request*/, ::google::cloud::recommender::v1::ListInsightsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInsights(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInsight : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInsight() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetInsight() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInsight(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInsight(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MarkInsightAccepted : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MarkInsightAccepted() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_MarkInsightAccepted() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkInsightAccepted(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMarkInsightAccepted(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRecommendations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRecommendations() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListRecommendations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRecommendations(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListRecommendationsRequest* /*request*/, ::google::cloud::recommender::v1::ListRecommendationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRecommendations(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRecommendation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRecommendation() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetRecommendation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRecommendation(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommendationRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRecommendation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MarkRecommendationDismissed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MarkRecommendationDismissed() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_MarkRecommendationDismissed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationDismissed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMarkRecommendationDismissed(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MarkRecommendationClaimed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MarkRecommendationClaimed() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_MarkRecommendationClaimed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationClaimed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMarkRecommendationClaimed(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MarkRecommendationSucceeded : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MarkRecommendationSucceeded() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_MarkRecommendationSucceeded() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationSucceeded(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMarkRecommendationSucceeded(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MarkRecommendationFailed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MarkRecommendationFailed() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_MarkRecommendationFailed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationFailed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMarkRecommendationFailed(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRecommenderConfig() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_GetRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRecommenderConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateRecommenderConfig() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_UpdateRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRecommenderConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInsightTypeConfig() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_GetInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInsightTypeConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateInsightTypeConfig() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_UpdateInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInsightTypeConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInsights : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInsights() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInsights(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInsights() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInsights(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListInsightsRequest* /*request*/, ::google::cloud::recommender::v1::ListInsightsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInsights(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInsight : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInsight() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInsight(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInsight() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInsight(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInsight(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MarkInsightAccepted : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MarkInsightAccepted() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MarkInsightAccepted(context, request, response); }));
    }
    ~WithRawCallbackMethod_MarkInsightAccepted() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkInsightAccepted(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MarkInsightAccepted(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRecommendations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRecommendations() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRecommendations(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRecommendations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRecommendations(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListRecommendationsRequest* /*request*/, ::google::cloud::recommender::v1::ListRecommendationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRecommendations(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRecommendation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRecommendation() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRecommendation(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRecommendation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRecommendation(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommendationRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRecommendation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MarkRecommendationDismissed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MarkRecommendationDismissed() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MarkRecommendationDismissed(context, request, response); }));
    }
    ~WithRawCallbackMethod_MarkRecommendationDismissed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationDismissed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MarkRecommendationDismissed(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MarkRecommendationClaimed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MarkRecommendationClaimed() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MarkRecommendationClaimed(context, request, response); }));
    }
    ~WithRawCallbackMethod_MarkRecommendationClaimed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationClaimed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MarkRecommendationClaimed(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MarkRecommendationSucceeded : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MarkRecommendationSucceeded() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MarkRecommendationSucceeded(context, request, response); }));
    }
    ~WithRawCallbackMethod_MarkRecommendationSucceeded() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationSucceeded(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MarkRecommendationSucceeded(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MarkRecommendationFailed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MarkRecommendationFailed() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MarkRecommendationFailed(context, request, response); }));
    }
    ~WithRawCallbackMethod_MarkRecommendationFailed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MarkRecommendationFailed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MarkRecommendationFailed(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRecommenderConfig() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRecommenderConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRecommenderConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateRecommenderConfig() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateRecommenderConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRecommenderConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInsightTypeConfig() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInsightTypeConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInsightTypeConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateInsightTypeConfig() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateInsightTypeConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInsightTypeConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInsights : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInsights() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::ListInsightsRequest, ::google::cloud::recommender::v1::ListInsightsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::ListInsightsRequest, ::google::cloud::recommender::v1::ListInsightsResponse>* streamer) {
                       return this->StreamedListInsights(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInsights() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInsights(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListInsightsRequest* /*request*/, ::google::cloud::recommender::v1::ListInsightsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInsights(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::ListInsightsRequest,::google::cloud::recommender::v1::ListInsightsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInsight : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInsight() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::GetInsightRequest, ::google::cloud::recommender::v1::Insight>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::GetInsightRequest, ::google::cloud::recommender::v1::Insight>* streamer) {
                       return this->StreamedGetInsight(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInsight() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInsight(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInsight(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::GetInsightRequest,::google::cloud::recommender::v1::Insight>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MarkInsightAccepted : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MarkInsightAccepted() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::MarkInsightAcceptedRequest, ::google::cloud::recommender::v1::Insight>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::MarkInsightAcceptedRequest, ::google::cloud::recommender::v1::Insight>* streamer) {
                       return this->StreamedMarkInsightAccepted(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MarkInsightAccepted() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MarkInsightAccepted(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkInsightAcceptedRequest* /*request*/, ::google::cloud::recommender::v1::Insight* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMarkInsightAccepted(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::MarkInsightAcceptedRequest,::google::cloud::recommender::v1::Insight>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRecommendations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRecommendations() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::ListRecommendationsRequest, ::google::cloud::recommender::v1::ListRecommendationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::ListRecommendationsRequest, ::google::cloud::recommender::v1::ListRecommendationsResponse>* streamer) {
                       return this->StreamedListRecommendations(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRecommendations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRecommendations(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::ListRecommendationsRequest* /*request*/, ::google::cloud::recommender::v1::ListRecommendationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRecommendations(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::ListRecommendationsRequest,::google::cloud::recommender::v1::ListRecommendationsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRecommendation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRecommendation() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::GetRecommendationRequest, ::google::cloud::recommender::v1::Recommendation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::GetRecommendationRequest, ::google::cloud::recommender::v1::Recommendation>* streamer) {
                       return this->StreamedGetRecommendation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRecommendation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRecommendation(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommendationRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRecommendation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::GetRecommendationRequest,::google::cloud::recommender::v1::Recommendation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MarkRecommendationDismissed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MarkRecommendationDismissed() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest, ::google::cloud::recommender::v1::Recommendation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest, ::google::cloud::recommender::v1::Recommendation>* streamer) {
                       return this->StreamedMarkRecommendationDismissed(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MarkRecommendationDismissed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MarkRecommendationDismissed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMarkRecommendationDismissed(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::MarkRecommendationDismissedRequest,::google::cloud::recommender::v1::Recommendation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MarkRecommendationClaimed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MarkRecommendationClaimed() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest, ::google::cloud::recommender::v1::Recommendation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest, ::google::cloud::recommender::v1::Recommendation>* streamer) {
                       return this->StreamedMarkRecommendationClaimed(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MarkRecommendationClaimed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MarkRecommendationClaimed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMarkRecommendationClaimed(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::MarkRecommendationClaimedRequest,::google::cloud::recommender::v1::Recommendation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MarkRecommendationSucceeded : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MarkRecommendationSucceeded() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest, ::google::cloud::recommender::v1::Recommendation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest, ::google::cloud::recommender::v1::Recommendation>* streamer) {
                       return this->StreamedMarkRecommendationSucceeded(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MarkRecommendationSucceeded() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MarkRecommendationSucceeded(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMarkRecommendationSucceeded(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::MarkRecommendationSucceededRequest,::google::cloud::recommender::v1::Recommendation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MarkRecommendationFailed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MarkRecommendationFailed() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::MarkRecommendationFailedRequest, ::google::cloud::recommender::v1::Recommendation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::MarkRecommendationFailedRequest, ::google::cloud::recommender::v1::Recommendation>* streamer) {
                       return this->StreamedMarkRecommendationFailed(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MarkRecommendationFailed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MarkRecommendationFailed(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::MarkRecommendationFailedRequest* /*request*/, ::google::cloud::recommender::v1::Recommendation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMarkRecommendationFailed(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::MarkRecommendationFailedRequest,::google::cloud::recommender::v1::Recommendation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRecommenderConfig() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::GetRecommenderConfigRequest, ::google::cloud::recommender::v1::RecommenderConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::GetRecommenderConfigRequest, ::google::cloud::recommender::v1::RecommenderConfig>* streamer) {
                       return this->StreamedGetRecommenderConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRecommenderConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::GetRecommenderConfigRequest,::google::cloud::recommender::v1::RecommenderConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateRecommenderConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateRecommenderConfig() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest, ::google::cloud::recommender::v1::RecommenderConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest, ::google::cloud::recommender::v1::RecommenderConfig>* streamer) {
                       return this->StreamedUpdateRecommenderConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateRecommenderConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateRecommenderConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest* /*request*/, ::google::cloud::recommender::v1::RecommenderConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateRecommenderConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::UpdateRecommenderConfigRequest,::google::cloud::recommender::v1::RecommenderConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInsightTypeConfig() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::GetInsightTypeConfigRequest, ::google::cloud::recommender::v1::InsightTypeConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::GetInsightTypeConfigRequest, ::google::cloud::recommender::v1::InsightTypeConfig>* streamer) {
                       return this->StreamedGetInsightTypeConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::GetInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInsightTypeConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::GetInsightTypeConfigRequest,::google::cloud::recommender::v1::InsightTypeConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateInsightTypeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateInsightTypeConfig() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest, ::google::cloud::recommender::v1::InsightTypeConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest, ::google::cloud::recommender::v1::InsightTypeConfig>* streamer) {
                       return this->StreamedUpdateInsightTypeConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateInsightTypeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateInsightTypeConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest* /*request*/, ::google::cloud::recommender::v1::InsightTypeConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateInsightTypeConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::recommender::v1::UpdateInsightTypeConfigRequest,::google::cloud::recommender::v1::InsightTypeConfig>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListInsights<WithStreamedUnaryMethod_GetInsight<WithStreamedUnaryMethod_MarkInsightAccepted<WithStreamedUnaryMethod_ListRecommendations<WithStreamedUnaryMethod_GetRecommendation<WithStreamedUnaryMethod_MarkRecommendationDismissed<WithStreamedUnaryMethod_MarkRecommendationClaimed<WithStreamedUnaryMethod_MarkRecommendationSucceeded<WithStreamedUnaryMethod_MarkRecommendationFailed<WithStreamedUnaryMethod_GetRecommenderConfig<WithStreamedUnaryMethod_UpdateRecommenderConfig<WithStreamedUnaryMethod_GetInsightTypeConfig<WithStreamedUnaryMethod_UpdateInsightTypeConfig<Service > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListInsights<WithStreamedUnaryMethod_GetInsight<WithStreamedUnaryMethod_MarkInsightAccepted<WithStreamedUnaryMethod_ListRecommendations<WithStreamedUnaryMethod_GetRecommendation<WithStreamedUnaryMethod_MarkRecommendationDismissed<WithStreamedUnaryMethod_MarkRecommendationClaimed<WithStreamedUnaryMethod_MarkRecommendationSucceeded<WithStreamedUnaryMethod_MarkRecommendationFailed<WithStreamedUnaryMethod_GetRecommenderConfig<WithStreamedUnaryMethod_UpdateRecommenderConfig<WithStreamedUnaryMethod_GetInsightTypeConfig<WithStreamedUnaryMethod_UpdateInsightTypeConfig<Service > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace recommender
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2frecommender_2fv1_2frecommender_5fservice_2eproto__INCLUDED
