// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/secretmanager/v1/service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fsecretmanager_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fsecretmanager_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/secretmanager/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace secretmanager {
namespace v1 {

// Secret Manager Service
//
// Manages secrets and operations using those secrets. Implements a REST
// model with the following objects:
//
// * [Secret][google.cloud.secretmanager.v1.Secret]
// * [SecretVersion][google.cloud.secretmanager.v1.SecretVersion]
class SecretManagerService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.secretmanager.v1.SecretManagerService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists [Secrets][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status ListSecrets(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest& request, ::google::cloud::secretmanager::v1::ListSecretsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretsResponse>> AsyncListSecrets(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretsResponse>>(AsyncListSecretsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretsResponse>> PrepareAsyncListSecrets(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretsResponse>>(PrepareAsyncListSecretsRaw(context, request, cq));
    }
    // Creates a new [Secret][google.cloud.secretmanager.v1.Secret] containing no
    // [SecretVersions][google.cloud.secretmanager.v1.SecretVersion].
    virtual ::grpc::Status CreateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest& request, ::google::cloud::secretmanager::v1::Secret* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>> AsyncCreateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>>(AsyncCreateSecretRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>> PrepareAsyncCreateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>>(PrepareAsyncCreateSecretRaw(context, request, cq));
    }
    // Creates a new [SecretVersion][google.cloud.secretmanager.v1.SecretVersion]
    // containing secret data and attaches it to an existing
    // [Secret][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status AddSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest& request, ::google::cloud::secretmanager::v1::SecretVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>> AsyncAddSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>>(AsyncAddSecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>> PrepareAsyncAddSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>>(PrepareAsyncAddSecretVersionRaw(context, request, cq));
    }
    // Gets metadata for a given [Secret][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status GetSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest& request, ::google::cloud::secretmanager::v1::Secret* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>> AsyncGetSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>>(AsyncGetSecretRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>> PrepareAsyncGetSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>>(PrepareAsyncGetSecretRaw(context, request, cq));
    }
    // Updates metadata of an existing
    // [Secret][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status UpdateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest& request, ::google::cloud::secretmanager::v1::Secret* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>> AsyncUpdateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>>(AsyncUpdateSecretRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>> PrepareAsyncUpdateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>>(PrepareAsyncUpdateSecretRaw(context, request, cq));
    }
    // Deletes a [Secret][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status DeleteSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteSecretRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteSecretRaw(context, request, cq));
    }
    // Lists [SecretVersions][google.cloud.secretmanager.v1.SecretVersion]. This
    // call does not return secret data.
    virtual ::grpc::Status ListSecretVersions(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest& request, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>> AsyncListSecretVersions(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>>(AsyncListSecretVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>> PrepareAsyncListSecretVersions(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>>(PrepareAsyncListSecretVersionsRaw(context, request, cq));
    }
    // Gets metadata for a
    // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    //
    // `projects/*/secrets/*/versions/latest` is an alias to the most recently
    // created [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    virtual ::grpc::Status GetSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest& request, ::google::cloud::secretmanager::v1::SecretVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>> AsyncGetSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>>(AsyncGetSecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>> PrepareAsyncGetSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>>(PrepareAsyncGetSecretVersionRaw(context, request, cq));
    }
    // Accesses a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    // This call returns the secret data.
    //
    // `projects/*/secrets/*/versions/latest` is an alias to the most recently
    // created [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    virtual ::grpc::Status AccessSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest& request, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>> AsyncAccessSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>>(AsyncAccessSecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>> PrepareAsyncAccessSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>>(PrepareAsyncAccessSecretVersionRaw(context, request, cq));
    }
    // Disables a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    //
    // Sets the [state][google.cloud.secretmanager.v1.SecretVersion.state] of the
    // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion] to
    // [DISABLED][google.cloud.secretmanager.v1.SecretVersion.State.DISABLED].
    virtual ::grpc::Status DisableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest& request, ::google::cloud::secretmanager::v1::SecretVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>> AsyncDisableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>>(AsyncDisableSecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>> PrepareAsyncDisableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>>(PrepareAsyncDisableSecretVersionRaw(context, request, cq));
    }
    // Enables a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    //
    // Sets the [state][google.cloud.secretmanager.v1.SecretVersion.state] of the
    // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion] to
    // [ENABLED][google.cloud.secretmanager.v1.SecretVersion.State.ENABLED].
    virtual ::grpc::Status EnableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest& request, ::google::cloud::secretmanager::v1::SecretVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>> AsyncEnableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>>(AsyncEnableSecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>> PrepareAsyncEnableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>>(PrepareAsyncEnableSecretVersionRaw(context, request, cq));
    }
    // Destroys a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    //
    // Sets the [state][google.cloud.secretmanager.v1.SecretVersion.state] of the
    // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion] to
    // [DESTROYED][google.cloud.secretmanager.v1.SecretVersion.State.DESTROYED]
    // and irrevocably destroys the secret data.
    virtual ::grpc::Status DestroySecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest& request, ::google::cloud::secretmanager::v1::SecretVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>> AsyncDestroySecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>>(AsyncDestroySecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>> PrepareAsyncDestroySecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>>(PrepareAsyncDestroySecretVersionRaw(context, request, cq));
    }
    // Sets the access control policy on the specified secret. Replaces any
    // existing policy.
    //
    // Permissions on
    // [SecretVersions][google.cloud.secretmanager.v1.SecretVersion] are enforced
    // according to the policy set on the associated
    // [Secret][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    // Gets the access control policy for a secret.
    // Returns empty policy if the secret exists and does not have a policy set.
    virtual ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    // Returns permissions that a caller has for the specified secret.
    // If the secret does not exist, this call returns an empty set of
    // permissions, not a NOT_FOUND error.
    //
    // Note: This operation is designed to be used for building permission-aware
    // UIs and command-line tools, not for authorization checking. This operation
    // may "fail open" without warning.
    virtual ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists [Secrets][google.cloud.secretmanager.v1.Secret].
      virtual void ListSecrets(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest* request, ::google::cloud::secretmanager::v1::ListSecretsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSecrets(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest* request, ::google::cloud::secretmanager::v1::ListSecretsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new [Secret][google.cloud.secretmanager.v1.Secret] containing no
      // [SecretVersions][google.cloud.secretmanager.v1.SecretVersion].
      virtual void CreateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new [SecretVersion][google.cloud.secretmanager.v1.SecretVersion]
      // containing secret data and attaches it to an existing
      // [Secret][google.cloud.secretmanager.v1.Secret].
      virtual void AddSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AddSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets metadata for a given [Secret][google.cloud.secretmanager.v1.Secret].
      virtual void GetSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates metadata of an existing
      // [Secret][google.cloud.secretmanager.v1.Secret].
      virtual void UpdateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a [Secret][google.cloud.secretmanager.v1.Secret].
      virtual void DeleteSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists [SecretVersions][google.cloud.secretmanager.v1.SecretVersion]. This
      // call does not return secret data.
      virtual void ListSecretVersions(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* request, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSecretVersions(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* request, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets metadata for a
      // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
      //
      // `projects/*/secrets/*/versions/latest` is an alias to the most recently
      // created [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
      virtual void GetSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Accesses a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
      // This call returns the secret data.
      //
      // `projects/*/secrets/*/versions/latest` is an alias to the most recently
      // created [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
      virtual void AccessSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* request, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AccessSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* request, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Disables a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
      //
      // Sets the [state][google.cloud.secretmanager.v1.SecretVersion.state] of the
      // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion] to
      // [DISABLED][google.cloud.secretmanager.v1.SecretVersion.State.DISABLED].
      virtual void DisableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DisableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Enables a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
      //
      // Sets the [state][google.cloud.secretmanager.v1.SecretVersion.state] of the
      // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion] to
      // [ENABLED][google.cloud.secretmanager.v1.SecretVersion.State.ENABLED].
      virtual void EnableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void EnableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Destroys a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
      //
      // Sets the [state][google.cloud.secretmanager.v1.SecretVersion.state] of the
      // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion] to
      // [DESTROYED][google.cloud.secretmanager.v1.SecretVersion.State.DESTROYED]
      // and irrevocably destroys the secret data.
      virtual void DestroySecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DestroySecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Sets the access control policy on the specified secret. Replaces any
      // existing policy.
      //
      // Permissions on
      // [SecretVersions][google.cloud.secretmanager.v1.SecretVersion] are enforced
      // according to the policy set on the associated
      // [Secret][google.cloud.secretmanager.v1.Secret].
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the access control policy for a secret.
      // Returns empty policy if the secret exists and does not have a policy set.
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns permissions that a caller has for the specified secret.
      // If the secret does not exist, this call returns an empty set of
      // permissions, not a NOT_FOUND error.
      //
      // Note: This operation is designed to be used for building permission-aware
      // UIs and command-line tools, not for authorization checking. This operation
      // may "fail open" without warning.
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretsResponse>* AsyncListSecretsRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretsResponse>* PrepareAsyncListSecretsRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>* AsyncCreateSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>* PrepareAsyncCreateSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>* AsyncAddSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>* PrepareAsyncAddSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>* AsyncGetSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>* PrepareAsyncGetSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>* AsyncUpdateSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::Secret>* PrepareAsyncUpdateSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>* AsyncListSecretVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>* PrepareAsyncListSecretVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>* AsyncGetSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>* PrepareAsyncGetSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>* AsyncAccessSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>* PrepareAsyncAccessSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>* AsyncDisableSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>* PrepareAsyncDisableSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>* AsyncEnableSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>* PrepareAsyncEnableSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>* AsyncDestroySecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::secretmanager::v1::SecretVersion>* PrepareAsyncDestroySecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListSecrets(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest& request, ::google::cloud::secretmanager::v1::ListSecretsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretsResponse>> AsyncListSecrets(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretsResponse>>(AsyncListSecretsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretsResponse>> PrepareAsyncListSecrets(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretsResponse>>(PrepareAsyncListSecretsRaw(context, request, cq));
    }
    ::grpc::Status CreateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest& request, ::google::cloud::secretmanager::v1::Secret* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>> AsyncCreateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>>(AsyncCreateSecretRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>> PrepareAsyncCreateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>>(PrepareAsyncCreateSecretRaw(context, request, cq));
    }
    ::grpc::Status AddSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest& request, ::google::cloud::secretmanager::v1::SecretVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>> AsyncAddSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>>(AsyncAddSecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>> PrepareAsyncAddSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>>(PrepareAsyncAddSecretVersionRaw(context, request, cq));
    }
    ::grpc::Status GetSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest& request, ::google::cloud::secretmanager::v1::Secret* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>> AsyncGetSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>>(AsyncGetSecretRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>> PrepareAsyncGetSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>>(PrepareAsyncGetSecretRaw(context, request, cq));
    }
    ::grpc::Status UpdateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest& request, ::google::cloud::secretmanager::v1::Secret* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>> AsyncUpdateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>>(AsyncUpdateSecretRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>> PrepareAsyncUpdateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>>(PrepareAsyncUpdateSecretRaw(context, request, cq));
    }
    ::grpc::Status DeleteSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteSecretRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteSecretRaw(context, request, cq));
    }
    ::grpc::Status ListSecretVersions(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest& request, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>> AsyncListSecretVersions(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>>(AsyncListSecretVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>> PrepareAsyncListSecretVersions(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>>(PrepareAsyncListSecretVersionsRaw(context, request, cq));
    }
    ::grpc::Status GetSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest& request, ::google::cloud::secretmanager::v1::SecretVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>> AsyncGetSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>>(AsyncGetSecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>> PrepareAsyncGetSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>>(PrepareAsyncGetSecretVersionRaw(context, request, cq));
    }
    ::grpc::Status AccessSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest& request, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>> AsyncAccessSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>>(AsyncAccessSecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>> PrepareAsyncAccessSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>>(PrepareAsyncAccessSecretVersionRaw(context, request, cq));
    }
    ::grpc::Status DisableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest& request, ::google::cloud::secretmanager::v1::SecretVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>> AsyncDisableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>>(AsyncDisableSecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>> PrepareAsyncDisableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>>(PrepareAsyncDisableSecretVersionRaw(context, request, cq));
    }
    ::grpc::Status EnableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest& request, ::google::cloud::secretmanager::v1::SecretVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>> AsyncEnableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>>(AsyncEnableSecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>> PrepareAsyncEnableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>>(PrepareAsyncEnableSecretVersionRaw(context, request, cq));
    }
    ::grpc::Status DestroySecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest& request, ::google::cloud::secretmanager::v1::SecretVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>> AsyncDestroySecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>>(AsyncDestroySecretVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>> PrepareAsyncDestroySecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>>(PrepareAsyncDestroySecretVersionRaw(context, request, cq));
    }
    ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListSecrets(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest* request, ::google::cloud::secretmanager::v1::ListSecretsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSecrets(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest* request, ::google::cloud::secretmanager::v1::ListSecretsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, std::function<void(::grpc::Status)>) override;
      void CreateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AddSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, std::function<void(::grpc::Status)>) override;
      void AddSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, std::function<void(::grpc::Status)>) override;
      void GetSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, std::function<void(::grpc::Status)>) override;
      void UpdateSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteSecret(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSecretVersions(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* request, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSecretVersions(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* request, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, std::function<void(::grpc::Status)>) override;
      void GetSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AccessSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* request, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* response, std::function<void(::grpc::Status)>) override;
      void AccessSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* request, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DisableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, std::function<void(::grpc::Status)>) override;
      void DisableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void EnableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, std::function<void(::grpc::Status)>) override;
      void EnableSecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DestroySecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, std::function<void(::grpc::Status)>) override;
      void DestroySecretVersion(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretsResponse>* AsyncListSecretsRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretsResponse>* PrepareAsyncListSecretsRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>* AsyncCreateSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>* PrepareAsyncCreateSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>* AsyncAddSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>* PrepareAsyncAddSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>* AsyncGetSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>* PrepareAsyncGetSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>* AsyncUpdateSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::Secret>* PrepareAsyncUpdateSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteSecretRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>* AsyncListSecretVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>* PrepareAsyncListSecretVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>* AsyncGetSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>* PrepareAsyncGetSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>* AsyncAccessSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>* PrepareAsyncAccessSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>* AsyncDisableSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>* PrepareAsyncDisableSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>* AsyncEnableSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>* PrepareAsyncEnableSecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>* AsyncDestroySecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::secretmanager::v1::SecretVersion>* PrepareAsyncDestroySecretVersionRaw(::grpc::ClientContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListSecrets_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSecret_;
    const ::grpc::internal::RpcMethod rpcmethod_AddSecretVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSecret_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSecret_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteSecret_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSecretVersions_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSecretVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_AccessSecretVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_DisableSecretVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_EnableSecretVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_DestroySecretVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_SetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_TestIamPermissions_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists [Secrets][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status ListSecrets(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest* request, ::google::cloud::secretmanager::v1::ListSecretsResponse* response);
    // Creates a new [Secret][google.cloud.secretmanager.v1.Secret] containing no
    // [SecretVersions][google.cloud.secretmanager.v1.SecretVersion].
    virtual ::grpc::Status CreateSecret(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response);
    // Creates a new [SecretVersion][google.cloud.secretmanager.v1.SecretVersion]
    // containing secret data and attaches it to an existing
    // [Secret][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status AddSecretVersion(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response);
    // Gets metadata for a given [Secret][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status GetSecret(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response);
    // Updates metadata of an existing
    // [Secret][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status UpdateSecret(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response);
    // Deletes a [Secret][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status DeleteSecret(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* request, ::google::protobuf::Empty* response);
    // Lists [SecretVersions][google.cloud.secretmanager.v1.SecretVersion]. This
    // call does not return secret data.
    virtual ::grpc::Status ListSecretVersions(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* request, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* response);
    // Gets metadata for a
    // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    //
    // `projects/*/secrets/*/versions/latest` is an alias to the most recently
    // created [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    virtual ::grpc::Status GetSecretVersion(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response);
    // Accesses a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    // This call returns the secret data.
    //
    // `projects/*/secrets/*/versions/latest` is an alias to the most recently
    // created [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    virtual ::grpc::Status AccessSecretVersion(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* request, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* response);
    // Disables a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    //
    // Sets the [state][google.cloud.secretmanager.v1.SecretVersion.state] of the
    // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion] to
    // [DISABLED][google.cloud.secretmanager.v1.SecretVersion.State.DISABLED].
    virtual ::grpc::Status DisableSecretVersion(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response);
    // Enables a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    //
    // Sets the [state][google.cloud.secretmanager.v1.SecretVersion.state] of the
    // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion] to
    // [ENABLED][google.cloud.secretmanager.v1.SecretVersion.State.ENABLED].
    virtual ::grpc::Status EnableSecretVersion(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response);
    // Destroys a [SecretVersion][google.cloud.secretmanager.v1.SecretVersion].
    //
    // Sets the [state][google.cloud.secretmanager.v1.SecretVersion.state] of the
    // [SecretVersion][google.cloud.secretmanager.v1.SecretVersion] to
    // [DESTROYED][google.cloud.secretmanager.v1.SecretVersion.State.DESTROYED]
    // and irrevocably destroys the secret data.
    virtual ::grpc::Status DestroySecretVersion(::grpc::ServerContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response);
    // Sets the access control policy on the specified secret. Replaces any
    // existing policy.
    //
    // Permissions on
    // [SecretVersions][google.cloud.secretmanager.v1.SecretVersion] are enforced
    // according to the policy set on the associated
    // [Secret][google.cloud.secretmanager.v1.Secret].
    virtual ::grpc::Status SetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Gets the access control policy for a secret.
    // Returns empty policy if the secret exists and does not have a policy set.
    virtual ::grpc::Status GetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Returns permissions that a caller has for the specified secret.
    // If the secret does not exist, this call returns an empty set of
    // permissions, not a NOT_FOUND error.
    //
    // Note: This operation is designed to be used for building permission-aware
    // UIs and command-line tools, not for authorization checking. This operation
    // may "fail open" without warning.
    virtual ::grpc::Status TestIamPermissions(::grpc::ServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSecrets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSecrets() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListSecrets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSecrets(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSecrets(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::ListSecretsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::secretmanager::v1::ListSecretsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSecret() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_CreateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::CreateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSecret(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::CreateSecretRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::secretmanager::v1::Secret>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AddSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AddSecretVersion() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_AddSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddSecretVersion(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::AddSecretVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::secretmanager::v1::SecretVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSecret() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSecret(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::GetSecretRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::secretmanager::v1::Secret>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSecret() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSecret(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::UpdateSecretRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::secretmanager::v1::Secret>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteSecret() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSecret(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::DeleteSecretRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSecretVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSecretVersions() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ListSecretVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSecretVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSecretVersions(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSecretVersion() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSecretVersion(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::GetSecretVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::secretmanager::v1::SecretVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AccessSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AccessSecretVersion() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_AccessSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AccessSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAccessSecretVersion(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DisableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DisableSecretVersion() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_DisableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDisableSecretVersion(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::secretmanager::v1::SecretVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_EnableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_EnableSecretVersion() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_EnableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEnableSecretVersion(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::secretmanager::v1::SecretVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DestroySecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DestroySecretVersion() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_DestroySecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DestroySecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDestroySecretVersion(::grpc::ServerContext* context, ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::secretmanager::v1::SecretVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::SetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::GetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::google::iam::v1::TestIamPermissionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::TestIamPermissionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListSecrets<WithAsyncMethod_CreateSecret<WithAsyncMethod_AddSecretVersion<WithAsyncMethod_GetSecret<WithAsyncMethod_UpdateSecret<WithAsyncMethod_DeleteSecret<WithAsyncMethod_ListSecretVersions<WithAsyncMethod_GetSecretVersion<WithAsyncMethod_AccessSecretVersion<WithAsyncMethod_DisableSecretVersion<WithAsyncMethod_EnableSecretVersion<WithAsyncMethod_DestroySecretVersion<WithAsyncMethod_SetIamPolicy<WithAsyncMethod_GetIamPolicy<WithAsyncMethod_TestIamPermissions<Service > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListSecrets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSecrets() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::ListSecretsRequest, ::google::cloud::secretmanager::v1::ListSecretsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::ListSecretsRequest* request, ::google::cloud::secretmanager::v1::ListSecretsResponse* response) { return this->ListSecrets(context, request, response); }));}
    void SetMessageAllocatorFor_ListSecrets(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::ListSecretsRequest, ::google::cloud::secretmanager::v1::ListSecretsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::ListSecretsRequest, ::google::cloud::secretmanager::v1::ListSecretsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSecrets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSecrets(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSecrets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSecret() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::CreateSecretRequest, ::google::cloud::secretmanager::v1::Secret>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::CreateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response) { return this->CreateSecret(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSecret(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::CreateSecretRequest, ::google::cloud::secretmanager::v1::Secret>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::CreateSecretRequest, ::google::cloud::secretmanager::v1::Secret>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::CreateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSecret(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::CreateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AddSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AddSecretVersion() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::AddSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response) { return this->AddSecretVersion(context, request, response); }));}
    void SetMessageAllocatorFor_AddSecretVersion(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::AddSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::AddSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AddSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddSecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSecret() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::GetSecretRequest, ::google::cloud::secretmanager::v1::Secret>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::GetSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response) { return this->GetSecret(context, request, response); }));}
    void SetMessageAllocatorFor_GetSecret(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::GetSecretRequest, ::google::cloud::secretmanager::v1::Secret>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::GetSecretRequest, ::google::cloud::secretmanager::v1::Secret>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSecret(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSecret() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::UpdateSecretRequest, ::google::cloud::secretmanager::v1::Secret>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* request, ::google::cloud::secretmanager::v1::Secret* response) { return this->UpdateSecret(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSecret(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::UpdateSecretRequest, ::google::cloud::secretmanager::v1::Secret>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::UpdateSecretRequest, ::google::cloud::secretmanager::v1::Secret>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSecret(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteSecret() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::DeleteSecretRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* request, ::google::protobuf::Empty* response) { return this->DeleteSecret(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteSecret(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::DeleteSecretRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::DeleteSecretRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSecret(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSecretVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSecretVersions() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::ListSecretVersionsRequest, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* request, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* response) { return this->ListSecretVersions(context, request, response); }));}
    void SetMessageAllocatorFor_ListSecretVersions(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::ListSecretVersionsRequest, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::ListSecretVersionsRequest, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSecretVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSecretVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSecretVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSecretVersion() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::GetSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response) { return this->GetSecretVersion(context, request, response); }));}
    void SetMessageAllocatorFor_GetSecretVersion(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::GetSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::GetSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AccessSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AccessSecretVersion() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::AccessSecretVersionRequest, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* request, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* response) { return this->AccessSecretVersion(context, request, response); }));}
    void SetMessageAllocatorFor_AccessSecretVersion(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::AccessSecretVersionRequest, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::AccessSecretVersionRequest, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AccessSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AccessSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AccessSecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DisableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DisableSecretVersion() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::DisableSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response) { return this->DisableSecretVersion(context, request, response); }));}
    void SetMessageAllocatorFor_DisableSecretVersion(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::DisableSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::DisableSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DisableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DisableSecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_EnableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_EnableSecretVersion() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::EnableSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response) { return this->EnableSecretVersion(context, request, response); }));}
    void SetMessageAllocatorFor_EnableSecretVersion(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::EnableSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::EnableSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_EnableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* EnableSecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DestroySecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DestroySecretVersion() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::DestroySecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* request, ::google::cloud::secretmanager::v1::SecretVersion* response) { return this->DestroySecretVersion(context, request, response); }));}
    void SetMessageAllocatorFor_DestroySecretVersion(
        ::grpc::MessageAllocator< ::google::cloud::secretmanager::v1::DestroySecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::secretmanager::v1::DestroySecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DestroySecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DestroySecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DestroySecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->SetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_SetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->GetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response) { return this->TestIamPermissions(context, request, response); }));}
    void SetMessageAllocatorFor_TestIamPermissions(
        ::grpc::MessageAllocator< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListSecrets<WithCallbackMethod_CreateSecret<WithCallbackMethod_AddSecretVersion<WithCallbackMethod_GetSecret<WithCallbackMethod_UpdateSecret<WithCallbackMethod_DeleteSecret<WithCallbackMethod_ListSecretVersions<WithCallbackMethod_GetSecretVersion<WithCallbackMethod_AccessSecretVersion<WithCallbackMethod_DisableSecretVersion<WithCallbackMethod_EnableSecretVersion<WithCallbackMethod_DestroySecretVersion<WithCallbackMethod_SetIamPolicy<WithCallbackMethod_GetIamPolicy<WithCallbackMethod_TestIamPermissions<Service > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListSecrets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSecrets() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListSecrets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSecrets(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSecret() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_CreateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::CreateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AddSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AddSecretVersion() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_AddSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSecret() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSecret() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteSecret() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSecretVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSecretVersions() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ListSecretVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSecretVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSecretVersion() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AccessSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AccessSecretVersion() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_AccessSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AccessSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DisableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DisableSecretVersion() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_DisableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_EnableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_EnableSecretVersion() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_EnableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DestroySecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DestroySecretVersion() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_DestroySecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DestroySecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSecrets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSecrets() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListSecrets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSecrets(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSecrets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSecret() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_CreateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::CreateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSecret(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AddSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AddSecretVersion() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_AddSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddSecretVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSecret() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSecret(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSecret() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSecret(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteSecret() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSecret(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSecretVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSecretVersions() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ListSecretVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSecretVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSecretVersions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSecretVersion() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSecretVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AccessSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AccessSecretVersion() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_AccessSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AccessSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAccessSecretVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DisableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DisableSecretVersion() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_DisableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDisableSecretVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_EnableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_EnableSecretVersion() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_EnableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEnableSecretVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DestroySecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DestroySecretVersion() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_DestroySecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DestroySecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDestroySecretVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSecrets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSecrets() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSecrets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSecrets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSecrets(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSecrets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSecret() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSecret(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::CreateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSecret(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AddSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AddSecretVersion() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AddSecretVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_AddSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddSecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSecret() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSecret(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSecret(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSecret() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSecret(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSecret(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteSecret() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteSecret(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSecret(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSecretVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSecretVersions() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSecretVersions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSecretVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSecretVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSecretVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSecretVersion() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSecretVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AccessSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AccessSecretVersion() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AccessSecretVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_AccessSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AccessSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AccessSecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DisableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DisableSecretVersion() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DisableSecretVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_DisableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DisableSecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_EnableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_EnableSecretVersion() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->EnableSecretVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_EnableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* EnableSecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DestroySecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DestroySecretVersion() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DestroySecretVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_DestroySecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DestroySecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DestroySecretVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TestIamPermissions(context, request, response); }));
    }
    ~WithRawCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSecrets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSecrets() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::ListSecretsRequest, ::google::cloud::secretmanager::v1::ListSecretsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::ListSecretsRequest, ::google::cloud::secretmanager::v1::ListSecretsResponse>* streamer) {
                       return this->StreamedListSecrets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSecrets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSecrets(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSecrets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::ListSecretsRequest,::google::cloud::secretmanager::v1::ListSecretsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSecret() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::CreateSecretRequest, ::google::cloud::secretmanager::v1::Secret>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::CreateSecretRequest, ::google::cloud::secretmanager::v1::Secret>* streamer) {
                       return this->StreamedCreateSecret(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::CreateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSecret(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::CreateSecretRequest,::google::cloud::secretmanager::v1::Secret>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AddSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AddSecretVersion() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::AddSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::AddSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>* streamer) {
                       return this->StreamedAddSecretVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AddSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AddSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AddSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAddSecretVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::AddSecretVersionRequest,::google::cloud::secretmanager::v1::SecretVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSecret() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::GetSecretRequest, ::google::cloud::secretmanager::v1::Secret>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::GetSecretRequest, ::google::cloud::secretmanager::v1::Secret>* streamer) {
                       return this->StreamedGetSecret(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSecret(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::GetSecretRequest,::google::cloud::secretmanager::v1::Secret>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSecret() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::UpdateSecretRequest, ::google::cloud::secretmanager::v1::Secret>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::UpdateSecretRequest, ::google::cloud::secretmanager::v1::Secret>* streamer) {
                       return this->StreamedUpdateSecret(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::UpdateSecretRequest* /*request*/, ::google::cloud::secretmanager::v1::Secret* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSecret(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::UpdateSecretRequest,::google::cloud::secretmanager::v1::Secret>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteSecret() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::DeleteSecretRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::DeleteSecretRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteSecret(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DeleteSecretRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteSecret(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::DeleteSecretRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSecretVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSecretVersions() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::ListSecretVersionsRequest, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::ListSecretVersionsRequest, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse>* streamer) {
                       return this->StreamedListSecretVersions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSecretVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSecretVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::ListSecretVersionsRequest* /*request*/, ::google::cloud::secretmanager::v1::ListSecretVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSecretVersions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::ListSecretVersionsRequest,::google::cloud::secretmanager::v1::ListSecretVersionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSecretVersion() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::GetSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::GetSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>* streamer) {
                       return this->StreamedGetSecretVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::GetSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSecretVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::GetSecretVersionRequest,::google::cloud::secretmanager::v1::SecretVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AccessSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AccessSecretVersion() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::AccessSecretVersionRequest, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::AccessSecretVersionRequest, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse>* streamer) {
                       return this->StreamedAccessSecretVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AccessSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AccessSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::AccessSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::AccessSecretVersionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAccessSecretVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::AccessSecretVersionRequest,::google::cloud::secretmanager::v1::AccessSecretVersionResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DisableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DisableSecretVersion() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::DisableSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::DisableSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>* streamer) {
                       return this->StreamedDisableSecretVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DisableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DisableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DisableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDisableSecretVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::DisableSecretVersionRequest,::google::cloud::secretmanager::v1::SecretVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_EnableSecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_EnableSecretVersion() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::EnableSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::EnableSecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>* streamer) {
                       return this->StreamedEnableSecretVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_EnableSecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status EnableSecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::EnableSecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedEnableSecretVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::EnableSecretVersionRequest,::google::cloud::secretmanager::v1::SecretVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DestroySecretVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DestroySecretVersion() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::secretmanager::v1::DestroySecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::secretmanager::v1::DestroySecretVersionRequest, ::google::cloud::secretmanager::v1::SecretVersion>* streamer) {
                       return this->StreamedDestroySecretVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DestroySecretVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DestroySecretVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::secretmanager::v1::DestroySecretVersionRequest* /*request*/, ::google::cloud::secretmanager::v1::SecretVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDestroySecretVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::secretmanager::v1::DestroySecretVersionRequest,::google::cloud::secretmanager::v1::SecretVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedSetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::SetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedGetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::GetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* streamer) {
                       return this->StreamedTestIamPermissions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTestIamPermissions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::TestIamPermissionsRequest,::google::iam::v1::TestIamPermissionsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListSecrets<WithStreamedUnaryMethod_CreateSecret<WithStreamedUnaryMethod_AddSecretVersion<WithStreamedUnaryMethod_GetSecret<WithStreamedUnaryMethod_UpdateSecret<WithStreamedUnaryMethod_DeleteSecret<WithStreamedUnaryMethod_ListSecretVersions<WithStreamedUnaryMethod_GetSecretVersion<WithStreamedUnaryMethod_AccessSecretVersion<WithStreamedUnaryMethod_DisableSecretVersion<WithStreamedUnaryMethod_EnableSecretVersion<WithStreamedUnaryMethod_DestroySecretVersion<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<Service > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListSecrets<WithStreamedUnaryMethod_CreateSecret<WithStreamedUnaryMethod_AddSecretVersion<WithStreamedUnaryMethod_GetSecret<WithStreamedUnaryMethod_UpdateSecret<WithStreamedUnaryMethod_DeleteSecret<WithStreamedUnaryMethod_ListSecretVersions<WithStreamedUnaryMethod_GetSecretVersion<WithStreamedUnaryMethod_AccessSecretVersion<WithStreamedUnaryMethod_DisableSecretVersion<WithStreamedUnaryMethod_EnableSecretVersion<WithStreamedUnaryMethod_DestroySecretVersion<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<Service > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace secretmanager
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fsecretmanager_2fv1_2fservice_2eproto__INCLUDED
