// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/workflows/executions/v1/executions.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fworkflows_2fexecutions_2fv1_2fexecutions_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fworkflows_2fexecutions_2fv1_2fexecutions_2eproto__INCLUDED

#include "google/cloud/workflows/executions/v1/executions.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace workflows {
namespace executions {
namespace v1 {

// Executions is used to start and manage running instances of
// [Workflows][google.cloud.workflows.v1.Workflow] called executions.
class Executions final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.workflows.executions.v1.Executions";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Returns a list of executions which belong to the workflow with
    // the given name. The method returns executions of all workflow
    // revisions. Returned executions are ordered by their start time (newest
    // first).
    virtual ::grpc::Status ListExecutions(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest& request, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>> AsyncListExecutions(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>>(AsyncListExecutionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>> PrepareAsyncListExecutions(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>>(PrepareAsyncListExecutionsRaw(context, request, cq));
    }
    // Creates a new execution using the latest revision of the given workflow.
    virtual ::grpc::Status CreateExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest& request, ::google::cloud::workflows::executions::v1::Execution* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>> AsyncCreateExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>>(AsyncCreateExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>> PrepareAsyncCreateExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>>(PrepareAsyncCreateExecutionRaw(context, request, cq));
    }
    // Returns an execution of the given name.
    virtual ::grpc::Status GetExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest& request, ::google::cloud::workflows::executions::v1::Execution* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>> AsyncGetExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>>(AsyncGetExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>> PrepareAsyncGetExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>>(PrepareAsyncGetExecutionRaw(context, request, cq));
    }
    // Cancels an execution of the given name.
    virtual ::grpc::Status CancelExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest& request, ::google::cloud::workflows::executions::v1::Execution* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>> AsyncCancelExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>>(AsyncCancelExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>> PrepareAsyncCancelExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>>(PrepareAsyncCancelExecutionRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Returns a list of executions which belong to the workflow with
      // the given name. The method returns executions of all workflow
      // revisions. Returned executions are ordered by their start time (newest
      // first).
      virtual void ListExecutions(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* request, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListExecutions(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* request, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new execution using the latest revision of the given workflow.
      virtual void CreateExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns an execution of the given name.
      virtual void GetExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancels an execution of the given name.
      virtual void CancelExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>* AsyncListExecutionsRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>* PrepareAsyncListExecutionsRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>* AsyncCreateExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>* PrepareAsyncCreateExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>* AsyncGetExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>* PrepareAsyncGetExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>* AsyncCancelExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::executions::v1::Execution>* PrepareAsyncCancelExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListExecutions(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest& request, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>> AsyncListExecutions(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>>(AsyncListExecutionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>> PrepareAsyncListExecutions(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>>(PrepareAsyncListExecutionsRaw(context, request, cq));
    }
    ::grpc::Status CreateExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest& request, ::google::cloud::workflows::executions::v1::Execution* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>> AsyncCreateExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>>(AsyncCreateExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>> PrepareAsyncCreateExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>>(PrepareAsyncCreateExecutionRaw(context, request, cq));
    }
    ::grpc::Status GetExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest& request, ::google::cloud::workflows::executions::v1::Execution* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>> AsyncGetExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>>(AsyncGetExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>> PrepareAsyncGetExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>>(PrepareAsyncGetExecutionRaw(context, request, cq));
    }
    ::grpc::Status CancelExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest& request, ::google::cloud::workflows::executions::v1::Execution* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>> AsyncCancelExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>>(AsyncCancelExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>> PrepareAsyncCancelExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>>(PrepareAsyncCancelExecutionRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListExecutions(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* request, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListExecutions(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* request, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, std::function<void(::grpc::Status)>) override;
      void CreateExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, std::function<void(::grpc::Status)>) override;
      void GetExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, std::function<void(::grpc::Status)>) override;
      void CancelExecution(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>* AsyncListExecutionsRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>* PrepareAsyncListExecutionsRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>* AsyncCreateExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>* PrepareAsyncCreateExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>* AsyncGetExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>* PrepareAsyncGetExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>* AsyncCancelExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::executions::v1::Execution>* PrepareAsyncCancelExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListExecutions_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateExecution_;
    const ::grpc::internal::RpcMethod rpcmethod_GetExecution_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelExecution_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Returns a list of executions which belong to the workflow with
    // the given name. The method returns executions of all workflow
    // revisions. Returned executions are ordered by their start time (newest
    // first).
    virtual ::grpc::Status ListExecutions(::grpc::ServerContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* request, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* response);
    // Creates a new execution using the latest revision of the given workflow.
    virtual ::grpc::Status CreateExecution(::grpc::ServerContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response);
    // Returns an execution of the given name.
    virtual ::grpc::Status GetExecution(::grpc::ServerContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response);
    // Cancels an execution of the given name.
    virtual ::grpc::Status CancelExecution(::grpc::ServerContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListExecutions() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* /*request*/, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListExecutions(::grpc::ServerContext* context, ::google::cloud::workflows::executions::v1::ListExecutionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::workflows::executions::v1::ListExecutionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateExecution() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateExecution(::grpc::ServerContext* context, ::google::cloud::workflows::executions::v1::CreateExecutionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::workflows::executions::v1::Execution>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetExecution() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetExecution(::grpc::ServerContext* context, ::google::cloud::workflows::executions::v1::GetExecutionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::workflows::executions::v1::Execution>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelExecution() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_CancelExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelExecution(::grpc::ServerContext* context, ::google::cloud::workflows::executions::v1::CancelExecutionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::workflows::executions::v1::Execution>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListExecutions<WithAsyncMethod_CreateExecution<WithAsyncMethod_GetExecution<WithAsyncMethod_CancelExecution<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListExecutions() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::executions::v1::ListExecutionsRequest, ::google::cloud::workflows::executions::v1::ListExecutionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* request, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* response) { return this->ListExecutions(context, request, response); }));}
    void SetMessageAllocatorFor_ListExecutions(
        ::grpc::MessageAllocator< ::google::cloud::workflows::executions::v1::ListExecutionsRequest, ::google::cloud::workflows::executions::v1::ListExecutionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::executions::v1::ListExecutionsRequest, ::google::cloud::workflows::executions::v1::ListExecutionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* /*request*/, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListExecutions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* /*request*/, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateExecution() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::executions::v1::CreateExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response) { return this->CreateExecution(context, request, response); }));}
    void SetMessageAllocatorFor_CreateExecution(
        ::grpc::MessageAllocator< ::google::cloud::workflows::executions::v1::CreateExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::executions::v1::CreateExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetExecution() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::executions::v1::GetExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response) { return this->GetExecution(context, request, response); }));}
    void SetMessageAllocatorFor_GetExecution(
        ::grpc::MessageAllocator< ::google::cloud::workflows::executions::v1::GetExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::executions::v1::GetExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelExecution() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::executions::v1::CancelExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* request, ::google::cloud::workflows::executions::v1::Execution* response) { return this->CancelExecution(context, request, response); }));}
    void SetMessageAllocatorFor_CancelExecution(
        ::grpc::MessageAllocator< ::google::cloud::workflows::executions::v1::CancelExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::executions::v1::CancelExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListExecutions<WithCallbackMethod_CreateExecution<WithCallbackMethod_GetExecution<WithCallbackMethod_CancelExecution<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListExecutions() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* /*request*/, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateExecution() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetExecution() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelExecution() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_CancelExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListExecutions() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* /*request*/, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListExecutions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateExecution() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateExecution(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetExecution() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetExecution(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelExecution() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_CancelExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelExecution(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListExecutions() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListExecutions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* /*request*/, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListExecutions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateExecution() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateExecution(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetExecution() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetExecution(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelExecution() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelExecution(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListExecutions() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::workflows::executions::v1::ListExecutionsRequest, ::google::cloud::workflows::executions::v1::ListExecutionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::workflows::executions::v1::ListExecutionsRequest, ::google::cloud::workflows::executions::v1::ListExecutionsResponse>* streamer) {
                       return this->StreamedListExecutions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::ListExecutionsRequest* /*request*/, ::google::cloud::workflows::executions::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListExecutions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::workflows::executions::v1::ListExecutionsRequest,::google::cloud::workflows::executions::v1::ListExecutionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateExecution() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::workflows::executions::v1::CreateExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::workflows::executions::v1::CreateExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>* streamer) {
                       return this->StreamedCreateExecution(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CreateExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateExecution(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::workflows::executions::v1::CreateExecutionRequest,::google::cloud::workflows::executions::v1::Execution>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetExecution() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::workflows::executions::v1::GetExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::workflows::executions::v1::GetExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>* streamer) {
                       return this->StreamedGetExecution(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::GetExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetExecution(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::workflows::executions::v1::GetExecutionRequest,::google::cloud::workflows::executions::v1::Execution>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelExecution() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::workflows::executions::v1::CancelExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::workflows::executions::v1::CancelExecutionRequest, ::google::cloud::workflows::executions::v1::Execution>* streamer) {
                       return this->StreamedCancelExecution(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::executions::v1::CancelExecutionRequest* /*request*/, ::google::cloud::workflows::executions::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelExecution(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::workflows::executions::v1::CancelExecutionRequest,::google::cloud::workflows::executions::v1::Execution>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListExecutions<WithStreamedUnaryMethod_CreateExecution<WithStreamedUnaryMethod_GetExecution<WithStreamedUnaryMethod_CancelExecution<Service > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListExecutions<WithStreamedUnaryMethod_CreateExecution<WithStreamedUnaryMethod_GetExecution<WithStreamedUnaryMethod_CancelExecution<Service > > > > StreamedService;
};

}  // namespace v1
}  // namespace executions
}  // namespace workflows
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fworkflows_2fexecutions_2fv1_2fexecutions_2eproto__INCLUDED
