// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/devtools/artifactregistry/v1/service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fdevtools_2fartifactregistry_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fdevtools_2fartifactregistry_2fv1_2fservice_2eproto__INCLUDED

#include "google/devtools/artifactregistry/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace devtools {
namespace artifactregistry {
namespace v1 {

// The Artifact Registry API service.
//
// Artifact Registry is an artifact management system for storing artifacts
// from different package management systems.
//
// The resources managed by this API are:
//
// * Repositories, which group packages and their data.
// * Packages, which group versions and their tags.
// * Versions, which are specific forms of a package.
// * Tags, which represent alternative names for versions.
// * Files, which contain content and are optionally associated with a Package
//   or Version.
class ArtifactRegistry final {
 public:
  static constexpr char const* service_full_name() {
    return "google.devtools.artifactregistry.v1.ArtifactRegistry";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists docker images.
    virtual ::grpc::Status ListDockerImages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest& request, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>> AsyncListDockerImages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>>(AsyncListDockerImagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>> PrepareAsyncListDockerImages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>>(PrepareAsyncListDockerImagesRaw(context, request, cq));
    }
    // Gets a docker image.
    virtual ::grpc::Status GetDockerImage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest& request, ::google::devtools::artifactregistry::v1::DockerImage* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::DockerImage>> AsyncGetDockerImage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::DockerImage>>(AsyncGetDockerImageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::DockerImage>> PrepareAsyncGetDockerImage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::DockerImage>>(PrepareAsyncGetDockerImageRaw(context, request, cq));
    }
    // Lists maven artifacts.
    virtual ::grpc::Status ListMavenArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest& request, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>> AsyncListMavenArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>>(AsyncListMavenArtifactsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>> PrepareAsyncListMavenArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>>(PrepareAsyncListMavenArtifactsRaw(context, request, cq));
    }
    // Gets a maven artifact.
    virtual ::grpc::Status GetMavenArtifact(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest& request, ::google::devtools::artifactregistry::v1::MavenArtifact* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::MavenArtifact>> AsyncGetMavenArtifact(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::MavenArtifact>>(AsyncGetMavenArtifactRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::MavenArtifact>> PrepareAsyncGetMavenArtifact(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::MavenArtifact>>(PrepareAsyncGetMavenArtifactRaw(context, request, cq));
    }
    // Lists npm packages.
    virtual ::grpc::Status ListNpmPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest& request, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>> AsyncListNpmPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>>(AsyncListNpmPackagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>> PrepareAsyncListNpmPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>>(PrepareAsyncListNpmPackagesRaw(context, request, cq));
    }
    // Gets a npm package.
    virtual ::grpc::Status GetNpmPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest& request, ::google::devtools::artifactregistry::v1::NpmPackage* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::NpmPackage>> AsyncGetNpmPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::NpmPackage>>(AsyncGetNpmPackageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::NpmPackage>> PrepareAsyncGetNpmPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::NpmPackage>>(PrepareAsyncGetNpmPackageRaw(context, request, cq));
    }
    // Lists python packages.
    virtual ::grpc::Status ListPythonPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest& request, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>> AsyncListPythonPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>>(AsyncListPythonPackagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>> PrepareAsyncListPythonPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>>(PrepareAsyncListPythonPackagesRaw(context, request, cq));
    }
    // Gets a python package.
    virtual ::grpc::Status GetPythonPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest& request, ::google::devtools::artifactregistry::v1::PythonPackage* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::PythonPackage>> AsyncGetPythonPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::PythonPackage>>(AsyncGetPythonPackageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::PythonPackage>> PrepareAsyncGetPythonPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::PythonPackage>>(PrepareAsyncGetPythonPackageRaw(context, request, cq));
    }
    // Imports Apt artifacts. The returned Operation will complete once the
    // resources are imported. Package, Version, and File resources are created
    // based on the imported artifacts. Imported artifacts that conflict with
    // existing resources are ignored.
    virtual ::grpc::Status ImportAptArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncImportAptArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncImportAptArtifactsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncImportAptArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncImportAptArtifactsRaw(context, request, cq));
    }
    // Imports Yum (RPM) artifacts. The returned Operation will complete once the
    // resources are imported. Package, Version, and File resources are created
    // based on the imported artifacts. Imported artifacts that conflict with
    // existing resources are ignored.
    virtual ::grpc::Status ImportYumArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncImportYumArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncImportYumArtifactsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncImportYumArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncImportYumArtifactsRaw(context, request, cq));
    }
    // Lists repositories.
    virtual ::grpc::Status ListRepositories(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest& request, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>> AsyncListRepositories(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>>(AsyncListRepositoriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>> PrepareAsyncListRepositories(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>>(PrepareAsyncListRepositoriesRaw(context, request, cq));
    }
    // Gets a repository.
    virtual ::grpc::Status GetRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest& request, ::google::devtools::artifactregistry::v1::Repository* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>> AsyncGetRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>>(AsyncGetRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>> PrepareAsyncGetRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>>(PrepareAsyncGetRepositoryRaw(context, request, cq));
    }
    // Creates a repository. The returned Operation will finish once the
    // repository has been created. Its response will be the created Repository.
    virtual ::grpc::Status CreateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateRepositoryRaw(context, request, cq));
    }
    // Updates a repository.
    virtual ::grpc::Status UpdateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest& request, ::google::devtools::artifactregistry::v1::Repository* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>> AsyncUpdateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>>(AsyncUpdateRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>> PrepareAsyncUpdateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>>(PrepareAsyncUpdateRepositoryRaw(context, request, cq));
    }
    // Deletes a repository and all of its contents. The returned Operation will
    // finish once the repository has been deleted. It will not have any Operation
    // metadata and will return a google.protobuf.Empty response.
    virtual ::grpc::Status DeleteRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteRepositoryRaw(context, request, cq));
    }
    // Lists packages.
    virtual ::grpc::Status ListPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest& request, ::google::devtools::artifactregistry::v1::ListPackagesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPackagesResponse>> AsyncListPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPackagesResponse>>(AsyncListPackagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPackagesResponse>> PrepareAsyncListPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPackagesResponse>>(PrepareAsyncListPackagesRaw(context, request, cq));
    }
    // Gets a package.
    virtual ::grpc::Status GetPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest& request, ::google::devtools::artifactregistry::v1::Package* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>> AsyncGetPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>>(AsyncGetPackageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>> PrepareAsyncGetPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>>(PrepareAsyncGetPackageRaw(context, request, cq));
    }
    // Deletes a package and all of its versions and tags. The returned operation
    // will complete once the package has been deleted.
    virtual ::grpc::Status DeletePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeletePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeletePackageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeletePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeletePackageRaw(context, request, cq));
    }
    // Lists versions.
    virtual ::grpc::Status ListVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest& request, ::google::devtools::artifactregistry::v1::ListVersionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListVersionsResponse>> AsyncListVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListVersionsResponse>>(AsyncListVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListVersionsResponse>> PrepareAsyncListVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListVersionsResponse>>(PrepareAsyncListVersionsRaw(context, request, cq));
    }
    // Gets a version
    virtual ::grpc::Status GetVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest& request, ::google::devtools::artifactregistry::v1::Version* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>> AsyncGetVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>>(AsyncGetVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>> PrepareAsyncGetVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>>(PrepareAsyncGetVersionRaw(context, request, cq));
    }
    // Deletes a version and all of its content. The returned operation will
    // complete once the version has been deleted.
    virtual ::grpc::Status DeleteVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteVersionRaw(context, request, cq));
    }
    // Deletes multiple versions across a repository. The returned operation will
    // complete once the versions have been deleted.
    virtual ::grpc::Status BatchDeleteVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchDeleteVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchDeleteVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteVersionsRaw(context, request, cq));
    }
    // Updates a version.
    virtual ::grpc::Status UpdateVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest& request, ::google::devtools::artifactregistry::v1::Version* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>> AsyncUpdateVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>>(AsyncUpdateVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>> PrepareAsyncUpdateVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>>(PrepareAsyncUpdateVersionRaw(context, request, cq));
    }
    // Lists files.
    virtual ::grpc::Status ListFiles(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest& request, ::google::devtools::artifactregistry::v1::ListFilesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListFilesResponse>> AsyncListFiles(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListFilesResponse>>(AsyncListFilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListFilesResponse>> PrepareAsyncListFiles(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListFilesResponse>>(PrepareAsyncListFilesRaw(context, request, cq));
    }
    // Gets a file.
    virtual ::grpc::Status GetFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest& request, ::google::devtools::artifactregistry::v1::File* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>> AsyncGetFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>>(AsyncGetFileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>> PrepareAsyncGetFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>>(PrepareAsyncGetFileRaw(context, request, cq));
    }
    // Deletes a file and all of its content. It is only allowed on generic
    // repositories. The returned operation will complete once the file has been
    // deleted.
    virtual ::grpc::Status DeleteFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteFileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteFileRaw(context, request, cq));
    }
    // Updates a file.
    virtual ::grpc::Status UpdateFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest& request, ::google::devtools::artifactregistry::v1::File* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>> AsyncUpdateFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>>(AsyncUpdateFileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>> PrepareAsyncUpdateFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>>(PrepareAsyncUpdateFileRaw(context, request, cq));
    }
    // Lists tags.
    virtual ::grpc::Status ListTags(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest& request, ::google::devtools::artifactregistry::v1::ListTagsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListTagsResponse>> AsyncListTags(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListTagsResponse>>(AsyncListTagsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListTagsResponse>> PrepareAsyncListTags(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListTagsResponse>>(PrepareAsyncListTagsRaw(context, request, cq));
    }
    // Gets a tag.
    virtual ::grpc::Status GetTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest& request, ::google::devtools::artifactregistry::v1::Tag* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>> AsyncGetTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>>(AsyncGetTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>> PrepareAsyncGetTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>>(PrepareAsyncGetTagRaw(context, request, cq));
    }
    // Creates a tag.
    virtual ::grpc::Status CreateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest& request, ::google::devtools::artifactregistry::v1::Tag* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>> AsyncCreateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>>(AsyncCreateTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>> PrepareAsyncCreateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>>(PrepareAsyncCreateTagRaw(context, request, cq));
    }
    // Updates a tag.
    virtual ::grpc::Status UpdateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest& request, ::google::devtools::artifactregistry::v1::Tag* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>> AsyncUpdateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>>(AsyncUpdateTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>> PrepareAsyncUpdateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>>(PrepareAsyncUpdateTagRaw(context, request, cq));
    }
    // Deletes a tag.
    virtual ::grpc::Status DeleteTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteTagRaw(context, request, cq));
    }
    // Creates a rule.
    virtual ::grpc::Status CreateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest& request, ::google::devtools::artifactregistry::v1::Rule* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>> AsyncCreateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>>(AsyncCreateRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>> PrepareAsyncCreateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>>(PrepareAsyncCreateRuleRaw(context, request, cq));
    }
    // Lists rules.
    virtual ::grpc::Status ListRules(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest& request, ::google::devtools::artifactregistry::v1::ListRulesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRulesResponse>> AsyncListRules(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRulesResponse>>(AsyncListRulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRulesResponse>> PrepareAsyncListRules(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRulesResponse>>(PrepareAsyncListRulesRaw(context, request, cq));
    }
    // Gets a rule.
    virtual ::grpc::Status GetRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest& request, ::google::devtools::artifactregistry::v1::Rule* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>> AsyncGetRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>>(AsyncGetRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>> PrepareAsyncGetRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>>(PrepareAsyncGetRuleRaw(context, request, cq));
    }
    // Updates a rule.
    virtual ::grpc::Status UpdateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest& request, ::google::devtools::artifactregistry::v1::Rule* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>> AsyncUpdateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>>(AsyncUpdateRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>> PrepareAsyncUpdateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>>(PrepareAsyncUpdateRuleRaw(context, request, cq));
    }
    // Deletes a rule.
    virtual ::grpc::Status DeleteRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteRuleRaw(context, request, cq));
    }
    // Updates the IAM policy for a given resource.
    virtual ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    // Gets the IAM policy for a given resource.
    virtual ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    // Tests if the caller has a list of permissions on a resource.
    virtual ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    // Retrieves the Settings for the Project.
    virtual ::grpc::Status GetProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest& request, ::google::devtools::artifactregistry::v1::ProjectSettings* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>> AsyncGetProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>>(AsyncGetProjectSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>> PrepareAsyncGetProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>>(PrepareAsyncGetProjectSettingsRaw(context, request, cq));
    }
    // Updates the Settings for the Project.
    virtual ::grpc::Status UpdateProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest& request, ::google::devtools::artifactregistry::v1::ProjectSettings* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>> AsyncUpdateProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>>(AsyncUpdateProjectSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>> PrepareAsyncUpdateProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>>(PrepareAsyncUpdateProjectSettingsRaw(context, request, cq));
    }
    // Retrieves the VPCSC Config for the Project.
    virtual ::grpc::Status GetVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest& request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>> AsyncGetVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>>(AsyncGetVPCSCConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>> PrepareAsyncGetVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>>(PrepareAsyncGetVPCSCConfigRaw(context, request, cq));
    }
    // Updates the VPCSC Config for the Project.
    virtual ::grpc::Status UpdateVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest& request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>> AsyncUpdateVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>>(AsyncUpdateVPCSCConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>> PrepareAsyncUpdateVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>>(PrepareAsyncUpdateVPCSCConfigRaw(context, request, cq));
    }
    // Updates a package.
    virtual ::grpc::Status UpdatePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest& request, ::google::devtools::artifactregistry::v1::Package* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>> AsyncUpdatePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>>(AsyncUpdatePackageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>> PrepareAsyncUpdatePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>>(PrepareAsyncUpdatePackageRaw(context, request, cq));
    }
    // Lists attachments.
    virtual ::grpc::Status ListAttachments(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest& request, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>> AsyncListAttachments(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>>(AsyncListAttachmentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>> PrepareAsyncListAttachments(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>>(PrepareAsyncListAttachmentsRaw(context, request, cq));
    }
    // Gets an attachment.
    virtual ::grpc::Status GetAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest& request, ::google::devtools::artifactregistry::v1::Attachment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Attachment>> AsyncGetAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Attachment>>(AsyncGetAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Attachment>> PrepareAsyncGetAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Attachment>>(PrepareAsyncGetAttachmentRaw(context, request, cq));
    }
    // Creates an attachment. The returned Operation will finish once the
    // attachment has been created. Its response will be the created attachment.
    virtual ::grpc::Status CreateAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateAttachmentRaw(context, request, cq));
    }
    // Deletes an attachment. The returned Operation will
    // finish once the attachments has been deleted. It will not have any
    // Operation metadata and will return a `google.protobuf.Empty` response.
    virtual ::grpc::Status DeleteAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteAttachmentRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists docker images.
      virtual void ListDockerImages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* request, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDockerImages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* request, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a docker image.
      virtual void GetDockerImage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* request, ::google::devtools::artifactregistry::v1::DockerImage* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDockerImage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* request, ::google::devtools::artifactregistry::v1::DockerImage* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists maven artifacts.
      virtual void ListMavenArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* request, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListMavenArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* request, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a maven artifact.
      virtual void GetMavenArtifact(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* request, ::google::devtools::artifactregistry::v1::MavenArtifact* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetMavenArtifact(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* request, ::google::devtools::artifactregistry::v1::MavenArtifact* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists npm packages.
      virtual void ListNpmPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListNpmPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a npm package.
      virtual void GetNpmPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* request, ::google::devtools::artifactregistry::v1::NpmPackage* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetNpmPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* request, ::google::devtools::artifactregistry::v1::NpmPackage* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists python packages.
      virtual void ListPythonPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPythonPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a python package.
      virtual void GetPythonPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* request, ::google::devtools::artifactregistry::v1::PythonPackage* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPythonPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* request, ::google::devtools::artifactregistry::v1::PythonPackage* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Imports Apt artifacts. The returned Operation will complete once the
      // resources are imported. Package, Version, and File resources are created
      // based on the imported artifacts. Imported artifacts that conflict with
      // existing resources are ignored.
      virtual void ImportAptArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportAptArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Imports Yum (RPM) artifacts. The returned Operation will complete once the
      // resources are imported. Package, Version, and File resources are created
      // based on the imported artifacts. Imported artifacts that conflict with
      // existing resources are ignored.
      virtual void ImportYumArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportYumArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists repositories.
      virtual void ListRepositories(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* request, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRepositories(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* request, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a repository.
      virtual void GetRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a repository. The returned Operation will finish once the
      // repository has been created. Its response will be the created Repository.
      virtual void CreateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a repository.
      virtual void UpdateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a repository and all of its contents. The returned Operation will
      // finish once the repository has been deleted. It will not have any Operation
      // metadata and will return a google.protobuf.Empty response.
      virtual void DeleteRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists packages.
      virtual void ListPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPackagesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPackagesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a package.
      virtual void GetPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a package and all of its versions and tags. The returned operation
      // will complete once the package has been deleted.
      virtual void DeletePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists versions.
      virtual void ListVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* request, ::google::devtools::artifactregistry::v1::ListVersionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* request, ::google::devtools::artifactregistry::v1::ListVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a version
      virtual void GetVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a version and all of its content. The returned operation will
      // complete once the version has been deleted.
      virtual void DeleteVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes multiple versions across a repository. The returned operation will
      // complete once the versions have been deleted.
      virtual void BatchDeleteVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchDeleteVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a version.
      virtual void UpdateVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists files.
      virtual void ListFiles(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest* request, ::google::devtools::artifactregistry::v1::ListFilesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListFiles(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest* request, ::google::devtools::artifactregistry::v1::ListFilesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a file.
      virtual void GetFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest* request, ::google::devtools::artifactregistry::v1::File* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest* request, ::google::devtools::artifactregistry::v1::File* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a file and all of its content. It is only allowed on generic
      // repositories. The returned operation will complete once the file has been
      // deleted.
      virtual void DeleteFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a file.
      virtual void UpdateFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* request, ::google::devtools::artifactregistry::v1::File* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* request, ::google::devtools::artifactregistry::v1::File* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists tags.
      virtual void ListTags(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest* request, ::google::devtools::artifactregistry::v1::ListTagsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTags(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest* request, ::google::devtools::artifactregistry::v1::ListTagsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a tag.
      virtual void GetTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a tag.
      virtual void CreateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a tag.
      virtual void UpdateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a tag.
      virtual void DeleteTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a rule.
      virtual void CreateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists rules.
      virtual void ListRules(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest* request, ::google::devtools::artifactregistry::v1::ListRulesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRules(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest* request, ::google::devtools::artifactregistry::v1::ListRulesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a rule.
      virtual void GetRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a rule.
      virtual void UpdateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a rule.
      virtual void DeleteRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the IAM policy for a given resource.
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the IAM policy for a given resource.
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Tests if the caller has a list of permissions on a resource.
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves the Settings for the Project.
      virtual void GetProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the Settings for the Project.
      virtual void UpdateProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves the VPCSC Config for the Project.
      virtual void GetVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the VPCSC Config for the Project.
      virtual void UpdateVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a package.
      virtual void UpdatePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdatePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists attachments.
      virtual void ListAttachments(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* request, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAttachments(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* request, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets an attachment.
      virtual void GetAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* request, ::google::devtools::artifactregistry::v1::Attachment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* request, ::google::devtools::artifactregistry::v1::Attachment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an attachment. The returned Operation will finish once the
      // attachment has been created. Its response will be the created attachment.
      virtual void CreateAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an attachment. The returned Operation will
      // finish once the attachments has been deleted. It will not have any
      // Operation metadata and will return a `google.protobuf.Empty` response.
      virtual void DeleteAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>* AsyncListDockerImagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>* PrepareAsyncListDockerImagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::DockerImage>* AsyncGetDockerImageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::DockerImage>* PrepareAsyncGetDockerImageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>* AsyncListMavenArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>* PrepareAsyncListMavenArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::MavenArtifact>* AsyncGetMavenArtifactRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::MavenArtifact>* PrepareAsyncGetMavenArtifactRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>* AsyncListNpmPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>* PrepareAsyncListNpmPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::NpmPackage>* AsyncGetNpmPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::NpmPackage>* PrepareAsyncGetNpmPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>* AsyncListPythonPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>* PrepareAsyncListPythonPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::PythonPackage>* AsyncGetPythonPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::PythonPackage>* PrepareAsyncGetPythonPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncImportAptArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncImportAptArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncImportYumArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncImportYumArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>* AsyncListRepositoriesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>* PrepareAsyncListRepositoriesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>* AsyncGetRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>* PrepareAsyncGetRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>* AsyncUpdateRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Repository>* PrepareAsyncUpdateRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPackagesResponse>* AsyncListPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListPackagesResponse>* PrepareAsyncListPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>* AsyncGetPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>* PrepareAsyncGetPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeletePackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeletePackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListVersionsResponse>* AsyncListVersionsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListVersionsResponse>* PrepareAsyncListVersionsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>* AsyncGetVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>* PrepareAsyncGetVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchDeleteVersionsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteVersionsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>* AsyncUpdateVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Version>* PrepareAsyncUpdateVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListFilesResponse>* AsyncListFilesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListFilesResponse>* PrepareAsyncListFilesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>* AsyncGetFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>* PrepareAsyncGetFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>* AsyncUpdateFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::File>* PrepareAsyncUpdateFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListTagsResponse>* AsyncListTagsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListTagsResponse>* PrepareAsyncListTagsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>* AsyncGetTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>* PrepareAsyncGetTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>* AsyncCreateTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>* PrepareAsyncCreateTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>* AsyncUpdateTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Tag>* PrepareAsyncUpdateTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>* AsyncCreateRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>* PrepareAsyncCreateRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRulesResponse>* AsyncListRulesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListRulesResponse>* PrepareAsyncListRulesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>* AsyncGetRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>* PrepareAsyncGetRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>* AsyncUpdateRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Rule>* PrepareAsyncUpdateRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>* AsyncGetProjectSettingsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>* PrepareAsyncGetProjectSettingsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>* AsyncUpdateProjectSettingsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ProjectSettings>* PrepareAsyncUpdateProjectSettingsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>* AsyncGetVPCSCConfigRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>* PrepareAsyncGetVPCSCConfigRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>* AsyncUpdateVPCSCConfigRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::VPCSCConfig>* PrepareAsyncUpdateVPCSCConfigRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>* AsyncUpdatePackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Package>* PrepareAsyncUpdatePackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>* AsyncListAttachmentsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>* PrepareAsyncListAttachmentsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Attachment>* AsyncGetAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::artifactregistry::v1::Attachment>* PrepareAsyncGetAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListDockerImages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest& request, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>> AsyncListDockerImages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>>(AsyncListDockerImagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>> PrepareAsyncListDockerImages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>>(PrepareAsyncListDockerImagesRaw(context, request, cq));
    }
    ::grpc::Status GetDockerImage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest& request, ::google::devtools::artifactregistry::v1::DockerImage* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::DockerImage>> AsyncGetDockerImage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::DockerImage>>(AsyncGetDockerImageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::DockerImage>> PrepareAsyncGetDockerImage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::DockerImage>>(PrepareAsyncGetDockerImageRaw(context, request, cq));
    }
    ::grpc::Status ListMavenArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest& request, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>> AsyncListMavenArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>>(AsyncListMavenArtifactsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>> PrepareAsyncListMavenArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>>(PrepareAsyncListMavenArtifactsRaw(context, request, cq));
    }
    ::grpc::Status GetMavenArtifact(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest& request, ::google::devtools::artifactregistry::v1::MavenArtifact* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::MavenArtifact>> AsyncGetMavenArtifact(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::MavenArtifact>>(AsyncGetMavenArtifactRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::MavenArtifact>> PrepareAsyncGetMavenArtifact(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::MavenArtifact>>(PrepareAsyncGetMavenArtifactRaw(context, request, cq));
    }
    ::grpc::Status ListNpmPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest& request, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>> AsyncListNpmPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>>(AsyncListNpmPackagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>> PrepareAsyncListNpmPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>>(PrepareAsyncListNpmPackagesRaw(context, request, cq));
    }
    ::grpc::Status GetNpmPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest& request, ::google::devtools::artifactregistry::v1::NpmPackage* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::NpmPackage>> AsyncGetNpmPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::NpmPackage>>(AsyncGetNpmPackageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::NpmPackage>> PrepareAsyncGetNpmPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::NpmPackage>>(PrepareAsyncGetNpmPackageRaw(context, request, cq));
    }
    ::grpc::Status ListPythonPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest& request, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>> AsyncListPythonPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>>(AsyncListPythonPackagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>> PrepareAsyncListPythonPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>>(PrepareAsyncListPythonPackagesRaw(context, request, cq));
    }
    ::grpc::Status GetPythonPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest& request, ::google::devtools::artifactregistry::v1::PythonPackage* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::PythonPackage>> AsyncGetPythonPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::PythonPackage>>(AsyncGetPythonPackageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::PythonPackage>> PrepareAsyncGetPythonPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::PythonPackage>>(PrepareAsyncGetPythonPackageRaw(context, request, cq));
    }
    ::grpc::Status ImportAptArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncImportAptArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncImportAptArtifactsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncImportAptArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncImportAptArtifactsRaw(context, request, cq));
    }
    ::grpc::Status ImportYumArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncImportYumArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncImportYumArtifactsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncImportYumArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncImportYumArtifactsRaw(context, request, cq));
    }
    ::grpc::Status ListRepositories(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest& request, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>> AsyncListRepositories(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>>(AsyncListRepositoriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>> PrepareAsyncListRepositories(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>>(PrepareAsyncListRepositoriesRaw(context, request, cq));
    }
    ::grpc::Status GetRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest& request, ::google::devtools::artifactregistry::v1::Repository* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>> AsyncGetRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>>(AsyncGetRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>> PrepareAsyncGetRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>>(PrepareAsyncGetRepositoryRaw(context, request, cq));
    }
    ::grpc::Status CreateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateRepositoryRaw(context, request, cq));
    }
    ::grpc::Status UpdateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest& request, ::google::devtools::artifactregistry::v1::Repository* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>> AsyncUpdateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>>(AsyncUpdateRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>> PrepareAsyncUpdateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>>(PrepareAsyncUpdateRepositoryRaw(context, request, cq));
    }
    ::grpc::Status DeleteRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteRepositoryRaw(context, request, cq));
    }
    ::grpc::Status ListPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest& request, ::google::devtools::artifactregistry::v1::ListPackagesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPackagesResponse>> AsyncListPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPackagesResponse>>(AsyncListPackagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPackagesResponse>> PrepareAsyncListPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPackagesResponse>>(PrepareAsyncListPackagesRaw(context, request, cq));
    }
    ::grpc::Status GetPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest& request, ::google::devtools::artifactregistry::v1::Package* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>> AsyncGetPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>>(AsyncGetPackageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>> PrepareAsyncGetPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>>(PrepareAsyncGetPackageRaw(context, request, cq));
    }
    ::grpc::Status DeletePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeletePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeletePackageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeletePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeletePackageRaw(context, request, cq));
    }
    ::grpc::Status ListVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest& request, ::google::devtools::artifactregistry::v1::ListVersionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListVersionsResponse>> AsyncListVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListVersionsResponse>>(AsyncListVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListVersionsResponse>> PrepareAsyncListVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListVersionsResponse>>(PrepareAsyncListVersionsRaw(context, request, cq));
    }
    ::grpc::Status GetVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest& request, ::google::devtools::artifactregistry::v1::Version* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>> AsyncGetVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>>(AsyncGetVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>> PrepareAsyncGetVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>>(PrepareAsyncGetVersionRaw(context, request, cq));
    }
    ::grpc::Status DeleteVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteVersionRaw(context, request, cq));
    }
    ::grpc::Status BatchDeleteVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchDeleteVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchDeleteVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteVersionsRaw(context, request, cq));
    }
    ::grpc::Status UpdateVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest& request, ::google::devtools::artifactregistry::v1::Version* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>> AsyncUpdateVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>>(AsyncUpdateVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>> PrepareAsyncUpdateVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>>(PrepareAsyncUpdateVersionRaw(context, request, cq));
    }
    ::grpc::Status ListFiles(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest& request, ::google::devtools::artifactregistry::v1::ListFilesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListFilesResponse>> AsyncListFiles(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListFilesResponse>>(AsyncListFilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListFilesResponse>> PrepareAsyncListFiles(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListFilesResponse>>(PrepareAsyncListFilesRaw(context, request, cq));
    }
    ::grpc::Status GetFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest& request, ::google::devtools::artifactregistry::v1::File* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>> AsyncGetFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>>(AsyncGetFileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>> PrepareAsyncGetFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>>(PrepareAsyncGetFileRaw(context, request, cq));
    }
    ::grpc::Status DeleteFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteFileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteFileRaw(context, request, cq));
    }
    ::grpc::Status UpdateFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest& request, ::google::devtools::artifactregistry::v1::File* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>> AsyncUpdateFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>>(AsyncUpdateFileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>> PrepareAsyncUpdateFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>>(PrepareAsyncUpdateFileRaw(context, request, cq));
    }
    ::grpc::Status ListTags(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest& request, ::google::devtools::artifactregistry::v1::ListTagsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListTagsResponse>> AsyncListTags(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListTagsResponse>>(AsyncListTagsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListTagsResponse>> PrepareAsyncListTags(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListTagsResponse>>(PrepareAsyncListTagsRaw(context, request, cq));
    }
    ::grpc::Status GetTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest& request, ::google::devtools::artifactregistry::v1::Tag* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>> AsyncGetTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>>(AsyncGetTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>> PrepareAsyncGetTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>>(PrepareAsyncGetTagRaw(context, request, cq));
    }
    ::grpc::Status CreateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest& request, ::google::devtools::artifactregistry::v1::Tag* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>> AsyncCreateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>>(AsyncCreateTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>> PrepareAsyncCreateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>>(PrepareAsyncCreateTagRaw(context, request, cq));
    }
    ::grpc::Status UpdateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest& request, ::google::devtools::artifactregistry::v1::Tag* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>> AsyncUpdateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>>(AsyncUpdateTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>> PrepareAsyncUpdateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>>(PrepareAsyncUpdateTagRaw(context, request, cq));
    }
    ::grpc::Status DeleteTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteTagRaw(context, request, cq));
    }
    ::grpc::Status CreateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest& request, ::google::devtools::artifactregistry::v1::Rule* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>> AsyncCreateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>>(AsyncCreateRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>> PrepareAsyncCreateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>>(PrepareAsyncCreateRuleRaw(context, request, cq));
    }
    ::grpc::Status ListRules(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest& request, ::google::devtools::artifactregistry::v1::ListRulesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRulesResponse>> AsyncListRules(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRulesResponse>>(AsyncListRulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRulesResponse>> PrepareAsyncListRules(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRulesResponse>>(PrepareAsyncListRulesRaw(context, request, cq));
    }
    ::grpc::Status GetRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest& request, ::google::devtools::artifactregistry::v1::Rule* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>> AsyncGetRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>>(AsyncGetRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>> PrepareAsyncGetRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>>(PrepareAsyncGetRuleRaw(context, request, cq));
    }
    ::grpc::Status UpdateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest& request, ::google::devtools::artifactregistry::v1::Rule* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>> AsyncUpdateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>>(AsyncUpdateRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>> PrepareAsyncUpdateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>>(PrepareAsyncUpdateRuleRaw(context, request, cq));
    }
    ::grpc::Status DeleteRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteRuleRaw(context, request, cq));
    }
    ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    ::grpc::Status GetProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest& request, ::google::devtools::artifactregistry::v1::ProjectSettings* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>> AsyncGetProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>>(AsyncGetProjectSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>> PrepareAsyncGetProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>>(PrepareAsyncGetProjectSettingsRaw(context, request, cq));
    }
    ::grpc::Status UpdateProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest& request, ::google::devtools::artifactregistry::v1::ProjectSettings* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>> AsyncUpdateProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>>(AsyncUpdateProjectSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>> PrepareAsyncUpdateProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>>(PrepareAsyncUpdateProjectSettingsRaw(context, request, cq));
    }
    ::grpc::Status GetVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest& request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>> AsyncGetVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>>(AsyncGetVPCSCConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>> PrepareAsyncGetVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>>(PrepareAsyncGetVPCSCConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest& request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>> AsyncUpdateVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>>(AsyncUpdateVPCSCConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>> PrepareAsyncUpdateVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>>(PrepareAsyncUpdateVPCSCConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdatePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest& request, ::google::devtools::artifactregistry::v1::Package* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>> AsyncUpdatePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>>(AsyncUpdatePackageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>> PrepareAsyncUpdatePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>>(PrepareAsyncUpdatePackageRaw(context, request, cq));
    }
    ::grpc::Status ListAttachments(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest& request, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>> AsyncListAttachments(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>>(AsyncListAttachmentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>> PrepareAsyncListAttachments(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>>(PrepareAsyncListAttachmentsRaw(context, request, cq));
    }
    ::grpc::Status GetAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest& request, ::google::devtools::artifactregistry::v1::Attachment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Attachment>> AsyncGetAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Attachment>>(AsyncGetAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Attachment>> PrepareAsyncGetAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Attachment>>(PrepareAsyncGetAttachmentRaw(context, request, cq));
    }
    ::grpc::Status CreateAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateAttachmentRaw(context, request, cq));
    }
    ::grpc::Status DeleteAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteAttachmentRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListDockerImages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* request, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDockerImages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* request, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDockerImage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* request, ::google::devtools::artifactregistry::v1::DockerImage* response, std::function<void(::grpc::Status)>) override;
      void GetDockerImage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* request, ::google::devtools::artifactregistry::v1::DockerImage* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListMavenArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* request, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListMavenArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* request, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetMavenArtifact(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* request, ::google::devtools::artifactregistry::v1::MavenArtifact* response, std::function<void(::grpc::Status)>) override;
      void GetMavenArtifact(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* request, ::google::devtools::artifactregistry::v1::MavenArtifact* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListNpmPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListNpmPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetNpmPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* request, ::google::devtools::artifactregistry::v1::NpmPackage* response, std::function<void(::grpc::Status)>) override;
      void GetNpmPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* request, ::google::devtools::artifactregistry::v1::NpmPackage* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPythonPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPythonPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPythonPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* request, ::google::devtools::artifactregistry::v1::PythonPackage* response, std::function<void(::grpc::Status)>) override;
      void GetPythonPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* request, ::google::devtools::artifactregistry::v1::PythonPackage* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportAptArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ImportAptArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportYumArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ImportYumArtifacts(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRepositories(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* request, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRepositories(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* request, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response, std::function<void(::grpc::Status)>) override;
      void GetRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response, std::function<void(::grpc::Status)>) override;
      void UpdateRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteRepository(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPackagesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPackages(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPackagesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response, std::function<void(::grpc::Status)>) override;
      void GetPackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeletePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* request, ::google::devtools::artifactregistry::v1::ListVersionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* request, ::google::devtools::artifactregistry::v1::ListVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response, std::function<void(::grpc::Status)>) override;
      void GetVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchDeleteVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchDeleteVersions(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response, std::function<void(::grpc::Status)>) override;
      void UpdateVersion(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListFiles(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest* request, ::google::devtools::artifactregistry::v1::ListFilesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListFiles(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest* request, ::google::devtools::artifactregistry::v1::ListFilesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest* request, ::google::devtools::artifactregistry::v1::File* response, std::function<void(::grpc::Status)>) override;
      void GetFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest* request, ::google::devtools::artifactregistry::v1::File* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* request, ::google::devtools::artifactregistry::v1::File* response, std::function<void(::grpc::Status)>) override;
      void UpdateFile(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* request, ::google::devtools::artifactregistry::v1::File* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTags(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest* request, ::google::devtools::artifactregistry::v1::ListTagsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTags(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest* request, ::google::devtools::artifactregistry::v1::ListTagsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, std::function<void(::grpc::Status)>) override;
      void GetTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, std::function<void(::grpc::Status)>) override;
      void CreateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, std::function<void(::grpc::Status)>) override;
      void UpdateTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteTag(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, std::function<void(::grpc::Status)>) override;
      void CreateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRules(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest* request, ::google::devtools::artifactregistry::v1::ListRulesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRules(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest* request, ::google::devtools::artifactregistry::v1::ListRulesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, std::function<void(::grpc::Status)>) override;
      void GetRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, std::function<void(::grpc::Status)>) override;
      void UpdateRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteRule(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response, std::function<void(::grpc::Status)>) override;
      void GetProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response, std::function<void(::grpc::Status)>) override;
      void UpdateProjectSettings(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response, std::function<void(::grpc::Status)>) override;
      void GetVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response, std::function<void(::grpc::Status)>) override;
      void UpdateVPCSCConfig(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdatePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response, std::function<void(::grpc::Status)>) override;
      void UpdatePackage(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAttachments(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* request, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAttachments(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* request, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* request, ::google::devtools::artifactregistry::v1::Attachment* response, std::function<void(::grpc::Status)>) override;
      void GetAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* request, ::google::devtools::artifactregistry::v1::Attachment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteAttachment(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>* AsyncListDockerImagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>* PrepareAsyncListDockerImagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::DockerImage>* AsyncGetDockerImageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::DockerImage>* PrepareAsyncGetDockerImageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>* AsyncListMavenArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>* PrepareAsyncListMavenArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::MavenArtifact>* AsyncGetMavenArtifactRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::MavenArtifact>* PrepareAsyncGetMavenArtifactRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>* AsyncListNpmPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>* PrepareAsyncListNpmPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::NpmPackage>* AsyncGetNpmPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::NpmPackage>* PrepareAsyncGetNpmPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>* AsyncListPythonPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>* PrepareAsyncListPythonPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::PythonPackage>* AsyncGetPythonPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::PythonPackage>* PrepareAsyncGetPythonPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncImportAptArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncImportAptArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncImportYumArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncImportYumArtifactsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>* AsyncListRepositoriesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>* PrepareAsyncListRepositoriesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>* AsyncGetRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>* PrepareAsyncGetRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>* AsyncUpdateRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Repository>* PrepareAsyncUpdateRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteRepositoryRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPackagesResponse>* AsyncListPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListPackagesResponse>* PrepareAsyncListPackagesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>* AsyncGetPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>* PrepareAsyncGetPackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeletePackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeletePackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListVersionsResponse>* AsyncListVersionsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListVersionsResponse>* PrepareAsyncListVersionsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>* AsyncGetVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>* PrepareAsyncGetVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchDeleteVersionsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteVersionsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>* AsyncUpdateVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Version>* PrepareAsyncUpdateVersionRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListFilesResponse>* AsyncListFilesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListFilesResponse>* PrepareAsyncListFilesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>* AsyncGetFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>* PrepareAsyncGetFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>* AsyncUpdateFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::File>* PrepareAsyncUpdateFileRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListTagsResponse>* AsyncListTagsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListTagsResponse>* PrepareAsyncListTagsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>* AsyncGetTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>* PrepareAsyncGetTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>* AsyncCreateTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>* PrepareAsyncCreateTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>* AsyncUpdateTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Tag>* PrepareAsyncUpdateTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteTagRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>* AsyncCreateRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>* PrepareAsyncCreateRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRulesResponse>* AsyncListRulesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListRulesResponse>* PrepareAsyncListRulesRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>* AsyncGetRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>* PrepareAsyncGetRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>* AsyncUpdateRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Rule>* PrepareAsyncUpdateRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteRuleRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>* AsyncGetProjectSettingsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>* PrepareAsyncGetProjectSettingsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>* AsyncUpdateProjectSettingsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ProjectSettings>* PrepareAsyncUpdateProjectSettingsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>* AsyncGetVPCSCConfigRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>* PrepareAsyncGetVPCSCConfigRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>* AsyncUpdateVPCSCConfigRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::VPCSCConfig>* PrepareAsyncUpdateVPCSCConfigRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>* AsyncUpdatePackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Package>* PrepareAsyncUpdatePackageRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>* AsyncListAttachmentsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>* PrepareAsyncListAttachmentsRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Attachment>* AsyncGetAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::artifactregistry::v1::Attachment>* PrepareAsyncGetAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteAttachmentRaw(::grpc::ClientContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListDockerImages_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDockerImage_;
    const ::grpc::internal::RpcMethod rpcmethod_ListMavenArtifacts_;
    const ::grpc::internal::RpcMethod rpcmethod_GetMavenArtifact_;
    const ::grpc::internal::RpcMethod rpcmethod_ListNpmPackages_;
    const ::grpc::internal::RpcMethod rpcmethod_GetNpmPackage_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPythonPackages_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPythonPackage_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportAptArtifacts_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportYumArtifacts_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRepositories_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRepository_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateRepository_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateRepository_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteRepository_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPackages_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPackage_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePackage_;
    const ::grpc::internal::RpcMethod rpcmethod_ListVersions_;
    const ::grpc::internal::RpcMethod rpcmethod_GetVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchDeleteVersions_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_ListFiles_;
    const ::grpc::internal::RpcMethod rpcmethod_GetFile_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteFile_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateFile_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTags_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTag_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTag_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTag_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTag_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateRule_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRules_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRule_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateRule_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteRule_;
    const ::grpc::internal::RpcMethod rpcmethod_SetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_TestIamPermissions_;
    const ::grpc::internal::RpcMethod rpcmethod_GetProjectSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateProjectSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_GetVPCSCConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateVPCSCConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdatePackage_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAttachments_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAttachment_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAttachment_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAttachment_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists docker images.
    virtual ::grpc::Status ListDockerImages(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* request, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* response);
    // Gets a docker image.
    virtual ::grpc::Status GetDockerImage(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* request, ::google::devtools::artifactregistry::v1::DockerImage* response);
    // Lists maven artifacts.
    virtual ::grpc::Status ListMavenArtifacts(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* request, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* response);
    // Gets a maven artifact.
    virtual ::grpc::Status GetMavenArtifact(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* request, ::google::devtools::artifactregistry::v1::MavenArtifact* response);
    // Lists npm packages.
    virtual ::grpc::Status ListNpmPackages(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* response);
    // Gets a npm package.
    virtual ::grpc::Status GetNpmPackage(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* request, ::google::devtools::artifactregistry::v1::NpmPackage* response);
    // Lists python packages.
    virtual ::grpc::Status ListPythonPackages(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* response);
    // Gets a python package.
    virtual ::grpc::Status GetPythonPackage(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* request, ::google::devtools::artifactregistry::v1::PythonPackage* response);
    // Imports Apt artifacts. The returned Operation will complete once the
    // resources are imported. Package, Version, and File resources are created
    // based on the imported artifacts. Imported artifacts that conflict with
    // existing resources are ignored.
    virtual ::grpc::Status ImportAptArtifacts(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* request, ::google::longrunning::Operation* response);
    // Imports Yum (RPM) artifacts. The returned Operation will complete once the
    // resources are imported. Package, Version, and File resources are created
    // based on the imported artifacts. Imported artifacts that conflict with
    // existing resources are ignored.
    virtual ::grpc::Status ImportYumArtifacts(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* request, ::google::longrunning::Operation* response);
    // Lists repositories.
    virtual ::grpc::Status ListRepositories(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* request, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* response);
    // Gets a repository.
    virtual ::grpc::Status GetRepository(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response);
    // Creates a repository. The returned Operation will finish once the
    // repository has been created. Its response will be the created Repository.
    virtual ::grpc::Status CreateRepository(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response);
    // Updates a repository.
    virtual ::grpc::Status UpdateRepository(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response);
    // Deletes a repository and all of its contents. The returned Operation will
    // finish once the repository has been deleted. It will not have any Operation
    // metadata and will return a google.protobuf.Empty response.
    virtual ::grpc::Status DeleteRepository(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response);
    // Lists packages.
    virtual ::grpc::Status ListPackages(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPackagesResponse* response);
    // Gets a package.
    virtual ::grpc::Status GetPackage(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response);
    // Deletes a package and all of its versions and tags. The returned operation
    // will complete once the package has been deleted.
    virtual ::grpc::Status DeletePackage(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* request, ::google::longrunning::Operation* response);
    // Lists versions.
    virtual ::grpc::Status ListVersions(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* request, ::google::devtools::artifactregistry::v1::ListVersionsResponse* response);
    // Gets a version
    virtual ::grpc::Status GetVersion(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response);
    // Deletes a version and all of its content. The returned operation will
    // complete once the version has been deleted.
    virtual ::grpc::Status DeleteVersion(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response);
    // Deletes multiple versions across a repository. The returned operation will
    // complete once the versions have been deleted.
    virtual ::grpc::Status BatchDeleteVersions(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* request, ::google::longrunning::Operation* response);
    // Updates a version.
    virtual ::grpc::Status UpdateVersion(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response);
    // Lists files.
    virtual ::grpc::Status ListFiles(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest* request, ::google::devtools::artifactregistry::v1::ListFilesResponse* response);
    // Gets a file.
    virtual ::grpc::Status GetFile(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest* request, ::google::devtools::artifactregistry::v1::File* response);
    // Deletes a file and all of its content. It is only allowed on generic
    // repositories. The returned operation will complete once the file has been
    // deleted.
    virtual ::grpc::Status DeleteFile(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* request, ::google::longrunning::Operation* response);
    // Updates a file.
    virtual ::grpc::Status UpdateFile(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* request, ::google::devtools::artifactregistry::v1::File* response);
    // Lists tags.
    virtual ::grpc::Status ListTags(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest* request, ::google::devtools::artifactregistry::v1::ListTagsResponse* response);
    // Gets a tag.
    virtual ::grpc::Status GetTag(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response);
    // Creates a tag.
    virtual ::grpc::Status CreateTag(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response);
    // Updates a tag.
    virtual ::grpc::Status UpdateTag(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response);
    // Deletes a tag.
    virtual ::grpc::Status DeleteTag(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response);
    // Creates a rule.
    virtual ::grpc::Status CreateRule(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response);
    // Lists rules.
    virtual ::grpc::Status ListRules(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest* request, ::google::devtools::artifactregistry::v1::ListRulesResponse* response);
    // Gets a rule.
    virtual ::grpc::Status GetRule(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response);
    // Updates a rule.
    virtual ::grpc::Status UpdateRule(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response);
    // Deletes a rule.
    virtual ::grpc::Status DeleteRule(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* request, ::google::protobuf::Empty* response);
    // Updates the IAM policy for a given resource.
    virtual ::grpc::Status SetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Gets the IAM policy for a given resource.
    virtual ::grpc::Status GetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Tests if the caller has a list of permissions on a resource.
    virtual ::grpc::Status TestIamPermissions(::grpc::ServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response);
    // Retrieves the Settings for the Project.
    virtual ::grpc::Status GetProjectSettings(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response);
    // Updates the Settings for the Project.
    virtual ::grpc::Status UpdateProjectSettings(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response);
    // Retrieves the VPCSC Config for the Project.
    virtual ::grpc::Status GetVPCSCConfig(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response);
    // Updates the VPCSC Config for the Project.
    virtual ::grpc::Status UpdateVPCSCConfig(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response);
    // Updates a package.
    virtual ::grpc::Status UpdatePackage(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response);
    // Lists attachments.
    virtual ::grpc::Status ListAttachments(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* request, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* response);
    // Gets an attachment.
    virtual ::grpc::Status GetAttachment(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* request, ::google::devtools::artifactregistry::v1::Attachment* response);
    // Creates an attachment. The returned Operation will finish once the
    // attachment has been created. Its response will be the created attachment.
    virtual ::grpc::Status CreateAttachment(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* request, ::google::longrunning::Operation* response);
    // Deletes an attachment. The returned Operation will
    // finish once the attachments has been deleted. It will not have any
    // Operation metadata and will return a `google.protobuf.Empty` response.
    virtual ::grpc::Status DeleteAttachment(::grpc::ServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDockerImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDockerImages() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListDockerImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDockerImages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDockerImages(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDockerImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDockerImage() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetDockerImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDockerImage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* /*request*/, ::google::devtools::artifactregistry::v1::DockerImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDockerImage(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetDockerImageRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::DockerImage>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListMavenArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListMavenArtifacts() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListMavenArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMavenArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListMavenArtifacts(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetMavenArtifact : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetMavenArtifact() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetMavenArtifact() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMavenArtifact(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* /*request*/, ::google::devtools::artifactregistry::v1::MavenArtifact* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetMavenArtifact(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::MavenArtifact>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListNpmPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListNpmPackages() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListNpmPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNpmPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNpmPackages(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetNpmPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetNpmPackage() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_GetNpmPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNpmPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::NpmPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNpmPackage(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::NpmPackage>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPythonPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPythonPackages() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ListPythonPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPythonPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPythonPackages(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPythonPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPythonPackage() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetPythonPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPythonPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::PythonPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPythonPackage(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::PythonPackage>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportAptArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportAptArtifacts() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ImportAptArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportAptArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportAptArtifacts(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportYumArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportYumArtifacts() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ImportYumArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportYumArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportYumArtifacts(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRepositories() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRepositories(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRepository() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRepository(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetRepositoryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Repository>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateRepository() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRepository(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateRepository() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_UpdateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRepository(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Repository>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRepository(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPackages() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_ListPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPackages(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ListPackagesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ListPackagesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPackage() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_GetPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPackage(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetPackageRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Package>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePackage() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_DeletePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePackage(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::DeletePackageRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListVersions() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVersions(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ListVersionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ListVersionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetVersion() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVersion(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Version>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteVersion(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::DeleteVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchDeleteVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchDeleteVersions() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_BatchDeleteVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteVersions(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVersion(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::UpdateVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Version>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListFiles() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_ListFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFiles(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListFilesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFiles(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ListFilesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ListFilesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetFile() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_GetFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFile(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetFileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::File>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteFile() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_DeleteFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFile(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::DeleteFileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateFile() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_UpdateFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFile(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::UpdateFileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::File>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTags() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListTagsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTags(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ListTagsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ListTagsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTag() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_GetTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTag(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetTagRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Tag>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTag() {
      ::grpc::Service::MarkMethodAsync(29);
    }
    ~WithAsyncMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTag(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::CreateTagRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Tag>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTag() {
      ::grpc::Service::MarkMethodAsync(30);
    }
    ~WithAsyncMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTag(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::UpdateTagRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Tag>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTag() {
      ::grpc::Service::MarkMethodAsync(31);
    }
    ~WithAsyncMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTag(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::DeleteTagRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateRule() {
      ::grpc::Service::MarkMethodAsync(32);
    }
    ~WithAsyncMethod_CreateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRule(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::CreateRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Rule>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRules() {
      ::grpc::Service::MarkMethodAsync(33);
    }
    ~WithAsyncMethod_ListRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRules(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRulesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRules(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ListRulesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ListRulesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRule() {
      ::grpc::Service::MarkMethodAsync(34);
    }
    ~WithAsyncMethod_GetRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRule(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Rule>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateRule() {
      ::grpc::Service::MarkMethodAsync(35);
    }
    ~WithAsyncMethod_UpdateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRule(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::UpdateRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Rule>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteRule() {
      ::grpc::Service::MarkMethodAsync(36);
    }
    ~WithAsyncMethod_DeleteRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRule(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::DeleteRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(37);
    }
    ~WithAsyncMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::SetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(38);
    }
    ~WithAsyncMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::GetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodAsync(39);
    }
    ~WithAsyncMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::google::iam::v1::TestIamPermissionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::TestIamPermissionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(39, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetProjectSettings() {
      ::grpc::Service::MarkMethodAsync(40);
    }
    ~WithAsyncMethod_GetProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProjectSettings(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ProjectSettings>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(40, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateProjectSettings() {
      ::grpc::Service::MarkMethodAsync(41);
    }
    ~WithAsyncMethod_UpdateProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProjectSettings(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ProjectSettings>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(41, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetVPCSCConfig() {
      ::grpc::Service::MarkMethodAsync(42);
    }
    ~WithAsyncMethod_GetVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVPCSCConfig(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::VPCSCConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(42, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateVPCSCConfig() {
      ::grpc::Service::MarkMethodAsync(43);
    }
    ~WithAsyncMethod_UpdateVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVPCSCConfig(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::VPCSCConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(43, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdatePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdatePackage() {
      ::grpc::Service::MarkMethodAsync(44);
    }
    ~WithAsyncMethod_UpdatePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePackage(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::UpdatePackageRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Package>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(44, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAttachments() {
      ::grpc::Service::MarkMethodAsync(45);
    }
    ~WithAsyncMethod_ListAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAttachments(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAttachments(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(45, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAttachment() {
      ::grpc::Service::MarkMethodAsync(46);
    }
    ~WithAsyncMethod_GetAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* /*request*/, ::google::devtools::artifactregistry::v1::Attachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAttachment(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::GetAttachmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::artifactregistry::v1::Attachment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(46, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAttachment() {
      ::grpc::Service::MarkMethodAsync(47);
    }
    ~WithAsyncMethod_CreateAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAttachment(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(47, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAttachment() {
      ::grpc::Service::MarkMethodAsync(48);
    }
    ~WithAsyncMethod_DeleteAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAttachment(::grpc::ServerContext* context, ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(48, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListDockerImages<WithAsyncMethod_GetDockerImage<WithAsyncMethod_ListMavenArtifacts<WithAsyncMethod_GetMavenArtifact<WithAsyncMethod_ListNpmPackages<WithAsyncMethod_GetNpmPackage<WithAsyncMethod_ListPythonPackages<WithAsyncMethod_GetPythonPackage<WithAsyncMethod_ImportAptArtifacts<WithAsyncMethod_ImportYumArtifacts<WithAsyncMethod_ListRepositories<WithAsyncMethod_GetRepository<WithAsyncMethod_CreateRepository<WithAsyncMethod_UpdateRepository<WithAsyncMethod_DeleteRepository<WithAsyncMethod_ListPackages<WithAsyncMethod_GetPackage<WithAsyncMethod_DeletePackage<WithAsyncMethod_ListVersions<WithAsyncMethod_GetVersion<WithAsyncMethod_DeleteVersion<WithAsyncMethod_BatchDeleteVersions<WithAsyncMethod_UpdateVersion<WithAsyncMethod_ListFiles<WithAsyncMethod_GetFile<WithAsyncMethod_DeleteFile<WithAsyncMethod_UpdateFile<WithAsyncMethod_ListTags<WithAsyncMethod_GetTag<WithAsyncMethod_CreateTag<WithAsyncMethod_UpdateTag<WithAsyncMethod_DeleteTag<WithAsyncMethod_CreateRule<WithAsyncMethod_ListRules<WithAsyncMethod_GetRule<WithAsyncMethod_UpdateRule<WithAsyncMethod_DeleteRule<WithAsyncMethod_SetIamPolicy<WithAsyncMethod_GetIamPolicy<WithAsyncMethod_TestIamPermissions<WithAsyncMethod_GetProjectSettings<WithAsyncMethod_UpdateProjectSettings<WithAsyncMethod_GetVPCSCConfig<WithAsyncMethod_UpdateVPCSCConfig<WithAsyncMethod_UpdatePackage<WithAsyncMethod_ListAttachments<WithAsyncMethod_GetAttachment<WithAsyncMethod_CreateAttachment<WithAsyncMethod_DeleteAttachment<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListDockerImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDockerImages() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListDockerImagesRequest, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* request, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* response) { return this->ListDockerImages(context, request, response); }));}
    void SetMessageAllocatorFor_ListDockerImages(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ListDockerImagesRequest, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListDockerImagesRequest, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDockerImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDockerImages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDockerImages(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDockerImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDockerImage() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetDockerImageRequest, ::google::devtools::artifactregistry::v1::DockerImage>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* request, ::google::devtools::artifactregistry::v1::DockerImage* response) { return this->GetDockerImage(context, request, response); }));}
    void SetMessageAllocatorFor_GetDockerImage(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetDockerImageRequest, ::google::devtools::artifactregistry::v1::DockerImage>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetDockerImageRequest, ::google::devtools::artifactregistry::v1::DockerImage>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDockerImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDockerImage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* /*request*/, ::google::devtools::artifactregistry::v1::DockerImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDockerImage(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* /*request*/, ::google::devtools::artifactregistry::v1::DockerImage* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListMavenArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListMavenArtifacts() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* request, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* response) { return this->ListMavenArtifacts(context, request, response); }));}
    void SetMessageAllocatorFor_ListMavenArtifacts(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListMavenArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMavenArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListMavenArtifacts(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetMavenArtifact : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetMavenArtifact() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest, ::google::devtools::artifactregistry::v1::MavenArtifact>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* request, ::google::devtools::artifactregistry::v1::MavenArtifact* response) { return this->GetMavenArtifact(context, request, response); }));}
    void SetMessageAllocatorFor_GetMavenArtifact(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest, ::google::devtools::artifactregistry::v1::MavenArtifact>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest, ::google::devtools::artifactregistry::v1::MavenArtifact>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetMavenArtifact() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMavenArtifact(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* /*request*/, ::google::devtools::artifactregistry::v1::MavenArtifact* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetMavenArtifact(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* /*request*/, ::google::devtools::artifactregistry::v1::MavenArtifact* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListNpmPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListNpmPackages() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* response) { return this->ListNpmPackages(context, request, response); }));}
    void SetMessageAllocatorFor_ListNpmPackages(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListNpmPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNpmPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNpmPackages(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetNpmPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetNpmPackage() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetNpmPackageRequest, ::google::devtools::artifactregistry::v1::NpmPackage>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* request, ::google::devtools::artifactregistry::v1::NpmPackage* response) { return this->GetNpmPackage(context, request, response); }));}
    void SetMessageAllocatorFor_GetNpmPackage(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetNpmPackageRequest, ::google::devtools::artifactregistry::v1::NpmPackage>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetNpmPackageRequest, ::google::devtools::artifactregistry::v1::NpmPackage>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetNpmPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNpmPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::NpmPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNpmPackage(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::NpmPackage* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPythonPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPythonPackages() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* response) { return this->ListPythonPackages(context, request, response); }));}
    void SetMessageAllocatorFor_ListPythonPackages(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPythonPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPythonPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPythonPackages(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPythonPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPythonPackage() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetPythonPackageRequest, ::google::devtools::artifactregistry::v1::PythonPackage>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* request, ::google::devtools::artifactregistry::v1::PythonPackage* response) { return this->GetPythonPackage(context, request, response); }));}
    void SetMessageAllocatorFor_GetPythonPackage(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetPythonPackageRequest, ::google::devtools::artifactregistry::v1::PythonPackage>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetPythonPackageRequest, ::google::devtools::artifactregistry::v1::PythonPackage>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPythonPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPythonPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::PythonPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPythonPackage(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::PythonPackage* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportAptArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportAptArtifacts() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* request, ::google::longrunning::Operation* response) { return this->ImportAptArtifacts(context, request, response); }));}
    void SetMessageAllocatorFor_ImportAptArtifacts(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportAptArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportAptArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportAptArtifacts(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportYumArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportYumArtifacts() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* request, ::google::longrunning::Operation* response) { return this->ImportYumArtifacts(context, request, response); }));}
    void SetMessageAllocatorFor_ImportYumArtifacts(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportYumArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportYumArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportYumArtifacts(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRepositories() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListRepositoriesRequest, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* request, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* response) { return this->ListRepositories(context, request, response); }));}
    void SetMessageAllocatorFor_ListRepositories(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ListRepositoriesRequest, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListRepositoriesRequest, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRepositories(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRepository() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetRepositoryRequest, ::google::devtools::artifactregistry::v1::Repository>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response) { return this->GetRepository(context, request, response); }));}
    void SetMessageAllocatorFor_GetRepository(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetRepositoryRequest, ::google::devtools::artifactregistry::v1::Repository>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetRepositoryRequest, ::google::devtools::artifactregistry::v1::Repository>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateRepository() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::CreateRepositoryRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response) { return this->CreateRepository(context, request, response); }));}
    void SetMessageAllocatorFor_CreateRepository(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::CreateRepositoryRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::CreateRepositoryRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateRepository() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest, ::google::devtools::artifactregistry::v1::Repository>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* request, ::google::devtools::artifactregistry::v1::Repository* response) { return this->UpdateRepository(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateRepository(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest, ::google::devtools::artifactregistry::v1::Repository>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest, ::google::devtools::artifactregistry::v1::Repository>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response) { return this->DeleteRepository(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteRepository(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPackages() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListPackagesRequest, ::google::devtools::artifactregistry::v1::ListPackagesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* request, ::google::devtools::artifactregistry::v1::ListPackagesResponse* response) { return this->ListPackages(context, request, response); }));}
    void SetMessageAllocatorFor_ListPackages(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ListPackagesRequest, ::google::devtools::artifactregistry::v1::ListPackagesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListPackagesRequest, ::google::devtools::artifactregistry::v1::ListPackagesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPackages(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPackagesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPackage() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetPackageRequest, ::google::devtools::artifactregistry::v1::Package>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetPackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response) { return this->GetPackage(context, request, response); }));}
    void SetMessageAllocatorFor_GetPackage(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetPackageRequest, ::google::devtools::artifactregistry::v1::Package>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetPackageRequest, ::google::devtools::artifactregistry::v1::Package>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPackage(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePackage() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeletePackageRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* request, ::google::longrunning::Operation* response) { return this->DeletePackage(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePackage(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::DeletePackageRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeletePackageRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePackage(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListVersions() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListVersionsRequest, ::google::devtools::artifactregistry::v1::ListVersionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* request, ::google::devtools::artifactregistry::v1::ListVersionsResponse* response) { return this->ListVersions(context, request, response); }));}
    void SetMessageAllocatorFor_ListVersions(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ListVersionsRequest, ::google::devtools::artifactregistry::v1::ListVersionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListVersionsRequest, ::google::devtools::artifactregistry::v1::ListVersionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListVersionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetVersion() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetVersionRequest, ::google::devtools::artifactregistry::v1::Version>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response) { return this->GetVersion(context, request, response); }));}
    void SetMessageAllocatorFor_GetVersion(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetVersionRequest, ::google::devtools::artifactregistry::v1::Version>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetVersionRequest, ::google::devtools::artifactregistry::v1::Version>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteVersionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response) { return this->DeleteVersion(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteVersion(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::DeleteVersionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteVersionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchDeleteVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchDeleteVersions() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* request, ::google::longrunning::Operation* response) { return this->BatchDeleteVersions(context, request, response); }));}
    void SetMessageAllocatorFor_BatchDeleteVersions(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchDeleteVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchDeleteVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateVersionRequest, ::google::devtools::artifactregistry::v1::Version>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* request, ::google::devtools::artifactregistry::v1::Version* response) { return this->UpdateVersion(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateVersion(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::UpdateVersionRequest, ::google::devtools::artifactregistry::v1::Version>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateVersionRequest, ::google::devtools::artifactregistry::v1::Version>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListFiles() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListFilesRequest, ::google::devtools::artifactregistry::v1::ListFilesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ListFilesRequest* request, ::google::devtools::artifactregistry::v1::ListFilesResponse* response) { return this->ListFiles(context, request, response); }));}
    void SetMessageAllocatorFor_ListFiles(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ListFilesRequest, ::google::devtools::artifactregistry::v1::ListFilesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListFilesRequest, ::google::devtools::artifactregistry::v1::ListFilesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFiles(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListFilesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFiles(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListFilesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListFilesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetFile() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetFileRequest, ::google::devtools::artifactregistry::v1::File>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetFileRequest* request, ::google::devtools::artifactregistry::v1::File* response) { return this->GetFile(context, request, response); }));}
    void SetMessageAllocatorFor_GetFile(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetFileRequest, ::google::devtools::artifactregistry::v1::File>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetFileRequest, ::google::devtools::artifactregistry::v1::File>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteFile() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteFileRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* request, ::google::longrunning::Operation* response) { return this->DeleteFile(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteFile(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::DeleteFileRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteFileRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateFile() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateFileRequest, ::google::devtools::artifactregistry::v1::File>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* request, ::google::devtools::artifactregistry::v1::File* response) { return this->UpdateFile(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateFile(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::UpdateFileRequest, ::google::devtools::artifactregistry::v1::File>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateFileRequest, ::google::devtools::artifactregistry::v1::File>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTags() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListTagsRequest, ::google::devtools::artifactregistry::v1::ListTagsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ListTagsRequest* request, ::google::devtools::artifactregistry::v1::ListTagsResponse* response) { return this->ListTags(context, request, response); }));}
    void SetMessageAllocatorFor_ListTags(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ListTagsRequest, ::google::devtools::artifactregistry::v1::ListTagsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListTagsRequest, ::google::devtools::artifactregistry::v1::ListTagsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListTagsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTags(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListTagsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListTagsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTag() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetTagRequest, ::google::devtools::artifactregistry::v1::Tag>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response) { return this->GetTag(context, request, response); }));}
    void SetMessageAllocatorFor_GetTag(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetTagRequest, ::google::devtools::artifactregistry::v1::Tag>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetTagRequest, ::google::devtools::artifactregistry::v1::Tag>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTag(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTag() {
      ::grpc::Service::MarkMethodCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::CreateTagRequest, ::google::devtools::artifactregistry::v1::Tag>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::CreateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response) { return this->CreateTag(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTag(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::CreateTagRequest, ::google::devtools::artifactregistry::v1::Tag>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(29);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::CreateTagRequest, ::google::devtools::artifactregistry::v1::Tag>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTag(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTag() {
      ::grpc::Service::MarkMethodCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateTagRequest, ::google::devtools::artifactregistry::v1::Tag>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* request, ::google::devtools::artifactregistry::v1::Tag* response) { return this->UpdateTag(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTag(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::UpdateTagRequest, ::google::devtools::artifactregistry::v1::Tag>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(30);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateTagRequest, ::google::devtools::artifactregistry::v1::Tag>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTag(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTag() {
      ::grpc::Service::MarkMethodCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteTagRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response) { return this->DeleteTag(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTag(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::DeleteTagRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(31);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteTagRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTag(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateRule() {
      ::grpc::Service::MarkMethodCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::CreateRuleRequest, ::google::devtools::artifactregistry::v1::Rule>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response) { return this->CreateRule(context, request, response); }));}
    void SetMessageAllocatorFor_CreateRule(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::CreateRuleRequest, ::google::devtools::artifactregistry::v1::Rule>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(32);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::CreateRuleRequest, ::google::devtools::artifactregistry::v1::Rule>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRules() {
      ::grpc::Service::MarkMethodCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListRulesRequest, ::google::devtools::artifactregistry::v1::ListRulesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ListRulesRequest* request, ::google::devtools::artifactregistry::v1::ListRulesResponse* response) { return this->ListRules(context, request, response); }));}
    void SetMessageAllocatorFor_ListRules(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ListRulesRequest, ::google::devtools::artifactregistry::v1::ListRulesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(33);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListRulesRequest, ::google::devtools::artifactregistry::v1::ListRulesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRules(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRulesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRules(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRulesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRulesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRule() {
      ::grpc::Service::MarkMethodCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetRuleRequest, ::google::devtools::artifactregistry::v1::Rule>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response) { return this->GetRule(context, request, response); }));}
    void SetMessageAllocatorFor_GetRule(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetRuleRequest, ::google::devtools::artifactregistry::v1::Rule>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(34);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetRuleRequest, ::google::devtools::artifactregistry::v1::Rule>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateRule() {
      ::grpc::Service::MarkMethodCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateRuleRequest, ::google::devtools::artifactregistry::v1::Rule>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* request, ::google::devtools::artifactregistry::v1::Rule* response) { return this->UpdateRule(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateRule(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::UpdateRuleRequest, ::google::devtools::artifactregistry::v1::Rule>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(35);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateRuleRequest, ::google::devtools::artifactregistry::v1::Rule>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteRule() {
      ::grpc::Service::MarkMethodCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteRuleRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* request, ::google::protobuf::Empty* response) { return this->DeleteRule(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteRule(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::DeleteRuleRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(36);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteRuleRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->SetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_SetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(37);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->GetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(38);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodCallback(39,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response) { return this->TestIamPermissions(context, request, response); }));}
    void SetMessageAllocatorFor_TestIamPermissions(
        ::grpc::MessageAllocator< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(39);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetProjectSettings() {
      ::grpc::Service::MarkMethodCallback(40,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest, ::google::devtools::artifactregistry::v1::ProjectSettings>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response) { return this->GetProjectSettings(context, request, response); }));}
    void SetMessageAllocatorFor_GetProjectSettings(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest, ::google::devtools::artifactregistry::v1::ProjectSettings>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(40);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest, ::google::devtools::artifactregistry::v1::ProjectSettings>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProjectSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateProjectSettings() {
      ::grpc::Service::MarkMethodCallback(41,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest, ::google::devtools::artifactregistry::v1::ProjectSettings>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* request, ::google::devtools::artifactregistry::v1::ProjectSettings* response) { return this->UpdateProjectSettings(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateProjectSettings(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest, ::google::devtools::artifactregistry::v1::ProjectSettings>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(41);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest, ::google::devtools::artifactregistry::v1::ProjectSettings>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProjectSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetVPCSCConfig() {
      ::grpc::Service::MarkMethodCallback(42,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest, ::google::devtools::artifactregistry::v1::VPCSCConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response) { return this->GetVPCSCConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetVPCSCConfig(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest, ::google::devtools::artifactregistry::v1::VPCSCConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(42);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest, ::google::devtools::artifactregistry::v1::VPCSCConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVPCSCConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateVPCSCConfig() {
      ::grpc::Service::MarkMethodCallback(43,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest, ::google::devtools::artifactregistry::v1::VPCSCConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* request, ::google::devtools::artifactregistry::v1::VPCSCConfig* response) { return this->UpdateVPCSCConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateVPCSCConfig(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest, ::google::devtools::artifactregistry::v1::VPCSCConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(43);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest, ::google::devtools::artifactregistry::v1::VPCSCConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVPCSCConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdatePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdatePackage() {
      ::grpc::Service::MarkMethodCallback(44,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdatePackageRequest, ::google::devtools::artifactregistry::v1::Package>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* request, ::google::devtools::artifactregistry::v1::Package* response) { return this->UpdatePackage(context, request, response); }));}
    void SetMessageAllocatorFor_UpdatePackage(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::UpdatePackageRequest, ::google::devtools::artifactregistry::v1::Package>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(44);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::UpdatePackageRequest, ::google::devtools::artifactregistry::v1::Package>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdatePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePackage(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAttachments() {
      ::grpc::Service::MarkMethodCallback(45,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListAttachmentsRequest, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* request, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* response) { return this->ListAttachments(context, request, response); }));}
    void SetMessageAllocatorFor_ListAttachments(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::ListAttachmentsRequest, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(45);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::ListAttachmentsRequest, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAttachments(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAttachments(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAttachment() {
      ::grpc::Service::MarkMethodCallback(46,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetAttachmentRequest, ::google::devtools::artifactregistry::v1::Attachment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* request, ::google::devtools::artifactregistry::v1::Attachment* response) { return this->GetAttachment(context, request, response); }));}
    void SetMessageAllocatorFor_GetAttachment(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::GetAttachmentRequest, ::google::devtools::artifactregistry::v1::Attachment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(46);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::GetAttachmentRequest, ::google::devtools::artifactregistry::v1::Attachment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* /*request*/, ::google::devtools::artifactregistry::v1::Attachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* /*request*/, ::google::devtools::artifactregistry::v1::Attachment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAttachment() {
      ::grpc::Service::MarkMethodCallback(47,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::CreateAttachmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* request, ::google::longrunning::Operation* response) { return this->CreateAttachment(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAttachment(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::CreateAttachmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(47);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::CreateAttachmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAttachment() {
      ::grpc::Service::MarkMethodCallback(48,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* request, ::google::longrunning::Operation* response) { return this->DeleteAttachment(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAttachment(
        ::grpc::MessageAllocator< ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(48);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListDockerImages<WithCallbackMethod_GetDockerImage<WithCallbackMethod_ListMavenArtifacts<WithCallbackMethod_GetMavenArtifact<WithCallbackMethod_ListNpmPackages<WithCallbackMethod_GetNpmPackage<WithCallbackMethod_ListPythonPackages<WithCallbackMethod_GetPythonPackage<WithCallbackMethod_ImportAptArtifacts<WithCallbackMethod_ImportYumArtifacts<WithCallbackMethod_ListRepositories<WithCallbackMethod_GetRepository<WithCallbackMethod_CreateRepository<WithCallbackMethod_UpdateRepository<WithCallbackMethod_DeleteRepository<WithCallbackMethod_ListPackages<WithCallbackMethod_GetPackage<WithCallbackMethod_DeletePackage<WithCallbackMethod_ListVersions<WithCallbackMethod_GetVersion<WithCallbackMethod_DeleteVersion<WithCallbackMethod_BatchDeleteVersions<WithCallbackMethod_UpdateVersion<WithCallbackMethod_ListFiles<WithCallbackMethod_GetFile<WithCallbackMethod_DeleteFile<WithCallbackMethod_UpdateFile<WithCallbackMethod_ListTags<WithCallbackMethod_GetTag<WithCallbackMethod_CreateTag<WithCallbackMethod_UpdateTag<WithCallbackMethod_DeleteTag<WithCallbackMethod_CreateRule<WithCallbackMethod_ListRules<WithCallbackMethod_GetRule<WithCallbackMethod_UpdateRule<WithCallbackMethod_DeleteRule<WithCallbackMethod_SetIamPolicy<WithCallbackMethod_GetIamPolicy<WithCallbackMethod_TestIamPermissions<WithCallbackMethod_GetProjectSettings<WithCallbackMethod_UpdateProjectSettings<WithCallbackMethod_GetVPCSCConfig<WithCallbackMethod_UpdateVPCSCConfig<WithCallbackMethod_UpdatePackage<WithCallbackMethod_ListAttachments<WithCallbackMethod_GetAttachment<WithCallbackMethod_CreateAttachment<WithCallbackMethod_DeleteAttachment<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListDockerImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDockerImages() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListDockerImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDockerImages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDockerImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDockerImage() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetDockerImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDockerImage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* /*request*/, ::google::devtools::artifactregistry::v1::DockerImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListMavenArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListMavenArtifacts() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListMavenArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMavenArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetMavenArtifact : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetMavenArtifact() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetMavenArtifact() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMavenArtifact(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* /*request*/, ::google::devtools::artifactregistry::v1::MavenArtifact* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListNpmPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListNpmPackages() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListNpmPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNpmPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetNpmPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetNpmPackage() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_GetNpmPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNpmPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::NpmPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPythonPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPythonPackages() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ListPythonPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPythonPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPythonPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPythonPackage() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetPythonPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPythonPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::PythonPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportAptArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportAptArtifacts() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ImportAptArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportAptArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportYumArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportYumArtifacts() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ImportYumArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportYumArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRepositories() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRepository() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateRepository() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateRepository() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_UpdateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPackages() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_ListPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPackage() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_GetPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePackage() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_DeletePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListVersions() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetVersion() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchDeleteVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchDeleteVersions() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_BatchDeleteVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListFiles() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_ListFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFiles(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListFilesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetFile() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_GetFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteFile() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_DeleteFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateFile() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_UpdateFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTags() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListTagsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTag() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_GetTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTag() {
      ::grpc::Service::MarkMethodGeneric(29);
    }
    ~WithGenericMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTag() {
      ::grpc::Service::MarkMethodGeneric(30);
    }
    ~WithGenericMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTag() {
      ::grpc::Service::MarkMethodGeneric(31);
    }
    ~WithGenericMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateRule() {
      ::grpc::Service::MarkMethodGeneric(32);
    }
    ~WithGenericMethod_CreateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRules() {
      ::grpc::Service::MarkMethodGeneric(33);
    }
    ~WithGenericMethod_ListRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRules(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRulesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRule() {
      ::grpc::Service::MarkMethodGeneric(34);
    }
    ~WithGenericMethod_GetRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateRule() {
      ::grpc::Service::MarkMethodGeneric(35);
    }
    ~WithGenericMethod_UpdateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteRule() {
      ::grpc::Service::MarkMethodGeneric(36);
    }
    ~WithGenericMethod_DeleteRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(37);
    }
    ~WithGenericMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(38);
    }
    ~WithGenericMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodGeneric(39);
    }
    ~WithGenericMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetProjectSettings() {
      ::grpc::Service::MarkMethodGeneric(40);
    }
    ~WithGenericMethod_GetProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateProjectSettings() {
      ::grpc::Service::MarkMethodGeneric(41);
    }
    ~WithGenericMethod_UpdateProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetVPCSCConfig() {
      ::grpc::Service::MarkMethodGeneric(42);
    }
    ~WithGenericMethod_GetVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateVPCSCConfig() {
      ::grpc::Service::MarkMethodGeneric(43);
    }
    ~WithGenericMethod_UpdateVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdatePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdatePackage() {
      ::grpc::Service::MarkMethodGeneric(44);
    }
    ~WithGenericMethod_UpdatePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAttachments() {
      ::grpc::Service::MarkMethodGeneric(45);
    }
    ~WithGenericMethod_ListAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAttachments(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAttachment() {
      ::grpc::Service::MarkMethodGeneric(46);
    }
    ~WithGenericMethod_GetAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* /*request*/, ::google::devtools::artifactregistry::v1::Attachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAttachment() {
      ::grpc::Service::MarkMethodGeneric(47);
    }
    ~WithGenericMethod_CreateAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAttachment() {
      ::grpc::Service::MarkMethodGeneric(48);
    }
    ~WithGenericMethod_DeleteAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDockerImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDockerImages() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListDockerImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDockerImages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDockerImages(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDockerImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDockerImage() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetDockerImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDockerImage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* /*request*/, ::google::devtools::artifactregistry::v1::DockerImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDockerImage(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListMavenArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListMavenArtifacts() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListMavenArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMavenArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListMavenArtifacts(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetMavenArtifact : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetMavenArtifact() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetMavenArtifact() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMavenArtifact(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* /*request*/, ::google::devtools::artifactregistry::v1::MavenArtifact* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetMavenArtifact(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListNpmPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListNpmPackages() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListNpmPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNpmPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNpmPackages(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetNpmPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetNpmPackage() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_GetNpmPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNpmPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::NpmPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNpmPackage(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPythonPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPythonPackages() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ListPythonPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPythonPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPythonPackages(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPythonPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPythonPackage() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetPythonPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPythonPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::PythonPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPythonPackage(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportAptArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportAptArtifacts() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ImportAptArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportAptArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportAptArtifacts(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportYumArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportYumArtifacts() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ImportYumArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportYumArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportYumArtifacts(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRepositories() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRepositories(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRepository() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRepository(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateRepository() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRepository(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateRepository() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_UpdateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRepository(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRepository(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPackages() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_ListPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPackages(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPackage() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_GetPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPackage(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePackage() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_DeletePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePackage(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListVersions() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVersions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetVersion() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchDeleteVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchDeleteVersions() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_BatchDeleteVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteVersions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListFiles() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_ListFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFiles(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListFilesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFiles(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetFile() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_GetFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteFile() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_DeleteFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateFile() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_UpdateFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTags() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListTagsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTags(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTag() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_GetTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTag(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTag() {
      ::grpc::Service::MarkMethodRaw(29);
    }
    ~WithRawMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTag(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTag() {
      ::grpc::Service::MarkMethodRaw(30);
    }
    ~WithRawMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTag(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTag() {
      ::grpc::Service::MarkMethodRaw(31);
    }
    ~WithRawMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTag(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateRule() {
      ::grpc::Service::MarkMethodRaw(32);
    }
    ~WithRawMethod_CreateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRules() {
      ::grpc::Service::MarkMethodRaw(33);
    }
    ~WithRawMethod_ListRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRules(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRulesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRules(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRule() {
      ::grpc::Service::MarkMethodRaw(34);
    }
    ~WithRawMethod_GetRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateRule() {
      ::grpc::Service::MarkMethodRaw(35);
    }
    ~WithRawMethod_UpdateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteRule() {
      ::grpc::Service::MarkMethodRaw(36);
    }
    ~WithRawMethod_DeleteRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(37);
    }
    ~WithRawMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(38);
    }
    ~WithRawMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRaw(39);
    }
    ~WithRawMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(39, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetProjectSettings() {
      ::grpc::Service::MarkMethodRaw(40);
    }
    ~WithRawMethod_GetProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProjectSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(40, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateProjectSettings() {
      ::grpc::Service::MarkMethodRaw(41);
    }
    ~WithRawMethod_UpdateProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProjectSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(41, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetVPCSCConfig() {
      ::grpc::Service::MarkMethodRaw(42);
    }
    ~WithRawMethod_GetVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVPCSCConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(42, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateVPCSCConfig() {
      ::grpc::Service::MarkMethodRaw(43);
    }
    ~WithRawMethod_UpdateVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVPCSCConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(43, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdatePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdatePackage() {
      ::grpc::Service::MarkMethodRaw(44);
    }
    ~WithRawMethod_UpdatePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePackage(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(44, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAttachments() {
      ::grpc::Service::MarkMethodRaw(45);
    }
    ~WithRawMethod_ListAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAttachments(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAttachments(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(45, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAttachment() {
      ::grpc::Service::MarkMethodRaw(46);
    }
    ~WithRawMethod_GetAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* /*request*/, ::google::devtools::artifactregistry::v1::Attachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAttachment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(46, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAttachment() {
      ::grpc::Service::MarkMethodRaw(47);
    }
    ~WithRawMethod_CreateAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAttachment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(47, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAttachment() {
      ::grpc::Service::MarkMethodRaw(48);
    }
    ~WithRawMethod_DeleteAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAttachment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(48, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDockerImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDockerImages() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDockerImages(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDockerImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDockerImages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDockerImages(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDockerImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDockerImage() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDockerImage(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDockerImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDockerImage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* /*request*/, ::google::devtools::artifactregistry::v1::DockerImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDockerImage(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListMavenArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListMavenArtifacts() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListMavenArtifacts(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListMavenArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMavenArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListMavenArtifacts(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetMavenArtifact : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetMavenArtifact() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetMavenArtifact(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetMavenArtifact() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMavenArtifact(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* /*request*/, ::google::devtools::artifactregistry::v1::MavenArtifact* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetMavenArtifact(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListNpmPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListNpmPackages() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListNpmPackages(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListNpmPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNpmPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNpmPackages(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetNpmPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetNpmPackage() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetNpmPackage(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetNpmPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNpmPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::NpmPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNpmPackage(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPythonPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPythonPackages() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPythonPackages(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPythonPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPythonPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPythonPackages(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPythonPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPythonPackage() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPythonPackage(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPythonPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPythonPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::PythonPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPythonPackage(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportAptArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportAptArtifacts() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportAptArtifacts(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportAptArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportAptArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportAptArtifacts(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportYumArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportYumArtifacts() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportYumArtifacts(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportYumArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportYumArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportYumArtifacts(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRepositories() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRepositories(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRepositories(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRepository() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRepository(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateRepository() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateRepository(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateRepository() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateRepository(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteRepository(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPackages() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPackages(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPackages(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPackage() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPackage(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPackage(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePackage() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePackage(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePackage(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListVersions() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListVersions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetVersion() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchDeleteVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchDeleteVersions() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchDeleteVersions(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchDeleteVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchDeleteVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListFiles() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListFiles(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFiles(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListFilesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFiles(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetFile() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetFile(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteFile() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteFile(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateFile() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateFile(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTags() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTags(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListTagsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTags(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTag() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTag(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTag(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTag() {
      ::grpc::Service::MarkMethodRawCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTag(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTag(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTag() {
      ::grpc::Service::MarkMethodRawCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTag(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTag(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTag() {
      ::grpc::Service::MarkMethodRawCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTag(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTag(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateRule() {
      ::grpc::Service::MarkMethodRawCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRules() {
      ::grpc::Service::MarkMethodRawCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRules(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRules(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRulesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRules(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRule() {
      ::grpc::Service::MarkMethodRawCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateRule() {
      ::grpc::Service::MarkMethodRawCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteRule() {
      ::grpc::Service::MarkMethodRawCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRawCallback(39,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TestIamPermissions(context, request, response); }));
    }
    ~WithRawCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetProjectSettings() {
      ::grpc::Service::MarkMethodRawCallback(40,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetProjectSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProjectSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateProjectSettings() {
      ::grpc::Service::MarkMethodRawCallback(41,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateProjectSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProjectSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetVPCSCConfig() {
      ::grpc::Service::MarkMethodRawCallback(42,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetVPCSCConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVPCSCConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateVPCSCConfig() {
      ::grpc::Service::MarkMethodRawCallback(43,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateVPCSCConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVPCSCConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdatePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdatePackage() {
      ::grpc::Service::MarkMethodRawCallback(44,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdatePackage(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdatePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePackage(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAttachments() {
      ::grpc::Service::MarkMethodRawCallback(45,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAttachments(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAttachments(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAttachments(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAttachment() {
      ::grpc::Service::MarkMethodRawCallback(46,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAttachment(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* /*request*/, ::google::devtools::artifactregistry::v1::Attachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAttachment() {
      ::grpc::Service::MarkMethodRawCallback(47,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAttachment(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAttachment() {
      ::grpc::Service::MarkMethodRawCallback(48,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAttachment(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDockerImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDockerImages() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ListDockerImagesRequest, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ListDockerImagesRequest, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse>* streamer) {
                       return this->StreamedListDockerImages(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDockerImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDockerImages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListDockerImagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListDockerImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDockerImages(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ListDockerImagesRequest,::google::devtools::artifactregistry::v1::ListDockerImagesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDockerImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDockerImage() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetDockerImageRequest, ::google::devtools::artifactregistry::v1::DockerImage>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetDockerImageRequest, ::google::devtools::artifactregistry::v1::DockerImage>* streamer) {
                       return this->StreamedGetDockerImage(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDockerImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDockerImage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetDockerImageRequest* /*request*/, ::google::devtools::artifactregistry::v1::DockerImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDockerImage(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetDockerImageRequest,::google::devtools::artifactregistry::v1::DockerImage>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListMavenArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListMavenArtifacts() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>* streamer) {
                       return this->StreamedListMavenArtifacts(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListMavenArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListMavenArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListMavenArtifacts(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ListMavenArtifactsRequest,::google::devtools::artifactregistry::v1::ListMavenArtifactsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetMavenArtifact : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetMavenArtifact() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest, ::google::devtools::artifactregistry::v1::MavenArtifact>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest, ::google::devtools::artifactregistry::v1::MavenArtifact>* streamer) {
                       return this->StreamedGetMavenArtifact(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetMavenArtifact() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetMavenArtifact(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest* /*request*/, ::google::devtools::artifactregistry::v1::MavenArtifact* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetMavenArtifact(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetMavenArtifactRequest,::google::devtools::artifactregistry::v1::MavenArtifact>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListNpmPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListNpmPackages() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>* streamer) {
                       return this->StreamedListNpmPackages(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListNpmPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListNpmPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListNpmPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListNpmPackages(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ListNpmPackagesRequest,::google::devtools::artifactregistry::v1::ListNpmPackagesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetNpmPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetNpmPackage() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetNpmPackageRequest, ::google::devtools::artifactregistry::v1::NpmPackage>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetNpmPackageRequest, ::google::devtools::artifactregistry::v1::NpmPackage>* streamer) {
                       return this->StreamedGetNpmPackage(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetNpmPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetNpmPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetNpmPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::NpmPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetNpmPackage(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetNpmPackageRequest,::google::devtools::artifactregistry::v1::NpmPackage>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPythonPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPythonPackages() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>* streamer) {
                       return this->StreamedListPythonPackages(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPythonPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPythonPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPythonPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPythonPackages(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ListPythonPackagesRequest,::google::devtools::artifactregistry::v1::ListPythonPackagesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPythonPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPythonPackage() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetPythonPackageRequest, ::google::devtools::artifactregistry::v1::PythonPackage>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetPythonPackageRequest, ::google::devtools::artifactregistry::v1::PythonPackage>* streamer) {
                       return this->StreamedGetPythonPackage(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPythonPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPythonPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPythonPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::PythonPackage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPythonPackage(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetPythonPackageRequest,::google::devtools::artifactregistry::v1::PythonPackage>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportAptArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportAptArtifacts() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedImportAptArtifacts(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportAptArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportAptArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportAptArtifacts(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ImportAptArtifactsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportYumArtifacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportYumArtifacts() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedImportYumArtifacts(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportYumArtifacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportYumArtifacts(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportYumArtifacts(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ImportYumArtifactsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRepositories() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ListRepositoriesRequest, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ListRepositoriesRequest, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse>* streamer) {
                       return this->StreamedListRepositories(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRepositoriesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRepositories(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ListRepositoriesRequest,::google::devtools::artifactregistry::v1::ListRepositoriesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRepository() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetRepositoryRequest, ::google::devtools::artifactregistry::v1::Repository>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetRepositoryRequest, ::google::devtools::artifactregistry::v1::Repository>* streamer) {
                       return this->StreamedGetRepository(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRepository(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetRepositoryRequest,::google::devtools::artifactregistry::v1::Repository>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateRepository() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::CreateRepositoryRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::CreateRepositoryRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateRepository(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateRepository(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::CreateRepositoryRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateRepository() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest, ::google::devtools::artifactregistry::v1::Repository>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest, ::google::devtools::artifactregistry::v1::Repository>* streamer) {
                       return this->StreamedUpdateRepository(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest* /*request*/, ::google::devtools::artifactregistry::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateRepository(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::UpdateRepositoryRequest,::google::devtools::artifactregistry::v1::Repository>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteRepository(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteRepository(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::DeleteRepositoryRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPackages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPackages() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ListPackagesRequest, ::google::devtools::artifactregistry::v1::ListPackagesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ListPackagesRequest, ::google::devtools::artifactregistry::v1::ListPackagesResponse>* streamer) {
                       return this->StreamedListPackages(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPackages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPackages(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListPackagesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListPackagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPackages(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ListPackagesRequest,::google::devtools::artifactregistry::v1::ListPackagesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPackage() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetPackageRequest, ::google::devtools::artifactregistry::v1::Package>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetPackageRequest, ::google::devtools::artifactregistry::v1::Package>* streamer) {
                       return this->StreamedGetPackage(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetPackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPackage(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetPackageRequest,::google::devtools::artifactregistry::v1::Package>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePackage() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::DeletePackageRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::DeletePackageRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeletePackage(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeletePackageRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePackage(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::DeletePackageRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListVersions() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ListVersionsRequest, ::google::devtools::artifactregistry::v1::ListVersionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ListVersionsRequest, ::google::devtools::artifactregistry::v1::ListVersionsResponse>* streamer) {
                       return this->StreamedListVersions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListVersionsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListVersions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ListVersionsRequest,::google::devtools::artifactregistry::v1::ListVersionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetVersion() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetVersionRequest, ::google::devtools::artifactregistry::v1::Version>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetVersionRequest, ::google::devtools::artifactregistry::v1::Version>* streamer) {
                       return this->StreamedGetVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetVersionRequest,::google::devtools::artifactregistry::v1::Version>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::DeleteVersionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::DeleteVersionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::DeleteVersionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchDeleteVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchDeleteVersions() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchDeleteVersions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchDeleteVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchDeleteVersions(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchDeleteVersions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::BatchDeleteVersionsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::UpdateVersionRequest, ::google::devtools::artifactregistry::v1::Version>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::UpdateVersionRequest, ::google::devtools::artifactregistry::v1::Version>* streamer) {
                       return this->StreamedUpdateVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVersionRequest* /*request*/, ::google::devtools::artifactregistry::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::UpdateVersionRequest,::google::devtools::artifactregistry::v1::Version>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListFiles() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ListFilesRequest, ::google::devtools::artifactregistry::v1::ListFilesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ListFilesRequest, ::google::devtools::artifactregistry::v1::ListFilesResponse>* streamer) {
                       return this->StreamedListFiles(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListFiles(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListFilesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListFiles(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ListFilesRequest,::google::devtools::artifactregistry::v1::ListFilesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetFile() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetFileRequest, ::google::devtools::artifactregistry::v1::File>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetFileRequest, ::google::devtools::artifactregistry::v1::File>* streamer) {
                       return this->StreamedGetFile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetFile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetFileRequest,::google::devtools::artifactregistry::v1::File>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteFile() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::DeleteFileRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::DeleteFileRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteFile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteFileRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteFile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::DeleteFileRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateFile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateFile() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::UpdateFileRequest, ::google::devtools::artifactregistry::v1::File>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::UpdateFileRequest, ::google::devtools::artifactregistry::v1::File>* streamer) {
                       return this->StreamedUpdateFile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateFile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateFile(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateFileRequest* /*request*/, ::google::devtools::artifactregistry::v1::File* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateFile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::UpdateFileRequest,::google::devtools::artifactregistry::v1::File>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTags() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ListTagsRequest, ::google::devtools::artifactregistry::v1::ListTagsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ListTagsRequest, ::google::devtools::artifactregistry::v1::ListTagsResponse>* streamer) {
                       return this->StreamedListTags(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListTagsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTags(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ListTagsRequest,::google::devtools::artifactregistry::v1::ListTagsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTag() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetTagRequest, ::google::devtools::artifactregistry::v1::Tag>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetTagRequest, ::google::devtools::artifactregistry::v1::Tag>* streamer) {
                       return this->StreamedGetTag(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTag(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetTagRequest,::google::devtools::artifactregistry::v1::Tag>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTag() {
      ::grpc::Service::MarkMethodStreamed(29,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::CreateTagRequest, ::google::devtools::artifactregistry::v1::Tag>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::CreateTagRequest, ::google::devtools::artifactregistry::v1::Tag>* streamer) {
                       return this->StreamedCreateTag(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTag(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::CreateTagRequest,::google::devtools::artifactregistry::v1::Tag>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTag() {
      ::grpc::Service::MarkMethodStreamed(30,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::UpdateTagRequest, ::google::devtools::artifactregistry::v1::Tag>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::UpdateTagRequest, ::google::devtools::artifactregistry::v1::Tag>* streamer) {
                       return this->StreamedUpdateTag(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateTagRequest* /*request*/, ::google::devtools::artifactregistry::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTag(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::UpdateTagRequest,::google::devtools::artifactregistry::v1::Tag>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTag() {
      ::grpc::Service::MarkMethodStreamed(31,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::DeleteTagRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::DeleteTagRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteTag(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTag(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::DeleteTagRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateRule() {
      ::grpc::Service::MarkMethodStreamed(32,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::CreateRuleRequest, ::google::devtools::artifactregistry::v1::Rule>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::CreateRuleRequest, ::google::devtools::artifactregistry::v1::Rule>* streamer) {
                       return this->StreamedCreateRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::CreateRuleRequest,::google::devtools::artifactregistry::v1::Rule>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRules() {
      ::grpc::Service::MarkMethodStreamed(33,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ListRulesRequest, ::google::devtools::artifactregistry::v1::ListRulesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ListRulesRequest, ::google::devtools::artifactregistry::v1::ListRulesResponse>* streamer) {
                       return this->StreamedListRules(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRules(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListRulesRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRules(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ListRulesRequest,::google::devtools::artifactregistry::v1::ListRulesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRule() {
      ::grpc::Service::MarkMethodStreamed(34,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetRuleRequest, ::google::devtools::artifactregistry::v1::Rule>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetRuleRequest, ::google::devtools::artifactregistry::v1::Rule>* streamer) {
                       return this->StreamedGetRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetRuleRequest,::google::devtools::artifactregistry::v1::Rule>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateRule() {
      ::grpc::Service::MarkMethodStreamed(35,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::UpdateRuleRequest, ::google::devtools::artifactregistry::v1::Rule>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::UpdateRuleRequest, ::google::devtools::artifactregistry::v1::Rule>* streamer) {
                       return this->StreamedUpdateRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateRuleRequest* /*request*/, ::google::devtools::artifactregistry::v1::Rule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::UpdateRuleRequest,::google::devtools::artifactregistry::v1::Rule>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteRule() {
      ::grpc::Service::MarkMethodStreamed(36,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::DeleteRuleRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::DeleteRuleRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteRule(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::DeleteRuleRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(37,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedSetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::SetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(38,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedGetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::GetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodStreamed(39,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* streamer) {
                       return this->StreamedTestIamPermissions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTestIamPermissions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::TestIamPermissionsRequest,::google::iam::v1::TestIamPermissionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetProjectSettings() {
      ::grpc::Service::MarkMethodStreamed(40,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest, ::google::devtools::artifactregistry::v1::ProjectSettings>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest, ::google::devtools::artifactregistry::v1::ProjectSettings>* streamer) {
                       return this->StreamedGetProjectSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetProjectSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetProjectSettingsRequest,::google::devtools::artifactregistry::v1::ProjectSettings>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateProjectSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateProjectSettings() {
      ::grpc::Service::MarkMethodStreamed(41,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest, ::google::devtools::artifactregistry::v1::ProjectSettings>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest, ::google::devtools::artifactregistry::v1::ProjectSettings>* streamer) {
                       return this->StreamedUpdateProjectSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateProjectSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateProjectSettings(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ProjectSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateProjectSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::UpdateProjectSettingsRequest,::google::devtools::artifactregistry::v1::ProjectSettings>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetVPCSCConfig() {
      ::grpc::Service::MarkMethodStreamed(42,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest, ::google::devtools::artifactregistry::v1::VPCSCConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest, ::google::devtools::artifactregistry::v1::VPCSCConfig>* streamer) {
                       return this->StreamedGetVPCSCConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetVPCSCConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetVPCSCConfigRequest,::google::devtools::artifactregistry::v1::VPCSCConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateVPCSCConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateVPCSCConfig() {
      ::grpc::Service::MarkMethodStreamed(43,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest, ::google::devtools::artifactregistry::v1::VPCSCConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest, ::google::devtools::artifactregistry::v1::VPCSCConfig>* streamer) {
                       return this->StreamedUpdateVPCSCConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateVPCSCConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateVPCSCConfig(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest* /*request*/, ::google::devtools::artifactregistry::v1::VPCSCConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateVPCSCConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::UpdateVPCSCConfigRequest,::google::devtools::artifactregistry::v1::VPCSCConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdatePackage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdatePackage() {
      ::grpc::Service::MarkMethodStreamed(44,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::UpdatePackageRequest, ::google::devtools::artifactregistry::v1::Package>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::UpdatePackageRequest, ::google::devtools::artifactregistry::v1::Package>* streamer) {
                       return this->StreamedUpdatePackage(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdatePackage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdatePackage(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::UpdatePackageRequest* /*request*/, ::google::devtools::artifactregistry::v1::Package* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdatePackage(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::UpdatePackageRequest,::google::devtools::artifactregistry::v1::Package>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAttachments() {
      ::grpc::Service::MarkMethodStreamed(45,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::ListAttachmentsRequest, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::ListAttachmentsRequest, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse>* streamer) {
                       return this->StreamedListAttachments(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAttachments(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::ListAttachmentsRequest* /*request*/, ::google::devtools::artifactregistry::v1::ListAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAttachments(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::ListAttachmentsRequest,::google::devtools::artifactregistry::v1::ListAttachmentsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAttachment() {
      ::grpc::Service::MarkMethodStreamed(46,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::GetAttachmentRequest, ::google::devtools::artifactregistry::v1::Attachment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::GetAttachmentRequest, ::google::devtools::artifactregistry::v1::Attachment>* streamer) {
                       return this->StreamedGetAttachment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::GetAttachmentRequest* /*request*/, ::google::devtools::artifactregistry::v1::Attachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAttachment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::GetAttachmentRequest,::google::devtools::artifactregistry::v1::Attachment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAttachment() {
      ::grpc::Service::MarkMethodStreamed(47,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::CreateAttachmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::CreateAttachmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateAttachment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::CreateAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAttachment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::CreateAttachmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAttachment() {
      ::grpc::Service::MarkMethodStreamed(48,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteAttachment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAttachment(::grpc::ServerContext* /*context*/, const ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAttachment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::artifactregistry::v1::DeleteAttachmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListDockerImages<WithStreamedUnaryMethod_GetDockerImage<WithStreamedUnaryMethod_ListMavenArtifacts<WithStreamedUnaryMethod_GetMavenArtifact<WithStreamedUnaryMethod_ListNpmPackages<WithStreamedUnaryMethod_GetNpmPackage<WithStreamedUnaryMethod_ListPythonPackages<WithStreamedUnaryMethod_GetPythonPackage<WithStreamedUnaryMethod_ImportAptArtifacts<WithStreamedUnaryMethod_ImportYumArtifacts<WithStreamedUnaryMethod_ListRepositories<WithStreamedUnaryMethod_GetRepository<WithStreamedUnaryMethod_CreateRepository<WithStreamedUnaryMethod_UpdateRepository<WithStreamedUnaryMethod_DeleteRepository<WithStreamedUnaryMethod_ListPackages<WithStreamedUnaryMethod_GetPackage<WithStreamedUnaryMethod_DeletePackage<WithStreamedUnaryMethod_ListVersions<WithStreamedUnaryMethod_GetVersion<WithStreamedUnaryMethod_DeleteVersion<WithStreamedUnaryMethod_BatchDeleteVersions<WithStreamedUnaryMethod_UpdateVersion<WithStreamedUnaryMethod_ListFiles<WithStreamedUnaryMethod_GetFile<WithStreamedUnaryMethod_DeleteFile<WithStreamedUnaryMethod_UpdateFile<WithStreamedUnaryMethod_ListTags<WithStreamedUnaryMethod_GetTag<WithStreamedUnaryMethod_CreateTag<WithStreamedUnaryMethod_UpdateTag<WithStreamedUnaryMethod_DeleteTag<WithStreamedUnaryMethod_CreateRule<WithStreamedUnaryMethod_ListRules<WithStreamedUnaryMethod_GetRule<WithStreamedUnaryMethod_UpdateRule<WithStreamedUnaryMethod_DeleteRule<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<WithStreamedUnaryMethod_GetProjectSettings<WithStreamedUnaryMethod_UpdateProjectSettings<WithStreamedUnaryMethod_GetVPCSCConfig<WithStreamedUnaryMethod_UpdateVPCSCConfig<WithStreamedUnaryMethod_UpdatePackage<WithStreamedUnaryMethod_ListAttachments<WithStreamedUnaryMethod_GetAttachment<WithStreamedUnaryMethod_CreateAttachment<WithStreamedUnaryMethod_DeleteAttachment<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListDockerImages<WithStreamedUnaryMethod_GetDockerImage<WithStreamedUnaryMethod_ListMavenArtifacts<WithStreamedUnaryMethod_GetMavenArtifact<WithStreamedUnaryMethod_ListNpmPackages<WithStreamedUnaryMethod_GetNpmPackage<WithStreamedUnaryMethod_ListPythonPackages<WithStreamedUnaryMethod_GetPythonPackage<WithStreamedUnaryMethod_ImportAptArtifacts<WithStreamedUnaryMethod_ImportYumArtifacts<WithStreamedUnaryMethod_ListRepositories<WithStreamedUnaryMethod_GetRepository<WithStreamedUnaryMethod_CreateRepository<WithStreamedUnaryMethod_UpdateRepository<WithStreamedUnaryMethod_DeleteRepository<WithStreamedUnaryMethod_ListPackages<WithStreamedUnaryMethod_GetPackage<WithStreamedUnaryMethod_DeletePackage<WithStreamedUnaryMethod_ListVersions<WithStreamedUnaryMethod_GetVersion<WithStreamedUnaryMethod_DeleteVersion<WithStreamedUnaryMethod_BatchDeleteVersions<WithStreamedUnaryMethod_UpdateVersion<WithStreamedUnaryMethod_ListFiles<WithStreamedUnaryMethod_GetFile<WithStreamedUnaryMethod_DeleteFile<WithStreamedUnaryMethod_UpdateFile<WithStreamedUnaryMethod_ListTags<WithStreamedUnaryMethod_GetTag<WithStreamedUnaryMethod_CreateTag<WithStreamedUnaryMethod_UpdateTag<WithStreamedUnaryMethod_DeleteTag<WithStreamedUnaryMethod_CreateRule<WithStreamedUnaryMethod_ListRules<WithStreamedUnaryMethod_GetRule<WithStreamedUnaryMethod_UpdateRule<WithStreamedUnaryMethod_DeleteRule<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<WithStreamedUnaryMethod_GetProjectSettings<WithStreamedUnaryMethod_UpdateProjectSettings<WithStreamedUnaryMethod_GetVPCSCConfig<WithStreamedUnaryMethod_UpdateVPCSCConfig<WithStreamedUnaryMethod_UpdatePackage<WithStreamedUnaryMethod_ListAttachments<WithStreamedUnaryMethod_GetAttachment<WithStreamedUnaryMethod_CreateAttachment<WithStreamedUnaryMethod_DeleteAttachment<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace artifactregistry
}  // namespace devtools
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fdevtools_2fartifactregistry_2fv1_2fservice_2eproto__INCLUDED
