// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/privacy/dlp/v2/dlp.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fprivacy_2fdlp_2fv2_2fdlp_2eproto__INCLUDED
#define GRPC_google_2fprivacy_2fdlp_2fv2_2fdlp_2eproto__INCLUDED

#include "google/privacy/dlp/v2/dlp.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace privacy {
namespace dlp {
namespace v2 {

// Sensitive Data Protection provides access to a powerful sensitive data
// inspection, classification, and de-identification platform that works
// on text, images, and Google Cloud storage repositories.
// To learn more about concepts and find how-to guides see
// https://cloud.google.com/sensitive-data-protection/docs/.
class DlpService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.privacy.dlp.v2.DlpService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Finds potentially sensitive info in content.
    // This method has limits on input size, processing time, and output size.
    //
    // When no InfoTypes or CustomInfoTypes are specified in this request, the
    // system will automatically choose what detectors to run. By default this may
    // be all types, but may change over time as detectors are updated.
    //
    // For how to guides, see
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-images
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-text,
    virtual ::grpc::Status InspectContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest& request, ::google::privacy::dlp::v2::InspectContentResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectContentResponse>> AsyncInspectContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectContentResponse>>(AsyncInspectContentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectContentResponse>> PrepareAsyncInspectContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectContentResponse>>(PrepareAsyncInspectContentRaw(context, request, cq));
    }
    // Redacts potentially sensitive info from an image.
    // This method has limits on input size, processing time, and output size.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/redacting-sensitive-data-images
    // to learn more.
    //
    // When no InfoTypes or CustomInfoTypes are specified in this request, the
    // system will automatically choose what detectors to run. By default this may
    // be all types, but may change over time as detectors are updated.
    virtual ::grpc::Status RedactImage(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest& request, ::google::privacy::dlp::v2::RedactImageResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::RedactImageResponse>> AsyncRedactImage(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::RedactImageResponse>>(AsyncRedactImageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::RedactImageResponse>> PrepareAsyncRedactImage(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::RedactImageResponse>>(PrepareAsyncRedactImageRaw(context, request, cq));
    }
    // De-identifies potentially sensitive info from a ContentItem.
    // This method has limits on input size and output size.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/deidentify-sensitive-data
    // to learn more.
    //
    // When no InfoTypes or CustomInfoTypes are specified in this request, the
    // system will automatically choose what detectors to run. By default this may
    // be all types, but may change over time as detectors are updated.
    virtual ::grpc::Status DeidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest& request, ::google::privacy::dlp::v2::DeidentifyContentResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyContentResponse>> AsyncDeidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyContentResponse>>(AsyncDeidentifyContentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyContentResponse>> PrepareAsyncDeidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyContentResponse>>(PrepareAsyncDeidentifyContentRaw(context, request, cq));
    }
    // Re-identifies content that has been de-identified.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/pseudonymization#re-identification_in_free_text_code_example
    // to learn more.
    virtual ::grpc::Status ReidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest& request, ::google::privacy::dlp::v2::ReidentifyContentResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ReidentifyContentResponse>> AsyncReidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ReidentifyContentResponse>>(AsyncReidentifyContentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ReidentifyContentResponse>> PrepareAsyncReidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ReidentifyContentResponse>>(PrepareAsyncReidentifyContentRaw(context, request, cq));
    }
    // Returns a list of the sensitive information types that DLP API
    // supports. See
    // https://cloud.google.com/sensitive-data-protection/docs/infotypes-reference
    // to learn more.
    virtual ::grpc::Status ListInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest& request, ::google::privacy::dlp::v2::ListInfoTypesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInfoTypesResponse>> AsyncListInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInfoTypesResponse>>(AsyncListInfoTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInfoTypesResponse>> PrepareAsyncListInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInfoTypesResponse>>(PrepareAsyncListInfoTypesRaw(context, request, cq));
    }
    // Creates an InspectTemplate for reusing frequently used configuration
    // for inspecting content, images, and storage.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
    // to learn more.
    virtual ::grpc::Status CreateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest& request, ::google::privacy::dlp::v2::InspectTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>> AsyncCreateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>>(AsyncCreateInspectTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>> PrepareAsyncCreateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>>(PrepareAsyncCreateInspectTemplateRaw(context, request, cq));
    }
    // Updates the InspectTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
    // to learn more.
    virtual ::grpc::Status UpdateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest& request, ::google::privacy::dlp::v2::InspectTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>> AsyncUpdateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>>(AsyncUpdateInspectTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>> PrepareAsyncUpdateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>>(PrepareAsyncUpdateInspectTemplateRaw(context, request, cq));
    }
    // Gets an InspectTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
    // to learn more.
    virtual ::grpc::Status GetInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest& request, ::google::privacy::dlp::v2::InspectTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>> AsyncGetInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>>(AsyncGetInspectTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>> PrepareAsyncGetInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>>(PrepareAsyncGetInspectTemplateRaw(context, request, cq));
    }
    // Lists InspectTemplates.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
    // to learn more.
    virtual ::grpc::Status ListInspectTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest& request, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>> AsyncListInspectTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>>(AsyncListInspectTemplatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>> PrepareAsyncListInspectTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>>(PrepareAsyncListInspectTemplatesRaw(context, request, cq));
    }
    // Deletes an InspectTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
    // to learn more.
    virtual ::grpc::Status DeleteInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteInspectTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteInspectTemplateRaw(context, request, cq));
    }
    // Creates a DeidentifyTemplate for reusing frequently used configuration
    // for de-identifying content, images, and storage.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
    // to learn more.
    virtual ::grpc::Status CreateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest& request, ::google::privacy::dlp::v2::DeidentifyTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>> AsyncCreateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>>(AsyncCreateDeidentifyTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>> PrepareAsyncCreateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>>(PrepareAsyncCreateDeidentifyTemplateRaw(context, request, cq));
    }
    // Updates the DeidentifyTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
    // to learn more.
    virtual ::grpc::Status UpdateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest& request, ::google::privacy::dlp::v2::DeidentifyTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>> AsyncUpdateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>>(AsyncUpdateDeidentifyTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>> PrepareAsyncUpdateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>>(PrepareAsyncUpdateDeidentifyTemplateRaw(context, request, cq));
    }
    // Gets a DeidentifyTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
    // to learn more.
    virtual ::grpc::Status GetDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest& request, ::google::privacy::dlp::v2::DeidentifyTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>> AsyncGetDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>>(AsyncGetDeidentifyTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>> PrepareAsyncGetDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>>(PrepareAsyncGetDeidentifyTemplateRaw(context, request, cq));
    }
    // Lists DeidentifyTemplates.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
    // to learn more.
    virtual ::grpc::Status ListDeidentifyTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest& request, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>> AsyncListDeidentifyTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>>(AsyncListDeidentifyTemplatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>> PrepareAsyncListDeidentifyTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>>(PrepareAsyncListDeidentifyTemplatesRaw(context, request, cq));
    }
    // Deletes a DeidentifyTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
    // to learn more.
    virtual ::grpc::Status DeleteDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteDeidentifyTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteDeidentifyTemplateRaw(context, request, cq));
    }
    // Creates a job trigger to run DLP actions such as scanning storage for
    // sensitive information on a set schedule.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
    // to learn more.
    virtual ::grpc::Status CreateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest& request, ::google::privacy::dlp::v2::JobTrigger* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>> AsyncCreateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>>(AsyncCreateJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>> PrepareAsyncCreateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>>(PrepareAsyncCreateJobTriggerRaw(context, request, cq));
    }
    // Updates a job trigger.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
    // to learn more.
    virtual ::grpc::Status UpdateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest& request, ::google::privacy::dlp::v2::JobTrigger* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>> AsyncUpdateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>>(AsyncUpdateJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>> PrepareAsyncUpdateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>>(PrepareAsyncUpdateJobTriggerRaw(context, request, cq));
    }
    // Inspect hybrid content and store findings to a trigger. The inspection
    // will be processed asynchronously. To review the findings monitor the
    // jobs within the trigger.
    virtual ::grpc::Status HybridInspectJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest& request, ::google::privacy::dlp::v2::HybridInspectResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>> AsyncHybridInspectJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>>(AsyncHybridInspectJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>> PrepareAsyncHybridInspectJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>>(PrepareAsyncHybridInspectJobTriggerRaw(context, request, cq));
    }
    // Gets a job trigger.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
    // to learn more.
    virtual ::grpc::Status GetJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest& request, ::google::privacy::dlp::v2::JobTrigger* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>> AsyncGetJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>>(AsyncGetJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>> PrepareAsyncGetJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>>(PrepareAsyncGetJobTriggerRaw(context, request, cq));
    }
    // Lists job triggers.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
    // to learn more.
    virtual ::grpc::Status ListJobTriggers(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest& request, ::google::privacy::dlp::v2::ListJobTriggersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListJobTriggersResponse>> AsyncListJobTriggers(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListJobTriggersResponse>>(AsyncListJobTriggersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListJobTriggersResponse>> PrepareAsyncListJobTriggers(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListJobTriggersResponse>>(PrepareAsyncListJobTriggersRaw(context, request, cq));
    }
    // Deletes a job trigger.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
    // to learn more.
    virtual ::grpc::Status DeleteJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobTriggerRaw(context, request, cq));
    }
    // Activate a job trigger. Causes the immediate execute of a trigger
    // instead of waiting on the trigger event to occur.
    virtual ::grpc::Status ActivateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest& request, ::google::privacy::dlp::v2::DlpJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>> AsyncActivateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>>(AsyncActivateJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>> PrepareAsyncActivateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>>(PrepareAsyncActivateJobTriggerRaw(context, request, cq));
    }
    // Creates a config for discovery to scan and profile storage.
    virtual ::grpc::Status CreateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest& request, ::google::privacy::dlp::v2::DiscoveryConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>> AsyncCreateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>>(AsyncCreateDiscoveryConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>> PrepareAsyncCreateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>>(PrepareAsyncCreateDiscoveryConfigRaw(context, request, cq));
    }
    // Updates a discovery configuration.
    virtual ::grpc::Status UpdateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest& request, ::google::privacy::dlp::v2::DiscoveryConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>> AsyncUpdateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>>(AsyncUpdateDiscoveryConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>> PrepareAsyncUpdateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>>(PrepareAsyncUpdateDiscoveryConfigRaw(context, request, cq));
    }
    // Gets a discovery configuration.
    virtual ::grpc::Status GetDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest& request, ::google::privacy::dlp::v2::DiscoveryConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>> AsyncGetDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>>(AsyncGetDiscoveryConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>> PrepareAsyncGetDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>>(PrepareAsyncGetDiscoveryConfigRaw(context, request, cq));
    }
    // Lists discovery configurations.
    virtual ::grpc::Status ListDiscoveryConfigs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest& request, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>> AsyncListDiscoveryConfigs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>>(AsyncListDiscoveryConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>> PrepareAsyncListDiscoveryConfigs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>>(PrepareAsyncListDiscoveryConfigsRaw(context, request, cq));
    }
    // Deletes a discovery configuration.
    virtual ::grpc::Status DeleteDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteDiscoveryConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteDiscoveryConfigRaw(context, request, cq));
    }
    // Creates a new job to inspect storage or calculate risk metrics.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
    // to learn more.
    //
    // When no InfoTypes or CustomInfoTypes are specified in inspect jobs, the
    // system will automatically choose what detectors to run. By default this may
    // be all types, but may change over time as detectors are updated.
    virtual ::grpc::Status CreateDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest& request, ::google::privacy::dlp::v2::DlpJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>> AsyncCreateDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>>(AsyncCreateDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>> PrepareAsyncCreateDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>>(PrepareAsyncCreateDlpJobRaw(context, request, cq));
    }
    // Lists DlpJobs that match the specified filter in the request.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
    // to learn more.
    virtual ::grpc::Status ListDlpJobs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest& request, ::google::privacy::dlp::v2::ListDlpJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDlpJobsResponse>> AsyncListDlpJobs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDlpJobsResponse>>(AsyncListDlpJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDlpJobsResponse>> PrepareAsyncListDlpJobs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDlpJobsResponse>>(PrepareAsyncListDlpJobsRaw(context, request, cq));
    }
    // Gets the latest state of a long-running DlpJob.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
    // to learn more.
    virtual ::grpc::Status GetDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest& request, ::google::privacy::dlp::v2::DlpJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>> AsyncGetDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>>(AsyncGetDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>> PrepareAsyncGetDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>>(PrepareAsyncGetDlpJobRaw(context, request, cq));
    }
    // Deletes a long-running DlpJob. This method indicates that the client is
    // no longer interested in the DlpJob result. The job will be canceled if
    // possible.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
    // to learn more.
    virtual ::grpc::Status DeleteDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteDlpJobRaw(context, request, cq));
    }
    // Starts asynchronous cancellation on a long-running DlpJob. The server
    // makes a best effort to cancel the DlpJob, but success is not
    // guaranteed.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
    // to learn more.
    virtual ::grpc::Status CancelDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncCancelDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncCancelDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncCancelDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncCancelDlpJobRaw(context, request, cq));
    }
    // Creates a pre-built stored infoType to be used for inspection.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
    // to learn more.
    virtual ::grpc::Status CreateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest& request, ::google::privacy::dlp::v2::StoredInfoType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>> AsyncCreateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>>(AsyncCreateStoredInfoTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>> PrepareAsyncCreateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>>(PrepareAsyncCreateStoredInfoTypeRaw(context, request, cq));
    }
    // Updates the stored infoType by creating a new version. The existing version
    // will continue to be used until the new version is ready.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
    // to learn more.
    virtual ::grpc::Status UpdateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest& request, ::google::privacy::dlp::v2::StoredInfoType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>> AsyncUpdateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>>(AsyncUpdateStoredInfoTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>> PrepareAsyncUpdateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>>(PrepareAsyncUpdateStoredInfoTypeRaw(context, request, cq));
    }
    // Gets a stored infoType.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
    // to learn more.
    virtual ::grpc::Status GetStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest& request, ::google::privacy::dlp::v2::StoredInfoType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>> AsyncGetStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>>(AsyncGetStoredInfoTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>> PrepareAsyncGetStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>>(PrepareAsyncGetStoredInfoTypeRaw(context, request, cq));
    }
    // Lists stored infoTypes.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
    // to learn more.
    virtual ::grpc::Status ListStoredInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest& request, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>> AsyncListStoredInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>>(AsyncListStoredInfoTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>> PrepareAsyncListStoredInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>>(PrepareAsyncListStoredInfoTypesRaw(context, request, cq));
    }
    // Deletes a stored infoType.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
    // to learn more.
    virtual ::grpc::Status DeleteStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteStoredInfoTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteStoredInfoTypeRaw(context, request, cq));
    }
    // Lists project data profiles for an organization.
    virtual ::grpc::Status ListProjectDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest& request, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>> AsyncListProjectDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>>(AsyncListProjectDataProfilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>> PrepareAsyncListProjectDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>>(PrepareAsyncListProjectDataProfilesRaw(context, request, cq));
    }
    // Lists table data profiles for an organization.
    virtual ::grpc::Status ListTableDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest& request, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>> AsyncListTableDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>>(AsyncListTableDataProfilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>> PrepareAsyncListTableDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>>(PrepareAsyncListTableDataProfilesRaw(context, request, cq));
    }
    // Lists column data profiles for an organization.
    virtual ::grpc::Status ListColumnDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest& request, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>> AsyncListColumnDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>>(AsyncListColumnDataProfilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>> PrepareAsyncListColumnDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>>(PrepareAsyncListColumnDataProfilesRaw(context, request, cq));
    }
    // Gets a project data profile.
    virtual ::grpc::Status GetProjectDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest& request, ::google::privacy::dlp::v2::ProjectDataProfile* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ProjectDataProfile>> AsyncGetProjectDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ProjectDataProfile>>(AsyncGetProjectDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ProjectDataProfile>> PrepareAsyncGetProjectDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ProjectDataProfile>>(PrepareAsyncGetProjectDataProfileRaw(context, request, cq));
    }
    // Lists file store data profiles for an organization.
    virtual ::grpc::Status ListFileStoreDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest& request, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>> AsyncListFileStoreDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>>(AsyncListFileStoreDataProfilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>> PrepareAsyncListFileStoreDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>>(PrepareAsyncListFileStoreDataProfilesRaw(context, request, cq));
    }
    // Gets a file store data profile.
    virtual ::grpc::Status GetFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest& request, ::google::privacy::dlp::v2::FileStoreDataProfile* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::FileStoreDataProfile>> AsyncGetFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::FileStoreDataProfile>>(AsyncGetFileStoreDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::FileStoreDataProfile>> PrepareAsyncGetFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::FileStoreDataProfile>>(PrepareAsyncGetFileStoreDataProfileRaw(context, request, cq));
    }
    // Delete a FileStoreDataProfile. Will not prevent the profile from being
    // regenerated if the resource is still included in a discovery configuration.
    virtual ::grpc::Status DeleteFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteFileStoreDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteFileStoreDataProfileRaw(context, request, cq));
    }
    // Gets a table data profile.
    virtual ::grpc::Status GetTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest& request, ::google::privacy::dlp::v2::TableDataProfile* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::TableDataProfile>> AsyncGetTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::TableDataProfile>>(AsyncGetTableDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::TableDataProfile>> PrepareAsyncGetTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::TableDataProfile>>(PrepareAsyncGetTableDataProfileRaw(context, request, cq));
    }
    // Gets a column data profile.
    virtual ::grpc::Status GetColumnDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest& request, ::google::privacy::dlp::v2::ColumnDataProfile* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ColumnDataProfile>> AsyncGetColumnDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ColumnDataProfile>>(AsyncGetColumnDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ColumnDataProfile>> PrepareAsyncGetColumnDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ColumnDataProfile>>(PrepareAsyncGetColumnDataProfileRaw(context, request, cq));
    }
    // Delete a TableDataProfile. Will not prevent the profile from being
    // regenerated if the table is still included in a discovery configuration.
    virtual ::grpc::Status DeleteTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteTableDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteTableDataProfileRaw(context, request, cq));
    }
    // Inspect hybrid content and store findings to a job.
    // To review the findings, inspect the job. Inspection will occur
    // asynchronously.
    virtual ::grpc::Status HybridInspectDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest& request, ::google::privacy::dlp::v2::HybridInspectResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>> AsyncHybridInspectDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>>(AsyncHybridInspectDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>> PrepareAsyncHybridInspectDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>>(PrepareAsyncHybridInspectDlpJobRaw(context, request, cq));
    }
    // Finish a running hybrid DlpJob. Triggers the finalization steps and running
    // of any enabled actions that have not yet run.
    virtual ::grpc::Status FinishDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncFinishDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncFinishDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncFinishDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncFinishDlpJobRaw(context, request, cq));
    }
    // Create a Connection to an external data source.
    virtual ::grpc::Status CreateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest& request, ::google::privacy::dlp::v2::Connection* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>> AsyncCreateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>>(AsyncCreateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>> PrepareAsyncCreateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>>(PrepareAsyncCreateConnectionRaw(context, request, cq));
    }
    // Get a Connection by name.
    virtual ::grpc::Status GetConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest& request, ::google::privacy::dlp::v2::Connection* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>> AsyncGetConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>>(AsyncGetConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>> PrepareAsyncGetConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>>(PrepareAsyncGetConnectionRaw(context, request, cq));
    }
    // Lists Connections in a parent. Use SearchConnections to see all connections
    // within an organization.
    virtual ::grpc::Status ListConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest& request, ::google::privacy::dlp::v2::ListConnectionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListConnectionsResponse>> AsyncListConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListConnectionsResponse>>(AsyncListConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListConnectionsResponse>> PrepareAsyncListConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListConnectionsResponse>>(PrepareAsyncListConnectionsRaw(context, request, cq));
    }
    // Searches for Connections in a parent.
    virtual ::grpc::Status SearchConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest& request, ::google::privacy::dlp::v2::SearchConnectionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::SearchConnectionsResponse>> AsyncSearchConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::SearchConnectionsResponse>>(AsyncSearchConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::SearchConnectionsResponse>> PrepareAsyncSearchConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::SearchConnectionsResponse>>(PrepareAsyncSearchConnectionsRaw(context, request, cq));
    }
    // Delete a Connection.
    virtual ::grpc::Status DeleteConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteConnectionRaw(context, request, cq));
    }
    // Update a Connection.
    virtual ::grpc::Status UpdateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest& request, ::google::privacy::dlp::v2::Connection* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>> AsyncUpdateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>>(AsyncUpdateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>> PrepareAsyncUpdateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>>(PrepareAsyncUpdateConnectionRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Finds potentially sensitive info in content.
      // This method has limits on input size, processing time, and output size.
      //
      // When no InfoTypes or CustomInfoTypes are specified in this request, the
      // system will automatically choose what detectors to run. By default this may
      // be all types, but may change over time as detectors are updated.
      //
      // For how to guides, see
      // https://cloud.google.com/sensitive-data-protection/docs/inspecting-images
      // and
      // https://cloud.google.com/sensitive-data-protection/docs/inspecting-text,
      virtual void InspectContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest* request, ::google::privacy::dlp::v2::InspectContentResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void InspectContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest* request, ::google::privacy::dlp::v2::InspectContentResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Redacts potentially sensitive info from an image.
      // This method has limits on input size, processing time, and output size.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/redacting-sensitive-data-images
      // to learn more.
      //
      // When no InfoTypes or CustomInfoTypes are specified in this request, the
      // system will automatically choose what detectors to run. By default this may
      // be all types, but may change over time as detectors are updated.
      virtual void RedactImage(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest* request, ::google::privacy::dlp::v2::RedactImageResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RedactImage(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest* request, ::google::privacy::dlp::v2::RedactImageResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // De-identifies potentially sensitive info from a ContentItem.
      // This method has limits on input size and output size.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/deidentify-sensitive-data
      // to learn more.
      //
      // When no InfoTypes or CustomInfoTypes are specified in this request, the
      // system will automatically choose what detectors to run. By default this may
      // be all types, but may change over time as detectors are updated.
      virtual void DeidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest* request, ::google::privacy::dlp::v2::DeidentifyContentResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest* request, ::google::privacy::dlp::v2::DeidentifyContentResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Re-identifies content that has been de-identified.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/pseudonymization#re-identification_in_free_text_code_example
      // to learn more.
      virtual void ReidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest* request, ::google::privacy::dlp::v2::ReidentifyContentResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest* request, ::google::privacy::dlp::v2::ReidentifyContentResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a list of the sensitive information types that DLP API
      // supports. See
      // https://cloud.google.com/sensitive-data-protection/docs/infotypes-reference
      // to learn more.
      virtual void ListInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest* request, ::google::privacy::dlp::v2::ListInfoTypesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest* request, ::google::privacy::dlp::v2::ListInfoTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an InspectTemplate for reusing frequently used configuration
      // for inspecting content, images, and storage.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
      // to learn more.
      virtual void CreateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the InspectTemplate.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
      // to learn more.
      virtual void UpdateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets an InspectTemplate.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
      // to learn more.
      virtual void GetInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists InspectTemplates.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
      // to learn more.
      virtual void ListInspectTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* request, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInspectTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* request, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an InspectTemplate.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
      // to learn more.
      virtual void DeleteInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a DeidentifyTemplate for reusing frequently used configuration
      // for de-identifying content, images, and storage.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
      // to learn more.
      virtual void CreateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the DeidentifyTemplate.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
      // to learn more.
      virtual void UpdateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a DeidentifyTemplate.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
      // to learn more.
      virtual void GetDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists DeidentifyTemplates.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
      // to learn more.
      virtual void ListDeidentifyTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* request, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDeidentifyTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* request, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a DeidentifyTemplate.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
      // to learn more.
      virtual void DeleteDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a job trigger to run DLP actions such as scanning storage for
      // sensitive information on a set schedule.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
      // to learn more.
      virtual void CreateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a job trigger.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
      // to learn more.
      virtual void UpdateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Inspect hybrid content and store findings to a trigger. The inspection
      // will be processed asynchronously. To review the findings monitor the
      // jobs within the trigger.
      virtual void HybridInspectJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void HybridInspectJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a job trigger.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
      // to learn more.
      virtual void GetJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists job triggers.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
      // to learn more.
      virtual void ListJobTriggers(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest* request, ::google::privacy::dlp::v2::ListJobTriggersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListJobTriggers(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest* request, ::google::privacy::dlp::v2::ListJobTriggersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a job trigger.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
      // to learn more.
      virtual void DeleteJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Activate a job trigger. Causes the immediate execute of a trigger
      // instead of waiting on the trigger event to occur.
      virtual void ActivateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* request, ::google::privacy::dlp::v2::DlpJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ActivateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* request, ::google::privacy::dlp::v2::DlpJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a config for discovery to scan and profile storage.
      virtual void CreateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a discovery configuration.
      virtual void UpdateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a discovery configuration.
      virtual void GetDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists discovery configurations.
      virtual void ListDiscoveryConfigs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* request, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDiscoveryConfigs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* request, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a discovery configuration.
      virtual void DeleteDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new job to inspect storage or calculate risk metrics.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
      // and
      // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
      // to learn more.
      //
      // When no InfoTypes or CustomInfoTypes are specified in inspect jobs, the
      // system will automatically choose what detectors to run. By default this may
      // be all types, but may change over time as detectors are updated.
      virtual void CreateDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists DlpJobs that match the specified filter in the request.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
      // and
      // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
      // to learn more.
      virtual void ListDlpJobs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest* request, ::google::privacy::dlp::v2::ListDlpJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDlpJobs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest* request, ::google::privacy::dlp::v2::ListDlpJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the latest state of a long-running DlpJob.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
      // and
      // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
      // to learn more.
      virtual void GetDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a long-running DlpJob. This method indicates that the client is
      // no longer interested in the DlpJob result. The job will be canceled if
      // possible.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
      // and
      // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
      // to learn more.
      virtual void DeleteDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Starts asynchronous cancellation on a long-running DlpJob. The server
      // makes a best effort to cancel the DlpJob, but success is not
      // guaranteed.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
      // and
      // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
      // to learn more.
      virtual void CancelDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a pre-built stored infoType to be used for inspection.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
      // to learn more.
      virtual void CreateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the stored infoType by creating a new version. The existing version
      // will continue to be used until the new version is ready.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
      // to learn more.
      virtual void UpdateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a stored infoType.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
      // to learn more.
      virtual void GetStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists stored infoTypes.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
      // to learn more.
      virtual void ListStoredInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* request, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListStoredInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* request, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a stored infoType.
      // See
      // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
      // to learn more.
      virtual void DeleteStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists project data profiles for an organization.
      virtual void ListProjectDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* request, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListProjectDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* request, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists table data profiles for an organization.
      virtual void ListTableDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* request, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTableDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* request, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists column data profiles for an organization.
      virtual void ListColumnDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* request, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListColumnDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* request, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a project data profile.
      virtual void GetProjectDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* request, ::google::privacy::dlp::v2::ProjectDataProfile* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetProjectDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* request, ::google::privacy::dlp::v2::ProjectDataProfile* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists file store data profiles for an organization.
      virtual void ListFileStoreDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* request, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListFileStoreDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* request, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a file store data profile.
      virtual void GetFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* request, ::google::privacy::dlp::v2::FileStoreDataProfile* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* request, ::google::privacy::dlp::v2::FileStoreDataProfile* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Delete a FileStoreDataProfile. Will not prevent the profile from being
      // regenerated if the resource is still included in a discovery configuration.
      virtual void DeleteFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a table data profile.
      virtual void GetTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* request, ::google::privacy::dlp::v2::TableDataProfile* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* request, ::google::privacy::dlp::v2::TableDataProfile* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a column data profile.
      virtual void GetColumnDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* request, ::google::privacy::dlp::v2::ColumnDataProfile* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetColumnDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* request, ::google::privacy::dlp::v2::ColumnDataProfile* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Delete a TableDataProfile. Will not prevent the profile from being
      // regenerated if the table is still included in a discovery configuration.
      virtual void DeleteTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Inspect hybrid content and store findings to a job.
      // To review the findings, inspect the job. Inspection will occur
      // asynchronously.
      virtual void HybridInspectDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void HybridInspectDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Finish a running hybrid DlpJob. Triggers the finalization steps and running
      // of any enabled actions that have not yet run.
      virtual void FinishDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void FinishDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Create a Connection to an external data source.
      virtual void CreateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get a Connection by name.
      virtual void GetConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Connections in a parent. Use SearchConnections to see all connections
      // within an organization.
      virtual void ListConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest* request, ::google::privacy::dlp::v2::ListConnectionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest* request, ::google::privacy::dlp::v2::ListConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Searches for Connections in a parent.
      virtual void SearchConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest* request, ::google::privacy::dlp::v2::SearchConnectionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest* request, ::google::privacy::dlp::v2::SearchConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Delete a Connection.
      virtual void DeleteConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Update a Connection.
      virtual void UpdateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectContentResponse>* AsyncInspectContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectContentResponse>* PrepareAsyncInspectContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::RedactImageResponse>* AsyncRedactImageRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::RedactImageResponse>* PrepareAsyncRedactImageRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyContentResponse>* AsyncDeidentifyContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyContentResponse>* PrepareAsyncDeidentifyContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ReidentifyContentResponse>* AsyncReidentifyContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ReidentifyContentResponse>* PrepareAsyncReidentifyContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInfoTypesResponse>* AsyncListInfoTypesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInfoTypesResponse>* PrepareAsyncListInfoTypesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>* AsyncCreateInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>* PrepareAsyncCreateInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>* AsyncUpdateInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>* PrepareAsyncUpdateInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>* AsyncGetInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::InspectTemplate>* PrepareAsyncGetInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>* AsyncListInspectTemplatesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>* PrepareAsyncListInspectTemplatesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>* AsyncCreateDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>* PrepareAsyncCreateDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>* AsyncUpdateDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>* PrepareAsyncUpdateDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>* AsyncGetDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DeidentifyTemplate>* PrepareAsyncGetDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>* AsyncListDeidentifyTemplatesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>* PrepareAsyncListDeidentifyTemplatesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>* AsyncCreateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>* PrepareAsyncCreateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>* AsyncUpdateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>* PrepareAsyncUpdateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>* AsyncHybridInspectJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>* PrepareAsyncHybridInspectJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>* AsyncGetJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::JobTrigger>* PrepareAsyncGetJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListJobTriggersResponse>* AsyncListJobTriggersRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListJobTriggersResponse>* PrepareAsyncListJobTriggersRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>* AsyncActivateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>* PrepareAsyncActivateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>* AsyncCreateDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>* PrepareAsyncCreateDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>* AsyncUpdateDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>* PrepareAsyncUpdateDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>* AsyncGetDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DiscoveryConfig>* PrepareAsyncGetDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>* AsyncListDiscoveryConfigsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>* PrepareAsyncListDiscoveryConfigsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>* AsyncCreateDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>* PrepareAsyncCreateDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDlpJobsResponse>* AsyncListDlpJobsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListDlpJobsResponse>* PrepareAsyncListDlpJobsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>* AsyncGetDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::DlpJob>* PrepareAsyncGetDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncCancelDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncCancelDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>* AsyncCreateStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>* PrepareAsyncCreateStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>* AsyncUpdateStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>* PrepareAsyncUpdateStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>* AsyncGetStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::StoredInfoType>* PrepareAsyncGetStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>* AsyncListStoredInfoTypesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>* PrepareAsyncListStoredInfoTypesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>* AsyncListProjectDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>* PrepareAsyncListProjectDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>* AsyncListTableDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>* PrepareAsyncListTableDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>* AsyncListColumnDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>* PrepareAsyncListColumnDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ProjectDataProfile>* AsyncGetProjectDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ProjectDataProfile>* PrepareAsyncGetProjectDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>* AsyncListFileStoreDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>* PrepareAsyncListFileStoreDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::FileStoreDataProfile>* AsyncGetFileStoreDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::FileStoreDataProfile>* PrepareAsyncGetFileStoreDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteFileStoreDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteFileStoreDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::TableDataProfile>* AsyncGetTableDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::TableDataProfile>* PrepareAsyncGetTableDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ColumnDataProfile>* AsyncGetColumnDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ColumnDataProfile>* PrepareAsyncGetColumnDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteTableDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteTableDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>* AsyncHybridInspectDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::HybridInspectResponse>* PrepareAsyncHybridInspectDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncFinishDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncFinishDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>* AsyncCreateConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>* PrepareAsyncCreateConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>* AsyncGetConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>* PrepareAsyncGetConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListConnectionsResponse>* AsyncListConnectionsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::ListConnectionsResponse>* PrepareAsyncListConnectionsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::SearchConnectionsResponse>* AsyncSearchConnectionsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::SearchConnectionsResponse>* PrepareAsyncSearchConnectionsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>* AsyncUpdateConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::privacy::dlp::v2::Connection>* PrepareAsyncUpdateConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status InspectContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest& request, ::google::privacy::dlp::v2::InspectContentResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectContentResponse>> AsyncInspectContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectContentResponse>>(AsyncInspectContentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectContentResponse>> PrepareAsyncInspectContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectContentResponse>>(PrepareAsyncInspectContentRaw(context, request, cq));
    }
    ::grpc::Status RedactImage(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest& request, ::google::privacy::dlp::v2::RedactImageResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::RedactImageResponse>> AsyncRedactImage(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::RedactImageResponse>>(AsyncRedactImageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::RedactImageResponse>> PrepareAsyncRedactImage(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::RedactImageResponse>>(PrepareAsyncRedactImageRaw(context, request, cq));
    }
    ::grpc::Status DeidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest& request, ::google::privacy::dlp::v2::DeidentifyContentResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyContentResponse>> AsyncDeidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyContentResponse>>(AsyncDeidentifyContentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyContentResponse>> PrepareAsyncDeidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyContentResponse>>(PrepareAsyncDeidentifyContentRaw(context, request, cq));
    }
    ::grpc::Status ReidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest& request, ::google::privacy::dlp::v2::ReidentifyContentResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ReidentifyContentResponse>> AsyncReidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ReidentifyContentResponse>>(AsyncReidentifyContentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ReidentifyContentResponse>> PrepareAsyncReidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ReidentifyContentResponse>>(PrepareAsyncReidentifyContentRaw(context, request, cq));
    }
    ::grpc::Status ListInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest& request, ::google::privacy::dlp::v2::ListInfoTypesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInfoTypesResponse>> AsyncListInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInfoTypesResponse>>(AsyncListInfoTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInfoTypesResponse>> PrepareAsyncListInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInfoTypesResponse>>(PrepareAsyncListInfoTypesRaw(context, request, cq));
    }
    ::grpc::Status CreateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest& request, ::google::privacy::dlp::v2::InspectTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>> AsyncCreateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>>(AsyncCreateInspectTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>> PrepareAsyncCreateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>>(PrepareAsyncCreateInspectTemplateRaw(context, request, cq));
    }
    ::grpc::Status UpdateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest& request, ::google::privacy::dlp::v2::InspectTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>> AsyncUpdateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>>(AsyncUpdateInspectTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>> PrepareAsyncUpdateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>>(PrepareAsyncUpdateInspectTemplateRaw(context, request, cq));
    }
    ::grpc::Status GetInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest& request, ::google::privacy::dlp::v2::InspectTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>> AsyncGetInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>>(AsyncGetInspectTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>> PrepareAsyncGetInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>>(PrepareAsyncGetInspectTemplateRaw(context, request, cq));
    }
    ::grpc::Status ListInspectTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest& request, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>> AsyncListInspectTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>>(AsyncListInspectTemplatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>> PrepareAsyncListInspectTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>>(PrepareAsyncListInspectTemplatesRaw(context, request, cq));
    }
    ::grpc::Status DeleteInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteInspectTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteInspectTemplateRaw(context, request, cq));
    }
    ::grpc::Status CreateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest& request, ::google::privacy::dlp::v2::DeidentifyTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>> AsyncCreateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>>(AsyncCreateDeidentifyTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>> PrepareAsyncCreateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>>(PrepareAsyncCreateDeidentifyTemplateRaw(context, request, cq));
    }
    ::grpc::Status UpdateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest& request, ::google::privacy::dlp::v2::DeidentifyTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>> AsyncUpdateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>>(AsyncUpdateDeidentifyTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>> PrepareAsyncUpdateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>>(PrepareAsyncUpdateDeidentifyTemplateRaw(context, request, cq));
    }
    ::grpc::Status GetDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest& request, ::google::privacy::dlp::v2::DeidentifyTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>> AsyncGetDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>>(AsyncGetDeidentifyTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>> PrepareAsyncGetDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>>(PrepareAsyncGetDeidentifyTemplateRaw(context, request, cq));
    }
    ::grpc::Status ListDeidentifyTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest& request, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>> AsyncListDeidentifyTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>>(AsyncListDeidentifyTemplatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>> PrepareAsyncListDeidentifyTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>>(PrepareAsyncListDeidentifyTemplatesRaw(context, request, cq));
    }
    ::grpc::Status DeleteDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteDeidentifyTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteDeidentifyTemplateRaw(context, request, cq));
    }
    ::grpc::Status CreateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest& request, ::google::privacy::dlp::v2::JobTrigger* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>> AsyncCreateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>>(AsyncCreateJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>> PrepareAsyncCreateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>>(PrepareAsyncCreateJobTriggerRaw(context, request, cq));
    }
    ::grpc::Status UpdateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest& request, ::google::privacy::dlp::v2::JobTrigger* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>> AsyncUpdateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>>(AsyncUpdateJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>> PrepareAsyncUpdateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>>(PrepareAsyncUpdateJobTriggerRaw(context, request, cq));
    }
    ::grpc::Status HybridInspectJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest& request, ::google::privacy::dlp::v2::HybridInspectResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>> AsyncHybridInspectJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>>(AsyncHybridInspectJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>> PrepareAsyncHybridInspectJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>>(PrepareAsyncHybridInspectJobTriggerRaw(context, request, cq));
    }
    ::grpc::Status GetJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest& request, ::google::privacy::dlp::v2::JobTrigger* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>> AsyncGetJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>>(AsyncGetJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>> PrepareAsyncGetJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>>(PrepareAsyncGetJobTriggerRaw(context, request, cq));
    }
    ::grpc::Status ListJobTriggers(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest& request, ::google::privacy::dlp::v2::ListJobTriggersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListJobTriggersResponse>> AsyncListJobTriggers(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListJobTriggersResponse>>(AsyncListJobTriggersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListJobTriggersResponse>> PrepareAsyncListJobTriggers(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListJobTriggersResponse>>(PrepareAsyncListJobTriggersRaw(context, request, cq));
    }
    ::grpc::Status DeleteJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobTriggerRaw(context, request, cq));
    }
    ::grpc::Status ActivateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest& request, ::google::privacy::dlp::v2::DlpJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>> AsyncActivateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>>(AsyncActivateJobTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>> PrepareAsyncActivateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>>(PrepareAsyncActivateJobTriggerRaw(context, request, cq));
    }
    ::grpc::Status CreateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest& request, ::google::privacy::dlp::v2::DiscoveryConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>> AsyncCreateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>>(AsyncCreateDiscoveryConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>> PrepareAsyncCreateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>>(PrepareAsyncCreateDiscoveryConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest& request, ::google::privacy::dlp::v2::DiscoveryConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>> AsyncUpdateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>>(AsyncUpdateDiscoveryConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>> PrepareAsyncUpdateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>>(PrepareAsyncUpdateDiscoveryConfigRaw(context, request, cq));
    }
    ::grpc::Status GetDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest& request, ::google::privacy::dlp::v2::DiscoveryConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>> AsyncGetDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>>(AsyncGetDiscoveryConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>> PrepareAsyncGetDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>>(PrepareAsyncGetDiscoveryConfigRaw(context, request, cq));
    }
    ::grpc::Status ListDiscoveryConfigs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest& request, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>> AsyncListDiscoveryConfigs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>>(AsyncListDiscoveryConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>> PrepareAsyncListDiscoveryConfigs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>>(PrepareAsyncListDiscoveryConfigsRaw(context, request, cq));
    }
    ::grpc::Status DeleteDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteDiscoveryConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteDiscoveryConfigRaw(context, request, cq));
    }
    ::grpc::Status CreateDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest& request, ::google::privacy::dlp::v2::DlpJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>> AsyncCreateDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>>(AsyncCreateDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>> PrepareAsyncCreateDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>>(PrepareAsyncCreateDlpJobRaw(context, request, cq));
    }
    ::grpc::Status ListDlpJobs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest& request, ::google::privacy::dlp::v2::ListDlpJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDlpJobsResponse>> AsyncListDlpJobs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDlpJobsResponse>>(AsyncListDlpJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDlpJobsResponse>> PrepareAsyncListDlpJobs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDlpJobsResponse>>(PrepareAsyncListDlpJobsRaw(context, request, cq));
    }
    ::grpc::Status GetDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest& request, ::google::privacy::dlp::v2::DlpJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>> AsyncGetDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>>(AsyncGetDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>> PrepareAsyncGetDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>>(PrepareAsyncGetDlpJobRaw(context, request, cq));
    }
    ::grpc::Status DeleteDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteDlpJobRaw(context, request, cq));
    }
    ::grpc::Status CancelDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncCancelDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncCancelDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncCancelDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncCancelDlpJobRaw(context, request, cq));
    }
    ::grpc::Status CreateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest& request, ::google::privacy::dlp::v2::StoredInfoType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>> AsyncCreateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>>(AsyncCreateStoredInfoTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>> PrepareAsyncCreateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>>(PrepareAsyncCreateStoredInfoTypeRaw(context, request, cq));
    }
    ::grpc::Status UpdateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest& request, ::google::privacy::dlp::v2::StoredInfoType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>> AsyncUpdateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>>(AsyncUpdateStoredInfoTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>> PrepareAsyncUpdateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>>(PrepareAsyncUpdateStoredInfoTypeRaw(context, request, cq));
    }
    ::grpc::Status GetStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest& request, ::google::privacy::dlp::v2::StoredInfoType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>> AsyncGetStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>>(AsyncGetStoredInfoTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>> PrepareAsyncGetStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>>(PrepareAsyncGetStoredInfoTypeRaw(context, request, cq));
    }
    ::grpc::Status ListStoredInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest& request, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>> AsyncListStoredInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>>(AsyncListStoredInfoTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>> PrepareAsyncListStoredInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>>(PrepareAsyncListStoredInfoTypesRaw(context, request, cq));
    }
    ::grpc::Status DeleteStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteStoredInfoTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteStoredInfoTypeRaw(context, request, cq));
    }
    ::grpc::Status ListProjectDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest& request, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>> AsyncListProjectDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>>(AsyncListProjectDataProfilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>> PrepareAsyncListProjectDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>>(PrepareAsyncListProjectDataProfilesRaw(context, request, cq));
    }
    ::grpc::Status ListTableDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest& request, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>> AsyncListTableDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>>(AsyncListTableDataProfilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>> PrepareAsyncListTableDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>>(PrepareAsyncListTableDataProfilesRaw(context, request, cq));
    }
    ::grpc::Status ListColumnDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest& request, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>> AsyncListColumnDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>>(AsyncListColumnDataProfilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>> PrepareAsyncListColumnDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>>(PrepareAsyncListColumnDataProfilesRaw(context, request, cq));
    }
    ::grpc::Status GetProjectDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest& request, ::google::privacy::dlp::v2::ProjectDataProfile* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ProjectDataProfile>> AsyncGetProjectDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ProjectDataProfile>>(AsyncGetProjectDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ProjectDataProfile>> PrepareAsyncGetProjectDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ProjectDataProfile>>(PrepareAsyncGetProjectDataProfileRaw(context, request, cq));
    }
    ::grpc::Status ListFileStoreDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest& request, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>> AsyncListFileStoreDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>>(AsyncListFileStoreDataProfilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>> PrepareAsyncListFileStoreDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>>(PrepareAsyncListFileStoreDataProfilesRaw(context, request, cq));
    }
    ::grpc::Status GetFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest& request, ::google::privacy::dlp::v2::FileStoreDataProfile* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::FileStoreDataProfile>> AsyncGetFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::FileStoreDataProfile>>(AsyncGetFileStoreDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::FileStoreDataProfile>> PrepareAsyncGetFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::FileStoreDataProfile>>(PrepareAsyncGetFileStoreDataProfileRaw(context, request, cq));
    }
    ::grpc::Status DeleteFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteFileStoreDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteFileStoreDataProfileRaw(context, request, cq));
    }
    ::grpc::Status GetTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest& request, ::google::privacy::dlp::v2::TableDataProfile* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::TableDataProfile>> AsyncGetTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::TableDataProfile>>(AsyncGetTableDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::TableDataProfile>> PrepareAsyncGetTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::TableDataProfile>>(PrepareAsyncGetTableDataProfileRaw(context, request, cq));
    }
    ::grpc::Status GetColumnDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest& request, ::google::privacy::dlp::v2::ColumnDataProfile* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ColumnDataProfile>> AsyncGetColumnDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ColumnDataProfile>>(AsyncGetColumnDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ColumnDataProfile>> PrepareAsyncGetColumnDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ColumnDataProfile>>(PrepareAsyncGetColumnDataProfileRaw(context, request, cq));
    }
    ::grpc::Status DeleteTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteTableDataProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteTableDataProfileRaw(context, request, cq));
    }
    ::grpc::Status HybridInspectDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest& request, ::google::privacy::dlp::v2::HybridInspectResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>> AsyncHybridInspectDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>>(AsyncHybridInspectDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>> PrepareAsyncHybridInspectDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>>(PrepareAsyncHybridInspectDlpJobRaw(context, request, cq));
    }
    ::grpc::Status FinishDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncFinishDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncFinishDlpJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncFinishDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncFinishDlpJobRaw(context, request, cq));
    }
    ::grpc::Status CreateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest& request, ::google::privacy::dlp::v2::Connection* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>> AsyncCreateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>>(AsyncCreateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>> PrepareAsyncCreateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>>(PrepareAsyncCreateConnectionRaw(context, request, cq));
    }
    ::grpc::Status GetConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest& request, ::google::privacy::dlp::v2::Connection* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>> AsyncGetConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>>(AsyncGetConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>> PrepareAsyncGetConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>>(PrepareAsyncGetConnectionRaw(context, request, cq));
    }
    ::grpc::Status ListConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest& request, ::google::privacy::dlp::v2::ListConnectionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListConnectionsResponse>> AsyncListConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListConnectionsResponse>>(AsyncListConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListConnectionsResponse>> PrepareAsyncListConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListConnectionsResponse>>(PrepareAsyncListConnectionsRaw(context, request, cq));
    }
    ::grpc::Status SearchConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest& request, ::google::privacy::dlp::v2::SearchConnectionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::SearchConnectionsResponse>> AsyncSearchConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::SearchConnectionsResponse>>(AsyncSearchConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::SearchConnectionsResponse>> PrepareAsyncSearchConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::SearchConnectionsResponse>>(PrepareAsyncSearchConnectionsRaw(context, request, cq));
    }
    ::grpc::Status DeleteConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteConnectionRaw(context, request, cq));
    }
    ::grpc::Status UpdateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest& request, ::google::privacy::dlp::v2::Connection* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>> AsyncUpdateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>>(AsyncUpdateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>> PrepareAsyncUpdateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>>(PrepareAsyncUpdateConnectionRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void InspectContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest* request, ::google::privacy::dlp::v2::InspectContentResponse* response, std::function<void(::grpc::Status)>) override;
      void InspectContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest* request, ::google::privacy::dlp::v2::InspectContentResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RedactImage(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest* request, ::google::privacy::dlp::v2::RedactImageResponse* response, std::function<void(::grpc::Status)>) override;
      void RedactImage(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest* request, ::google::privacy::dlp::v2::RedactImageResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest* request, ::google::privacy::dlp::v2::DeidentifyContentResponse* response, std::function<void(::grpc::Status)>) override;
      void DeidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest* request, ::google::privacy::dlp::v2::DeidentifyContentResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest* request, ::google::privacy::dlp::v2::ReidentifyContentResponse* response, std::function<void(::grpc::Status)>) override;
      void ReidentifyContent(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest* request, ::google::privacy::dlp::v2::ReidentifyContentResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest* request, ::google::privacy::dlp::v2::ListInfoTypesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest* request, ::google::privacy::dlp::v2::ListInfoTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, std::function<void(::grpc::Status)>) override;
      void CreateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, std::function<void(::grpc::Status)>) override;
      void UpdateInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, std::function<void(::grpc::Status)>) override;
      void GetInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListInspectTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* request, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInspectTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* request, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteInspectTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, std::function<void(::grpc::Status)>) override;
      void CreateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, std::function<void(::grpc::Status)>) override;
      void UpdateDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, std::function<void(::grpc::Status)>) override;
      void GetDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListDeidentifyTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* request, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDeidentifyTemplates(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* request, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteDeidentifyTemplate(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, std::function<void(::grpc::Status)>) override;
      void CreateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, std::function<void(::grpc::Status)>) override;
      void UpdateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, ::grpc::ClientUnaryReactor* reactor) override;
      void HybridInspectJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response, std::function<void(::grpc::Status)>) override;
      void HybridInspectJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, std::function<void(::grpc::Status)>) override;
      void GetJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListJobTriggers(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest* request, ::google::privacy::dlp::v2::ListJobTriggersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListJobTriggers(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest* request, ::google::privacy::dlp::v2::ListJobTriggersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ActivateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* request, ::google::privacy::dlp::v2::DlpJob* response, std::function<void(::grpc::Status)>) override;
      void ActivateJobTrigger(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* request, ::google::privacy::dlp::v2::DlpJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, std::function<void(::grpc::Status)>) override;
      void CreateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, std::function<void(::grpc::Status)>) override;
      void UpdateDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, std::function<void(::grpc::Status)>) override;
      void GetDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListDiscoveryConfigs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* request, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDiscoveryConfigs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* request, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteDiscoveryConfig(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response, std::function<void(::grpc::Status)>) override;
      void CreateDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListDlpJobs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest* request, ::google::privacy::dlp::v2::ListDlpJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDlpJobs(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest* request, ::google::privacy::dlp::v2::ListDlpJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response, std::function<void(::grpc::Status)>) override;
      void GetDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void CancelDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, std::function<void(::grpc::Status)>) override;
      void CreateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, std::function<void(::grpc::Status)>) override;
      void UpdateStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, std::function<void(::grpc::Status)>) override;
      void GetStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListStoredInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* request, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListStoredInfoTypes(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* request, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteStoredInfoType(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListProjectDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* request, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListProjectDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* request, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTableDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* request, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTableDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* request, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListColumnDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* request, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListColumnDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* request, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetProjectDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* request, ::google::privacy::dlp::v2::ProjectDataProfile* response, std::function<void(::grpc::Status)>) override;
      void GetProjectDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* request, ::google::privacy::dlp::v2::ProjectDataProfile* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListFileStoreDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* request, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListFileStoreDataProfiles(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* request, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* request, ::google::privacy::dlp::v2::FileStoreDataProfile* response, std::function<void(::grpc::Status)>) override;
      void GetFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* request, ::google::privacy::dlp::v2::FileStoreDataProfile* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteFileStoreDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* request, ::google::privacy::dlp::v2::TableDataProfile* response, std::function<void(::grpc::Status)>) override;
      void GetTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* request, ::google::privacy::dlp::v2::TableDataProfile* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetColumnDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* request, ::google::privacy::dlp::v2::ColumnDataProfile* response, std::function<void(::grpc::Status)>) override;
      void GetColumnDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* request, ::google::privacy::dlp::v2::ColumnDataProfile* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteTableDataProfile(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void HybridInspectDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response, std::function<void(::grpc::Status)>) override;
      void HybridInspectDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void FinishDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void FinishDlpJob(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, std::function<void(::grpc::Status)>) override;
      void CreateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, std::function<void(::grpc::Status)>) override;
      void GetConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest* request, ::google::privacy::dlp::v2::ListConnectionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest* request, ::google::privacy::dlp::v2::ListConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest* request, ::google::privacy::dlp::v2::SearchConnectionsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchConnections(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest* request, ::google::privacy::dlp::v2::SearchConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, std::function<void(::grpc::Status)>) override;
      void UpdateConnection(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectContentResponse>* AsyncInspectContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectContentResponse>* PrepareAsyncInspectContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::InspectContentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::RedactImageResponse>* AsyncRedactImageRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::RedactImageResponse>* PrepareAsyncRedactImageRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::RedactImageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyContentResponse>* AsyncDeidentifyContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyContentResponse>* PrepareAsyncDeidentifyContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ReidentifyContentResponse>* AsyncReidentifyContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ReidentifyContentResponse>* PrepareAsyncReidentifyContentRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInfoTypesResponse>* AsyncListInfoTypesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInfoTypesResponse>* PrepareAsyncListInfoTypesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>* AsyncCreateInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>* PrepareAsyncCreateInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>* AsyncUpdateInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>* PrepareAsyncUpdateInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>* AsyncGetInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::InspectTemplate>* PrepareAsyncGetInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>* AsyncListInspectTemplatesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>* PrepareAsyncListInspectTemplatesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteInspectTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>* AsyncCreateDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>* PrepareAsyncCreateDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>* AsyncUpdateDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>* PrepareAsyncUpdateDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>* AsyncGetDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DeidentifyTemplate>* PrepareAsyncGetDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>* AsyncListDeidentifyTemplatesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>* PrepareAsyncListDeidentifyTemplatesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteDeidentifyTemplateRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>* AsyncCreateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>* PrepareAsyncCreateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>* AsyncUpdateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>* PrepareAsyncUpdateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>* AsyncHybridInspectJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>* PrepareAsyncHybridInspectJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>* AsyncGetJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::JobTrigger>* PrepareAsyncGetJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListJobTriggersResponse>* AsyncListJobTriggersRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListJobTriggersResponse>* PrepareAsyncListJobTriggersRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>* AsyncActivateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>* PrepareAsyncActivateJobTriggerRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>* AsyncCreateDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>* PrepareAsyncCreateDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>* AsyncUpdateDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>* PrepareAsyncUpdateDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>* AsyncGetDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DiscoveryConfig>* PrepareAsyncGetDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>* AsyncListDiscoveryConfigsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>* PrepareAsyncListDiscoveryConfigsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteDiscoveryConfigRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>* AsyncCreateDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>* PrepareAsyncCreateDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDlpJobsResponse>* AsyncListDlpJobsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListDlpJobsResponse>* PrepareAsyncListDlpJobsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>* AsyncGetDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::DlpJob>* PrepareAsyncGetDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncCancelDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncCancelDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>* AsyncCreateStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>* PrepareAsyncCreateStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>* AsyncUpdateStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>* PrepareAsyncUpdateStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>* AsyncGetStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::StoredInfoType>* PrepareAsyncGetStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>* AsyncListStoredInfoTypesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>* PrepareAsyncListStoredInfoTypesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteStoredInfoTypeRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>* AsyncListProjectDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>* PrepareAsyncListProjectDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>* AsyncListTableDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>* PrepareAsyncListTableDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>* AsyncListColumnDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>* PrepareAsyncListColumnDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ProjectDataProfile>* AsyncGetProjectDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ProjectDataProfile>* PrepareAsyncGetProjectDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>* AsyncListFileStoreDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>* PrepareAsyncListFileStoreDataProfilesRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::FileStoreDataProfile>* AsyncGetFileStoreDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::FileStoreDataProfile>* PrepareAsyncGetFileStoreDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteFileStoreDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteFileStoreDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::TableDataProfile>* AsyncGetTableDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::TableDataProfile>* PrepareAsyncGetTableDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ColumnDataProfile>* AsyncGetColumnDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ColumnDataProfile>* PrepareAsyncGetColumnDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteTableDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteTableDataProfileRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>* AsyncHybridInspectDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::HybridInspectResponse>* PrepareAsyncHybridInspectDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncFinishDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncFinishDlpJobRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>* AsyncCreateConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>* PrepareAsyncCreateConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>* AsyncGetConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>* PrepareAsyncGetConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListConnectionsResponse>* AsyncListConnectionsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::ListConnectionsResponse>* PrepareAsyncListConnectionsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::SearchConnectionsResponse>* AsyncSearchConnectionsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::SearchConnectionsResponse>* PrepareAsyncSearchConnectionsRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>* AsyncUpdateConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::privacy::dlp::v2::Connection>* PrepareAsyncUpdateConnectionRaw(::grpc::ClientContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_InspectContent_;
    const ::grpc::internal::RpcMethod rpcmethod_RedactImage_;
    const ::grpc::internal::RpcMethod rpcmethod_DeidentifyContent_;
    const ::grpc::internal::RpcMethod rpcmethod_ReidentifyContent_;
    const ::grpc::internal::RpcMethod rpcmethod_ListInfoTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateInspectTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateInspectTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInspectTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_ListInspectTemplates_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteInspectTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateDeidentifyTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDeidentifyTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDeidentifyTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_ListDeidentifyTemplates_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteDeidentifyTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateJobTrigger_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateJobTrigger_;
    const ::grpc::internal::RpcMethod rpcmethod_HybridInspectJobTrigger_;
    const ::grpc::internal::RpcMethod rpcmethod_GetJobTrigger_;
    const ::grpc::internal::RpcMethod rpcmethod_ListJobTriggers_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteJobTrigger_;
    const ::grpc::internal::RpcMethod rpcmethod_ActivateJobTrigger_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateDiscoveryConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDiscoveryConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDiscoveryConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_ListDiscoveryConfigs_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteDiscoveryConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateDlpJob_;
    const ::grpc::internal::RpcMethod rpcmethod_ListDlpJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDlpJob_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteDlpJob_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelDlpJob_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateStoredInfoType_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateStoredInfoType_;
    const ::grpc::internal::RpcMethod rpcmethod_GetStoredInfoType_;
    const ::grpc::internal::RpcMethod rpcmethod_ListStoredInfoTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteStoredInfoType_;
    const ::grpc::internal::RpcMethod rpcmethod_ListProjectDataProfiles_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTableDataProfiles_;
    const ::grpc::internal::RpcMethod rpcmethod_ListColumnDataProfiles_;
    const ::grpc::internal::RpcMethod rpcmethod_GetProjectDataProfile_;
    const ::grpc::internal::RpcMethod rpcmethod_ListFileStoreDataProfiles_;
    const ::grpc::internal::RpcMethod rpcmethod_GetFileStoreDataProfile_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteFileStoreDataProfile_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTableDataProfile_;
    const ::grpc::internal::RpcMethod rpcmethod_GetColumnDataProfile_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTableDataProfile_;
    const ::grpc::internal::RpcMethod rpcmethod_HybridInspectDlpJob_;
    const ::grpc::internal::RpcMethod rpcmethod_FinishDlpJob_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_GetConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_ListConnections_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchConnections_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateConnection_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Finds potentially sensitive info in content.
    // This method has limits on input size, processing time, and output size.
    //
    // When no InfoTypes or CustomInfoTypes are specified in this request, the
    // system will automatically choose what detectors to run. By default this may
    // be all types, but may change over time as detectors are updated.
    //
    // For how to guides, see
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-images
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-text,
    virtual ::grpc::Status InspectContent(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::InspectContentRequest* request, ::google::privacy::dlp::v2::InspectContentResponse* response);
    // Redacts potentially sensitive info from an image.
    // This method has limits on input size, processing time, and output size.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/redacting-sensitive-data-images
    // to learn more.
    //
    // When no InfoTypes or CustomInfoTypes are specified in this request, the
    // system will automatically choose what detectors to run. By default this may
    // be all types, but may change over time as detectors are updated.
    virtual ::grpc::Status RedactImage(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::RedactImageRequest* request, ::google::privacy::dlp::v2::RedactImageResponse* response);
    // De-identifies potentially sensitive info from a ContentItem.
    // This method has limits on input size and output size.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/deidentify-sensitive-data
    // to learn more.
    //
    // When no InfoTypes or CustomInfoTypes are specified in this request, the
    // system will automatically choose what detectors to run. By default this may
    // be all types, but may change over time as detectors are updated.
    virtual ::grpc::Status DeidentifyContent(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest* request, ::google::privacy::dlp::v2::DeidentifyContentResponse* response);
    // Re-identifies content that has been de-identified.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/pseudonymization#re-identification_in_free_text_code_example
    // to learn more.
    virtual ::grpc::Status ReidentifyContent(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest* request, ::google::privacy::dlp::v2::ReidentifyContentResponse* response);
    // Returns a list of the sensitive information types that DLP API
    // supports. See
    // https://cloud.google.com/sensitive-data-protection/docs/infotypes-reference
    // to learn more.
    virtual ::grpc::Status ListInfoTypes(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest* request, ::google::privacy::dlp::v2::ListInfoTypesResponse* response);
    // Creates an InspectTemplate for reusing frequently used configuration
    // for inspecting content, images, and storage.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
    // to learn more.
    virtual ::grpc::Status CreateInspectTemplate(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response);
    // Updates the InspectTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
    // to learn more.
    virtual ::grpc::Status UpdateInspectTemplate(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response);
    // Gets an InspectTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
    // to learn more.
    virtual ::grpc::Status GetInspectTemplate(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response);
    // Lists InspectTemplates.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
    // to learn more.
    virtual ::grpc::Status ListInspectTemplates(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* request, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* response);
    // Deletes an InspectTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates
    // to learn more.
    virtual ::grpc::Status DeleteInspectTemplate(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* request, ::google::protobuf::Empty* response);
    // Creates a DeidentifyTemplate for reusing frequently used configuration
    // for de-identifying content, images, and storage.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
    // to learn more.
    virtual ::grpc::Status CreateDeidentifyTemplate(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response);
    // Updates the DeidentifyTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
    // to learn more.
    virtual ::grpc::Status UpdateDeidentifyTemplate(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response);
    // Gets a DeidentifyTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
    // to learn more.
    virtual ::grpc::Status GetDeidentifyTemplate(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response);
    // Lists DeidentifyTemplates.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
    // to learn more.
    virtual ::grpc::Status ListDeidentifyTemplates(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* request, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* response);
    // Deletes a DeidentifyTemplate.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-templates-deid
    // to learn more.
    virtual ::grpc::Status DeleteDeidentifyTemplate(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* request, ::google::protobuf::Empty* response);
    // Creates a job trigger to run DLP actions such as scanning storage for
    // sensitive information on a set schedule.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
    // to learn more.
    virtual ::grpc::Status CreateJobTrigger(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response);
    // Updates a job trigger.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
    // to learn more.
    virtual ::grpc::Status UpdateJobTrigger(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response);
    // Inspect hybrid content and store findings to a trigger. The inspection
    // will be processed asynchronously. To review the findings monitor the
    // jobs within the trigger.
    virtual ::grpc::Status HybridInspectJobTrigger(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response);
    // Gets a job trigger.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
    // to learn more.
    virtual ::grpc::Status GetJobTrigger(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response);
    // Lists job triggers.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
    // to learn more.
    virtual ::grpc::Status ListJobTriggers(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest* request, ::google::privacy::dlp::v2::ListJobTriggersResponse* response);
    // Deletes a job trigger.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-job-triggers
    // to learn more.
    virtual ::grpc::Status DeleteJobTrigger(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* request, ::google::protobuf::Empty* response);
    // Activate a job trigger. Causes the immediate execute of a trigger
    // instead of waiting on the trigger event to occur.
    virtual ::grpc::Status ActivateJobTrigger(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* request, ::google::privacy::dlp::v2::DlpJob* response);
    // Creates a config for discovery to scan and profile storage.
    virtual ::grpc::Status CreateDiscoveryConfig(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response);
    // Updates a discovery configuration.
    virtual ::grpc::Status UpdateDiscoveryConfig(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response);
    // Gets a discovery configuration.
    virtual ::grpc::Status GetDiscoveryConfig(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response);
    // Lists discovery configurations.
    virtual ::grpc::Status ListDiscoveryConfigs(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* request, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* response);
    // Deletes a discovery configuration.
    virtual ::grpc::Status DeleteDiscoveryConfig(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* request, ::google::protobuf::Empty* response);
    // Creates a new job to inspect storage or calculate risk metrics.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
    // to learn more.
    //
    // When no InfoTypes or CustomInfoTypes are specified in inspect jobs, the
    // system will automatically choose what detectors to run. By default this may
    // be all types, but may change over time as detectors are updated.
    virtual ::grpc::Status CreateDlpJob(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response);
    // Lists DlpJobs that match the specified filter in the request.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
    // to learn more.
    virtual ::grpc::Status ListDlpJobs(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest* request, ::google::privacy::dlp::v2::ListDlpJobsResponse* response);
    // Gets the latest state of a long-running DlpJob.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
    // to learn more.
    virtual ::grpc::Status GetDlpJob(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response);
    // Deletes a long-running DlpJob. This method indicates that the client is
    // no longer interested in the DlpJob result. The job will be canceled if
    // possible.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
    // to learn more.
    virtual ::grpc::Status DeleteDlpJob(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* request, ::google::protobuf::Empty* response);
    // Starts asynchronous cancellation on a long-running DlpJob. The server
    // makes a best effort to cancel the DlpJob, but success is not
    // guaranteed.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/inspecting-storage
    // and
    // https://cloud.google.com/sensitive-data-protection/docs/compute-risk-analysis
    // to learn more.
    virtual ::grpc::Status CancelDlpJob(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest* request, ::google::protobuf::Empty* response);
    // Creates a pre-built stored infoType to be used for inspection.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
    // to learn more.
    virtual ::grpc::Status CreateStoredInfoType(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response);
    // Updates the stored infoType by creating a new version. The existing version
    // will continue to be used until the new version is ready.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
    // to learn more.
    virtual ::grpc::Status UpdateStoredInfoType(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response);
    // Gets a stored infoType.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
    // to learn more.
    virtual ::grpc::Status GetStoredInfoType(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response);
    // Lists stored infoTypes.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
    // to learn more.
    virtual ::grpc::Status ListStoredInfoTypes(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* request, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* response);
    // Deletes a stored infoType.
    // See
    // https://cloud.google.com/sensitive-data-protection/docs/creating-stored-infotypes
    // to learn more.
    virtual ::grpc::Status DeleteStoredInfoType(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* request, ::google::protobuf::Empty* response);
    // Lists project data profiles for an organization.
    virtual ::grpc::Status ListProjectDataProfiles(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* request, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* response);
    // Lists table data profiles for an organization.
    virtual ::grpc::Status ListTableDataProfiles(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* request, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* response);
    // Lists column data profiles for an organization.
    virtual ::grpc::Status ListColumnDataProfiles(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* request, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* response);
    // Gets a project data profile.
    virtual ::grpc::Status GetProjectDataProfile(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* request, ::google::privacy::dlp::v2::ProjectDataProfile* response);
    // Lists file store data profiles for an organization.
    virtual ::grpc::Status ListFileStoreDataProfiles(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* request, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* response);
    // Gets a file store data profile.
    virtual ::grpc::Status GetFileStoreDataProfile(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* request, ::google::privacy::dlp::v2::FileStoreDataProfile* response);
    // Delete a FileStoreDataProfile. Will not prevent the profile from being
    // regenerated if the resource is still included in a discovery configuration.
    virtual ::grpc::Status DeleteFileStoreDataProfile(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* request, ::google::protobuf::Empty* response);
    // Gets a table data profile.
    virtual ::grpc::Status GetTableDataProfile(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* request, ::google::privacy::dlp::v2::TableDataProfile* response);
    // Gets a column data profile.
    virtual ::grpc::Status GetColumnDataProfile(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* request, ::google::privacy::dlp::v2::ColumnDataProfile* response);
    // Delete a TableDataProfile. Will not prevent the profile from being
    // regenerated if the table is still included in a discovery configuration.
    virtual ::grpc::Status DeleteTableDataProfile(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* request, ::google::protobuf::Empty* response);
    // Inspect hybrid content and store findings to a job.
    // To review the findings, inspect the job. Inspection will occur
    // asynchronously.
    virtual ::grpc::Status HybridInspectDlpJob(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response);
    // Finish a running hybrid DlpJob. Triggers the finalization steps and running
    // of any enabled actions that have not yet run.
    virtual ::grpc::Status FinishDlpJob(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest* request, ::google::protobuf::Empty* response);
    // Create a Connection to an external data source.
    virtual ::grpc::Status CreateConnection(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response);
    // Get a Connection by name.
    virtual ::grpc::Status GetConnection(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response);
    // Lists Connections in a parent. Use SearchConnections to see all connections
    // within an organization.
    virtual ::grpc::Status ListConnections(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest* request, ::google::privacy::dlp::v2::ListConnectionsResponse* response);
    // Searches for Connections in a parent.
    virtual ::grpc::Status SearchConnections(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest* request, ::google::privacy::dlp::v2::SearchConnectionsResponse* response);
    // Delete a Connection.
    virtual ::grpc::Status DeleteConnection(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest* request, ::google::protobuf::Empty* response);
    // Update a Connection.
    virtual ::grpc::Status UpdateConnection(::grpc::ServerContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_InspectContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_InspectContent() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_InspectContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InspectContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::InspectContentRequest* /*request*/, ::google::privacy::dlp::v2::InspectContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInspectContent(::grpc::ServerContext* context, ::google::privacy::dlp::v2::InspectContentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::InspectContentResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RedactImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RedactImage() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_RedactImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RedactImage(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::RedactImageRequest* /*request*/, ::google::privacy::dlp::v2::RedactImageResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRedactImage(::grpc::ServerContext* context, ::google::privacy::dlp::v2::RedactImageRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::RedactImageResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeidentifyContent() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_DeidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeidentifyContent(::grpc::ServerContext* context, ::google::privacy::dlp::v2::DeidentifyContentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::DeidentifyContentResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReidentifyContent() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ReidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ReidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::ReidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReidentifyContent(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ReidentifyContentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ReidentifyContentResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInfoTypes() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInfoTypes(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListInfoTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListInfoTypesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateInspectTemplate() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_CreateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInspectTemplate(::grpc::ServerContext* context, ::google::privacy::dlp::v2::CreateInspectTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::InspectTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateInspectTemplate() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_UpdateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInspectTemplate(::grpc::ServerContext* context, ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::InspectTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInspectTemplate() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInspectTemplate(::grpc::ServerContext* context, ::google::privacy::dlp::v2::GetInspectTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::InspectTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInspectTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInspectTemplates() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ListInspectTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInspectTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInspectTemplates(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListInspectTemplatesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListInspectTemplatesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteInspectTemplate() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_DeleteInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInspectTemplate(::grpc::ServerContext* context, ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_CreateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDeidentifyTemplate(::grpc::ServerContext* context, ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::DeidentifyTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_UpdateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDeidentifyTemplate(::grpc::ServerContext* context, ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::DeidentifyTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDeidentifyTemplate() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_GetDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDeidentifyTemplate(::grpc::ServerContext* context, ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::DeidentifyTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDeidentifyTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDeidentifyTemplates() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_ListDeidentifyTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeidentifyTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDeidentifyTemplates(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteDeidentifyTemplate() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_DeleteDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDeidentifyTemplate(::grpc::ServerContext* context, ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateJobTrigger() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_CreateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateJobTrigger(::grpc::ServerContext* context, ::google::privacy::dlp::v2::CreateJobTriggerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::JobTrigger>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateJobTrigger() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_UpdateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateJobTrigger(::grpc::ServerContext* context, ::google::privacy::dlp::v2::UpdateJobTriggerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::JobTrigger>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_HybridInspectJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_HybridInspectJobTrigger() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_HybridInspectJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status HybridInspectJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestHybridInspectJobTrigger(::grpc::ServerContext* context, ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::HybridInspectResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetJobTrigger() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_GetJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJobTrigger(::grpc::ServerContext* context, ::google::privacy::dlp::v2::GetJobTriggerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::JobTrigger>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListJobTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListJobTriggers() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_ListJobTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobTriggers(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListJobTriggersRequest* /*request*/, ::google::privacy::dlp::v2::ListJobTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobTriggers(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListJobTriggersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListJobTriggersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteJobTrigger() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_DeleteJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJobTrigger(::grpc::ServerContext* context, ::google::privacy::dlp::v2::DeleteJobTriggerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ActivateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ActivateJobTrigger() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_ActivateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ActivateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestActivateJobTrigger(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ActivateJobTriggerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::DlpJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateDiscoveryConfig() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_CreateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDiscoveryConfig(::grpc::ServerContext* context, ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::DiscoveryConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDiscoveryConfig() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_UpdateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDiscoveryConfig(::grpc::ServerContext* context, ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::DiscoveryConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDiscoveryConfig() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_GetDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDiscoveryConfig(::grpc::ServerContext* context, ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::DiscoveryConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDiscoveryConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDiscoveryConfigs() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_ListDiscoveryConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDiscoveryConfigs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* /*request*/, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDiscoveryConfigs(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteDiscoveryConfig() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_DeleteDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDiscoveryConfig(::grpc::ServerContext* context, ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateDlpJob() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_CreateDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDlpJob(::grpc::ServerContext* context, ::google::privacy::dlp::v2::CreateDlpJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::DlpJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDlpJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDlpJobs() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_ListDlpJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDlpJobs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDlpJobsRequest* /*request*/, ::google::privacy::dlp::v2::ListDlpJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDlpJobs(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListDlpJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListDlpJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDlpJob() {
      ::grpc::Service::MarkMethodAsync(29);
    }
    ~WithAsyncMethod_GetDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDlpJob(::grpc::ServerContext* context, ::google::privacy::dlp::v2::GetDlpJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::DlpJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteDlpJob() {
      ::grpc::Service::MarkMethodAsync(30);
    }
    ~WithAsyncMethod_DeleteDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDlpJob(::grpc::ServerContext* context, ::google::privacy::dlp::v2::DeleteDlpJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelDlpJob() {
      ::grpc::Service::MarkMethodAsync(31);
    }
    ~WithAsyncMethod_CancelDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CancelDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelDlpJob(::grpc::ServerContext* context, ::google::privacy::dlp::v2::CancelDlpJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateStoredInfoType() {
      ::grpc::Service::MarkMethodAsync(32);
    }
    ~WithAsyncMethod_CreateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateStoredInfoType(::grpc::ServerContext* context, ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::StoredInfoType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateStoredInfoType() {
      ::grpc::Service::MarkMethodAsync(33);
    }
    ~WithAsyncMethod_UpdateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateStoredInfoType(::grpc::ServerContext* context, ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::StoredInfoType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetStoredInfoType() {
      ::grpc::Service::MarkMethodAsync(34);
    }
    ~WithAsyncMethod_GetStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetStoredInfoType(::grpc::ServerContext* context, ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::StoredInfoType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListStoredInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListStoredInfoTypes() {
      ::grpc::Service::MarkMethodAsync(35);
    }
    ~WithAsyncMethod_ListStoredInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListStoredInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListStoredInfoTypes(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteStoredInfoType() {
      ::grpc::Service::MarkMethodAsync(36);
    }
    ~WithAsyncMethod_DeleteStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteStoredInfoType(::grpc::ServerContext* context, ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListProjectDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListProjectDataProfiles() {
      ::grpc::Service::MarkMethodAsync(37);
    }
    ~WithAsyncMethod_ListProjectDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProjectDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProjectDataProfiles(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTableDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTableDataProfiles() {
      ::grpc::Service::MarkMethodAsync(38);
    }
    ~WithAsyncMethod_ListTableDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTableDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTableDataProfiles(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListTableDataProfilesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListTableDataProfilesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListColumnDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListColumnDataProfiles() {
      ::grpc::Service::MarkMethodAsync(39);
    }
    ~WithAsyncMethod_ListColumnDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListColumnDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListColumnDataProfiles(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(39, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetProjectDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetProjectDataProfile() {
      ::grpc::Service::MarkMethodAsync(40);
    }
    ~WithAsyncMethod_GetProjectDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProjectDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ProjectDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProjectDataProfile(::grpc::ServerContext* context, ::google::privacy::dlp::v2::GetProjectDataProfileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ProjectDataProfile>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(40, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListFileStoreDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListFileStoreDataProfiles() {
      ::grpc::Service::MarkMethodAsync(41);
    }
    ~WithAsyncMethod_ListFileStoreDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFileStoreDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFileStoreDataProfiles(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(41, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetFileStoreDataProfile() {
      ::grpc::Service::MarkMethodAsync(42);
    }
    ~WithAsyncMethod_GetFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::FileStoreDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFileStoreDataProfile(::grpc::ServerContext* context, ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::FileStoreDataProfile>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(42, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteFileStoreDataProfile() {
      ::grpc::Service::MarkMethodAsync(43);
    }
    ~WithAsyncMethod_DeleteFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFileStoreDataProfile(::grpc::ServerContext* context, ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(43, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTableDataProfile() {
      ::grpc::Service::MarkMethodAsync(44);
    }
    ~WithAsyncMethod_GetTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::TableDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTableDataProfile(::grpc::ServerContext* context, ::google::privacy::dlp::v2::GetTableDataProfileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::TableDataProfile>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(44, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetColumnDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetColumnDataProfile() {
      ::grpc::Service::MarkMethodAsync(45);
    }
    ~WithAsyncMethod_GetColumnDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetColumnDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ColumnDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetColumnDataProfile(::grpc::ServerContext* context, ::google::privacy::dlp::v2::GetColumnDataProfileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ColumnDataProfile>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(45, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTableDataProfile() {
      ::grpc::Service::MarkMethodAsync(46);
    }
    ~WithAsyncMethod_DeleteTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTableDataProfile(::grpc::ServerContext* context, ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(46, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_HybridInspectDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_HybridInspectDlpJob() {
      ::grpc::Service::MarkMethodAsync(47);
    }
    ~WithAsyncMethod_HybridInspectDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status HybridInspectDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestHybridInspectDlpJob(::grpc::ServerContext* context, ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::HybridInspectResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(47, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_FinishDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_FinishDlpJob() {
      ::grpc::Service::MarkMethodAsync(48);
    }
    ~WithAsyncMethod_FinishDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FinishDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::FinishDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFinishDlpJob(::grpc::ServerContext* context, ::google::privacy::dlp::v2::FinishDlpJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(48, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateConnection() {
      ::grpc::Service::MarkMethodAsync(49);
    }
    ~WithAsyncMethod_CreateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateConnection(::grpc::ServerContext* context, ::google::privacy::dlp::v2::CreateConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::Connection>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(49, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetConnection() {
      ::grpc::Service::MarkMethodAsync(50);
    }
    ~WithAsyncMethod_GetConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConnection(::grpc::ServerContext* context, ::google::privacy::dlp::v2::GetConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::Connection>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(50, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListConnections() {
      ::grpc::Service::MarkMethodAsync(51);
    }
    ~WithAsyncMethod_ListConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::ListConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConnections(::grpc::ServerContext* context, ::google::privacy::dlp::v2::ListConnectionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::ListConnectionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(51, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchConnections() {
      ::grpc::Service::MarkMethodAsync(52);
    }
    ~WithAsyncMethod_SearchConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::SearchConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::SearchConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchConnections(::grpc::ServerContext* context, ::google::privacy::dlp::v2::SearchConnectionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::SearchConnectionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(52, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteConnection() {
      ::grpc::Service::MarkMethodAsync(53);
    }
    ~WithAsyncMethod_DeleteConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteConnectionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteConnection(::grpc::ServerContext* context, ::google::privacy::dlp::v2::DeleteConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(53, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateConnection() {
      ::grpc::Service::MarkMethodAsync(54);
    }
    ~WithAsyncMethod_UpdateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateConnection(::grpc::ServerContext* context, ::google::privacy::dlp::v2::UpdateConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::privacy::dlp::v2::Connection>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(54, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_InspectContent<WithAsyncMethod_RedactImage<WithAsyncMethod_DeidentifyContent<WithAsyncMethod_ReidentifyContent<WithAsyncMethod_ListInfoTypes<WithAsyncMethod_CreateInspectTemplate<WithAsyncMethod_UpdateInspectTemplate<WithAsyncMethod_GetInspectTemplate<WithAsyncMethod_ListInspectTemplates<WithAsyncMethod_DeleteInspectTemplate<WithAsyncMethod_CreateDeidentifyTemplate<WithAsyncMethod_UpdateDeidentifyTemplate<WithAsyncMethod_GetDeidentifyTemplate<WithAsyncMethod_ListDeidentifyTemplates<WithAsyncMethod_DeleteDeidentifyTemplate<WithAsyncMethod_CreateJobTrigger<WithAsyncMethod_UpdateJobTrigger<WithAsyncMethod_HybridInspectJobTrigger<WithAsyncMethod_GetJobTrigger<WithAsyncMethod_ListJobTriggers<WithAsyncMethod_DeleteJobTrigger<WithAsyncMethod_ActivateJobTrigger<WithAsyncMethod_CreateDiscoveryConfig<WithAsyncMethod_UpdateDiscoveryConfig<WithAsyncMethod_GetDiscoveryConfig<WithAsyncMethod_ListDiscoveryConfigs<WithAsyncMethod_DeleteDiscoveryConfig<WithAsyncMethod_CreateDlpJob<WithAsyncMethod_ListDlpJobs<WithAsyncMethod_GetDlpJob<WithAsyncMethod_DeleteDlpJob<WithAsyncMethod_CancelDlpJob<WithAsyncMethod_CreateStoredInfoType<WithAsyncMethod_UpdateStoredInfoType<WithAsyncMethod_GetStoredInfoType<WithAsyncMethod_ListStoredInfoTypes<WithAsyncMethod_DeleteStoredInfoType<WithAsyncMethod_ListProjectDataProfiles<WithAsyncMethod_ListTableDataProfiles<WithAsyncMethod_ListColumnDataProfiles<WithAsyncMethod_GetProjectDataProfile<WithAsyncMethod_ListFileStoreDataProfiles<WithAsyncMethod_GetFileStoreDataProfile<WithAsyncMethod_DeleteFileStoreDataProfile<WithAsyncMethod_GetTableDataProfile<WithAsyncMethod_GetColumnDataProfile<WithAsyncMethod_DeleteTableDataProfile<WithAsyncMethod_HybridInspectDlpJob<WithAsyncMethod_FinishDlpJob<WithAsyncMethod_CreateConnection<WithAsyncMethod_GetConnection<WithAsyncMethod_ListConnections<WithAsyncMethod_SearchConnections<WithAsyncMethod_DeleteConnection<WithAsyncMethod_UpdateConnection<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_InspectContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_InspectContent() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::InspectContentRequest, ::google::privacy::dlp::v2::InspectContentResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::InspectContentRequest* request, ::google::privacy::dlp::v2::InspectContentResponse* response) { return this->InspectContent(context, request, response); }));}
    void SetMessageAllocatorFor_InspectContent(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::InspectContentRequest, ::google::privacy::dlp::v2::InspectContentResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::InspectContentRequest, ::google::privacy::dlp::v2::InspectContentResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_InspectContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InspectContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::InspectContentRequest* /*request*/, ::google::privacy::dlp::v2::InspectContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InspectContent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::InspectContentRequest* /*request*/, ::google::privacy::dlp::v2::InspectContentResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RedactImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RedactImage() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::RedactImageRequest, ::google::privacy::dlp::v2::RedactImageResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::RedactImageRequest* request, ::google::privacy::dlp::v2::RedactImageResponse* response) { return this->RedactImage(context, request, response); }));}
    void SetMessageAllocatorFor_RedactImage(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::RedactImageRequest, ::google::privacy::dlp::v2::RedactImageResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::RedactImageRequest, ::google::privacy::dlp::v2::RedactImageResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RedactImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RedactImage(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::RedactImageRequest* /*request*/, ::google::privacy::dlp::v2::RedactImageResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RedactImage(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::RedactImageRequest* /*request*/, ::google::privacy::dlp::v2::RedactImageResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeidentifyContent() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeidentifyContentRequest, ::google::privacy::dlp::v2::DeidentifyContentResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::DeidentifyContentRequest* request, ::google::privacy::dlp::v2::DeidentifyContentResponse* response) { return this->DeidentifyContent(context, request, response); }));}
    void SetMessageAllocatorFor_DeidentifyContent(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::DeidentifyContentRequest, ::google::privacy::dlp::v2::DeidentifyContentResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeidentifyContentRequest, ::google::privacy::dlp::v2::DeidentifyContentResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeidentifyContent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::DeidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyContentResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReidentifyContent() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ReidentifyContentRequest, ::google::privacy::dlp::v2::ReidentifyContentResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ReidentifyContentRequest* request, ::google::privacy::dlp::v2::ReidentifyContentResponse* response) { return this->ReidentifyContent(context, request, response); }));}
    void SetMessageAllocatorFor_ReidentifyContent(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ReidentifyContentRequest, ::google::privacy::dlp::v2::ReidentifyContentResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ReidentifyContentRequest, ::google::privacy::dlp::v2::ReidentifyContentResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ReidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::ReidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReidentifyContent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ReidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::ReidentifyContentResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInfoTypes() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListInfoTypesRequest, ::google::privacy::dlp::v2::ListInfoTypesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListInfoTypesRequest* request, ::google::privacy::dlp::v2::ListInfoTypesResponse* response) { return this->ListInfoTypes(context, request, response); }));}
    void SetMessageAllocatorFor_ListInfoTypes(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListInfoTypesRequest, ::google::privacy::dlp::v2::ListInfoTypesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListInfoTypesRequest, ::google::privacy::dlp::v2::ListInfoTypesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInfoTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListInfoTypesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateInspectTemplate() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response) { return this->CreateInspectTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_CreateInspectTemplate(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::CreateInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInspectTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateInspectTemplate() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response) { return this->UpdateInspectTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateInspectTemplate(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::UpdateInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInspectTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInspectTemplate() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* request, ::google::privacy::dlp::v2::InspectTemplate* response) { return this->GetInspectTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_GetInspectTemplate(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::GetInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInspectTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListInspectTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInspectTemplates() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListInspectTemplatesRequest, ::google::privacy::dlp::v2::ListInspectTemplatesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* request, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* response) { return this->ListInspectTemplates(context, request, response); }));}
    void SetMessageAllocatorFor_ListInspectTemplates(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListInspectTemplatesRequest, ::google::privacy::dlp::v2::ListInspectTemplatesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListInspectTemplatesRequest, ::google::privacy::dlp::v2::ListInspectTemplatesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInspectTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInspectTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInspectTemplates(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteInspectTemplate() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteInspectTemplateRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* request, ::google::protobuf::Empty* response) { return this->DeleteInspectTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteInspectTemplate(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::DeleteInspectTemplateRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteInspectTemplateRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInspectTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response) { return this->CreateDeidentifyTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_CreateDeidentifyTemplate(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDeidentifyTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response) { return this->UpdateDeidentifyTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDeidentifyTemplate(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDeidentifyTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDeidentifyTemplate() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* request, ::google::privacy::dlp::v2::DeidentifyTemplate* response) { return this->GetDeidentifyTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_GetDeidentifyTemplate(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDeidentifyTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListDeidentifyTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDeidentifyTemplates() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* request, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* response) { return this->ListDeidentifyTemplates(context, request, response); }));}
    void SetMessageAllocatorFor_ListDeidentifyTemplates(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDeidentifyTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeidentifyTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDeidentifyTemplates(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteDeidentifyTemplate() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* request, ::google::protobuf::Empty* response) { return this->DeleteDeidentifyTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteDeidentifyTemplate(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDeidentifyTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateJobTrigger() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response) { return this->CreateJobTrigger(context, request, response); }));}
    void SetMessageAllocatorFor_CreateJobTrigger(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::CreateJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateJobTrigger() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response) { return this->UpdateJobTrigger(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateJobTrigger(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::UpdateJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_HybridInspectJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_HybridInspectJobTrigger() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest, ::google::privacy::dlp::v2::HybridInspectResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response) { return this->HybridInspectJobTrigger(context, request, response); }));}
    void SetMessageAllocatorFor_HybridInspectJobTrigger(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest, ::google::privacy::dlp::v2::HybridInspectResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest, ::google::privacy::dlp::v2::HybridInspectResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_HybridInspectJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status HybridInspectJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* HybridInspectJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetJobTrigger() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::GetJobTriggerRequest* request, ::google::privacy::dlp::v2::JobTrigger* response) { return this->GetJobTrigger(context, request, response); }));}
    void SetMessageAllocatorFor_GetJobTrigger(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::GetJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::GetJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListJobTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListJobTriggers() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListJobTriggersRequest, ::google::privacy::dlp::v2::ListJobTriggersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListJobTriggersRequest* request, ::google::privacy::dlp::v2::ListJobTriggersResponse* response) { return this->ListJobTriggers(context, request, response); }));}
    void SetMessageAllocatorFor_ListJobTriggers(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListJobTriggersRequest, ::google::privacy::dlp::v2::ListJobTriggersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListJobTriggersRequest, ::google::privacy::dlp::v2::ListJobTriggersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListJobTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobTriggers(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListJobTriggersRequest* /*request*/, ::google::privacy::dlp::v2::ListJobTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobTriggers(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListJobTriggersRequest* /*request*/, ::google::privacy::dlp::v2::ListJobTriggersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteJobTrigger() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteJobTriggerRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* request, ::google::protobuf::Empty* response) { return this->DeleteJobTrigger(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteJobTrigger(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::DeleteJobTriggerRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteJobTriggerRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ActivateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ActivateJobTrigger() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ActivateJobTriggerRequest, ::google::privacy::dlp::v2::DlpJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* request, ::google::privacy::dlp::v2::DlpJob* response) { return this->ActivateJobTrigger(context, request, response); }));}
    void SetMessageAllocatorFor_ActivateJobTrigger(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ActivateJobTriggerRequest, ::google::privacy::dlp::v2::DlpJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ActivateJobTriggerRequest, ::google::privacy::dlp::v2::DlpJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ActivateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ActivateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ActivateJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateDiscoveryConfig() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response) { return this->CreateDiscoveryConfig(context, request, response); }));}
    void SetMessageAllocatorFor_CreateDiscoveryConfig(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDiscoveryConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDiscoveryConfig() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response) { return this->UpdateDiscoveryConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDiscoveryConfig(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDiscoveryConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDiscoveryConfig() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* request, ::google::privacy::dlp::v2::DiscoveryConfig* response) { return this->GetDiscoveryConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetDiscoveryConfig(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::GetDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDiscoveryConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListDiscoveryConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDiscoveryConfigs() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* request, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* response) { return this->ListDiscoveryConfigs(context, request, response); }));}
    void SetMessageAllocatorFor_ListDiscoveryConfigs(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDiscoveryConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDiscoveryConfigs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* /*request*/, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDiscoveryConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* /*request*/, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteDiscoveryConfig() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* request, ::google::protobuf::Empty* response) { return this->DeleteDiscoveryConfig(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteDiscoveryConfig(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDiscoveryConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateDlpJob() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateDlpJobRequest, ::google::privacy::dlp::v2::DlpJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::CreateDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response) { return this->CreateDlpJob(context, request, response); }));}
    void SetMessageAllocatorFor_CreateDlpJob(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::CreateDlpJobRequest, ::google::privacy::dlp::v2::DlpJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateDlpJobRequest, ::google::privacy::dlp::v2::DlpJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListDlpJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDlpJobs() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListDlpJobsRequest, ::google::privacy::dlp::v2::ListDlpJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListDlpJobsRequest* request, ::google::privacy::dlp::v2::ListDlpJobsResponse* response) { return this->ListDlpJobs(context, request, response); }));}
    void SetMessageAllocatorFor_ListDlpJobs(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListDlpJobsRequest, ::google::privacy::dlp::v2::ListDlpJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListDlpJobsRequest, ::google::privacy::dlp::v2::ListDlpJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDlpJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDlpJobs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDlpJobsRequest* /*request*/, ::google::privacy::dlp::v2::ListDlpJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDlpJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDlpJobsRequest* /*request*/, ::google::privacy::dlp::v2::ListDlpJobsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDlpJob() {
      ::grpc::Service::MarkMethodCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetDlpJobRequest, ::google::privacy::dlp::v2::DlpJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::GetDlpJobRequest* request, ::google::privacy::dlp::v2::DlpJob* response) { return this->GetDlpJob(context, request, response); }));}
    void SetMessageAllocatorFor_GetDlpJob(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::GetDlpJobRequest, ::google::privacy::dlp::v2::DlpJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(29);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetDlpJobRequest, ::google::privacy::dlp::v2::DlpJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteDlpJob() {
      ::grpc::Service::MarkMethodCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteDlpJobRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* request, ::google::protobuf::Empty* response) { return this->DeleteDlpJob(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteDlpJob(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::DeleteDlpJobRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(30);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteDlpJobRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelDlpJob() {
      ::grpc::Service::MarkMethodCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CancelDlpJobRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::CancelDlpJobRequest* request, ::google::protobuf::Empty* response) { return this->CancelDlpJob(context, request, response); }));}
    void SetMessageAllocatorFor_CancelDlpJob(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::CancelDlpJobRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(31);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CancelDlpJobRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CancelDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::CancelDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateStoredInfoType() {
      ::grpc::Service::MarkMethodCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response) { return this->CreateStoredInfoType(context, request, response); }));}
    void SetMessageAllocatorFor_CreateStoredInfoType(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(32);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateStoredInfoType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateStoredInfoType() {
      ::grpc::Service::MarkMethodCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response) { return this->UpdateStoredInfoType(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateStoredInfoType(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(33);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateStoredInfoType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetStoredInfoType() {
      ::grpc::Service::MarkMethodCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* request, ::google::privacy::dlp::v2::StoredInfoType* response) { return this->GetStoredInfoType(context, request, response); }));}
    void SetMessageAllocatorFor_GetStoredInfoType(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::GetStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(34);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetStoredInfoType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListStoredInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListStoredInfoTypes() {
      ::grpc::Service::MarkMethodCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListStoredInfoTypesRequest, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* request, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* response) { return this->ListStoredInfoTypes(context, request, response); }));}
    void SetMessageAllocatorFor_ListStoredInfoTypes(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListStoredInfoTypesRequest, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(35);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListStoredInfoTypesRequest, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListStoredInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListStoredInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListStoredInfoTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteStoredInfoType() {
      ::grpc::Service::MarkMethodCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* request, ::google::protobuf::Empty* response) { return this->DeleteStoredInfoType(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteStoredInfoType(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(36);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteStoredInfoType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListProjectDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListProjectDataProfiles() {
      ::grpc::Service::MarkMethodCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListProjectDataProfilesRequest, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* request, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* response) { return this->ListProjectDataProfiles(context, request, response); }));}
    void SetMessageAllocatorFor_ListProjectDataProfiles(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListProjectDataProfilesRequest, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(37);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListProjectDataProfilesRequest, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListProjectDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProjectDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProjectDataProfiles(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTableDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTableDataProfiles() {
      ::grpc::Service::MarkMethodCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListTableDataProfilesRequest, ::google::privacy::dlp::v2::ListTableDataProfilesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* request, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* response) { return this->ListTableDataProfiles(context, request, response); }));}
    void SetMessageAllocatorFor_ListTableDataProfiles(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListTableDataProfilesRequest, ::google::privacy::dlp::v2::ListTableDataProfilesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(38);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListTableDataProfilesRequest, ::google::privacy::dlp::v2::ListTableDataProfilesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTableDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTableDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTableDataProfiles(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListColumnDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListColumnDataProfiles() {
      ::grpc::Service::MarkMethodCallback(39,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListColumnDataProfilesRequest, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* request, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* response) { return this->ListColumnDataProfiles(context, request, response); }));}
    void SetMessageAllocatorFor_ListColumnDataProfiles(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListColumnDataProfilesRequest, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(39);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListColumnDataProfilesRequest, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListColumnDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListColumnDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListColumnDataProfiles(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetProjectDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetProjectDataProfile() {
      ::grpc::Service::MarkMethodCallback(40,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetProjectDataProfileRequest, ::google::privacy::dlp::v2::ProjectDataProfile>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* request, ::google::privacy::dlp::v2::ProjectDataProfile* response) { return this->GetProjectDataProfile(context, request, response); }));}
    void SetMessageAllocatorFor_GetProjectDataProfile(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::GetProjectDataProfileRequest, ::google::privacy::dlp::v2::ProjectDataProfile>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(40);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetProjectDataProfileRequest, ::google::privacy::dlp::v2::ProjectDataProfile>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetProjectDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProjectDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ProjectDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProjectDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ProjectDataProfile* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListFileStoreDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListFileStoreDataProfiles() {
      ::grpc::Service::MarkMethodCallback(41,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* request, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* response) { return this->ListFileStoreDataProfiles(context, request, response); }));}
    void SetMessageAllocatorFor_ListFileStoreDataProfiles(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(41);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListFileStoreDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFileStoreDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFileStoreDataProfiles(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetFileStoreDataProfile() {
      ::grpc::Service::MarkMethodCallback(42,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest, ::google::privacy::dlp::v2::FileStoreDataProfile>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* request, ::google::privacy::dlp::v2::FileStoreDataProfile* response) { return this->GetFileStoreDataProfile(context, request, response); }));}
    void SetMessageAllocatorFor_GetFileStoreDataProfile(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest, ::google::privacy::dlp::v2::FileStoreDataProfile>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(42);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest, ::google::privacy::dlp::v2::FileStoreDataProfile>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::FileStoreDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFileStoreDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::FileStoreDataProfile* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteFileStoreDataProfile() {
      ::grpc::Service::MarkMethodCallback(43,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* request, ::google::protobuf::Empty* response) { return this->DeleteFileStoreDataProfile(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteFileStoreDataProfile(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(43);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFileStoreDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTableDataProfile() {
      ::grpc::Service::MarkMethodCallback(44,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetTableDataProfileRequest, ::google::privacy::dlp::v2::TableDataProfile>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* request, ::google::privacy::dlp::v2::TableDataProfile* response) { return this->GetTableDataProfile(context, request, response); }));}
    void SetMessageAllocatorFor_GetTableDataProfile(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::GetTableDataProfileRequest, ::google::privacy::dlp::v2::TableDataProfile>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(44);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetTableDataProfileRequest, ::google::privacy::dlp::v2::TableDataProfile>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::TableDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTableDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::TableDataProfile* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetColumnDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetColumnDataProfile() {
      ::grpc::Service::MarkMethodCallback(45,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetColumnDataProfileRequest, ::google::privacy::dlp::v2::ColumnDataProfile>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* request, ::google::privacy::dlp::v2::ColumnDataProfile* response) { return this->GetColumnDataProfile(context, request, response); }));}
    void SetMessageAllocatorFor_GetColumnDataProfile(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::GetColumnDataProfileRequest, ::google::privacy::dlp::v2::ColumnDataProfile>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(45);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetColumnDataProfileRequest, ::google::privacy::dlp::v2::ColumnDataProfile>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetColumnDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetColumnDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ColumnDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetColumnDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ColumnDataProfile* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTableDataProfile() {
      ::grpc::Service::MarkMethodCallback(46,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteTableDataProfileRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* request, ::google::protobuf::Empty* response) { return this->DeleteTableDataProfile(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTableDataProfile(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::DeleteTableDataProfileRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(46);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteTableDataProfileRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTableDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_HybridInspectDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_HybridInspectDlpJob() {
      ::grpc::Service::MarkMethodCallback(47,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::HybridInspectDlpJobRequest, ::google::privacy::dlp::v2::HybridInspectResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* request, ::google::privacy::dlp::v2::HybridInspectResponse* response) { return this->HybridInspectDlpJob(context, request, response); }));}
    void SetMessageAllocatorFor_HybridInspectDlpJob(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::HybridInspectDlpJobRequest, ::google::privacy::dlp::v2::HybridInspectResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(47);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::HybridInspectDlpJobRequest, ::google::privacy::dlp::v2::HybridInspectResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_HybridInspectDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status HybridInspectDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* HybridInspectDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_FinishDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_FinishDlpJob() {
      ::grpc::Service::MarkMethodCallback(48,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::FinishDlpJobRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::FinishDlpJobRequest* request, ::google::protobuf::Empty* response) { return this->FinishDlpJob(context, request, response); }));}
    void SetMessageAllocatorFor_FinishDlpJob(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::FinishDlpJobRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(48);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::FinishDlpJobRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_FinishDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FinishDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::FinishDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FinishDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::FinishDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateConnection() {
      ::grpc::Service::MarkMethodCallback(49,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateConnectionRequest, ::google::privacy::dlp::v2::Connection>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::CreateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response) { return this->CreateConnection(context, request, response); }));}
    void SetMessageAllocatorFor_CreateConnection(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::CreateConnectionRequest, ::google::privacy::dlp::v2::Connection>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(49);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::CreateConnectionRequest, ::google::privacy::dlp::v2::Connection>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetConnection() {
      ::grpc::Service::MarkMethodCallback(50,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetConnectionRequest, ::google::privacy::dlp::v2::Connection>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::GetConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response) { return this->GetConnection(context, request, response); }));}
    void SetMessageAllocatorFor_GetConnection(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::GetConnectionRequest, ::google::privacy::dlp::v2::Connection>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(50);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::GetConnectionRequest, ::google::privacy::dlp::v2::Connection>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::GetConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListConnections() {
      ::grpc::Service::MarkMethodCallback(51,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListConnectionsRequest, ::google::privacy::dlp::v2::ListConnectionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::ListConnectionsRequest* request, ::google::privacy::dlp::v2::ListConnectionsResponse* response) { return this->ListConnections(context, request, response); }));}
    void SetMessageAllocatorFor_ListConnections(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::ListConnectionsRequest, ::google::privacy::dlp::v2::ListConnectionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(51);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::ListConnectionsRequest, ::google::privacy::dlp::v2::ListConnectionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::ListConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::ListConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::ListConnectionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchConnections() {
      ::grpc::Service::MarkMethodCallback(52,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::SearchConnectionsRequest, ::google::privacy::dlp::v2::SearchConnectionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::SearchConnectionsRequest* request, ::google::privacy::dlp::v2::SearchConnectionsResponse* response) { return this->SearchConnections(context, request, response); }));}
    void SetMessageAllocatorFor_SearchConnections(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::SearchConnectionsRequest, ::google::privacy::dlp::v2::SearchConnectionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(52);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::SearchConnectionsRequest, ::google::privacy::dlp::v2::SearchConnectionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::SearchConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::SearchConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::SearchConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::SearchConnectionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteConnection() {
      ::grpc::Service::MarkMethodCallback(53,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteConnectionRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::DeleteConnectionRequest* request, ::google::protobuf::Empty* response) { return this->DeleteConnection(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteConnection(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::DeleteConnectionRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(53);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::DeleteConnectionRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteConnectionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteConnectionRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateConnection() {
      ::grpc::Service::MarkMethodCallback(54,
          new ::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateConnectionRequest, ::google::privacy::dlp::v2::Connection>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::privacy::dlp::v2::UpdateConnectionRequest* request, ::google::privacy::dlp::v2::Connection* response) { return this->UpdateConnection(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateConnection(
        ::grpc::MessageAllocator< ::google::privacy::dlp::v2::UpdateConnectionRequest, ::google::privacy::dlp::v2::Connection>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(54);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::privacy::dlp::v2::UpdateConnectionRequest, ::google::privacy::dlp::v2::Connection>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_InspectContent<WithCallbackMethod_RedactImage<WithCallbackMethod_DeidentifyContent<WithCallbackMethod_ReidentifyContent<WithCallbackMethod_ListInfoTypes<WithCallbackMethod_CreateInspectTemplate<WithCallbackMethod_UpdateInspectTemplate<WithCallbackMethod_GetInspectTemplate<WithCallbackMethod_ListInspectTemplates<WithCallbackMethod_DeleteInspectTemplate<WithCallbackMethod_CreateDeidentifyTemplate<WithCallbackMethod_UpdateDeidentifyTemplate<WithCallbackMethod_GetDeidentifyTemplate<WithCallbackMethod_ListDeidentifyTemplates<WithCallbackMethod_DeleteDeidentifyTemplate<WithCallbackMethod_CreateJobTrigger<WithCallbackMethod_UpdateJobTrigger<WithCallbackMethod_HybridInspectJobTrigger<WithCallbackMethod_GetJobTrigger<WithCallbackMethod_ListJobTriggers<WithCallbackMethod_DeleteJobTrigger<WithCallbackMethod_ActivateJobTrigger<WithCallbackMethod_CreateDiscoveryConfig<WithCallbackMethod_UpdateDiscoveryConfig<WithCallbackMethod_GetDiscoveryConfig<WithCallbackMethod_ListDiscoveryConfigs<WithCallbackMethod_DeleteDiscoveryConfig<WithCallbackMethod_CreateDlpJob<WithCallbackMethod_ListDlpJobs<WithCallbackMethod_GetDlpJob<WithCallbackMethod_DeleteDlpJob<WithCallbackMethod_CancelDlpJob<WithCallbackMethod_CreateStoredInfoType<WithCallbackMethod_UpdateStoredInfoType<WithCallbackMethod_GetStoredInfoType<WithCallbackMethod_ListStoredInfoTypes<WithCallbackMethod_DeleteStoredInfoType<WithCallbackMethod_ListProjectDataProfiles<WithCallbackMethod_ListTableDataProfiles<WithCallbackMethod_ListColumnDataProfiles<WithCallbackMethod_GetProjectDataProfile<WithCallbackMethod_ListFileStoreDataProfiles<WithCallbackMethod_GetFileStoreDataProfile<WithCallbackMethod_DeleteFileStoreDataProfile<WithCallbackMethod_GetTableDataProfile<WithCallbackMethod_GetColumnDataProfile<WithCallbackMethod_DeleteTableDataProfile<WithCallbackMethod_HybridInspectDlpJob<WithCallbackMethod_FinishDlpJob<WithCallbackMethod_CreateConnection<WithCallbackMethod_GetConnection<WithCallbackMethod_ListConnections<WithCallbackMethod_SearchConnections<WithCallbackMethod_DeleteConnection<WithCallbackMethod_UpdateConnection<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_InspectContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_InspectContent() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_InspectContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InspectContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::InspectContentRequest* /*request*/, ::google::privacy::dlp::v2::InspectContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RedactImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RedactImage() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_RedactImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RedactImage(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::RedactImageRequest* /*request*/, ::google::privacy::dlp::v2::RedactImageResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeidentifyContent() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_DeidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReidentifyContent() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ReidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ReidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::ReidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInfoTypes() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateInspectTemplate() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_CreateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateInspectTemplate() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_UpdateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInspectTemplate() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListInspectTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInspectTemplates() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ListInspectTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInspectTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteInspectTemplate() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_DeleteInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_CreateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_UpdateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDeidentifyTemplate() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_GetDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListDeidentifyTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDeidentifyTemplates() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_ListDeidentifyTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeidentifyTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteDeidentifyTemplate() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_DeleteDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateJobTrigger() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_CreateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateJobTrigger() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_UpdateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_HybridInspectJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_HybridInspectJobTrigger() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_HybridInspectJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status HybridInspectJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetJobTrigger() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_GetJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListJobTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListJobTriggers() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_ListJobTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobTriggers(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListJobTriggersRequest* /*request*/, ::google::privacy::dlp::v2::ListJobTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteJobTrigger() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_DeleteJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ActivateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ActivateJobTrigger() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_ActivateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ActivateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateDiscoveryConfig() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_CreateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDiscoveryConfig() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_UpdateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDiscoveryConfig() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_GetDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListDiscoveryConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDiscoveryConfigs() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_ListDiscoveryConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDiscoveryConfigs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* /*request*/, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteDiscoveryConfig() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_DeleteDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateDlpJob() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_CreateDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListDlpJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDlpJobs() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_ListDlpJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDlpJobs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDlpJobsRequest* /*request*/, ::google::privacy::dlp::v2::ListDlpJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDlpJob() {
      ::grpc::Service::MarkMethodGeneric(29);
    }
    ~WithGenericMethod_GetDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteDlpJob() {
      ::grpc::Service::MarkMethodGeneric(30);
    }
    ~WithGenericMethod_DeleteDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelDlpJob() {
      ::grpc::Service::MarkMethodGeneric(31);
    }
    ~WithGenericMethod_CancelDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CancelDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateStoredInfoType() {
      ::grpc::Service::MarkMethodGeneric(32);
    }
    ~WithGenericMethod_CreateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateStoredInfoType() {
      ::grpc::Service::MarkMethodGeneric(33);
    }
    ~WithGenericMethod_UpdateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetStoredInfoType() {
      ::grpc::Service::MarkMethodGeneric(34);
    }
    ~WithGenericMethod_GetStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListStoredInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListStoredInfoTypes() {
      ::grpc::Service::MarkMethodGeneric(35);
    }
    ~WithGenericMethod_ListStoredInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListStoredInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteStoredInfoType() {
      ::grpc::Service::MarkMethodGeneric(36);
    }
    ~WithGenericMethod_DeleteStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListProjectDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListProjectDataProfiles() {
      ::grpc::Service::MarkMethodGeneric(37);
    }
    ~WithGenericMethod_ListProjectDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProjectDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTableDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTableDataProfiles() {
      ::grpc::Service::MarkMethodGeneric(38);
    }
    ~WithGenericMethod_ListTableDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTableDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListColumnDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListColumnDataProfiles() {
      ::grpc::Service::MarkMethodGeneric(39);
    }
    ~WithGenericMethod_ListColumnDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListColumnDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetProjectDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetProjectDataProfile() {
      ::grpc::Service::MarkMethodGeneric(40);
    }
    ~WithGenericMethod_GetProjectDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProjectDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ProjectDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListFileStoreDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListFileStoreDataProfiles() {
      ::grpc::Service::MarkMethodGeneric(41);
    }
    ~WithGenericMethod_ListFileStoreDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFileStoreDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetFileStoreDataProfile() {
      ::grpc::Service::MarkMethodGeneric(42);
    }
    ~WithGenericMethod_GetFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::FileStoreDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteFileStoreDataProfile() {
      ::grpc::Service::MarkMethodGeneric(43);
    }
    ~WithGenericMethod_DeleteFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTableDataProfile() {
      ::grpc::Service::MarkMethodGeneric(44);
    }
    ~WithGenericMethod_GetTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::TableDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetColumnDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetColumnDataProfile() {
      ::grpc::Service::MarkMethodGeneric(45);
    }
    ~WithGenericMethod_GetColumnDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetColumnDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ColumnDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTableDataProfile() {
      ::grpc::Service::MarkMethodGeneric(46);
    }
    ~WithGenericMethod_DeleteTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_HybridInspectDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_HybridInspectDlpJob() {
      ::grpc::Service::MarkMethodGeneric(47);
    }
    ~WithGenericMethod_HybridInspectDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status HybridInspectDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_FinishDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_FinishDlpJob() {
      ::grpc::Service::MarkMethodGeneric(48);
    }
    ~WithGenericMethod_FinishDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FinishDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::FinishDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateConnection() {
      ::grpc::Service::MarkMethodGeneric(49);
    }
    ~WithGenericMethod_CreateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetConnection() {
      ::grpc::Service::MarkMethodGeneric(50);
    }
    ~WithGenericMethod_GetConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListConnections() {
      ::grpc::Service::MarkMethodGeneric(51);
    }
    ~WithGenericMethod_ListConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::ListConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchConnections() {
      ::grpc::Service::MarkMethodGeneric(52);
    }
    ~WithGenericMethod_SearchConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::SearchConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::SearchConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteConnection() {
      ::grpc::Service::MarkMethodGeneric(53);
    }
    ~WithGenericMethod_DeleteConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteConnectionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateConnection() {
      ::grpc::Service::MarkMethodGeneric(54);
    }
    ~WithGenericMethod_UpdateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_InspectContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_InspectContent() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_InspectContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InspectContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::InspectContentRequest* /*request*/, ::google::privacy::dlp::v2::InspectContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInspectContent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RedactImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RedactImage() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_RedactImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RedactImage(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::RedactImageRequest* /*request*/, ::google::privacy::dlp::v2::RedactImageResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRedactImage(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeidentifyContent() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_DeidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeidentifyContent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReidentifyContent() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ReidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ReidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::ReidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReidentifyContent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInfoTypes() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInfoTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateInspectTemplate() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_CreateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInspectTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateInspectTemplate() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_UpdateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInspectTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInspectTemplate() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInspectTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInspectTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInspectTemplates() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ListInspectTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInspectTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInspectTemplates(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteInspectTemplate() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_DeleteInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInspectTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_CreateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDeidentifyTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_UpdateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDeidentifyTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDeidentifyTemplate() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_GetDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDeidentifyTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDeidentifyTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDeidentifyTemplates() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_ListDeidentifyTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeidentifyTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDeidentifyTemplates(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteDeidentifyTemplate() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_DeleteDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDeidentifyTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateJobTrigger() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_CreateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateJobTrigger(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateJobTrigger() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_UpdateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateJobTrigger(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_HybridInspectJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_HybridInspectJobTrigger() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_HybridInspectJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status HybridInspectJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestHybridInspectJobTrigger(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetJobTrigger() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_GetJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJobTrigger(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListJobTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListJobTriggers() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_ListJobTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobTriggers(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListJobTriggersRequest* /*request*/, ::google::privacy::dlp::v2::ListJobTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobTriggers(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteJobTrigger() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_DeleteJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJobTrigger(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ActivateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ActivateJobTrigger() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_ActivateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ActivateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestActivateJobTrigger(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateDiscoveryConfig() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_CreateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDiscoveryConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDiscoveryConfig() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_UpdateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDiscoveryConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDiscoveryConfig() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_GetDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDiscoveryConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDiscoveryConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDiscoveryConfigs() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_ListDiscoveryConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDiscoveryConfigs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* /*request*/, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDiscoveryConfigs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteDiscoveryConfig() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_DeleteDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDiscoveryConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateDlpJob() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_CreateDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDlpJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDlpJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDlpJobs() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_ListDlpJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDlpJobs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDlpJobsRequest* /*request*/, ::google::privacy::dlp::v2::ListDlpJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDlpJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDlpJob() {
      ::grpc::Service::MarkMethodRaw(29);
    }
    ~WithRawMethod_GetDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDlpJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteDlpJob() {
      ::grpc::Service::MarkMethodRaw(30);
    }
    ~WithRawMethod_DeleteDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDlpJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelDlpJob() {
      ::grpc::Service::MarkMethodRaw(31);
    }
    ~WithRawMethod_CancelDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CancelDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelDlpJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateStoredInfoType() {
      ::grpc::Service::MarkMethodRaw(32);
    }
    ~WithRawMethod_CreateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateStoredInfoType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateStoredInfoType() {
      ::grpc::Service::MarkMethodRaw(33);
    }
    ~WithRawMethod_UpdateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateStoredInfoType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetStoredInfoType() {
      ::grpc::Service::MarkMethodRaw(34);
    }
    ~WithRawMethod_GetStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetStoredInfoType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListStoredInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListStoredInfoTypes() {
      ::grpc::Service::MarkMethodRaw(35);
    }
    ~WithRawMethod_ListStoredInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListStoredInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListStoredInfoTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteStoredInfoType() {
      ::grpc::Service::MarkMethodRaw(36);
    }
    ~WithRawMethod_DeleteStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteStoredInfoType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListProjectDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListProjectDataProfiles() {
      ::grpc::Service::MarkMethodRaw(37);
    }
    ~WithRawMethod_ListProjectDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProjectDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProjectDataProfiles(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTableDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTableDataProfiles() {
      ::grpc::Service::MarkMethodRaw(38);
    }
    ~WithRawMethod_ListTableDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTableDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTableDataProfiles(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListColumnDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListColumnDataProfiles() {
      ::grpc::Service::MarkMethodRaw(39);
    }
    ~WithRawMethod_ListColumnDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListColumnDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListColumnDataProfiles(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(39, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetProjectDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetProjectDataProfile() {
      ::grpc::Service::MarkMethodRaw(40);
    }
    ~WithRawMethod_GetProjectDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProjectDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ProjectDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProjectDataProfile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(40, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListFileStoreDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListFileStoreDataProfiles() {
      ::grpc::Service::MarkMethodRaw(41);
    }
    ~WithRawMethod_ListFileStoreDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFileStoreDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFileStoreDataProfiles(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(41, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetFileStoreDataProfile() {
      ::grpc::Service::MarkMethodRaw(42);
    }
    ~WithRawMethod_GetFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::FileStoreDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFileStoreDataProfile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(42, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteFileStoreDataProfile() {
      ::grpc::Service::MarkMethodRaw(43);
    }
    ~WithRawMethod_DeleteFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFileStoreDataProfile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(43, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTableDataProfile() {
      ::grpc::Service::MarkMethodRaw(44);
    }
    ~WithRawMethod_GetTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::TableDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTableDataProfile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(44, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetColumnDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetColumnDataProfile() {
      ::grpc::Service::MarkMethodRaw(45);
    }
    ~WithRawMethod_GetColumnDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetColumnDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ColumnDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetColumnDataProfile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(45, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTableDataProfile() {
      ::grpc::Service::MarkMethodRaw(46);
    }
    ~WithRawMethod_DeleteTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTableDataProfile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(46, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_HybridInspectDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_HybridInspectDlpJob() {
      ::grpc::Service::MarkMethodRaw(47);
    }
    ~WithRawMethod_HybridInspectDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status HybridInspectDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestHybridInspectDlpJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(47, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_FinishDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_FinishDlpJob() {
      ::grpc::Service::MarkMethodRaw(48);
    }
    ~WithRawMethod_FinishDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FinishDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::FinishDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFinishDlpJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(48, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateConnection() {
      ::grpc::Service::MarkMethodRaw(49);
    }
    ~WithRawMethod_CreateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(49, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetConnection() {
      ::grpc::Service::MarkMethodRaw(50);
    }
    ~WithRawMethod_GetConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(50, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListConnections() {
      ::grpc::Service::MarkMethodRaw(51);
    }
    ~WithRawMethod_ListConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::ListConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConnections(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(51, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchConnections() {
      ::grpc::Service::MarkMethodRaw(52);
    }
    ~WithRawMethod_SearchConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::SearchConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::SearchConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchConnections(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(52, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteConnection() {
      ::grpc::Service::MarkMethodRaw(53);
    }
    ~WithRawMethod_DeleteConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteConnectionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(53, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateConnection() {
      ::grpc::Service::MarkMethodRaw(54);
    }
    ~WithRawMethod_UpdateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(54, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_InspectContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_InspectContent() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->InspectContent(context, request, response); }));
    }
    ~WithRawCallbackMethod_InspectContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InspectContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::InspectContentRequest* /*request*/, ::google::privacy::dlp::v2::InspectContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InspectContent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RedactImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RedactImage() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RedactImage(context, request, response); }));
    }
    ~WithRawCallbackMethod_RedactImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RedactImage(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::RedactImageRequest* /*request*/, ::google::privacy::dlp::v2::RedactImageResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RedactImage(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeidentifyContent() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeidentifyContent(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeidentifyContent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReidentifyContent() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReidentifyContent(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ReidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::ReidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReidentifyContent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInfoTypes() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInfoTypes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInfoTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateInspectTemplate() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateInspectTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInspectTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateInspectTemplate() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateInspectTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInspectTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInspectTemplate() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInspectTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInspectTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInspectTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInspectTemplates() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInspectTemplates(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInspectTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInspectTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInspectTemplates(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteInspectTemplate() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteInspectTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInspectTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateDeidentifyTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDeidentifyTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDeidentifyTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDeidentifyTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDeidentifyTemplate() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDeidentifyTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDeidentifyTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDeidentifyTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDeidentifyTemplates() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDeidentifyTemplates(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDeidentifyTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeidentifyTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDeidentifyTemplates(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteDeidentifyTemplate() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteDeidentifyTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDeidentifyTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateJobTrigger() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateJobTrigger(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateJobTrigger() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateJobTrigger(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_HybridInspectJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_HybridInspectJobTrigger() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->HybridInspectJobTrigger(context, request, response); }));
    }
    ~WithRawCallbackMethod_HybridInspectJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status HybridInspectJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* HybridInspectJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetJobTrigger() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetJobTrigger(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListJobTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListJobTriggers() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListJobTriggers(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListJobTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobTriggers(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListJobTriggersRequest* /*request*/, ::google::privacy::dlp::v2::ListJobTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobTriggers(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteJobTrigger() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteJobTrigger(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ActivateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ActivateJobTrigger() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ActivateJobTrigger(context, request, response); }));
    }
    ~WithRawCallbackMethod_ActivateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ActivateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ActivateJobTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateDiscoveryConfig() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateDiscoveryConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDiscoveryConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDiscoveryConfig() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDiscoveryConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDiscoveryConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDiscoveryConfig() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDiscoveryConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDiscoveryConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDiscoveryConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDiscoveryConfigs() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDiscoveryConfigs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDiscoveryConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDiscoveryConfigs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* /*request*/, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDiscoveryConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteDiscoveryConfig() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteDiscoveryConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDiscoveryConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateDlpJob() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateDlpJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDlpJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDlpJobs() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDlpJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDlpJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDlpJobs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDlpJobsRequest* /*request*/, ::google::privacy::dlp::v2::ListDlpJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDlpJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDlpJob() {
      ::grpc::Service::MarkMethodRawCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDlpJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteDlpJob() {
      ::grpc::Service::MarkMethodRawCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteDlpJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelDlpJob() {
      ::grpc::Service::MarkMethodRawCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelDlpJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CancelDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateStoredInfoType() {
      ::grpc::Service::MarkMethodRawCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateStoredInfoType(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateStoredInfoType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateStoredInfoType() {
      ::grpc::Service::MarkMethodRawCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateStoredInfoType(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateStoredInfoType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetStoredInfoType() {
      ::grpc::Service::MarkMethodRawCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetStoredInfoType(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetStoredInfoType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListStoredInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListStoredInfoTypes() {
      ::grpc::Service::MarkMethodRawCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListStoredInfoTypes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListStoredInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListStoredInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListStoredInfoTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteStoredInfoType() {
      ::grpc::Service::MarkMethodRawCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteStoredInfoType(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteStoredInfoType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListProjectDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListProjectDataProfiles() {
      ::grpc::Service::MarkMethodRawCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListProjectDataProfiles(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListProjectDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProjectDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProjectDataProfiles(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTableDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTableDataProfiles() {
      ::grpc::Service::MarkMethodRawCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTableDataProfiles(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTableDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTableDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTableDataProfiles(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListColumnDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListColumnDataProfiles() {
      ::grpc::Service::MarkMethodRawCallback(39,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListColumnDataProfiles(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListColumnDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListColumnDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListColumnDataProfiles(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetProjectDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetProjectDataProfile() {
      ::grpc::Service::MarkMethodRawCallback(40,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetProjectDataProfile(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetProjectDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProjectDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ProjectDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProjectDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListFileStoreDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListFileStoreDataProfiles() {
      ::grpc::Service::MarkMethodRawCallback(41,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListFileStoreDataProfiles(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListFileStoreDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFileStoreDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFileStoreDataProfiles(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetFileStoreDataProfile() {
      ::grpc::Service::MarkMethodRawCallback(42,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetFileStoreDataProfile(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::FileStoreDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFileStoreDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteFileStoreDataProfile() {
      ::grpc::Service::MarkMethodRawCallback(43,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteFileStoreDataProfile(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFileStoreDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTableDataProfile() {
      ::grpc::Service::MarkMethodRawCallback(44,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTableDataProfile(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::TableDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTableDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetColumnDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetColumnDataProfile() {
      ::grpc::Service::MarkMethodRawCallback(45,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetColumnDataProfile(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetColumnDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetColumnDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ColumnDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetColumnDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTableDataProfile() {
      ::grpc::Service::MarkMethodRawCallback(46,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTableDataProfile(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTableDataProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_HybridInspectDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_HybridInspectDlpJob() {
      ::grpc::Service::MarkMethodRawCallback(47,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->HybridInspectDlpJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_HybridInspectDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status HybridInspectDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* HybridInspectDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_FinishDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_FinishDlpJob() {
      ::grpc::Service::MarkMethodRawCallback(48,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->FinishDlpJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_FinishDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FinishDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::FinishDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FinishDlpJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateConnection() {
      ::grpc::Service::MarkMethodRawCallback(49,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetConnection() {
      ::grpc::Service::MarkMethodRawCallback(50,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListConnections() {
      ::grpc::Service::MarkMethodRawCallback(51,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListConnections(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::ListConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchConnections() {
      ::grpc::Service::MarkMethodRawCallback(52,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchConnections(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::SearchConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::SearchConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteConnection() {
      ::grpc::Service::MarkMethodRawCallback(53,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteConnectionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateConnection() {
      ::grpc::Service::MarkMethodRawCallback(54,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_InspectContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_InspectContent() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::InspectContentRequest, ::google::privacy::dlp::v2::InspectContentResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::InspectContentRequest, ::google::privacy::dlp::v2::InspectContentResponse>* streamer) {
                       return this->StreamedInspectContent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_InspectContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status InspectContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::InspectContentRequest* /*request*/, ::google::privacy::dlp::v2::InspectContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedInspectContent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::InspectContentRequest,::google::privacy::dlp::v2::InspectContentResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RedactImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RedactImage() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::RedactImageRequest, ::google::privacy::dlp::v2::RedactImageResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::RedactImageRequest, ::google::privacy::dlp::v2::RedactImageResponse>* streamer) {
                       return this->StreamedRedactImage(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RedactImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RedactImage(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::RedactImageRequest* /*request*/, ::google::privacy::dlp::v2::RedactImageResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRedactImage(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::RedactImageRequest,::google::privacy::dlp::v2::RedactImageResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeidentifyContent() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::DeidentifyContentRequest, ::google::privacy::dlp::v2::DeidentifyContentResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::DeidentifyContentRequest, ::google::privacy::dlp::v2::DeidentifyContentResponse>* streamer) {
                       return this->StreamedDeidentifyContent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeidentifyContent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::DeidentifyContentRequest,::google::privacy::dlp::v2::DeidentifyContentResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReidentifyContent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReidentifyContent() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ReidentifyContentRequest, ::google::privacy::dlp::v2::ReidentifyContentResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ReidentifyContentRequest, ::google::privacy::dlp::v2::ReidentifyContentResponse>* streamer) {
                       return this->StreamedReidentifyContent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReidentifyContent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReidentifyContent(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ReidentifyContentRequest* /*request*/, ::google::privacy::dlp::v2::ReidentifyContentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReidentifyContent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ReidentifyContentRequest,::google::privacy::dlp::v2::ReidentifyContentResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInfoTypes() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListInfoTypesRequest, ::google::privacy::dlp::v2::ListInfoTypesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListInfoTypesRequest, ::google::privacy::dlp::v2::ListInfoTypesResponse>* streamer) {
                       return this->StreamedListInfoTypes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInfoTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListInfoTypesRequest,::google::privacy::dlp::v2::ListInfoTypesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateInspectTemplate() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::CreateInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::CreateInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>* streamer) {
                       return this->StreamedCreateInspectTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateInspectTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::CreateInspectTemplateRequest,::google::privacy::dlp::v2::InspectTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateInspectTemplate() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::UpdateInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::UpdateInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>* streamer) {
                       return this->StreamedUpdateInspectTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateInspectTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::UpdateInspectTemplateRequest,::google::privacy::dlp::v2::InspectTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInspectTemplate() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::GetInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::GetInspectTemplateRequest, ::google::privacy::dlp::v2::InspectTemplate>* streamer) {
                       return this->StreamedGetInspectTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetInspectTemplateRequest* /*request*/, ::google::privacy::dlp::v2::InspectTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInspectTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::GetInspectTemplateRequest,::google::privacy::dlp::v2::InspectTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInspectTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInspectTemplates() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListInspectTemplatesRequest, ::google::privacy::dlp::v2::ListInspectTemplatesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListInspectTemplatesRequest, ::google::privacy::dlp::v2::ListInspectTemplatesResponse>* streamer) {
                       return this->StreamedListInspectTemplates(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInspectTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInspectTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListInspectTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListInspectTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInspectTemplates(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListInspectTemplatesRequest,::google::privacy::dlp::v2::ListInspectTemplatesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteInspectTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteInspectTemplate() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::DeleteInspectTemplateRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::DeleteInspectTemplateRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteInspectTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteInspectTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteInspectTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteInspectTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteInspectTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::DeleteInspectTemplateRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>* streamer) {
                       return this->StreamedCreateDeidentifyTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateDeidentifyTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::CreateDeidentifyTemplateRequest,::google::privacy::dlp::v2::DeidentifyTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDeidentifyTemplate() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>* streamer) {
                       return this->StreamedUpdateDeidentifyTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDeidentifyTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::UpdateDeidentifyTemplateRequest,::google::privacy::dlp::v2::DeidentifyTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDeidentifyTemplate() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest, ::google::privacy::dlp::v2::DeidentifyTemplate>* streamer) {
                       return this->StreamedGetDeidentifyTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest* /*request*/, ::google::privacy::dlp::v2::DeidentifyTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDeidentifyTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::GetDeidentifyTemplateRequest,::google::privacy::dlp::v2::DeidentifyTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDeidentifyTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDeidentifyTemplates() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>* streamer) {
                       return this->StreamedListDeidentifyTemplates(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDeidentifyTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDeidentifyTemplates(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest* /*request*/, ::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDeidentifyTemplates(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListDeidentifyTemplatesRequest,::google::privacy::dlp::v2::ListDeidentifyTemplatesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteDeidentifyTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteDeidentifyTemplate() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteDeidentifyTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteDeidentifyTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteDeidentifyTemplate(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteDeidentifyTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::DeleteDeidentifyTemplateRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateJobTrigger() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::CreateJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::CreateJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>* streamer) {
                       return this->StreamedCreateJobTrigger(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateJobTrigger(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::CreateJobTriggerRequest,::google::privacy::dlp::v2::JobTrigger>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateJobTrigger() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::UpdateJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::UpdateJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>* streamer) {
                       return this->StreamedUpdateJobTrigger(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateJobTrigger(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::UpdateJobTriggerRequest,::google::privacy::dlp::v2::JobTrigger>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_HybridInspectJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_HybridInspectJobTrigger() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest, ::google::privacy::dlp::v2::HybridInspectResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest, ::google::privacy::dlp::v2::HybridInspectResponse>* streamer) {
                       return this->StreamedHybridInspectJobTrigger(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_HybridInspectJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status HybridInspectJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedHybridInspectJobTrigger(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::HybridInspectJobTriggerRequest,::google::privacy::dlp::v2::HybridInspectResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetJobTrigger() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::GetJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::GetJobTriggerRequest, ::google::privacy::dlp::v2::JobTrigger>* streamer) {
                       return this->StreamedGetJobTrigger(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::JobTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetJobTrigger(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::GetJobTriggerRequest,::google::privacy::dlp::v2::JobTrigger>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListJobTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListJobTriggers() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListJobTriggersRequest, ::google::privacy::dlp::v2::ListJobTriggersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListJobTriggersRequest, ::google::privacy::dlp::v2::ListJobTriggersResponse>* streamer) {
                       return this->StreamedListJobTriggers(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListJobTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListJobTriggers(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListJobTriggersRequest* /*request*/, ::google::privacy::dlp::v2::ListJobTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListJobTriggers(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListJobTriggersRequest,::google::privacy::dlp::v2::ListJobTriggersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteJobTrigger() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::DeleteJobTriggerRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::DeleteJobTriggerRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteJobTrigger(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteJobTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteJobTrigger(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::DeleteJobTriggerRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ActivateJobTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ActivateJobTrigger() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ActivateJobTriggerRequest, ::google::privacy::dlp::v2::DlpJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ActivateJobTriggerRequest, ::google::privacy::dlp::v2::DlpJob>* streamer) {
                       return this->StreamedActivateJobTrigger(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ActivateJobTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ActivateJobTrigger(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ActivateJobTriggerRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedActivateJobTrigger(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ActivateJobTriggerRequest,::google::privacy::dlp::v2::DlpJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateDiscoveryConfig() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>* streamer) {
                       return this->StreamedCreateDiscoveryConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateDiscoveryConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::CreateDiscoveryConfigRequest,::google::privacy::dlp::v2::DiscoveryConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDiscoveryConfig() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>* streamer) {
                       return this->StreamedUpdateDiscoveryConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDiscoveryConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::UpdateDiscoveryConfigRequest,::google::privacy::dlp::v2::DiscoveryConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDiscoveryConfig() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::GetDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::GetDiscoveryConfigRequest, ::google::privacy::dlp::v2::DiscoveryConfig>* streamer) {
                       return this->StreamedGetDiscoveryConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDiscoveryConfigRequest* /*request*/, ::google::privacy::dlp::v2::DiscoveryConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDiscoveryConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::GetDiscoveryConfigRequest,::google::privacy::dlp::v2::DiscoveryConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDiscoveryConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDiscoveryConfigs() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>* streamer) {
                       return this->StreamedListDiscoveryConfigs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDiscoveryConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDiscoveryConfigs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest* /*request*/, ::google::privacy::dlp::v2::ListDiscoveryConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDiscoveryConfigs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListDiscoveryConfigsRequest,::google::privacy::dlp::v2::ListDiscoveryConfigsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteDiscoveryConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteDiscoveryConfig() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteDiscoveryConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteDiscoveryConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteDiscoveryConfig(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteDiscoveryConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::DeleteDiscoveryConfigRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateDlpJob() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::CreateDlpJobRequest, ::google::privacy::dlp::v2::DlpJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::CreateDlpJobRequest, ::google::privacy::dlp::v2::DlpJob>* streamer) {
                       return this->StreamedCreateDlpJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateDlpJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::CreateDlpJobRequest,::google::privacy::dlp::v2::DlpJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDlpJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDlpJobs() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListDlpJobsRequest, ::google::privacy::dlp::v2::ListDlpJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListDlpJobsRequest, ::google::privacy::dlp::v2::ListDlpJobsResponse>* streamer) {
                       return this->StreamedListDlpJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDlpJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDlpJobs(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListDlpJobsRequest* /*request*/, ::google::privacy::dlp::v2::ListDlpJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDlpJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListDlpJobsRequest,::google::privacy::dlp::v2::ListDlpJobsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDlpJob() {
      ::grpc::Service::MarkMethodStreamed(29,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::GetDlpJobRequest, ::google::privacy::dlp::v2::DlpJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::GetDlpJobRequest, ::google::privacy::dlp::v2::DlpJob>* streamer) {
                       return this->StreamedGetDlpJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::DlpJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDlpJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::GetDlpJobRequest,::google::privacy::dlp::v2::DlpJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteDlpJob() {
      ::grpc::Service::MarkMethodStreamed(30,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::DeleteDlpJobRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::DeleteDlpJobRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteDlpJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteDlpJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::DeleteDlpJobRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelDlpJob() {
      ::grpc::Service::MarkMethodStreamed(31,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::CancelDlpJobRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::CancelDlpJobRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedCancelDlpJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CancelDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelDlpJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::CancelDlpJobRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateStoredInfoType() {
      ::grpc::Service::MarkMethodStreamed(32,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>* streamer) {
                       return this->StreamedCreateStoredInfoType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateStoredInfoType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::CreateStoredInfoTypeRequest,::google::privacy::dlp::v2::StoredInfoType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateStoredInfoType() {
      ::grpc::Service::MarkMethodStreamed(33,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>* streamer) {
                       return this->StreamedUpdateStoredInfoType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateStoredInfoType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::UpdateStoredInfoTypeRequest,::google::privacy::dlp::v2::StoredInfoType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetStoredInfoType() {
      ::grpc::Service::MarkMethodStreamed(34,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::GetStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::GetStoredInfoTypeRequest, ::google::privacy::dlp::v2::StoredInfoType>* streamer) {
                       return this->StreamedGetStoredInfoType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetStoredInfoTypeRequest* /*request*/, ::google::privacy::dlp::v2::StoredInfoType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetStoredInfoType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::GetStoredInfoTypeRequest,::google::privacy::dlp::v2::StoredInfoType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListStoredInfoTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListStoredInfoTypes() {
      ::grpc::Service::MarkMethodStreamed(35,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListStoredInfoTypesRequest, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListStoredInfoTypesRequest, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse>* streamer) {
                       return this->StreamedListStoredInfoTypes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListStoredInfoTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListStoredInfoTypes(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListStoredInfoTypesRequest* /*request*/, ::google::privacy::dlp::v2::ListStoredInfoTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListStoredInfoTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListStoredInfoTypesRequest,::google::privacy::dlp::v2::ListStoredInfoTypesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteStoredInfoType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteStoredInfoType() {
      ::grpc::Service::MarkMethodStreamed(36,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteStoredInfoType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteStoredInfoType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteStoredInfoType(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteStoredInfoType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::DeleteStoredInfoTypeRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListProjectDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListProjectDataProfiles() {
      ::grpc::Service::MarkMethodStreamed(37,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListProjectDataProfilesRequest, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListProjectDataProfilesRequest, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse>* streamer) {
                       return this->StreamedListProjectDataProfiles(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListProjectDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListProjectDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListProjectDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListProjectDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListProjectDataProfiles(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListProjectDataProfilesRequest,::google::privacy::dlp::v2::ListProjectDataProfilesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTableDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTableDataProfiles() {
      ::grpc::Service::MarkMethodStreamed(38,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListTableDataProfilesRequest, ::google::privacy::dlp::v2::ListTableDataProfilesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListTableDataProfilesRequest, ::google::privacy::dlp::v2::ListTableDataProfilesResponse>* streamer) {
                       return this->StreamedListTableDataProfiles(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTableDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTableDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListTableDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListTableDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTableDataProfiles(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListTableDataProfilesRequest,::google::privacy::dlp::v2::ListTableDataProfilesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListColumnDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListColumnDataProfiles() {
      ::grpc::Service::MarkMethodStreamed(39,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListColumnDataProfilesRequest, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListColumnDataProfilesRequest, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse>* streamer) {
                       return this->StreamedListColumnDataProfiles(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListColumnDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListColumnDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListColumnDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListColumnDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListColumnDataProfiles(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListColumnDataProfilesRequest,::google::privacy::dlp::v2::ListColumnDataProfilesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetProjectDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetProjectDataProfile() {
      ::grpc::Service::MarkMethodStreamed(40,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::GetProjectDataProfileRequest, ::google::privacy::dlp::v2::ProjectDataProfile>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::GetProjectDataProfileRequest, ::google::privacy::dlp::v2::ProjectDataProfile>* streamer) {
                       return this->StreamedGetProjectDataProfile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetProjectDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetProjectDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetProjectDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ProjectDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetProjectDataProfile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::GetProjectDataProfileRequest,::google::privacy::dlp::v2::ProjectDataProfile>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListFileStoreDataProfiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListFileStoreDataProfiles() {
      ::grpc::Service::MarkMethodStreamed(41,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>* streamer) {
                       return this->StreamedListFileStoreDataProfiles(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListFileStoreDataProfiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListFileStoreDataProfiles(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest* /*request*/, ::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListFileStoreDataProfiles(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListFileStoreDataProfilesRequest,::google::privacy::dlp::v2::ListFileStoreDataProfilesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetFileStoreDataProfile() {
      ::grpc::Service::MarkMethodStreamed(42,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest, ::google::privacy::dlp::v2::FileStoreDataProfile>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest, ::google::privacy::dlp::v2::FileStoreDataProfile>* streamer) {
                       return this->StreamedGetFileStoreDataProfile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::FileStoreDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetFileStoreDataProfile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::GetFileStoreDataProfileRequest,::google::privacy::dlp::v2::FileStoreDataProfile>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteFileStoreDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteFileStoreDataProfile() {
      ::grpc::Service::MarkMethodStreamed(43,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteFileStoreDataProfile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteFileStoreDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteFileStoreDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteFileStoreDataProfile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::DeleteFileStoreDataProfileRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTableDataProfile() {
      ::grpc::Service::MarkMethodStreamed(44,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::GetTableDataProfileRequest, ::google::privacy::dlp::v2::TableDataProfile>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::GetTableDataProfileRequest, ::google::privacy::dlp::v2::TableDataProfile>* streamer) {
                       return this->StreamedGetTableDataProfile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetTableDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::TableDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTableDataProfile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::GetTableDataProfileRequest,::google::privacy::dlp::v2::TableDataProfile>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetColumnDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetColumnDataProfile() {
      ::grpc::Service::MarkMethodStreamed(45,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::GetColumnDataProfileRequest, ::google::privacy::dlp::v2::ColumnDataProfile>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::GetColumnDataProfileRequest, ::google::privacy::dlp::v2::ColumnDataProfile>* streamer) {
                       return this->StreamedGetColumnDataProfile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetColumnDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetColumnDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetColumnDataProfileRequest* /*request*/, ::google::privacy::dlp::v2::ColumnDataProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetColumnDataProfile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::GetColumnDataProfileRequest,::google::privacy::dlp::v2::ColumnDataProfile>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTableDataProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTableDataProfile() {
      ::grpc::Service::MarkMethodStreamed(46,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::DeleteTableDataProfileRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::DeleteTableDataProfileRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteTableDataProfile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTableDataProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTableDataProfile(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteTableDataProfileRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTableDataProfile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::DeleteTableDataProfileRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_HybridInspectDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_HybridInspectDlpJob() {
      ::grpc::Service::MarkMethodStreamed(47,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::HybridInspectDlpJobRequest, ::google::privacy::dlp::v2::HybridInspectResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::HybridInspectDlpJobRequest, ::google::privacy::dlp::v2::HybridInspectResponse>* streamer) {
                       return this->StreamedHybridInspectDlpJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_HybridInspectDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status HybridInspectDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::HybridInspectDlpJobRequest* /*request*/, ::google::privacy::dlp::v2::HybridInspectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedHybridInspectDlpJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::HybridInspectDlpJobRequest,::google::privacy::dlp::v2::HybridInspectResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_FinishDlpJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_FinishDlpJob() {
      ::grpc::Service::MarkMethodStreamed(48,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::FinishDlpJobRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::FinishDlpJobRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedFinishDlpJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_FinishDlpJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status FinishDlpJob(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::FinishDlpJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedFinishDlpJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::FinishDlpJobRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateConnection() {
      ::grpc::Service::MarkMethodStreamed(49,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::CreateConnectionRequest, ::google::privacy::dlp::v2::Connection>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::CreateConnectionRequest, ::google::privacy::dlp::v2::Connection>* streamer) {
                       return this->StreamedCreateConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::CreateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::CreateConnectionRequest,::google::privacy::dlp::v2::Connection>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetConnection() {
      ::grpc::Service::MarkMethodStreamed(50,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::GetConnectionRequest, ::google::privacy::dlp::v2::Connection>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::GetConnectionRequest, ::google::privacy::dlp::v2::Connection>* streamer) {
                       return this->StreamedGetConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::GetConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::GetConnectionRequest,::google::privacy::dlp::v2::Connection>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListConnections() {
      ::grpc::Service::MarkMethodStreamed(51,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::ListConnectionsRequest, ::google::privacy::dlp::v2::ListConnectionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::ListConnectionsRequest, ::google::privacy::dlp::v2::ListConnectionsResponse>* streamer) {
                       return this->StreamedListConnections(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::ListConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::ListConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListConnections(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::ListConnectionsRequest,::google::privacy::dlp::v2::ListConnectionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchConnections() {
      ::grpc::Service::MarkMethodStreamed(52,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::SearchConnectionsRequest, ::google::privacy::dlp::v2::SearchConnectionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::SearchConnectionsRequest, ::google::privacy::dlp::v2::SearchConnectionsResponse>* streamer) {
                       return this->StreamedSearchConnections(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchConnections(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::SearchConnectionsRequest* /*request*/, ::google::privacy::dlp::v2::SearchConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchConnections(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::SearchConnectionsRequest,::google::privacy::dlp::v2::SearchConnectionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteConnection() {
      ::grpc::Service::MarkMethodStreamed(53,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::DeleteConnectionRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::DeleteConnectionRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::DeleteConnectionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::DeleteConnectionRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateConnection() {
      ::grpc::Service::MarkMethodStreamed(54,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::privacy::dlp::v2::UpdateConnectionRequest, ::google::privacy::dlp::v2::Connection>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::privacy::dlp::v2::UpdateConnectionRequest, ::google::privacy::dlp::v2::Connection>* streamer) {
                       return this->StreamedUpdateConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateConnection(::grpc::ServerContext* /*context*/, const ::google::privacy::dlp::v2::UpdateConnectionRequest* /*request*/, ::google::privacy::dlp::v2::Connection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::privacy::dlp::v2::UpdateConnectionRequest,::google::privacy::dlp::v2::Connection>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_InspectContent<WithStreamedUnaryMethod_RedactImage<WithStreamedUnaryMethod_DeidentifyContent<WithStreamedUnaryMethod_ReidentifyContent<WithStreamedUnaryMethod_ListInfoTypes<WithStreamedUnaryMethod_CreateInspectTemplate<WithStreamedUnaryMethod_UpdateInspectTemplate<WithStreamedUnaryMethod_GetInspectTemplate<WithStreamedUnaryMethod_ListInspectTemplates<WithStreamedUnaryMethod_DeleteInspectTemplate<WithStreamedUnaryMethod_CreateDeidentifyTemplate<WithStreamedUnaryMethod_UpdateDeidentifyTemplate<WithStreamedUnaryMethod_GetDeidentifyTemplate<WithStreamedUnaryMethod_ListDeidentifyTemplates<WithStreamedUnaryMethod_DeleteDeidentifyTemplate<WithStreamedUnaryMethod_CreateJobTrigger<WithStreamedUnaryMethod_UpdateJobTrigger<WithStreamedUnaryMethod_HybridInspectJobTrigger<WithStreamedUnaryMethod_GetJobTrigger<WithStreamedUnaryMethod_ListJobTriggers<WithStreamedUnaryMethod_DeleteJobTrigger<WithStreamedUnaryMethod_ActivateJobTrigger<WithStreamedUnaryMethod_CreateDiscoveryConfig<WithStreamedUnaryMethod_UpdateDiscoveryConfig<WithStreamedUnaryMethod_GetDiscoveryConfig<WithStreamedUnaryMethod_ListDiscoveryConfigs<WithStreamedUnaryMethod_DeleteDiscoveryConfig<WithStreamedUnaryMethod_CreateDlpJob<WithStreamedUnaryMethod_ListDlpJobs<WithStreamedUnaryMethod_GetDlpJob<WithStreamedUnaryMethod_DeleteDlpJob<WithStreamedUnaryMethod_CancelDlpJob<WithStreamedUnaryMethod_CreateStoredInfoType<WithStreamedUnaryMethod_UpdateStoredInfoType<WithStreamedUnaryMethod_GetStoredInfoType<WithStreamedUnaryMethod_ListStoredInfoTypes<WithStreamedUnaryMethod_DeleteStoredInfoType<WithStreamedUnaryMethod_ListProjectDataProfiles<WithStreamedUnaryMethod_ListTableDataProfiles<WithStreamedUnaryMethod_ListColumnDataProfiles<WithStreamedUnaryMethod_GetProjectDataProfile<WithStreamedUnaryMethod_ListFileStoreDataProfiles<WithStreamedUnaryMethod_GetFileStoreDataProfile<WithStreamedUnaryMethod_DeleteFileStoreDataProfile<WithStreamedUnaryMethod_GetTableDataProfile<WithStreamedUnaryMethod_GetColumnDataProfile<WithStreamedUnaryMethod_DeleteTableDataProfile<WithStreamedUnaryMethod_HybridInspectDlpJob<WithStreamedUnaryMethod_FinishDlpJob<WithStreamedUnaryMethod_CreateConnection<WithStreamedUnaryMethod_GetConnection<WithStreamedUnaryMethod_ListConnections<WithStreamedUnaryMethod_SearchConnections<WithStreamedUnaryMethod_DeleteConnection<WithStreamedUnaryMethod_UpdateConnection<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_InspectContent<WithStreamedUnaryMethod_RedactImage<WithStreamedUnaryMethod_DeidentifyContent<WithStreamedUnaryMethod_ReidentifyContent<WithStreamedUnaryMethod_ListInfoTypes<WithStreamedUnaryMethod_CreateInspectTemplate<WithStreamedUnaryMethod_UpdateInspectTemplate<WithStreamedUnaryMethod_GetInspectTemplate<WithStreamedUnaryMethod_ListInspectTemplates<WithStreamedUnaryMethod_DeleteInspectTemplate<WithStreamedUnaryMethod_CreateDeidentifyTemplate<WithStreamedUnaryMethod_UpdateDeidentifyTemplate<WithStreamedUnaryMethod_GetDeidentifyTemplate<WithStreamedUnaryMethod_ListDeidentifyTemplates<WithStreamedUnaryMethod_DeleteDeidentifyTemplate<WithStreamedUnaryMethod_CreateJobTrigger<WithStreamedUnaryMethod_UpdateJobTrigger<WithStreamedUnaryMethod_HybridInspectJobTrigger<WithStreamedUnaryMethod_GetJobTrigger<WithStreamedUnaryMethod_ListJobTriggers<WithStreamedUnaryMethod_DeleteJobTrigger<WithStreamedUnaryMethod_ActivateJobTrigger<WithStreamedUnaryMethod_CreateDiscoveryConfig<WithStreamedUnaryMethod_UpdateDiscoveryConfig<WithStreamedUnaryMethod_GetDiscoveryConfig<WithStreamedUnaryMethod_ListDiscoveryConfigs<WithStreamedUnaryMethod_DeleteDiscoveryConfig<WithStreamedUnaryMethod_CreateDlpJob<WithStreamedUnaryMethod_ListDlpJobs<WithStreamedUnaryMethod_GetDlpJob<WithStreamedUnaryMethod_DeleteDlpJob<WithStreamedUnaryMethod_CancelDlpJob<WithStreamedUnaryMethod_CreateStoredInfoType<WithStreamedUnaryMethod_UpdateStoredInfoType<WithStreamedUnaryMethod_GetStoredInfoType<WithStreamedUnaryMethod_ListStoredInfoTypes<WithStreamedUnaryMethod_DeleteStoredInfoType<WithStreamedUnaryMethod_ListProjectDataProfiles<WithStreamedUnaryMethod_ListTableDataProfiles<WithStreamedUnaryMethod_ListColumnDataProfiles<WithStreamedUnaryMethod_GetProjectDataProfile<WithStreamedUnaryMethod_ListFileStoreDataProfiles<WithStreamedUnaryMethod_GetFileStoreDataProfile<WithStreamedUnaryMethod_DeleteFileStoreDataProfile<WithStreamedUnaryMethod_GetTableDataProfile<WithStreamedUnaryMethod_GetColumnDataProfile<WithStreamedUnaryMethod_DeleteTableDataProfile<WithStreamedUnaryMethod_HybridInspectDlpJob<WithStreamedUnaryMethod_FinishDlpJob<WithStreamedUnaryMethod_CreateConnection<WithStreamedUnaryMethod_GetConnection<WithStreamedUnaryMethod_ListConnections<WithStreamedUnaryMethod_SearchConnections<WithStreamedUnaryMethod_DeleteConnection<WithStreamedUnaryMethod_UpdateConnection<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace dlp
}  // namespace privacy
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fprivacy_2fdlp_2fv2_2fdlp_2eproto__INCLUDED
